var apiEnvironment = "RELEASE";
if (typeof apiEnvironment == "undefined" || apiEnvironment == null || apiEnvironment == '') {
	apiEnvironment = "TEST";
}

var apiHost; //API服务器地址
var h5Host; //H5服务器地址
var uploadHost; //图片上传服务器地址
var logSwitch = true; // 日志开关，true 打印日志，false 不打印
var nowVersion = 170; //当前与服务端定义的版本号
var openWindowType; //页面打开方式：混合mui和原生native 

mui.plusReady(function(){
	openWindowType = comGetPageParam("openWindowType");
	initHost();
	//触发扫一扫关闭事件
	mui.fire(plus.webview.currentWebview().opener(), "onScanCloseListener", {});
	//添加统计
	statisticEvent("pageLoadTime", {"pageUrl" : location.href.substring(location.href.indexOf("ui/") + 3)});
});

function initHost(){
	if(apiEnvironment != 'RELEASE'){
		var cacheEnv = getCache(USER_SELECT_API_EVN);
		if(cacheEnv){
			apiEnvironment = cacheEnv;
		}
	}
	switch (apiEnvironment){
		case "SONG":
			apiHost = "http://192.168.1.107:8091"; // 开发环境
			break;
		case "CHAO":
			apiHost = "http://192.168.1.116:8086"; // 开发环境
			break;
		case "DEV":
			apiHost = "https://compusapi.lsmart.wang"; // 开发环境
			break;
		case "TEST":
			apiHost = "https://compusapi.lsmart.wang"; //测试环境
			h5Host = "https://h5.lsmart.wang";
			break;
		case "STABLE":
			apiHost = "https://compus.lsmart.wang"; //稳定测试环境
			h5Host = "https://h5.lsmart.wang";
			break;
		case "PRE":
			apiHost = "https://compuspre.lsmart.wang"; //预发布环境
			h5Host = "https://h5.lsmart.wang";
			break;
		case "GRAY":
			apiHost = "https://compusgray.xiaofubao.com"; //灰度布环境
			h5Host = "https://h5gray.xiaofubao.com";
			break;
		case "RELEASE":
			logSwitch = false; // 日志开关，true 打印日志，false 不打印
		case "PRO":
			apiHost = "https://compus.xiaofubao.com"; //正式环境 https
			h5Host = "https://h5.xiaofubao.com";
			break;
		default:
			break;
	}
	uploadHost = apiHost;
}

/**
 * 接口公共访问方法
 * @param {Object} urlPath 访问路径
 * @param {Object} params 访问参数（json格式）
 * @param {Object} requestCode 访问码，返回处理使用
 * @param {Object} onSuccess 成功回调
 * @param {Object} onErrorBefore 失败回调
 * @param {Object} requestType 请求类型（默认POST，也支持GET）
 * @param {Object} retry 访问失败重新请求次数（默认1次）
 */
var requestCount = {};
var requestParams = {};
function webCall2(urlPath, params, requestCode, onSuccess, onErrorBefore, requestType, retry, reqIntervalTime, extParams, isMustLogin) {
	//防止重复提交，相同请求间隔时间不能小于500毫秒
	if(!reqIntervalTime) reqIntervalTime = 500;
	var nowTime = new Date().getTime();
	if(requestCount[urlPath] && requestParams[urlPath] && requestParams[urlPath] == JSON.stringify(params) && (nowTime - requestCount[urlPath]) < reqIntervalTime) {
		closeWaiting();
		return;
	}
	requestCount[urlPath] = nowTime;
	requestParams[urlPath] = JSON.stringify(params);
	
	var params = arguments[1] ? arguments[1] : {};
	var requestCode = arguments[2] ? arguments[2] : 1;
	var onSuccess = arguments[3] ? arguments[3] : function() {};
	var onErrorBefore = arguments[4] ? arguments[4] : onError;
	var requestType = arguments[5] ? arguments[5] : "post";
	var retry = arguments[6] ? arguments[6] : 2;

	var userId = getCache(USER_ID_KEY);
	if(!params.id && userId && userId != 'null') {
		params.id = userId;
	}
	var schoolCode = getCache(SCHOOL_CODE_KEY);
	if(!params.schoolCode && schoolCode) {
		params.schoolCode = schoolCode;
	}
	var userToken = getCache(USER_TOKEN_KEY);
	if(!params.token && userToken) {
		params.token = userToken;
	}
	//判断为必须登录接口，如果用户id或token为空，则直接返回
	if(isMustLogin && (!userId || !userToken)){
		return;
	}
	params.deviceId = getLocalDeviceId();
	var testAccount = getCache(USER_TEST_ACCOUNT);
	params.testAccount = testAccount === "0" ? "0" : "1"; //是否测试账号（0是1否）
	params.appVersion = nowVersion;
	params.platform = "YUNMA_K12";
	
	var _params = params;
	//判断是否验证重复提交
	if(urlPath == '/common/token/get') {
		_params = {
			deviceId: params.deviceId,
			appVersion: params.appVersion,
			platform: params.platform
		};
	}
	//安全验证
	if(urlPath == '/common/security/token') {
		_params = {
			appVersion: params.appVersion,
			platform: params.platform,
			sceneCode: params.sceneCode
		};
	}
	//调用网络
	mui.ajax(apiHost + urlPath, {
		data: _params,
		dataType: 'json',
		type: requestType,
		timeout: 15000,
		headers: {
			"X-Requested-With": ""
		},
		success: function(data) {
			console.log("网络访问成功, 路径:" + apiHost + urlPath + ", 参数:" + JSON.stringify(_params));
			console.log("返回结果：" + JSON.stringify(data));
			outputLog("网络访问成功, 路径:" + apiHost + urlPath + ", 参数:" + JSON.stringify(_params));
			outputLog("返回结果：" + JSON.stringify(data));
			if(!data) {
				onErrorBefore(0, "请求失败 , 请重试", requestCode);
			}
			if(data.bizCode == 200812 || data.bizCode == 200811){ //身份证有效期已过期
				closeWaiting();
				var authDialog = plus.webview.create("../common/auth_dialog.html", "authDialog", 
					{top: '0px', bottom: '0px', position: 'fiexd', zindex: '9999', background: 'transparent'},
					{type:'over', overType:data.bizCode+''});
				plus.webview.currentWebview().append(authDialog);
				return;
			}	
			if(data.statusCode == 0) { //访问成功
				if(urlPath == '/common/token/get') { //重复提交token返回
					params.submitToken = data.data;
					webCall2(extParams.urlPath, params, requestCode, onSuccess, onErrorBefore);
				} else if(urlPath == '/common/security/token') {
					//获取本地安全码
					if(compareVersions("1.6.10", plus.runtime.version)){
						if(plus.os.name == 'iOS'){
							data.data.appSecurityToken = plus.ios.invoke("NativeJsTool", "getAppToken:", data.data.securityToken);
						}else{
							var NativeYischool = plus.android.importClass("com.app.yunma.cpp.NativeYischool");
							data.data.appSecurityToken = NativeYischool.getInstance().getAppToken(data.data.securityToken, plus.android.runtimeMainActivity());
						}
					}
					if(data.data.level !== 0){
						onErrorBefore('code', data.message, requestCode, data);
						return;
					}
					params.securityToken = data.data.securityToken;
					params.appSecurityToken = data.data.appSecurityToken;
					webCall2(extParams.urlPath, params, requestCode, onSuccess, onErrorBefore);
				} else {
					onSuccess(data, requestCode);
				}
			} else if(data.statusCode == 204) { //登录失效
				commonDoLogout();
			} else if(data.statusCode == 205 || data.statusCode == 207 || data.statusCode == 210  //设备更换/一卡通状态未激活/一卡通已经被他人绑定
				 || data.statusCode == 211 || data.statusCode == 212 || data.statusCode == 213) { //验证指纹/验证手势/未设置密码
				onErrorBefore(data.statusCode, data.message, requestCode, data);
			} else if(data.statusCode == 208) { //未选择学校
				closeWaiting();
				openUnSelectSchoolDialog();
			} else if(data.statusCode == 209) { //未绑卡
				closeWaiting();
				openUnBindDialog();
			} else if(data.statusCode == 300) { //系统维护时间
				closeWaiting();
				plus.nativeUI.alert(data.message, function(){
					mui.back();
				}, "", "确定");
			} else {
				onErrorBefore(0, data.message, requestCode, data);
			}
		},
		error: function(xhr, type, errorThrown) {
			retry--;
			console.log("status: " + xhr.status + ", type: " + type + ", 网络访问失败: " + apiHost + urlPath + ", 参数:" + JSON.stringify(params));
			outputLog("status: " + xhr.status + ", type: " + type + ", 网络访问失败: " + apiHost + urlPath + ", 参数:" + JSON.stringify(params));
			if(retry > 1 || (type == "abort" && retry > 0)) return webCall2(urlPath, params, requestCode, onSuccess, onErrorBefore, requestType, retry);
			if(xhr.response) {
				var response;
				try {
					response = JSON.parse(xhr.response);
				} catch(e) {
					console.error(e);
				}

				if(response && response.message) {
					onErrorBefore(0, response.message, requestCode);
				} else {
					onErrorBefore('FAILED_NETWORK', '网络状态不佳，请查检您的网络', requestCode);
				}
			} else if(plus.networkinfo.getCurrentType() <= 1) {
				onErrorBefore('FAILED_NETWORK', '', requestCode);
			} else if(type == "abort" || type == "timeout" || type == "error" || type == "parsererror") {
				onErrorBefore(0, "服务连接超时", requestCode);
			} else {
				onErrorBefore('BAND_REQUEST', '请求访问失败，请重试', requestCode);
			}
		}
	});
}

/**
 * 网络访问错误
 * @param {Object} errcode
 */
var onError = function(resultCode, resultMsgDesc, requestCode) {
	switch(resultCode) {
		case 'FAILED_NETWORK':
			toast('网络状态不佳，请查检您的网络');
			break;
		case 'BAND_REQUEST':
			toast('请求访问失败，请重试');
			break;
		case 0:
			toast(resultMsgDesc);
			break;
		default:
			break;
	}
}

function commonDoLogout() {
	if(getCache(IS_SHOW_UNLOGIN_KEY)) return; //如果已经执行过该流程，则直接返回
	//清空消息
	clearPushMessage();
	setCache(IS_SHOW_UNLOGIN_KEY, "true");
	closeWaiting();
	toast("您的账号已被登出或已失效，请重新登录");
	//清理本地信息
	clearLoginInfo();
	loginoutRongIM(true);
	var self = plus.webview.currentWebview();
	var nowUrl = location.href;
	var loginUrl = nowUrl.substring(0, nowUrl.indexOf("/ui/")) + "/ui/login/login_by_code.html";
	openWindow("loginByCode", loginUrl, false, null, null, true);
	//清理缓存
	plus.navigator.removeAllCookie();
	plus.cache.clear();
	clearWxLogin();
	closeWebviewWhenLoginOut();
}

/**
 * 打开新页面
 * @param {Object} id 页面标识
 * @param {Object} url 页面路径
 * @param {Object} waiting 是否显示加载框
 * @param {Object} params json参数
 */
var openWindowCount = {};
function openWindow(id, url, waiting, params, aniShow, createNew) {
	//防止重复提交，相同请求间隔时间不能小于1000毫秒
	var nowTime = new Date().getTime();
	if(openWindowCount[id] && (nowTime - openWindowCount[id]) < 1000) {
		return;
	}
	openWindowCount[id] = nowTime;
	if(params == null) params = {};
	//params.loadUrl = url;
	//原生模式打开页面
	if(openWindowType == 'native'){
		//object参数处理成string
		for(var key in params){
			if(typeof(params[key]) == "object"){
				params[key] = JSON.stringify(params[key]);
			}
		}
		//打开页面
		if(plus.os.name == 'iOS'){
			plus.ios.invoke("CustomTool", "openHbWindow:webviewId:param:", url , id, JSON.stringify(params));
		}else{
			var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
			SealAppContext.getInstance().openWindow(id, url, JSON.stringify(params));
		}
		return;
	}
	//混合模式打开页面
	mui.openWindow({
		id: id,
		url: url,
		show: {
			aniShow: aniShow || 'slide-in-right'
		},
		waiting: {
			autoShow: waiting
		},
		createNew: createNew,
		extras: params
	});
}
/*
* 判断是否以指定字符串结尾
*/
function isEndSpecifiedStr(str, endStr) {
	if(!str || !endStr){
		return true;
	}
	var d = str.length - endStr.length;
	return(d >= 0 && str.lastIndexOf(endStr) == d);
}
/**
 * 关闭界面 当账号被登出时
 * @param {Object}
 */
function closeWebviewWhenLoginOut() {
	//获取所有webView
	var wvs=plus.webview.all();
	for(var i = 0; i < wvs.length; i++) {
		//不关闭start login 两个页面
		if(!wvs[i].getURL() || wvs[i].getURL() == null || isEndSpecifiedStr(wvs[i].getURL(), "start.html") || isEndSpecifiedStr(wvs[i].getURL(), "login_by_code.html") || isEndSpecifiedStr(wvs[i].getURL(), "login.html")) {
			continue;
		}
		wvs[i].hide();
	}
	setTimeout(function(){
		for(var i = 0; i < wvs.length; i++) {
			//不关闭start login 两个页面
			if(!wvs[i].getURL() || wvs[i].getURL() == null || isEndSpecifiedStr(wvs[i].getURL(), "start.html") || isEndSpecifiedStr(wvs[i].getURL(), "login_by_code.html") || isEndSpecifiedStr(wvs[i].getURL(), "login.html")) {
				continue;
			}
			wvs[i].close();
		}
	}, 500);
}
/**
 * 关闭界面（手动关闭界面前必须用这个方法关闭，否则在Android很多机型上出现被关闭的界面一闪而过的情况）
 * @param {Object} id 界面id
 */
function closeWebview(id, isCloseLater) {
	if(id == "main") {
		var subpages = ['home/home_main.html', 'grow/grow_main.html', 'message/message_main.html', 'center/center_main.html'];
		for(var i = 0; i < subpages.length; i++) {
			var subpage = plus.webview.getWebviewById(subpages[i]);
			if(subpage != null) {
				subpage.hide();
			}
		}
		setTimeout(function() {
			for(var i = 0; i < subpages.length; i++) {
				var subpage = plus.webview.getWebviewById(subpages[i]);
				if(subpage != null) {
					subpage.close();
				}
			}
		}, 500);
	}
	
	//关闭原生打开的页面
	if(openWindowType == 'native' && plus.os.name == "iOS"){ 
		closeNativePage(id);
		return;
	}
	closeNativePage(id);
	//关闭混合打开的页面
	var webview = plus.webview.getWebviewById(id);
	if(webview != null) {
		webview.hide();
		setTimeout(function() {
			webview.close();
		}, isCloseLater ? 1500 : 500);
	}
}

/**
 * 关闭原生打开的页面
 * @param {Object} pageId 页面ID
 */
function closeNativePage(pageId) {
	if(plus.os.name == 'iOS'){
		plus.ios.invoke("CustomTool", "closeHbWindow:", pageId);
	}else{
		var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
		SealAppContext.getInstance().removeActivity(pageId);
	}
}

/**
 * 自定义事件触发
 * @param {Object} pageId
 * @param {Object} eventName
 * @param {Object} detailObj
 */
function excuteFireEvent(pageId, eventName, detailObj){
	mui.fire(plus.webview.getWebviewById(pageId), eventName, detailObj);
	if(plus.os.name == 'Android'){
		var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
		SealAppContext.getInstance().firePageEvent(pageId, eventName, detailObj ? JSON.stringify(detailObj) : "{}");
	}
}

/**
 * 获取本地设备ID
 * 0. 从缓存中获取
 * 1. iOS取uuid，Android取oaid
 * 2. 取个推clientid
 * 3. 自己生成
 */
function getLocalDeviceId(){
	//0. 从缓存中获取
	var deviceId = getCache(LOCAL_DEVICE_ID);
	if(deviceId && deviceId != 'null' && deviceId != 'undefined') return deviceId;
	deviceId = setLocalDeviceId(); //本地自动生成
	return deviceId;
}

/**
 * 设置本地设备ID
 * 0. 从缓存中获取
 * 1. 取uuid
 * 2. 取个推clientid
 * 3. 自己生成
 */
function setLocalDeviceId(){
	//0. 从缓存中获取
	var deviceId = getCache(LOCAL_DEVICE_ID);
	if(deviceId && deviceId != 'null' && deviceId != 'undefined') return deviceId;
	deviceId = plus.device.uuid;
	if(!deviceId || deviceId == 'null' || deviceId == 'undefined'){
		deviceId = getClientId();
	}
	if(!deviceId || deviceId == 'null' || deviceId == 'undefined'){
		deviceId = getUuid();
	}
	setCache(LOCAL_DEVICE_ID, deviceId);
	return deviceId;
}

/**
 * 打开学校未选择弹窗
 */
function openUnSelectSchoolDialog() {
	confirmDialog('', '您还未选择学校，去选择学校？', '取消', '确定', function cancelCallback(){
		mui.back();
	}, function sureCallback(){
		openWindow("selectSchool", "../login/select_school.html", false, {
			statusBarType: plus.webview.currentWebview().statusBarType,
			from: 'userinfo'
		}, null, true);
		setTimeout(function(){
			closeWebview(plus.webview.currentWebview().id);
		}, 500);
	});
}

/**
 * 打开未绑卡弹窗
 */
function openUnBindDialog() {
	confirmDialog('', '您还未绑定学生卡，去绑定？', '取消', '确定', function cancelCallback(){
		mui.back();
	}, function sureCallback(){
		openBindCard(plus.webview.currentWebview().statusBarType);
		setTimeout(function(){
			closeWebview(plus.webview.currentWebview().id);
		}, 500);
	});
}

/**
 * 生成uuid
 */
function getUuid() {
	var s = [];
	var hexDigits = "0123456789abcdef";
	for(var i = 0; i < 36; i++) {
		s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
	}
	s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
	s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
	s[8] = s[13] = s[18] = s[23] = "-";

	uuid = s.join("");
	return uuid;
}

/**封装加载等待框的显示和关闭*/
var waitingCount = 0;
/**
 * 显示等待框
 * @param {Object} interfaceNum 接口数
 */
function showWaiting(interfaceNum) {
	if (navigator.userAgent.indexOf("Html5Plus") < 0) return; // 浏览器模式
	if(waitingCount < 0) waitingCount = 0;
	if(interfaceNum && interfaceNum > 1) {
		waitingCount += interfaceNum;
	} else {
		waitingCount++;
	}
	//iOS 原生打开的页面无法显示等待框, 使用本地等待框
	if(openWindowType == 'native' && plus.os.name == "iOS"){
		plus.ios.invoke("CustomTool", "closeWaiting");
		plus.ios.invoke("CustomTool", "showWaiting");
		return;
	}
	plus.nativeUI.closeWaiting();
	plus.nativeUI.showWaiting('');
}

/**
 * 关闭等待框(当返回接口数减为0后关闭)
 */
function closeWaiting() {
	if (navigator.userAgent.indexOf("Html5Plus") < 0) return; // 浏览器模式
	waitingCount--;
	if(waitingCount <= 0) {
		waitingCount = 0;
		//iOS 原生打开的页面无法显示等待框, 使用本地等待框
		if(openWindowType == 'native' && plus.os.name == "iOS"){
			plus.ios.invoke("CustomTool", "closeWaiting");
			return;
		}
		plus.nativeUI.closeWaiting();
	}
}

/**
 * 设置状态栏背景为蓝底白字
 */
function setStatusBarDefault() {
	// 设置状态栏背景颜色
	if (plus.os.name == "iOS") {
		plus.ios.invoke("NativeJsTool", "setBarsStyle:", "UIStatusBarStyleDefault");
	} else {
		plus.navigator.setStatusBarBackground("#ffffff");
		plus.navigator.setStatusBarStyle("dark");
	}
}

/**
 * 设置状态栏 渐变色 首页等界面
 */
function setStatusBarMain() {
	if (plus.os.name == "iOS") {
		// 设置状态栏背景颜色
		plus.ios.invoke("NativeJsTool", "setBarsStyle:", "UIStatusBarStyleLightContent");
	} else {
		plus.navigator.setStatusBarBackground("#229FFE");
		plus.navigator.setStatusBarStyle("light");
	}
}


/**
 * 设置状态栏背景为黑色、字体为白色
 */
function setStatusBarBlack() {
	if (plus.os.name == "iOS") {
		// 设置状态栏背景颜色
		plus.ios.invoke("NativeJsTool", "setBarsStyle:", "UIStatusBarStyleLightContent");
	} else {
		plus.navigator.setStatusBarBackground("#000000");
		plus.navigator.setStatusBarStyle("light");
	}
}

/**
 * 返回时 设置上个界面状态栏颜色
 * @param {Object} sourceStatusBarType default black main
 */
function setUpViewStatusBar(sourceStatusBarType) {
	//返回，把等待框关掉
	closeWaiting();
	if(sourceStatusBarType == STATUS_BAR_MAIN_KEY) {
		setStatusBarMain();
	}else if(sourceStatusBarType == STATUS_BAR_BLACK_KEY){
		setStatusBarBlack();
	}else{
		setStatusBarDefault();
	}
}

/**
 * 获取当前的状态栏类型
 */
function getCurrentStatusBarType(){
	var sBarBg = plus.navigator.getStatusBarBackground();
    if(sBarBg == '#229ffe' || sBarBg == '#229FFE') return STATUS_BAR_MAIN_KEY;
	else if(sBarBg == '#ffffff' || sBarBg == '#FFFFFF') return STATUS_BAR_DEFAULT_KEY;
	else if(sBarBg == '#000000') return STATUS_BAR_BLACK_KEY;
}

function fullscreen() {
	plus.navigator.setFullscreen(true);
}

function unfullscreen() {
	plus.navigator.setFullscreen(false);
}

//是否是字符串类型. eg: isString(requestCode)
function isString(str) {
	return(typeof str == 'string') && (str.constructor == String);
}

/*
 * 获取clientId 
 */
function getClientId(){
	var clientId = getCache(CLIENT_ID_KEY);
	if(clientId && clientId.length > 0){
		return clientId;
	}
	var clientInfo = plus.push.getClientInfo();
	clientId = clientInfo ? clientInfo.clientid : "";
	if(clientId != null &&  clientId != "" && clientId != "null"){
		setCache(CLIENT_ID_KEY, clientId);
		return clientId;
	} else {
		return "";
	}
}

var setClientIdInterval;
var setClientIdNum = 0;
/*
 * 存储clientId 
 */
function setClientId() {
	if(getCache(CLIENT_ID_KEY) != null && getCache(CLIENT_ID_KEY).length > 0){
		return;
	}
	var clientInfo = plus.push.getClientInfo();
	var clientId = clientInfo ? clientInfo.clientid : "";
	if(clientId != null && clientId != "" && clientId != "null") {
		setCache(CLIENT_ID_KEY, clientId);
		return;
	}
	setClientIdInterval = setInterval(function() {
		setClientIdNum++;
		clientInfo = plus.push.getClientInfo();
		clientId = clientInfo ? clientInfo.clientid : "";
		if(clientId != null && clientId != "" && clientId != "null") {
			setCache(CLIENT_ID_KEY, clientId);
			clearInterval(setClientIdInterval);
			return;
		}
		if(setClientIdNum > 10) clearInterval(setClientIdInterval);
	}, 3000);
}

/**
 * 添加右滑返回事件
 */
function drawCloseCurWeb(webview, color, style){
	if(plus.os.name == "iOS") {
		webview.drag({callbackStep:'35',direction:'right',moveMode:'followFinger'}, {view:"webview",moveMode:'follow'}, function(e){
		//outputLog('Right drag event: '+JSON.stringify(e));
			if(e.type == "end" && e.result == true){
				setUpViewStatusBar(color, style);	
				webview.close();
			}
		});
	}
}

/**
 * iOS打印日志
 * @param {Object} logInfo: 要输出的日志内容
 */
function outputLog(logInfo){
	if(!logInfo) return;
	if(navigator.userAgent.indexOf("Html5Plus") >= 0 && plus.os.name == 'iOS'){
         plus.ios.invoke("NativeJsTool", "log:", logInfo);
    }
}

/**
 * 弹框居中显示
 */
function toast(message){
	if(!window.plus || message == null || message == undefined || message == 'null' || message == 'undefined'){
		return;
	}
	plus.nativeUI.toast(message, {verticalAlign:"center"});
}

/**
 * 判断是否登录
 */
function isLogin() {
	var account = getCache(ACCOUNT_KEY);
	var userToken = getCache(USER_TOKEN_KEY);
	if(account != null && userToken != null && account.length > 0 && userToken.length > 0) {
		return true;
	}
	return false;
}

/**
 * 获取用户信息
 */
function getUserInfo(){
	var userInfoStr = getCache(USER_INFO_KEY);
	if(userInfoStr){
		return JSON.parse(userInfoStr);
	}
	return {};
}

/**
  * 更新用户登录信息
  * @param {Object} phone
  * @param {Object} userInfo
  */
function updateLoginInfo(phone, userInfo){
	removeCache(IS_SHOW_UNLOGIN_KEY);
	
	setCache(IS_LOGIN_KEY, "true");
	if(phone) setCache(ACCOUNT_KEY, phone);
	setCache(USER_INFO_KEY, JSON.stringify(userInfo));
	setCache(USER_TOKEN_KEY, userInfo.token);
	if(userInfo.uuToken) setCache(UU_TOKEN_KEY, userInfo.uuToken);
	if(userInfo.imToken) setCache(IM_TOKEN_KEY, userInfo.imToken);
	removeCache(SCHOOL_CODE_KEY);
	setCache(SCHOOL_CODE_KEY, userInfo.schoolCode);
	setCache(SCHOOL_NAME_KEY, userInfo.schoolName);
	setCache(USER_ID_KEY, userInfo.id);//用户id
	setCache(REAL_NAME_KEY, userInfo.userName);//姓名
	setCache(NICK_NAME_KEY, userInfo.nickName);//昵称
	setCache(IMAGE_URL_KEY, userInfo.headImg);// 头像
	setCache(USER_PHONE_KEY, userInfo.mobilePhone);// 手机
	setCache(USER_TEST_ACCOUNT, userInfo.testAccount);
	setCache(USER_MEDIUM_ID_KEY, userInfo.payUser);//二类账户id
}
/**
 * 用户点击退出登录时，清除登录信息
 */
function clearLoginInfo(){
	setCache(IS_LOGIN_KEY, "false");
	removeCache(USER_INFO_KEY);
	removeCache(USER_TOKEN_KEY);
	removeCache(UU_TOKEN_KEY);
	removeCache(IM_TOKEN_KEY);
	//removeCache(SCHOOL_CODE_KEY);
	removeCache(SCHOOL_NAME_KEY);
	removeCache(USER_ID_KEY);
	removeCache(REAL_NAME_KEY);
	removeCache(NICK_NAME_KEY);
	removeCache(IMAGE_URL_KEY);
	removeCache(USER_PHONE_KEY);
	removeCache(USER_TEST_ACCOUNT);
	removeCache(USER_MEDIUM_ID_KEY);
	removeCache(CARD_SCHOOL_TYPE_KEY);
}

/**
 * 清除微信授权登录
 */
function clearWxLogin() {
	plus.oauth.getServices(function(services) {
		var auths = services;
		console.log(JSON.stringify(auths));
		for ( var i in auths ) {
			var s = auths[i];
			console.log(JSON.stringify(s));
			s.logout(function(e){
					console.log( "注销登录认证成功！" );
			}, function(e){
					console.log( "注销登录认证失败！" + JSON.stringify(e) );
			});
		}
	}, function(e) {
		console.log("获取分享服务列表失败：" + e.message + " - " + e.code);
	});
}

/**
 * 缓存一卡通余额
 */
function setCardRemain(remain){
	setCache(CARD_REMAIN_KEY, remain);
}

/**
 * 获取缓存中一卡通余额
 */
function getCardRemain(){
	var remain = getCache(CARD_REMAIN_KEY);
	if(!remain){
		remain = "0.00";
	}
	return remain;
}

/**
 * 缓存未读消息数
 */
function setUnReadCount(count){
	setCache(USER_UN_READ_MSG_COUNT + getCache(USER_ID_KEY), count);
}

/**
 * 获取未读消息数
 */
function getUnReadCount(){
	var count = getCache(USER_UN_READ_MSG_COUNT + getCache(USER_ID_KEY));
	if(!count || parseInt(count) < 0){
		count = 0;
	}
	return count;
}

/**
 * 添加到粘贴版
 * @param {Object} linkUrl
 */
function copyLink(linkUrl) {
	if(plus.os.name == 'Android') {
		var Context = plus.android.importClass("android.content.Context");
		var main = plus.android.runtimeMainActivity();
		var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
		plus.android.invoke(clip, "setText", linkUrl);
		toast("已复制到剪贴板");
	} else if(plus.os.name == 'iOS') {
		var UIPasteboard = plus.ios.importClass("UIPasteboard");
		var generalPasteboard = UIPasteboard.generalPasteboard();
		generalPasteboard.setValueforPasteboardType(linkUrl, "public.utf8-plain-text");
		toast("已复制到剪贴板");
	} else {
		toast("不支持的系统类型");
	}
}

/**========================本地缓存管理   start==========================*/
/*key键名*/
var LAUNCH_FLAG_YUNMA_KEY = "launchFlagYunma"; //应用第一次启动标识
var IS_SHOW_UNLOGIN_KEY = "isShowUnlogin"; //显示未登录
var ACCOUNT_KEY = "account"; //用户账号key
var USER_PHONE_KEY = "userPhone"; //用户账号key
var USER_TOKEN_KEY = "userToken"; //登录token
var UU_TOKEN_KEY = "uuToken"; //用户token
var IM_TOKEN_KEY = "imToken"; //登录token
var SCHOOL_CODE_KEY = "userSchoolCode"; //用户学校编码
var SCHOOL_NAME_KEY = "userSchoolName"; //用户学校名称
var IS_LOGIN_KEY = "isLogin"; //登录标识key
var USER_INFO_KEY = "userInfo"; //用户信息key
var USER_ID_KEY = "userId"; //用户ID key
var REAL_NAME_KEY = "realName"; //用户真实姓名key
var NICK_NAME_KEY = "nickName"; //用户昵称key
var IMAGE_URL_KEY = "imageUrl"; //用户头像地址key
var CLIENT_ID_KEY = "clientId"; //clientId key
var LOCATION_POSITION_KEY = "localPosition"; //用户定位信息
var USER_TEST_ACCOUNT = "testAccount"; //是否测试账号（0是1否）
//状态栏相关
var STATUS_BAR_DEFAULT_KEY = "default"; //默认色调(白)
var STATUS_BAR_MAIN_KEY = "main"; //主色调
var STATUS_BAR_BLACK_KEY = "black"; //黑色调
//一卡通相关
var CARD_REMAIN_KEY = "cardRemain"; //一卡通余额
var CARD_MAIN_BG_KEY = "cardMainBackground"; //一卡通余额
var CARD_SCHOOL_TYPE_KEY = "cardSchoolType"; //1001：学校不支持一卡通
//消息相关
var USER_UN_READ_MSG_COUNT = "userUnReadMsgCount"; //用户未读消息数
//发布之前用户选择的系统环境
var USER_SELECT_API_EVN = "userSelectApiEnv"; //用户选择的环境
//是否有增量新版本更新
var WGT_NEWEST_VERSION_FLAG = "wgtNewestVersinoFlag";
//钱包相关
var USER_MEDIUM_ID_KEY = "userMediumIdKey"; //用户二类账号唯一编码
//启动页广告
var START_AD_DATA = "startAdData"; //启动页广告数据
var START_AD_IMAGE = "startAdImage"; //启动页广告图片
//首页公告
var HOME_NOTICE_ID = "homeNoticeID"; //首页公告数据
//首页应用和banner缓存数据
var HOME_APPS_DATA = "homeAppsDataK12";
var HOME_BANNERS_DATA = "homeBannersDataK12";
//社团相关
var CLUB_DEFAULT_DATA = "clubDefaultData"; //当前社团默认数据
var CLUB_DEFAULT_ID = "clubDefaultId"; //当前社团ID
//身份列表缓存
var IDENTITY_LIST_DATA = "identityListData";
//隐私政策和协议弹框
var LOGIN_PRIVATEP_ROTOCOL = "loginPrivateProtocol";
var LOCAL_DEVICE_ID = "YUNMA_APP_LOCAL_DEVICEID";

var PlatformUtil;
/**
 * 设置存储值
 * @param {Object} key
 * @param {Object} value
 */
function setCache(key, value){
	if(!window.plus) {
		return;
	}
	if(key == null || key.length <= 0 || value == null || value.length <= 0) return;
	value += "";
	if(plus.os.name == 'iOS' || openWindowType != 'native'){
		plus.storage.setItem(key, value);
	}else{
		if(!PlatformUtil){
			PlatformUtil = plus.android.importClass("io.dcloud.common.adapter.util.PlatformUtil");
		}
		PlatformUtil.setBundleData("H56ED11E9_storages", key, value);
	}
}
/**
 * 获取存储值
 * @param {Object} key
 */
function getCache(key){
	if(!window.plus) {
		return;
	}
	if(key == null || key.length <= 0) return;
	if(plus.os.name == 'iOS' || openWindowType != 'native'){
		return plus.storage.getItem(key);
	}else{
		if(!PlatformUtil){
			PlatformUtil = plus.android.importClass("io.dcloud.common.adapter.util.PlatformUtil");
		}
		return PlatformUtil.getBundleData("H56ED11E9_storages", key);
	}
}
/**
 * 移除存储值
 * @param {Object} key
 */
function removeCache(key){
	if(!window.plus) {
		return;
	}
	if(key == null || key.length <= 0) return;
	if(plus.os.name == 'iOS' || openWindowType != 'native'){
		plus.storage.removeItem(key);
	}else{
		if(!PlatformUtil){
			PlatformUtil = plus.android.importClass("io.dcloud.common.adapter.util.PlatformUtil");
		}
		PlatformUtil.removeBundleData("H56ED11E9_storages", key);
	}
}
/**========================本地缓存管理   end  ==========================*/

//=======对话框===========
/**
 * 确认对话框
 * @param {Object} tipTitle  可以为空
 * @param {Object} tipSubTitle 不能为空
 * @param {Object} leftBtnTitle 左边按钮 title
 * @param {Object} rightBtnTitle  右边按钮 title
 * @param {Object} leftBtnCallback  左边按钮点击回调
 * @param {Object} rightBtnCallback  右边按钮点击回调
 */
function confirmDialog(tipTitle, tipSubTitle, leftBtnTitle, rightBtnTitle, leftBtnCallback, rightBtnCallback){
	//tipSubTitle 不能为空
	if(!tipSubTitle || tipSubTitle.length==0)	return;
	
	var btnArray = [leftBtnTitle, rightBtnTitle];
	if(plus.os.name == "Android") {//iOS和安卓上 按钮的方向是相反的
		btnArray = [rightBtnTitle, leftBtnTitle];
	}
	plus.nativeUI.confirm(tipSubTitle, function(e) {
		if(e.index < 0) return;
		if((e.index == 0 && plus.os.name == "iOS") || (e.index == 1 && plus.os.name == "Android")) { //left
			leftBtnCallback ? leftBtnCallback() : null;
		} else{//right
			rightBtnCallback ? rightBtnCallback() : null;
		}
	}, tipTitle, btnArray);
}

/**
 * 获取带unionid的url
 */
function getUnionUrl(url){
	if(!url || url.indexOf("unionid=") > 0) return url;
	if(url.indexOf("?") > 0){
		return url + "&unionid=" + getCache(USER_ID_KEY) + "&schoolCode=" + getCache(SCHOOL_CODE_KEY);
	}else{
		return url + "?unionid=" + getCache(USER_ID_KEY) + "&schoolCode=" + getCache(SCHOOL_CODE_KEY);
	}
}

/**
 * 在链接后面追加参数
 * @param {Object} url
 * @param {Object} params
 */
function appendParamsUrl(url, params){
	if(!params) return url;
	for(var key in params){
		if(url.indexOf("?") > 0){
			url = url + "&" + key +"=" + params[key];
		}else{
			url = url + "?" + key +"=" + params[key];
		}
	}
	return url;
}

/**沉浸式状态栏判断*/
(function(w) {
	var immersed = 0;
	var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
	if(ms && ms.length >= 3) {
		immersed = parseFloat(ms[2]);
	}
	w.immersed = immersed;
	if(!immersed || (!(/iphone|ipad|ipod/.test(navigator.userAgent.toLowerCase())) && comGetUrlParamByName(location.href, "openWindowType") == 'native')) {
		return;
	}
	var hhh = document.getElementById('header');
	hhh && (hhh.style.height = 44 + immersed + 'px', hhh.style.paddingTop = immersed + 'px');
	mmm = document.getElementById('main');
	if(mmm && mmm.classList.contains("wrapper")){
		hhh && (mmm.style.top = 44 + immersed + 'px');
		!hhh && (mmm.style.top = immersed + 'px');
	}else if(mmm){
		hhh && (mmm.style.paddingTop = 44 + immersed + 'px');
		!hhh && (mmm.style.paddingTop = immersed + 'px');
	}
	mappp = document.getElementById('map');
	mappp && (mappp.style.marginTop = immersed + 'px');
	scannnn = document.getElementById('scanMain');
	scannnn && (scannnn.style.marginTop = immersed + 'px');
	closeBtnnn = document.getElementById('closeBtn');
	closeBtnnn && (closeBtnnn.style.top = immersed + 'px');
	settingBtnnn = document.getElementById('settingBtn');
	settingBtnnn && (settingBtnnn.style.top = immersed + 'px');
	tabGrouppp = document.getElementById('tabGroup');
	tabGrouppp && (tabGrouppp.style.top = immersed + 44 + 'px');
	searchBtn = document.getElementById('searchBtn');
	searchBtn && (searchBtn.style.top = immersed +'px');
})(window);

/*
 *  权限判断
 *  相机: CAMERA,  相册: GALLERY, 通讯录: CONTACTS, 定位:LOCATION 
 */
function checkUserPermission(permissionType, webView, successBack, cancelBack){
	if(!permissionType || permissionType.length <= 0) return false;
	var promptTitle = "";
	var androidPermission = new Array();
	switch(permissionType){
		case 'CAMERA'://相机
			promptTitle= plus.os.name == "Android" ? "您的相机权限未打开，是否去打开相机权限" : "您的相机权限未打开，请在当前应用设置-隐私-相机来开打此权限";
			androidPermission.push("android.permission.CAMERA");
			break;
		case 'GALLERY'://相册
			promptTitle= plus.os.name == "Android" ? "您的存储权限未打开，是否去打开存储权限" : "您的相册权限未打开，请在当前应用设置-隐私-相册来开打此权限";
			androidPermission.push("android.permission.WRITE_EXTERNAL_STORAGE");
			androidPermission.push("android.permission.READ_EXTERNAL_STORAGE");
			break;
		case 'CONTACTS'://通讯录
			promptTitle= plus.os.name == "Android" ? "您的通讯录权限未打开，是否去打开通讯录权限" : "您的通讯录权限未打开，请在当前应用设置-隐私-通讯录来开打此权限";
			androidPermission.push("android.permission.READ_CONTACTS");
			androidPermission.push("android.permission.WRITE_CONTACTS");
			break;
		case 'LOCATION'://定位
			promptTitle= plus.os.name == "Android" ? "您的定位权限未打开，是否去打开定位权限" : "您的定位权限未打开，请在当前应用设置-隐私-位置来开打此权限";
			androidPermission.push("android.permission.ACCESS_FINE_LOCATION");
			androidPermission.push("android.permission.ACCESS_COARSE_LOCATION");
			break;
		case 'SCREEN'://系统设置
			androidPermission.push("android.permission.WRITE_SETTINGS");
			break;	
		default:
			break;
	}
	//Android授权
	if(plus.os.name == 'Android'){
		var main = plus.android.runtimeMainActivity();
		var Build = plus.android.importClass("android.os.Build");
		var ContextCompat = plus.android.importClass("android.support.v4.content.ContextCompat");
		var PackageManager = plus.android.importClass("android.content.pm.PackageManager");
		if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.M){
			if(ContextCompat.checkSelfPermission(main, androidPermission[0]) != PackageManager.PERMISSION_GRANTED){
				plus.android.requestPermissions(androidPermission, function(e){
					if(e.granted.length > 0){ //权限被允许
					    successBack ? successBack(): null;
					}else if(e.deniedPresent.length > 0){ //权限被临时拒绝
						cancelBack ? cancelBack(): null;
					}else if(e.deniedAlways.length > 0 && permissionType != 'SCREEN'){ //权限被永久拒绝
						confirmDialog("", promptTitle, "取消", "去打开", function() {}, function() {
							var Settings = plus.android.importClass('android.provider.Settings');
							var Uri = plus.android.importClass('android.net.Uri');
						    var Intent = plus.android.importClass("android.content.Intent");
						    var mIntent = new Intent(Settings.ACTION_APPLICATION_DETAILS_SETTINGS);
						    var uri = Uri.fromParts("package", main.getPackageName(), null);
						    mIntent.setData(uri);
							main.startActivity(mIntent);	
						});
					}
				}, function(e){
				    console.log('Request Permissions error:'+JSON.stringify(e));
				});
				return false;
			}
		}
		return true;
	}
	//iOS授权
	var permission = plus.navigator.checkPermission(permissionType);
	if(permission != "denied"){//已开启权限或者还未提示获取权限
		return true;
	}
	confirmDialog("", promptTitle, "确定", "取消", function sureCallback() {
		plus.ios.invoke("NativeJsTool", "openAlbumReject");
		if(webView) webView.close();
		successBack ? successBack(): null;
	}, function sureCallback(){
		if(webView) webView.close();
		cancelBack ? cancelBack(): null;
	});
	return false;
}
/*
 * 两位小数，不足用0补齐
 */
function toDecimalTwo(x) {
   var f = parseFloat(x);
   if (isNaN(f)) {
      return false;
   }
   var f = Math.round(x*100)/100;
   var s = f.toString();
   var rs = s.indexOf('.');
   if (rs < 0) {
      rs = s.length;
      s += '.';
   }
   while (s.length <= rs + 2) {
      s += '0';
   }
   return s;
}

/*
 * 账号登出, 清空消息
 */
function clearPushMessage(){
	plus.push.clear();
	if(plus.os.name == "Android") return;
	var nativeJsToolClass = plus.ios.importClass("NativeJsTool");
	var nativeJsToolObj = plus.ios.newObject("NativeJsTool");
	plus.ios.invoke(nativeJsToolObj, "resetBadgeNum");
}
/*
 * 只清空角标 不清空消息中心的消息
 */
function clearPushNumberMessage(){
	plus.runtime.setBadgeNumber("0");
	if(plus.os.name == "Android") return;
	var nativeJsToolClass = plus.ios.importClass("NativeJsTool");
	var nativeJsToolObj = plus.ios.newObject("NativeJsTool");
	plus.ios.invoke(nativeJsToolObj, "resetBadgeNum");
}
/**
 * 友盟自定义事件次数统计
 */
function statisticEvent(enentId, extObj){
	if(!window.plus || apiEnvironment != 'RELEASE') return;
	var user = getUserInfo();
	var vObj = {};
	if(extObj){
		mui.extend(vObj, extObj);
	}
	if(user.id){
		vObj.schoolName = user.schoolName ? user.schoolName : '未知';
		vObj.realNameStatus = user.realNameStatus == 1 ? "实名" : "未实名";
		vObj.bindCardStatus = user.bindCardStatus == 1 ? "绑卡" : "未绑卡";
	}
	vObj.mobileType = plus.device.model;
	if(plus.os.name == 'Android'){
		plus.statistic.eventTrig(enentId, JSON.stringify(vObj));
	}else{
		plus.statistic.eventTrig(enentId, vObj);
	}
}

/**
 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean} 
 */
function compareVersions( ov, nv ){
	if ( !ov || !nv || ov=="" || nv=="" ){
		return false;
	}
	var b=false;
	var ova = ov.split(".",4);
	var nva = nv.split(".",4);
	for ( var i=0; i<ova.length&&i<nva.length; i++ ) {
		var so=ova[i],no=parseInt(so),sn=nva[i],nn=parseInt(sn);
		if ( nn>no || sn.length>so.length  ) {
			return true;
		} else if ( nn<no ) {
			return false;
		}
	}
	if ( nva.length>ova.length && 0==nv.indexOf(ov) ) {
		return true;
	}
	return false;
}

/**
 * 页面统一参数获取，优先从webview获取，再从url中获取
 */
function comGetPageParam(key){
	var webview = plus.webview.currentWebview();
	var result = webview[key];
	if(!result){
		result = comGetUrlParamByName(webview.getURL(), key);
	}
	if(result && typeof(result) == 'string'){
		result = decodeURIComponent(result);
		if(result.indexOf("{") == 0){
			result = JSON.parse(result);
		}
	}
	return result;
}

/**
 * 获取url中指定的参数
 * @param {Object} url
 * @param {Object} name
 */
function comGetUrlParamByName(url, name) {
	if(!url || url.indexOf("?") < 0) return null;
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
	var r = url.split("?")[1].match(reg);
	if(r != null) return decodeURI(r[2]);
	return null;
}

/**
 * 打开绑卡页面
 */
function openBindCard(statusBarType, isCardAssist) {
	//判断学校是否支持一卡通
	if(!isCardAssist && getCache(CARD_SCHOOL_TYPE_KEY) == '1001'){
		toast("您的学校未开通学生卡功能");	
		return;
	}
	//如果没有选择学校，则选择学校
	var schoolCode = getCache(SCHOOL_CODE_KEY);
	if(!schoolCode){
		openWindow("selectSchool", "../login/select_school.html", false, {
			statusBarType: statusBarType?statusBarType:getCurrentStatusBarType(),
			from: 'noSchool'
		}, null, true);
		return;
	}
	//选择了学校，打开绑卡页面
	openWindow("bindCard", "../card/bind_card.html", false, {statusBarType: statusBarType?statusBarType:getCurrentStatusBarType()});
}
function openBindCardByParams(fromThirdAuth, webPageId) {
	//如果没有选择学校，则选择学校
	var schoolCode = getCache(SCHOOL_CODE_KEY);
	if(!schoolCode){
		openWindow("selectSchool", "../login/select_school.html", false, {
			statusBarType: getCurrentStatusBarType(),
			from: 'noSchool',
			fromThirdAuth: fromThirdAuth,
			webPageId: webPageId
		}, null, true);
		return;
	}
	//选择了学校，打开绑卡页面
	openWindow("bindCard", "../card/bind_card.html", false, {
		statusBarType: getCurrentStatusBarType(),
		fromThirdAuth: fromThirdAuth,
		webPageId: webPageId
	});
}
/*
 * 设置键盘弹出模式 
 * Android 生效
 * iOS 新版XCODE 不支持 底部会黑影
 */
function keyboardAdjustResize(){
	if(plus.os.name == "iOS") return;
	plus.webview.currentWebview().setStyle({softinputMode:"adjustResize"});
}

/*
 * Android 判断APP是否安装
 */
function judgeThirdAPPIsInstalled(andAppid){
	if(plus.os.name == "iOS") return;
	var Utils = plus.android.importClass("com.app.yunma.common.Utils");
	var main = plus.android.runtimeMainActivity();
	return Utils.isAppExists(main, andAppid);
}

/**
 * 获取相册模块展示的图片地址（小图）
 * @param {Object} url
 */
function getAlbumShowUrl(url){
	var showUrl = "https://imgfile.xiaofubao.com/group1/M00/01/98/wKhQNFy_08aAbChDAAADF8k50Xs437.png"
	if(!url) return showUrl;
	var start = url.lastIndexOf(".");
	if(start < 0) return showUrl;
	showUrl = url.substring(0, start) + "200_200." + url.substring(start+1);
	return showUrl;
}

/**
 * 获取头像的图片地址（小图）
 * @param {Object} url
 */
function getUserPhotoShowUrl(url){
	var showUrl = "https://imgfile.xiaofubao.com/group1/M00/01/AD/wKhQM1zH6wuALIIrAAAHIGh1QHQ722.png"
	if(!url) return showUrl;
	var start = url.lastIndexOf(".");
	if(start < 0) return showUrl;
	showUrl = url.substring(0, start) + "120_120." + url.substring(start+1);
	return showUrl;
}

/** 融云相关接口 **/

/**
 * IM连接
 * @param {Object} isFromLogin
 */
function connectRongIM(){
	saveUserInfo();
	if(!getCache(IM_TOKEN_KEY)) return;
	if(plus.os.name == 'iOS'){
		var userInfo = getUserInfo();
		plus.ios.invoke("RYImTool", "connectRongIM:withUserInfo:", getCache(IM_TOKEN_KEY), JSON.stringify(userInfo));
	}else{
		var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
		SealAppContext.getInstance().connectRongIM(getCache(IM_TOKEN_KEY));
	}
}

/**
 * IM登出
 * @param {Object} isKicked 是否被另外设备踢出
 */
function loginoutRongIM(isKicked){
	if(plus.os.name == 'iOS'){
		plus.ios.invoke("RYImTool", "loginOutRongIM:", isKicked ? "1" : "0");
	}else{
		var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
		SealAppContext.getInstance().quit(isKicked);
	}
}

/**
 * 更新融云用户信息
 */
function updateRongIMUserinfo(){
	if(plus.os.name == 'iOS'){
		var userInfo = getUserInfo();
		plus.ios.invoke("RYImTool", "updateUserInfo:", JSON.stringify(userInfo));
	}else{
		var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
		SealAppContext.getInstance().updateNowUserinfo(getCache(NICK_NAME_KEY), getCache(IMAGE_URL_KEY));
	}
}

/**
 * 设置IM接口域名
 */
function setRongIMDomain(){
	//重新初始化域名
	initHost();
	//设置域名
	if(plus.os.name == 'iOS'){
		var deviceId = getLocalDeviceId();
		plus.ios.invoke("AFHttpTool", "setApiHost:withDeviceId:", apiHost, deviceId);
	}else{
		var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
		SealAppContext.getInstance().setDomain(apiHost);
	}
}
/*
 * iOS本地保存用户信息
 */
function saveUserInfo(){
	if(plus.os.name == "Android") return;
	var userInfo = getUserInfo() ? getUserInfo() : "";
	plus.ios.invoke("RYImTool", "saveUserInfo:", JSON.stringify(userInfo));
}

/**
 * 设置UserAgent
 */
function setLcalUserAgent(localDeviceId){
	try{
		var userAgent = navigator.userAgent;
		if(userAgent.indexOf("/yunmaapp.NET/yunmak12.NET/") < 0){
			userAgent = userAgent + " " + "/yunmaapp.NET/yunmak12.NET/" + plus.runtime.version + "/" + localDeviceId;
			plus.navigator.setUserAgent(userAgent);
		}
		console.log("userAgent: " + userAgent);
	}catch(e){
	}
}

/**去除字符串两端空格**/
function commonTrim(str){
	if(!str) return str;
	if(typeof(str) != 'string') return str;
	return str.replace(/^\s+|\s+$/g, "");
}
