/**
 * 滚动辅助模块
 * @author 564539969@qq.com
 * @since 2013-07-26
 */
(function($, window) {
	var exportsMethods = {
		newVerScrollForPull: function(wrapper, pullDownAction, pullupAction, opts, pullText) {
			var $wrapper;
			if(typeof wrapper === 'string') {
				$wrapper = $(wrapper)
			} else if(typeof wrapper === 'object') {
				$wrapper = wrapper
			}
			$wrapper = $wrapper[0];
			var pullDownRefresh = pullText && pullText['pullDownRefresh'] ? pullText['pullDownRefresh'] : '下拉刷新',
				releaseToRefresh = pullText && pullText['releaseToRefresh'] ? pullText['releaseToRefresh'] : '释放刷新',
				loading = pullText && pullText['loading'] ? pullText['loading'] : '正在加载中...';
			var $pullDown = $wrapper.querySelectorAll('#pullDown'),
				pullDownOffset = 0;
			if($pullDown.length > 0) {
				pullDownOffset = $pullDown[0].offsetHeight;
				$pullDown[0].querySelectorAll('.pullDownLabel')[0].innerHTML = pullDownRefresh;
				$pullDown[0].querySelectorAll('.pullDownLabel')[0].classList.add("mui-hidden")
			}
			var options = {
				topOffset: pullDownOffset,
				tap: false,
				eventPassthrough: 'horizontal'
			};
			$.extend(true, options, opts);
			var scrollObj = this.newVerScroll($wrapper, options);
			scrollObj.on('refresh', function() {
				var $pullDown = $wrapper.querySelectorAll('#pullDown');
				if($pullDown.length > 0 && $pullDown[0].classList.contains('loading')) {
					$pullDown[0].className = "";
					$pullDown[0].querySelectorAll('.pullDownLabel')[0].innerHTML = pullDownRefresh;
					$pullDown[0].querySelectorAll('.pullDownLabel')[0].classList.add("mui-hidden")
				}
			});
			scrollObj.on('scrollMove', function() {
				var $pullDown = $wrapper.querySelectorAll('#pullDown');
				if((this.y < this.maxScrollY) && (this.pointY < 1)) {
					this.scrollTo(0, this.maxScrollY, 100);
					return
				} else if(this.y > 0 && (this.pointY > window.innerHeight * 1)) {
					this.scrollTo(0, 0, 100);
					return
				}
				if($pullDown.length > 0 && this.y > 5 && !$pullDown[0].classList.contains('flip')) {
					$pullDown[0].className = "";
					$pullDown[0].classList.add('flip');
					$pullDown[0].querySelectorAll('.pullDownLabel')[0].innerHTML = releaseToRefresh;
					$pullDown[0].querySelectorAll('.pullDownLabel')[0].classList.remove("mui-hidden");
					this.minScrollY = 0
				} else if($pullDown.length > 0 && this.y < 5 && $pullDown[0].classList.contains('flip')) {
					$pullDown[0].className = "";
					$pullDown[0].querySelectorAll('.pullDownLabel')[0].innerHTML = pullDownRefresh;
					$pullDown[0].querySelectorAll('.pullDownLabel')[0].classList.add("mui-hidden");
					this.minScrollY = -pullDownOffset
				}
			});
			scrollObj.on('scrollEnd', function() {
				//解决页面图片动态加载高度问题，导致无法上拉
				var scrollers = document.getElementsByClassName("scroller");
				if(scrollers && scrollers.length > 0 && scrollers[0] && this.maxScrollY == 0 
					&& scrollers[0].offsetHeight > this.wrapper.clientHeight){
					this.refresh();
				}
				var $pullDown = $wrapper.querySelectorAll('#pullDown');
				var $loadMoreSpan = $wrapper.querySelectorAll('.loadmore__tips');
				if($pullDown.length > 0 && $pullDown[0].classList.contains('flip')) {
					$pullDown[0].className = "";
					$pullDown[0].classList.add('loading');
					$pullDown[0].querySelectorAll('.pullDownLabel')[0].innerHTML = loading;
					$pullDown[0].querySelectorAll('.pullDownLabel')[0].classList.add("mui-hidden");
					if(typeof pullDownAction === 'function') {
						pullDownAction.call(scrollObj)
					}
					if($loadMoreSpan[0]) {
						$loadMoreSpan[0].innerHTML = "正在加载..."
					}
				} else if(this.y == this.maxScrollY) {
					if(typeof pullupAction === 'function') {
						pullupAction.call(scrollObj)
					}
				}
			});
			scrollObj.on('touchEnd', function() {
				console.error("我离开了屏幕");
				this.refresh();
			});
			scrollObj.on('scrollStart', function() {
				var $pullDown = $wrapper.querySelectorAll('#pullDown');
				if($pullDown.length > 0 && ($pullDown[0].classList.contains('loading') || $pullDown[0].classList.contains('flip'))) {
					scrollObj._execEvent('scrollEnd')
				}
			});
			return scrollObj
		},
		newVerScroll: function(dom, option) {
			var opt = {
				scrollbars: false,
				useTransition: false,
				click: true,
				tap: true
			};
			if(option) {
				$.extend(opt, option)
			}
			var iSObj = new IScroll(dom, opt);
			iSObj.on("scrollEnd", function() {
				if(this.indicator1) {
					this.indicator1.indicatorStyle['transition-duration'] = '350ms';
					this.indicator1.indicatorStyle['opacity'] = '0'
				}
			});
			iSObj.on("scrollMove", function() {
				if(this.indicator1) {
					this.indicator1.indicatorStyle['transition-duration'] = '0ms';
					this.indicator1.indicatorStyle['opacity'] = '0.8'
				}
			});
			return iSObj
		}
	};
	window.iscrollAssist = exportsMethods
})(mui, window);