/**
 * 弹出导航选择对话框
 * @param {Object} convert 目的地
 * @param {Object} navDesc 导航描述，装货目的地、卸货目的地
 * @param {Object} convertNow 出发地
 */
function navigationChoose(convert, navDesc, convertNow) {
	// 弹出系统选择按钮框
	plus.nativeUI.actionSheet({
			cancel: "取消",
			buttons: [{
				title: "高德地图"
			}, {
				title: "百度地图"
			}, {
				title: "系统默认"
			}]
		},
		function(e) {
			var Utils = plus.android.importClass("com.app.logistics.common.Utils");
			var main = plus.android.runtimeMainActivity();
			if(e.index == 1) { // 选择高德地图
				if (Utils.isInstall("com.autonavi.minimap", main)){
					// Android平台导入Intent、Uri类
					var Intent = plus.android.importClass("android.content.Intent");
					var Uri = plus.android.importClass("android.net.Uri");
					// 获取主Activity对象的实例
					var main = plus.android.runtimeMainActivity();
					// 创建Intent
					var naviIntent = new Intent("android.intent.action.VIEW",Uri.parse("androidamap://route?sourceApplication=聚运通司机APP&dlat=" + convert.lat + "&dlon=" + convert.lon + "&dname=" + navDesc +"&dev=0&t=2"));
					naviIntent.setPackage("com.autonavi.minimap"); 
					main.startActivity(naviIntent);
				} else {
					mui.toast("请先安装高德地图");
				}
			} else if(e.index == 2) { // 选择百度地图
				if (Utils.isInstall("com.baidu.BaiduMap", main)){
					// Android平台导入Intent、Uri类
					var Intent = plus.android.importClass("android.content.Intent");
					var Uri = plus.android.importClass("android.net.Uri");
					// 获取主Activity对象的实例
					var main = plus.android.runtimeMainActivity();
					// 创建Intent
					var naviIntent = new Intent();
					naviIntent.setData(Uri.parse("baidumap://map/direction?destination=" + convert.lat + "," + convert.lon + "&mode=driving&coord_type=gcj02&src=聚运通司机APP"))
					main.startActivity(naviIntent);
				} else {
					mui.toast("请先安装百度地图");
				}
			} else if(e.index == 3) { // 选择系统默认
				var dst = new plus.maps.Point(convert.lon, convert.lat); // 目的地
				var src = new plus.maps.Point(convertNow.lon, convertNow.lat); // 出发地
				plus.maps.openSysMap(dst, navDesc, src);
				//判断是否安装第三方地图客户端
				Utils.isInstallMap(main);
			}
		}
	);
}