var wgtVer = null;
var curVer = null;
function plusReady() {
	// 获取本地应用资源版本号
	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		wgtVer = inf.version;
		console.log("当前应用资源版本：" + wgtVer);
	});
	curVer = plus.runtime.version;
	//console.log("当前应用版本：" + plus.runtime.version);
	//5秒后检查资源升级
	setTimeout(function() {
		checkUpdate();
	}, 2000);
}
if(window.plus) {
	plusReady();
} else {
	document.addEventListener('plusready', plusReady, false);
}

function checkUpdate() {
	var params = {
		updateType: "0",
		applyVersion: curVer
	};
	webCall2("/compus/appversion/getAppVersioList", params, 1001, function(data, requestCode){
		//data.data.version ==>  服务端配置的最新的增量包版本号，整包版本集合
		//data.data.applyVersion ==>  服务端配置的最新增量包所适用的整包版本集合
		if (data.data && data.data && data.data.version && data.data.applyVersion) {
			var wgtSerVer = data.data.version;
			var applyVers = data.data.applyVersion.split(",");
			if (!compareVersion(wgtVer, wgtSerVer)) { // 无需增量升级
				return;
			}
			for (var i = 0; i < applyVers.length; i++) {
				if (curVer == applyVers[i]) {
					downWgt(data.data.url); // 下载升级包
				}
			}
		}
	});
}

/**
 * 比较整包版本，如果新版本nv等于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean} 
 */
function compareBundleVersion( ov, nv ){
	if ( !ov || !nv || ov=="" || nv=="" ){
		return false;
	}
	if (nv == ov && 0==nv.indexOf(ov) ) {
		return true;
	}
	return false;
}


/**
 * 比较版本大小，如果新版本nv大于旧版本ov则返回true，否则返回false
 * @param {String} ov
 * @param {String} nv
 * @return {Boolean} 
 */
function compareVersion( ov, nv ){
	if ( !ov || !nv || ov=="" || nv=="" ){
		return false;
	}
	var b=false;
	var ova = ov.split(".",4);
	var nva = nv.split(".",4);
	for ( var i=0; i<ova.length&&i<nva.length; i++ ) {
		var so=ova[i],no=parseInt(so),sn=nva[i],nn=parseInt(sn);
		if ( nn>no || sn.length>so.length  ) {
			return true;
		} else if ( nn<no ) {
			return false;
		}
	}
	if ( nva.length>ova.length && 0==nv.indexOf(ov) ) {
		return true;
	}
	return false;
}


function downWgt(wgtUrl) {
	//plus.nativeUI.showWaiting("下载wgt文件...");
	console.log("下载wgt文件...");
	plus.downloader.createDownload(wgtUrl, {
		filename: "_doc/update/"
	}, function(d, status) {
		if(status == 200) {
			installWgt(d.filename); // 安装wgt包
		} else {
			//plus.nativeUI.alert("下载wgt失败！");
			console.log("下载wgt失败！");
		}
		//plus.nativeUI.closeWaiting();
	}).start();
}
// 更新应用资源
function installWgt(path) {
	//plus.nativeUI.showWaiting("安装wgt文件...");
	console.log("安装wgt文件...");
	plus.runtime.install(path, {}, function() {
		//标记有新版本更新
		setCache(WGT_NEWEST_VERSION_FLAG, "yes");
		//plus.nativeUI.closeWaiting();
		/*plus.nativeUI.confirm("资源有更新，重启后生效，是否立即重启？", function(i) {
			if(0 == i.index) {
				//先关闭所有webview，再重启
				var wvs = plus.webview.all();
	            for(var i = 0; i < wvs.length; i++){
	                if(plus.webview.currentWebview().id != wvs[i].id && wvs[i].id != "main"){
	                    plus.webview.close(wvs[i]);
	                }
	            }
				setTimeout(function(){
	            	plus.runtime.restart();
	            }, 500);
			}
		}, "资源升级", ["重新启动", "取　　消"]);*/
		//清理缓存
		console.log("安装wgt成功...");
		plus.cache.clear();
	}, function(e) {
		//plus.nativeUI.closeWaiting();
		//plus.nativeUI.alert("安装wgt文件失败[" + e.code + "]：" + e.message);
	});
}