/*
 * 判断本地是否存在这个图片
 */
function isExistenceImg(loadUrl,callback) {
	if(!loadUrl || loadUrl.length <= 0){
		callback(false);	
		return;
	}
	//图片下载成功 默认保存在本地相对路径的"_downloads"文件夹里面, 如"_downloads/logo.jpg"
	var filename = loadUrl.substring(loadUrl.lastIndexOf("/") + 1, loadUrl.length);
	var relativePath = "_downloads/adImg/" + filename;
	//检查图片是否已存在
	plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
		callback(true);
	}, function(e) {
		callback(false);
	});
}

/*
 * 下载图片
 */
function setImgFromNet(loadUrl, data) {
	if(!loadUrl || loadUrl.length <= 0) return;
	//图片下载成功 默认保存在本地相对路径的"_downloads"文件夹里面, 如"_downloads/logo.jpg"
	var filename = loadUrl.substring(loadUrl.lastIndexOf("/") + 1, loadUrl.length);
	var relativePath = "_downloads/adImg/" + filename;
	//检查图片是否已存在
	plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
		console.log("图片存在,直接设置=" + relativePath);
		var sd_path = plus.io.convertLocalFileSystemURL(relativePath);
		setCache(START_AD_IMAGE, sd_path);
		setCache(START_AD_DATA, JSON.stringify(data));
	}, function(e) {
		downloadImg(loadUrl, data);
	});
}

 /*联网下载图片,并设置给<img>*/
function downloadImg(loadUrl, data) {
	//图片下载成功 默认保存在本地相对路径的"_downloads"文件夹里面, 如"_downloads/logo.jpg"
	var filename = loadUrl.substring(loadUrl.lastIndexOf("/") + 1, loadUrl.length);
	var relativePath = "_downloads/adImg/" + filename;
	//创建下载任务
	var dtask = plus.downloader.createDownload(loadUrl, {
		filename: relativePath
	}, function(d, status) {
		if(status == 200) {
			//下载成功
			console.log("下载成功=" + relativePath);
			var sd_path = plus.io.convertLocalFileSystemURL(relativePath);
			setCache(START_AD_IMAGE, sd_path);
			setCache(START_AD_DATA, JSON.stringify(data));
		} else {
			//下载失败,需删除本地临时文件,否则下次进来时会检查到图片已存在
			console.log("下载失败=" + status + "==" + relativePath);
			var sd_path = plus.io.convertLocalFileSystemURL(relativePath);
			delFile(sd_path);
		}
	});
	//启动下载任务
	dtask.start();
 }
/*删除指定文件*/
function delFile(loadUrl) {
	if(!loadUrl || loadUrl.length <= 0) return;
	//图片下载成功 默认保存在本地相对路径的"_downloads"文件夹里面, 如"_downloads/logo.jpg"
	var filename = loadUrl.substring(loadUrl.lastIndexOf("/") + 1, loadUrl.length);
	var relativePath = "_downloads/adImg/" + filename;
	plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
		entry.remove(function(entry) {
			console.log("文件删除成功==" + relativePath);
		}, function(e) {
			console.log("文件删除失败=" + relativePath);
		});
	});
}