/**
 * @author 1020450921@qq.com
 * @link http://www.cnblogs.com/phillyx
 * @link http://ask.dcloud.net.cn/people/%E5%B0%8F%E4%BA%91%E8%8F%9C
 */
var imageTool = (function(mui, com) {
	/**
	 * 1.使用native.js压缩
	 * 1.1.拍照上传
	 * 1.2.选择图片上传
	 */
	var endReturn = [];
	var itool = {
		options: {
			//uploadUrl: '/common/upload/uploadFile', //图片上传地址
			uploadUrl: '/common/upload/uploadFileSize', //图片上传地址
			multiple: false, //是否多图上传
			maxPicsCount: 8, //默认一次最多选择8张图片
			isZoom: true, //默认通过native.js压缩
			isClip: false, //是否要剪裁
			group: null, //私有目录，传值公有目录不传
			uploadType: null, //上传类型
			isBankCard: null, //是否银行卡OCR
			itemCb: null, //批量上传单文件上传回调
			ZoomBox: 1200, //缩放宽高，默认1200px,横图缩放宽度，高度根据比例计算，同理竖图
			ZoomQuality: 70, //压缩图片的质量
			isUpload: true, //默认不上传
			system: false, //设置为true时，如果系统自带相册选择控件时则优先使用，否则使用5+统一相册选择控件；设置为false则不使用系统自带相册选择控件，直接使用5+统一相册选择界面。
		},
		setUploadData: function(task) {
			task.addData("id", getCache(USER_ID_KEY));
			task.addData("token", getCache(USER_TOKEN_KEY));
			task.addData("deviceId", getLocalDeviceId());
			task.addData("osType", plus.os.name);
			task.addData("mobileType", plus.device.model);
			task.addData("platform", "YUNMA_K12");
			if(itool.options.group){
				task.addData("group", itool.options.group);
			}
			if(itool.options.uploadType != null && itool.options.uploadType != ""){
				task.addData("uploadType", itool.options.uploadType);
			}
		}
	};
	/**
	 * @description get images from an album
	 * @param {Object} cb(err,files)
	 */
	function galleryImgs(cb, itemCb, isMultiple, maxNum, isClip, group, isBankCard, uploadType, isNotUpload) {
		itool.options.group = group;
		itool.options.uploadType = uploadType;
		itool.options.itemCb = itemCb;
		itool.options.isBankCard = isBankCard;
		if(isBankCard){
			itool.options.uploadUrl = "/common/ocr/bankcard";
		}
		//权限判断
		if(!checkUserPermission("GALLERY", null, function(){
			galleryImgs(cb, itemCb, isMultiple, maxNum, isClip, group, isBankCard, uploadType, isNotUpload);
		})){
			return;
		}
		if(isClip){
			itool.options.isClip = isClip;
		}else{
			itool.options.isClip = false;
		}
		if(isMultiple){
			itool.options.multiple = isMultiple;
			itool.options.maxPicsCount = maxNum;
		}
		//重置
		endReturn = [];
		plus.gallery.pick(function(e) {
			if (itool.options.multiple) {
				/*if(e.files.length > itool.options.maxPicsCount){
					return cb && cb('最多选择'+itool.options.maxPicsCount+'张图片');
				}*/
			}
			if(isNotUpload){
				cb && cb(true, itool.options.multiple ? e.files : e);
				return;
			}
			processing_imgs(itool.options.multiple ? e.files : e, cb);
		}, function(error) {
			cb && cb(error.message);
		}, {
			filter: "image",
			multiple: itool.options.multiple,
			maximum: itool.options.multiple ? parseInt(itool.options.maxPicsCount) : 1,
			system: false,
			onmaxed: function() {
				toast('最多选择' + itool.options.maxPicsCount + '张图片');
			}
		});
	};
	
	/**
	 * 设置批量上传时，阻止继续上传
	 */
	function setBlockUpload(blockUpload){
		com.setBlockUpload(blockUpload);
	}

	var endReturn = [];

	/**
	 * 执行压缩并上传
	 * @param {Object} files
	 * @param {Object} cb
	 * @param {Object} itemCb
	 */
	function processing_imgs(files, cb, itemCb) {
		if(itemCb) itool.options.itemCb = itemCb;
		setBlockUpload(false);
		plus.nativeUI.closeWaiting();
		plus.nativeUI.showWaiting('');
		if (typeof(files) === "string") {
			files = [files];
		}
		console.log(JSON.stringify(files));
		com.myasync(files, processing_img, function() {
			plus.nativeUI.closeWaiting();
			//end
			console.log("end");
			cb && cb(false, endReturn);
		});
	};
	/**
	 * @description 压缩并上传图片单独拎出来，拍照也可用到
	 * @param {Object} pic
	 * @param {Object} next
	 */
	function processing_img(pic, next) {
		console.log(pic);
		if (pic) {
			//是否需要剪裁
			if (itool.options.isClip) {
				clip_img(pic, next);
			}else{
				//是否需要压缩
				if (itool.options.isZoom) {
					zoomImage(pic, function(err, p) {
						processing_img_x(p, next);
					});
				} else {
					processing_img_x(pic, next);
				}
			}
		}
	};
	
	function clip_img(pth, next){
		if(plus.os.name == 'iOS'){
			function getImgPath(e){
                 
                 var isCancel = imageCutTools.plusGetAttribute('isCancel');
                 if (isCancel == "ture") {
                  toast("取消上传");
                  plus.nativeUI.closeWaiting();

                 } else {
                    var imgPath = "file://" + imageCutTools.plusGetAttribute('path');
                 
                    //是否需要压缩
                    if (itool.options.isZoom) {
                        zoomImage(imgPath, function(err, p) {
                           processing_img_x(p, next);
                           });
                    } else {
                        processing_img_x(imgPath, next);
                    }
                 }
            }
			
			var delegate = plus.ios.implements("ImageCutToolsDelegate",{"returnImagePath:":getImgPath});
            var imageCutTools = plus.ios.newObject("ImageCutTools");
             imageCutTools.plusSetAttribute("delegate", delegate);
             imageCutTools.plusSetAttribute("oriImgPath",plus.io.convertLocalFileSystemURL(pth));
             plus.ios.invoke(imageCutTools, "getCropImg");
		}else{
			var main = plus.android.runtimeMainActivity();
			var Crop;
			try{
				Crop = plus.android.importClass("com.app.common.crop.Crop");
			}catch(e){
				console.log(JSON.stringify(e));
			}
			if (!Crop) { // HBuilder运行跳过裁剪
				console.log("HBuilder运行跳过裁剪");
				//是否需要压缩
				if (itool.options.isZoom) {
					zoomImage(pth, function(err, p) {
						processing_img_x(p, next);
					});
				} else {
					processing_img_x(pth, next);
				}
			} else {
				var File = plus.android.importClass("java.io.File");
		        var Uri = plus.android.importClass("android.net.Uri");
		        var outPutDir = plus.io.convertLocalFileSystemURL("_photos/");
		        var fileDir = new File(outPutDir);
		        if(!fileDir.exists()){
		        	fileDir.mkdirs();
		        }
		        var outPutPath = plus.io.convertLocalFileSystemURL("_photos/" + new Date().getTime() + ".jpg");
				var file = new File(outPutPath);
				console.log("file.exist: " + file.exists());
				var outPutUri = Uri.fromFile(file);
				var imgFile = new File(plus.io.convertLocalFileSystemURL(pth));
				var imgUri = Uri.fromFile(imgFile);
				new Crop(imgUri).output(outPutUri).withWidth(500).start(main);
				console.log("pth: " + plus.io.convertLocalFileSystemURL(pth));
				console.log("outPutPath: " + outPutPath);
				main.onActivityResult = function(requestCode, resultCode, data) {
					console.log("requestCode: " + requestCode);
					console.log("resultCode: " + resultCode);
					console.log("Crop.REQUEST_CROP: " + Crop.REQUEST_CROP);
					var file = new File(outPutPath);
					console.log("file.exist: " + file.exists());
					//outPutPath = "file://" + outPutPath;
					console.log("outPutPath: " + outPutPath);
					if(requestCode == Crop.REQUEST_CROP && resultCode == Crop.RESULT_CROP){
						//是否需要压缩
						if (itool.options.isZoom) {
							zoomImage(outPutPath, function(err, p) {
								processing_img_x(p, next);
							});
						} else {
							processing_img_x(outPutPath, next);
						}
					}else if(requestCode == Crop.REQUEST_CROP && resultCode == Crop.RESULT_CANCEL){
						toast("取消上传");
						plus.nativeUI.closeWaiting();
					}
				}
			}
		}
	}

	function processing_img_x(pic, next) {
		if (itool.options.isUpload) {
			imgUploadCom(pic, function(err, imgUrl, localPath) {
				endReturn.push({
					error: err,
					imgUrl: imgUrl,
					localPath: localPath
				});
				next();
			});
		} else {
			endReturn.push({
				imgUrl: pic
			});
			next();
		}
	}
	/**
	 * @description 上传图片带参数 
	 * @param {Object} path
	 * @param {Object} cb
	 */
	function imgUploadCom(path, cb) {
		var task = plus.uploader.createUpload(uploadHost + itool.options.uploadUrl, {
			method: "POST",
			timeout: 8,  //上传任务超时时间（s）
			retry: 0,  //上传任务重试次数
			retryInterval: 1 //上传任务重试间隔时间
		}, function(t, status) {
			console.log("t.responseText" + t.responseText);
			console.log(status);
			if (status == 200 && t.responseText && t.responseText.indexOf("data") >= 0) {
				var data = JSON.parse(t.responseText);
				//上传成功后后台返回的数据格式规范为{code:200,url:'网络链接'}
				if (data && data.statusCode == 0) {
					var imgurl = itool.options.isBankCard ? data.data : data.data.fileUrl;
					itool.options.itemCb && itool.options.itemCb(imgurl, path, data.data.fileSize);
					cb && cb(false, imgurl, path);
					return;
				} else {
					itool.options.itemCb && itool.options.itemCb(null, path);
					cb && cb(data.message);
				}
			}else if (t.responseText && t.responseText.indexOf("message") >= 0) {
				if(!itool.options.multiple) toast(JSON.parse(t.responseText).message);
				itool.options.itemCb && itool.options.itemCb(null, path);
				cb && cb('上传失败！');
			} else {
				if(!itool.options.multiple) toast("上传失败 , 请重试");
				itool.options.itemCb && itool.options.itemCb(null, path);
				cb && cb('上传失败！');
			}
		});
		task.addFile(path, {
			key: "qqfile"
		});
		//添加上传的其他参数
		itool.setUploadData(task);
		task.start();
	}
	/**
	 * @description 缩放图片
	 * @param {Object} pth 图片本地路径
	 * @param {Object} cb 
	 */
	function zoomImage(pth, cb) {
		//Android判断图片旋转
		var rotate = 0;
		if(plus.os.name == 'Android'){
			try{
				var Utils = plus.android.importClass("com.app.yunma.common.Utils");
				rotate = Utils.getExifOrientation(pth);
				console.log("图片旋转角度=========>" + rotate);
			}catch(e){
				JSON.stringify(e);
			}
		}
		//不覆盖原图
		var newImgSrc = "_downloads/" + (+new Date()) + pth.substr(pth.lastIndexOf('.'));
		var conf = {
			src: pth,
			dst: newImgSrc,
			//dst:pth,
			//overwrite:true,
			quality: itool.options.ZoomQuality,
			rotate: rotate
		};
		//iOS HEIC 转换成 png
		if(pth.indexOf("HEIC") >= 0) {
			conf.dst = newImgSrc.replace("HEIC", "png");
			conf.format = "png";
			conf.overwrite = true;
		}
		//不再判断横图和竖图
		conf['width'] = itool.options.ZoomBox + 'px';
		plus.zip.compressImage(conf, function(data) {
			cb(false, data.target);
		}, function(err) {
			cb(err.message, pth);
		});
	};
	/**
	 * @description 手机拍照并压缩(上传)
	 * @param {Object} cb(err,files)
	 * @param {Object} err
	 */
	function camera(cb, itemCb, isClip, isClipCamera, group, cameraType, isBankCard, uploadType) {
		itool.options.group = group;
		itool.options.uploadType = uploadType;
		itool.options.itemCb = itemCb;
		itool.options.isBankCard = isBankCard;
		if(isBankCard){
			itool.options.uploadUrl = "/common/ocr/bankcard";
		}
		if(isClip){
			itool.options.isClip = isClip;
		}else{
			itool.options.isClip = false;
		}
		//判断Android是否禁用权限
		if(!checkUserPermission("CAMERA", null, function(){
			camera(cb, itemCb, isClip, isClipCamera, group, cameraType, isBankCard, uploadType);
		})){return}
		//重置 拍照无用，重置不要占内存
		endReturn = [];
		//自定义线框拍照
		if(isClipCamera){
			var prompt = "";
			if(cameraType == "front") {
				prompt = "将身份证国徽页置于此区域，并对齐扫描框边缘"
			} else if(cameraType == "back"){
				prompt = "将身份证头像页置于此区域，并对齐扫描框边缘"
			} else {
				prompt = "将银行卡正面置于此区域，并对齐扫描框边缘"
			}
			if(plus.os.name == 'Android'){
				var main = plus.android.runtimeMainActivity();
				var ClipCamera = plus.android.importClass("com.app.yunma.crop.ClipCamera");
				var Intent = plus.android.importClass("android.content.Intent");
				ClipCamera.startClipCamera(main, prompt);
				main.onActivityResult = function(requestCode, resultCode, data) {
					console.log("requestCode: " + requestCode);
					console.log("resultCode: " + resultCode);
					if(requestCode == 1002 && resultCode == 1002){
						var picPath = "file://" + data.getStringExtra("picPath");
						console.log("picPath: " + picPath);
						processing_imgs(picPath, cb);
					}
				}
			}else{
				var NativeJsTool = plus.ios.importClass("NativeJsTool");
				var nativeJsTool = plus.ios.newObject("NativeJsTool");
				function getImgPath(e) {
					var picPath =  "file://" + plus.ios.invoke(nativeJsTool, "getIdCardImgPath");
					outputLog("picPath" + picPath);
					//身份证拍照不需要压缩 压缩之后无法上传
					itool.options.isZoom = false;
					processing_imgs(picPath, cb);
				}
				var delegate = plus.ios.implements("NativeJsToolDelegate", {"getCardImageFile:": getImgPath});
				nativeJsTool.plusSetAttribute("delegate", delegate);
				plus.ios.invoke(nativeJsTool, "openCameraToolVC:", prompt);
			}
			return;
		}
		//普通拍照
		var cmr = plus.camera.getCamera();
		cmr.captureImage(function(p) {
			plus.io.resolveLocalFileSystemURL(p, function(entry) {
				//妈蛋 entry.fullPath 有坑，在ios上获取不到
				var u = entry.toLocalURL();
				console.log("entry.toLocalURL: " + u);
				processing_imgs(u, cb);
			}, function(err) {
				console.log("读取拍照文件错误：" + err.message);
				toast("读取拍照文件错误 , 请重试");
				cb && cb(err.message);
			});
		}, function(err) {
			//未测拍照权限 err.code
			console.log("失败：" + err.code + err.message);
			if(plus.os.name == 'Android' && err.message == 'null'){
				toast("请在设置中允许使用相机");
			}
			cb && cb(err.message);
		}, {
			filename: "_doc/camera/",
			index: 1
		});
	};

	/**
	 * @description 打开相册失败，请求系统权限
	 * @param {Error} e
	 */
	function sys_permission(e) {
		if (plus.os.name == "iOS") {
			if (e.code == 8) {
				checkUserPermission("GALLERY");
			}
		} else if (plus.os.name == "Android") {
			if (e.code != 12) {
				mui.alert("您的相册权限未打开，请在应用列表中找到您的程序，将您的权限打开", function() {
					var android = plus.android.importClass('com.android.settings');
					var main = plus.android.runtimeMainActivity();
					var Intent = plus.android.importClass("android.content.Intent");
					var mIntent = new Intent('android.settings.APPLICATION_SETTINGS');
					main.startActivity(mIntent);
				});
			}
		}
	};
	itool.galleryImgs = galleryImgs;
	itool.imgUpload = imgUploadCom;
	itool.zoomImage = zoomImage;
	itool.camera = camera;
	itool.processing_imgs = processing_imgs;
	itool.setBlockUpload = setBlockUpload;
	return itool;
})(mui, common);