//网络请求码
var DO_DEL = 1001;
//iscroll
var myScroll;
var isLoadingMore;
var isNoMore;
var startIndex = 0, urlIndex = 0;
//Vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		identity: 1, //身份 1家长 2老师
		userId: null, //当前用户ID
		album: {},
		photos: [], //接口返回的所有照片
		showPhotos: [], //分页显示的照片
		showNum: 0,
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault()
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听照片更新
			window.addEventListener("onPhotoUpdate", function(event){
				vueObj.album = event.detail.album;
				var photos = event.detail.photos;
				vueObj.filterData(photos);
			});
			//参数
			vueObj.userId = getCache(USER_ID_KEY);
			vueObj.identity = getUserInfo().identityType;
			vueObj.album = plus.webview.currentWebview().album;
			if(vueObj.album.name) document.getElementById("title").innerText = vueObj.album.name;
			//过滤照片
			var photos = plus.webview.currentWebview().photos;
			vueObj.filterData(photos);
		});
	},
	methods: {
		/**
		 * 过滤照片数据
		 */
		filterData: function(photos){
			vueObj.showNum = 0;
			if(vueObj.identity == 2){ //如果为老师，可编辑所有照片
				vueObj.photos = photos;
				vueObj.showNum = vueObj.album.photoNum
			}else{ //如果为家长，只能编辑自己上传照片		 		
				vueObj.photos = [];
				for(var i=0; i<photos.length; i++){
					if(photos[i].createId == vueObj.userId){
						vueObj.photos.push(photos[i]);
						vueObj.showNum += photos[i].num;
					}
				}
			}
			//构造参数
			vueObj.showPhotos = [];
			startIndex = 0;
			urlIndex = 0;
			vueObj.loadData();
			if(vueObj.showNum <= 0){
				toast("当前没有您可操作的图片，请上传图片");
			}
		},
		/**
		 * 加载列表数据
		 */
		loadData: function(){
			var loadNum = 0;
			for(var i = startIndex; i < vueObj.photos.length; i++){
				if(i < vueObj.showPhotos.length){
					item = vueObj.showPhotos[i];
				}else{
					item = {};
					item.strPhotoDate = vueObj.photos[i].strPhotoDate;
					item.createName = vueObj.photos[i].createName;
					item.num = vueObj.photos[i].num;
					item.selectNum = 0;
					item.urlList = [];
					item.flagList = [];
				}
				var j;
				for(j = urlIndex; j < vueObj.photos[i].urlList.length; j++){
					urlIndex = j + 1;
					item.urlList.push(vueObj.photos[i].urlList[j]);
					item.flagList.push({select:false, id:vueObj.photos[i].idList[j]});
					loadNum++;
					if(loadNum >= 30) break;
				}
				Vue.set(vueObj.showPhotos, i, item);
				if(j >= vueObj.photos[i].urlList.length){
					urlIndex = 0;
					startIndex = i + 1;
				}
				if(loadNum >= 30) break;
			}
			closePullStatus(loadNum);
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			myScroll.refresh();
			switch(requestCode) {
			case DO_DEL: //删除成功
				toast("删除成功");
				//刷新列表页
				mui.fire(plus.webview.getWebviewById(getCache("albumHomeId")), "onAlbumCreateSuccess", {});
				mui.fire(plus.webview.getWebviewById("albumDetail"), "onPhotoUploadSuccess", {album:vueObj.album});
				//关闭页面
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
			myScroll.refresh();
		},
		/**
		 * 按钮点击事件
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'upload': //上传按钮
				//上传页必须由main来打开，不然返回到上级，上传页会被关闭
				mui.fire(plus.webview.getWebviewById("main"), "openAlbumUpload", {album:vueObj.album});
				break;
			case 'itemClick': //图片点击
				var index = e.currentTarget.dataset.index;
				var urlIndex = e.currentTarget.dataset.urlIndex;
				vueObj.showPhotos[index].flagList[urlIndex].select = !vueObj.showPhotos[index].flagList[urlIndex].select;
				if(vueObj.showPhotos[index].flagList[urlIndex].select){
					vueObj.showPhotos[index].selectNum++;
				}else{
					vueObj.showPhotos[index].selectNum--;
				}
				break;
			case 'select': //选择/取消选择
				var index = e.currentTarget.dataset.index;
				var item = vueObj.showPhotos[index];
				if(item.selectNum == item.num){ //取消选择
					item.selectNum = 0;
					for(var i=0; i<item.flagList.length; i++){
						item.flagList[i].select = false;
					}
				}else{ //选择
					item.selectNum = item.num;
					for(var i=0; i<item.flagList.length; i++){
						item.flagList[i].select = true;
					}
				}
				break;
			default:
				break;
			}
		},
		/**
		 * 获取显示的url
		 */
		getShowUrl: function(url){
			return getAlbumShowUrl(url);
		}
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
	
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', null, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(loadNum) {
	if(loadNum < 30) {
		document.getElementById("item0mobileSpan").innerHTML = "没有更多数据了";
		isNoMore = true;
	} else {
		document.getElementById("item0mobileSpan").innerHTML = "正在加载...";
		isNoMore = false;
	}
	isLoadingMore = false;
	//小于9
	if(vueObj.showNum < 9){
		document.getElementById("item0mobileSpan").style.display = "none";
	}else{
		document.getElementById("item0mobileSpan").style.display = "block";
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}

//删除按钮监听
document.getElementById("delBtn").addEventListener("tap", function(e){
	var delIds = [];
	for(var i=0; i<vueObj.showPhotos.length; i++){
		for(var j=0; j<vueObj.showPhotos[i].flagList.length; j++){
			if(vueObj.showPhotos[i].flagList[j].select){
				delIds.push(vueObj.showPhotos[i].flagList[j].id);
			}
		}
	}
	if(delIds.length <= 0){
		toast("请选择要删除的图片");
		return;
	}
	confirmDialog("", "确定要删除选中的图片吗？", "确定", "取消", function(){
		showWaiting();
		webCall2("/kt/album/photo/delete", {
			photoIds: delIds.join(",")
		}, DO_DEL, vueObj.onSuccess, vueObj.onErrorBefore);
	});
});