//网络请求码
var DO_SUBMIT = 1001, QUERY_TYPES = 1002;
//Vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		types: [],
		typeBtns: [],
		name: null, //相册标题
		description: null, //相册描述
		defaultTypeCode: null, //相册分类
		typeCode: null, //相册分类
		typeName: null, //相册分类
		classId: null, //班级编码
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault()
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置滚动
			mui('.mui-scroll-wrapper').scroll();
			vueObj.defaultTypeCode = plus.webview.currentWebview().typeCode;
			vueObj.classId = plus.webview.currentWebview().classId;
			//查询类型和班级数据
			var params = {classId: vueObj.classId};
			if(getUserInfo().identityType == 1){ //只要家长需要传
				params.identity = 1;
			}
			webCall2("/kt/album/getType", params, QUERY_TYPES, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_TYPES: //相册分类
				vueObj.types = data.rows;
				vueObj.typeBtns = [];
				for(var i in vueObj.types){
					var btn = {id:vueObj.types[i].code, title:vueObj.types[i].name}
					vueObj.typeBtns.push(btn);
					if(vueObj.types[i].code == vueObj.defaultTypeCode){
						vueObj.typeCode = vueObj.types[i].code;
						vueObj.typeName = vueObj.types[i].name;
					}
				}
				//默认展示第一个分类
				if(!vueObj.typeCode && vueObj.types.length > 0){
					vueObj.typeCode = vueObj.types[0].code;
					vueObj.typeName = vueObj.types[0].name;
				}
				break;
			case DO_SUBMIT: //获取数据
				toast("相册创建成功");
				//刷新列表页
				mui.fire(plus.webview.getWebviewById(getCache("albumHomeId")), "onAlbumCreateSuccess", {});
				mui.fire(plus.webview.getWebviewById("albumSelect"), "onAlbumCreateSuccess", {});
				//关闭页面
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 按钮点击事件
		 */
		onButtonClick: function(e) {
			document.activeElement.blur();
			switch (e.currentTarget.dataset.type){
			case 'type': //类型选择
				if(vueObj.types.length <= 0) return;
				plus.nativeUI.actionSheet({
					title: "请选择相册分类",
					cancel: "取消",
					buttons: vueObj.typeBtns
				}, function(e){
					if(e.index <= 0) return;
					vueObj.typeCode = vueObj.types[e.index-1].code;
					vueObj.typeName = vueObj.types[e.index-1].name;
				});
				break;
			case 'create': //创建相册
				if(!vueObj.name){
					toast("请输入相册标题")
					return;
				}
				if(!vueObj.name.length > 25){
					toast("相册标题最多支持25个字符")
					return;
				}
				if(!vueObj.typeCode){
					toast("请选择相册分类")
					return;
				}
				if(!vueObj.classId){
					toast("请选择所属班级")
					return;
				}
				showWaiting();
				webCall2("/kt/album/create", {
					name: vueObj.name,
					description: vueObj.description?vueObj.description:'',
					typeCode: vueObj.typeCode,
					classId: vueObj.classId
				}, DO_SUBMIT, vueObj.onSuccess, vueObj.onErrorBefore);
				break;
			default:
				break;
			}
		}
	}
});