//网络请求码
var QUERY_DETAIL = 1001;
//iscroll
var myScroll;
var isLoadingMore;
var isNoMore;
var startIndex = 0, urlIndex = 0;
//Vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		opeType: null, //操作类型 select选择图片
		album: {},
		photos: [], //接口返回的所有照片
		showPhotos: [], //分页显示的照片
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault()
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听图片上传更新
			window.addEventListener("onPhotoUploadSuccess", function(event){
				var album = event.detail.album;
				if(album && album.id == vueObj.album.id){
					webCall2("/kt/album/detail", {albumId: vueObj.album.id}, QUERY_DETAIL, vueObj.onSuccess, vueObj.onErrorBefore)
				}
			});
			//相册编辑更新
			window.addEventListener("onAlbumCreateSuccess", function(event){
				vueObj.album = event.detail.album;
				document.getElementById("title").innerText = vueObj.album.name;
			});
			//参数
			vueObj.opeType = plus.webview.currentWebview().opeType;
			vueObj.album = plus.webview.currentWebview().album;
			//只有相册详情且为老师或为自己创建的相册才可编辑
			if(!vueObj.opeType && (getUserInfo().identityType == 2 || (vueObj.album.identity != 2 && getUserInfo().identityType != 2 && vueObj.album.createId == getCache(USER_ID_KEY)))) {
				document.getElementById("editBtn").style.display = "block";
			}
			if(vueObj.album.name) document.getElementById("title").innerText = vueObj.album.name;
			//查询详情
			showWaiting();
			webCall2("/kt/album/detail", {albumId: vueObj.album.id}, QUERY_DETAIL, vueObj.onSuccess, vueObj.onErrorBefore)
		});
	},
	methods: {
		/**
		 * 加载列表数据
		 */
		loadData: function(){
			var loadNum = 0;
			for(var i = startIndex; i < vueObj.photos.length; i++){
				if(i < vueObj.showPhotos.length){
					item = vueObj.showPhotos[i];
				}else{
					item = {};
					item.strPhotoDate = vueObj.photos[i].strPhotoDate;
					item.createName = vueObj.photos[i].createName;
					item.num = vueObj.photos[i].num;
					item.urlList = [];
				}
				var j;
				for(j = urlIndex; j < vueObj.photos[i].urlList.length; j++){
					urlIndex = j + 1;
					item.urlList.push(vueObj.photos[i].urlList[j]);
					loadNum++;
					if(loadNum >= 30) break;
				}
				Vue.set(vueObj.showPhotos, i, item);
				if(j >= vueObj.photos[i].urlList.length){
					urlIndex = 0;
					startIndex = i + 1;
				}
				if(loadNum >= 30) break;
			}
			closePullStatus(loadNum);
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			myScroll.refresh();
			switch(requestCode) {
			case QUERY_DETAIL: //详情数据
				vueObj.album = data.data;
				document.getElementById("title").innerText = vueObj.album.name;
				vueObj.photos = data.rows;
				vueObj.showPhotos = [];
				//开始分页展示数据
				startIndex = 0;
				urlIndex = 0;
				vueObj.loadData();
				//数据有更新，通知批量操作页面
				mui.fire(plus.webview.getWebviewById("albumBatch"), "onPhotoUpdate", {
					album: vueObj.album,
					photos: vueObj.photos
				});
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
			myScroll.refresh();
		},
		/**
		 * 按钮点击事件
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'upload': //上传按钮
				//上传页必须由main来打开，不然返回到上级，上传页会被关闭
				mui.fire(plus.webview.getWebviewById("main"), "openAlbumUpload", {album:vueObj.album});
				break;
			case 'itemClick': //图片点击
				if(vueObj.opeType == 'select'){
					var url = e.currentTarget.dataset.url;
					mui.fire(plus.webview.currentWebview().opener(), "onPhotoSelect", {url:url});
					mui.back();
					return;
				}
				//查看图片详情
				var index = e.currentTarget.dataset.index;
				var urlIndex = e.currentTarget.dataset.urlIndex;
				openWindow("albumPhotoDetail", "../album/album_photo_detail.html", false, {
					statusBarType:STATUS_BAR_DEFAULT_KEY,
					album: vueObj.album,
					photoDate: vueObj.photos[index].photoDate,
					createId: vueObj.photos[index].createId,
					urlIndex: urlIndex
				});
				break;
			case 'batch': //批量操作
				openWindow("albumBatch", "../album/album_batch.html", false, {
					statusBarType:STATUS_BAR_DEFAULT_KEY,
					album: vueObj.album,
					photos: vueObj.photos
				});
				break;
			default:
				break;
			}
		},
		/**
		 * 获取显示的url
		 */
		getShowUrl: function(url){
			return getAlbumShowUrl(url);
		}
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
	
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', null, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(loadNum) {
	if(loadNum < 30) {
		document.getElementById("item0mobileSpan").innerHTML = "没有更多数据了";
		isNoMore = true;
	} else {
		document.getElementById("item0mobileSpan").innerHTML = "正在加载...";
		isNoMore = false;
	}
	isLoadingMore = false;
	//小于9
	if(vueObj.album.photoNum < 9){
		document.getElementById("item0mobileSpan").style.display = "none";
	}else{
		document.getElementById("item0mobileSpan").style.display = "block";
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}

//编辑按钮监听
document.getElementById("editBtn").addEventListener("tap", function(e){
	openWindow("albumEdit", "../album/album_edit.html", false, {
		statusBarType:STATUS_BAR_DEFAULT_KEY,
		album: vueObj.album
	});
});