//网络请求码
var DO_DEL = 1001, QUERY_TYPES = 1002, DO_SAVE = 1003;
//Vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		album: {},
		types: [],
		typeBtns: [],
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault()
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置滚动
			mui('.mui-scroll-wrapper').scroll();
			//监听封面选择返回
			window.addEventListener("onPhotoSelect", function(event){
				Vue.set(vueObj.album, "coverUrl", event.detail.url)
			});
			//参数
			vueObj.album = plus.webview.currentWebview().album;
			//查询类型和班级数据
			var params = {classId: vueObj.album.classId};
			if(getUserInfo().identityType == 1){ //只要家长需要传
				params.identity = 1;
			}
			webCall2("/kt/album/getType", params, QUERY_TYPES, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_TYPES: //相册分类
				vueObj.types = data.rows;
				vueObj.typeBtns = [];
				for(var i in vueObj.types){
					var btn = {id:vueObj.types[i].code, title:vueObj.types[i].name}
					vueObj.typeBtns.push(btn);
				}
				break;
			case DO_SAVE: //编辑相册
				toast("相册编辑成功");
				//刷新列表页
				mui.fire(plus.webview.getWebviewById(getCache("albumHomeId")), "onAlbumCreateSuccess", {});
				mui.fire(plus.webview.getWebviewById("albumDetail"), "onAlbumCreateSuccess", {album:vueObj.album});
				//关闭页面
				mui.back();
				break;
			case DO_DEL: //删除相册
				toast("相册删除成功");
				//刷新列表页
				mui.fire(plus.webview.getWebviewById(getCache("albumHomeId")), "onAlbumCreateSuccess", {});
				mui.fire(plus.webview.getWebviewById("albumUpload"), "onAlbumDelete", {album:vueObj.album});
				closeWebview("albumDetail");
				//关闭页面
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 按钮点击事件
		 */
		onButtonClick: function(e) {
			document.activeElement.blur();
			switch (e.currentTarget.dataset.type){
			case 'cover': //更换封面
				openWindow("albumDetailSelect", "../album/album_detail.html", false, {
					statusBarType:STATUS_BAR_DEFAULT_KEY,
					album: vueObj.album,
					opeType: 'select'
				});
				break;
			case 'type': //相册分类
				if(vueObj.types.length <= 0) return;
				plus.nativeUI.actionSheet({
					title: "请选择相册分类",
					cancel: "取消",
					buttons: vueObj.typeBtns
				}, function(e){
					if(e.index <= 0) return;
					vueObj.album.typeCode = vueObj.types[e.index-1].code;
					vueObj.album.typeCodeName = vueObj.types[e.index-1].name;
				});
				break;
			case 'top': //置顶
				if(vueObj.album.isTop == 0){
					vueObj.album.isTop = 1;
				}else{
					vueObj.album.isTop = 0;
				}
				break;
			case 'del': //删除相册
				confirmDialog("", "确认要删除该相册吗？", "确定", "取消", function(){
					showWaiting();
					webCall2("/kt/album/delete", {
						albumId: vueObj.album.id
					}, DO_DEL, vueObj.onSuccess, vueObj.onErrorBefore);
				});
				break;
			default:
				break;
			}
		},
		/**
		 * 获取显示的url
		 */
		getShowUrl: function(url){
			return getAlbumShowUrl(url);
		}
	}
});

//保存按钮监听
document.getElementById("saveBtn").addEventListener("tap", function(e){
	if(!vueObj.album.name){
		toast("请输入相册标题")
		return;
	}
	if(!vueObj.album.name.length > 25){
		toast("相册标题最多支持25个字符")
		return;
	}
	if(!vueObj.album.typeCode){
		toast("请选择相册分类")
		return;
	}
	showWaiting();
	webCall2("/kt/album/modify", {
		albumId: vueObj.album.id,
		name: vueObj.album.name,
		description: vueObj.album.description?vueObj.album.description:'',
		typeCode: vueObj.album.typeCode,
		classId: vueObj.album.classId,
		isTop: vueObj.album.isTop,
		coverUrl: vueObj.album.coverUrl
	}, DO_SAVE, vueObj.onSuccess, vueObj.onErrorBefore);
});