//网络请求码
var QUERY_CLASS_TYPE = 1001;
//Vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		classes: [],
		types: [],
		datas: [],
		classId: null,
		lastClassIndex: -1,
		sliderIndex: 0, //页面索引
		searchTime: null,
		searchName: null,
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault()
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听相册创建
			window.addEventListener("onAlbumCreateSuccess", function(event){
				var index = vueObj.lastClassIndex;
				vueObj.lastClassIndex = -1;
				vueObj.exchangeClass(index);
			});
			//监听图片上传
			window.addEventListener("onPhotoUploadListener", function(event){
				var uploadStatus = event.detail.uploadStatus;
				document.getElementById("uploadIcon").style.display = "none";
				if(uploadStatus == 2){ //开始上传
					document.getElementById("uploadIcon").style.display = "block";
				}else if(uploadStatus == 3){ //上传结束
					var index = vueObj.lastClassIndex;
					vueObj.lastClassIndex = -1;
					vueObj.exchangeClass(index);
				}
			});
			mui.fire(plus.webview.getWebviewById("albumUpload"), "onAlbumClose", {});
			//缓存相册首页webviewid
			setCache("albumHomeId", plus.webview.currentWebview().id);
			//处理slider高度
			vueObj.handleSliderBar();
			//加载类型
			if(getUserInfo().identityType == 1 || getUserInfo().identityType == 2){				
				showWaiting();
				vueObj.loadClassType();
			}else{
				confirmDialog("", "你还未绑定默认身份，是否去绑定？或切换已有身份为默认身份?", "去切换", "去绑定", function(){
					mui.back();
				}, function(){
					openWindow("selectSchool", "../login/select_school.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType,
						from: 'student'
					});
					closeWebview(getCache("albumHomeId"));
				});
			}
		});
	},
	methods: {
		/**
		 * 加载班级和类型
		 */
		loadClassType: function(){
			webCall2("/kt/album/getClassType", null, QUERY_CLASS_TYPE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 加载列表
		 */
		loadList: function(typeCode){
			showWaiting();
			var params = {classId: vueObj.classId, offset: 0, limit: 10000};
			if(typeCode > 0) params.typeCode = typeCode;
			if(vueObj.searchName) params.name = vueObj.searchName;
			webCall2("/kt/album/query", params, typeCode, vueObj.onSuccess, vueObj.onErrorBefore)
		},
		/**
		 * 切换班级
		 */
		exchangeClass: function(index){
			if(index == vueObj.lastClassIndex) return;
			mui.fire(plus.webview.getWebviewById("albumUpload"), "onAlbumClose", {});
			vueObj.lastClassIndex = index;
			var cls = vueObj.classes[index];
			document.getElementById("nowClass").innerText = cls.name;
			vueObj.classId = cls.classId;
			vueObj.types = cls.types;
			vueObj.datas = [];
			Vue.nextTick(function() {
				//清空所有数据，加载第一个列表
				vueObj.loadList(vueObj.types[0].code);
				//slider滑动到第1项
				mui('.mui-slider').slider().gotoItem(0, 0);
				mui('.mui-scroll-wrapper').scroll();
			});
		},
		/**
		 * 搜索框输入监听
		 */
		onSearchInput: function(e){
			console.error(e.currentTarget.value)
			vueObj.searchName = e.currentTarget.value;
			if(vueObj.searchTime) clearTimeout(vueObj.searchTime);
			setTimeout(function(){
				vueObj.datas = [];
				vueObj.loadList(vueObj.types[vueObj.sliderIndex].code);
			}, 800);
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_CLASS_TYPE: //获取班级类别数据
				vueObj.classes = data.rows;
				document.getElementById("exchangeIcon").style.display = "none";
				if(vueObj.classes.length <= 0) return;
				if(vueObj.classes.length > 1){
					document.getElementById("exchangeIcon").style.display = "inline-block";
				}
				for(var i in vueObj.classes){
					vueObj.classes[i].types.unshift({ "name": "全部", "code": -1 });
				}
				vueObj.exchangeClass(0);
				break;
			default:
				for(var i in vueObj.types){
					if(vueObj.types[i].code == requestCode){
						Vue.set(vueObj.datas, i, data.rows);
						break;
					}
				}
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 标签滑动事件
		 */
		onSliderChange: function(e) {
			document.activeElement.blur();
			vueObj.sliderIndex = e.detail.slideNumber;
			closeWaiting();
			if(vueObj.datas[vueObj.sliderIndex] && vueObj.datas[vueObj.sliderIndex].length > 0) return; // 如果有数据，则不发起请求
			vueObj.loadList(vueObj.types[vueObj.sliderIndex].code);
		},
		/**
		 * 按钮点击事件
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'create': //新建相册
				openWindow("albumCreate", "../album/album_create.html", false, {
					statusBarType:STATUS_BAR_DEFAULT_KEY,
					classId: vueObj.classId,
					typeCode: vueObj.sliderIndex > 0 ? (vueObj.types[vueObj.sliderIndex].code) :''
				});
				break;
			case 'itemClick': //相册点击
				var index = e.currentTarget.dataset.index;
				var typeIndex = e.currentTarget.dataset.typeIndex;
				var album = vueObj.datas[typeIndex][index];
				openWindow("albumDetail", "../album/album_detail.html", false, {
					statusBarType:STATUS_BAR_DEFAULT_KEY,
					album: album
				});
				break;
			default:
				break;
			}
		},
		/**
		 * 获取显示的url
		 */
		getShowUrl: function(url){
			return getAlbumShowUrl(url);
		},
		handleSliderBar: function() {
			var immersed = 0;
			var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
			if(ms && ms.length >= 3) {
				immersed = parseFloat(ms[2]);
			}
			if(!immersed) {
				return;
			}
			document.getElementById("slider").style.top = 110 + immersed + 'px';
		}
	}
});

//标题点击
document.getElementById("topTitle").addEventListener("tap", function(e){
	if(vueObj.classes.length <= 1){
		return;
	}
	var classBtns = [];
	for(var i in vueObj.classes){
		classBtns.push({id:vueObj.classes[i].classId, title:vueObj.classes[i].name})
	}
	plus.nativeUI.actionSheet({
		title: "请选择班级",
		cancel: "取消",
		buttons: classBtns
	}, function(e){
		if(e.index <= 0) return;
		vueObj.exchangeClass(e.index - 1);
	});
});

//上传按钮点击
document.getElementById("uploadIcon").addEventListener("tap", function(e){
	//上传页必须由main来打开，不然返回到上级，上传页会被关闭
	mui.fire(plus.webview.getWebviewById("main"), "openAlbumUpload", {});
});