//网络请求码
var QUERY_LIST = 1001;
//Vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		classId: null,
		albums: [],
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault()
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听相册创建
			window.addEventListener("onAlbumCreateSuccess", function(event){
				vueObj.loadData();
			});
			//设置滚动
			mui('.mui-scroll-wrapper').scroll();
			//查询数据
			vueObj.classId = plus.webview.currentWebview().album.classId;
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			showWaiting();
			var params = {classId: vueObj.classId, offset: 0, limit: 10000};
			webCall2("/kt/album/query", params, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore)
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_LIST: //获取数据
				vueObj.albums = data.rows;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 按钮点击事件
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'create': //新建相册
				openWindow("albumCreate", "../album/album_create.html", false, {
					statusBarType:STATUS_BAR_DEFAULT_KEY,
					classId: vueObj.classId
				});
				break;
			case 'itemClick': //相册点击
				var index = e.currentTarget.dataset.index;
				var album = vueObj.albums[index];
				mui.fire(plus.webview.currentWebview().opener(), "onAlbumSelect", {album:album});
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 获取显示的url
		 */
		getShowUrl: function(url){
			return getAlbumShowUrl(url);
		}
	}
});