//网络请求码
var DO_SUBMIT = 1001, QUERY_DETAIL = 1002;
//Vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		uploadStatus: 1, //上传中状态 1等待上传 2上传中 3上传结束
		album: {},
		files: [],
		failFiles: [], //上传失败的图片地址
		description: null,
		submitNum: 0, //保存成功张数
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault()
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//相册选择返回
			window.addEventListener("onAlbumSelect", function(event){
				vueObj.album = event.detail.album;
			});
			//相册删除
			window.addEventListener("onAlbumDelete", function(event){
				var album = event.detail.album;
				if(album && album.id == vueObj.album.id){
					oldBack();
				}
			});
			//关闭页面
			window.addEventListener("onAlbumClose", function(event){
				if(vueObj.uploadStatus != 2){
					oldBack();
				}
			});
			//相册更新
			window.addEventListener("onAlbumUpdate", function(event){
				if(vueObj.album && vueObj.album.id){
					webCall2("/kt/album/detailBase", {
						albumId: vueObj.album.id
					}, QUERY_DETAIL, vueObj.onSuccess, vueObj.onErrorBefore);
				}
			});
			//设置滚动
			mui('.mui-scroll-wrapper').scroll();
			//参数
			vueObj.album = plus.webview.currentWebview().album;
			//调起相册选择
			vueObj.callGallery();
		});
	},
	methods: {
		/**
		 * 开始上传
		 */
		startUpload: function(){
			document.activeElement.blur();
			if(vueObj.uploadStatus == 2) return;
			if(vueObj.files.length <= 0){
				toast("请选择要上传的图片");
				return;
			}
			vueObj.uploadStatus = 2;
			vueObj.submitNum = 0;
			vueObj.failFiles = [];
			document.getElementById("uploadBtn").innerText = "上传中";
			mui.fire(plus.webview.getWebviewById(getCache("albumHomeId")), "onPhotoUploadListener", {uploadStatus:vueObj.uploadStatus});
			// 关闭侧滑返回功能
			plus.webview.currentWebview().setStyle({'popGesture':'none'});
			imageTool.processing_imgs(vueObj.files, function(isError, list){ //整体上传返回
				vueObj.uploadStatus = 3;
				document.getElementById("uploadBtn").innerText = "上传";
				plus.webview.currentWebview().setStyle({'popGesture':'close'});
				//如果files中还有值，证明都是上传失败的图片
				vueObj.files = vueObj.files.concat(vueObj.failFiles);
				if(vueObj.failFiles.length > 0){
					toast("有" + vueObj.failFiles.length + "张图片上传失败");
				}
			}, function(imgurl, path, fileSize){ //单项上传后返回
				if(!imgurl){ //上传失败
					vueObj.failFiles.push(path);
					return;
				}
				//上传成功，保存到相册
				webCall2("/kt/album/photo/upload", {
					albumId: vueObj.album.id,
					description: vueObj.description?vueObj.description:'',
					photoUrl: imgurl,
					photoSize: fileSize
				}, DO_SUBMIT, vueObj.onSuccess, vueObj.onErrorBefore);
			});
			//关闭页面
			toast("开始上传...");
			closeWaiting();
			mui.back();
		},
		/**
		 * 调起相册界面
		 */
		callGallery: function(){
			var maxNum = 100;
			if((vueObj.album.photoMaxNum - vueObj.album.photoNum - vueObj.files.length) < 100){
				maxNum = vueObj.album.photoMaxNum - vueObj.album.photoNum - vueObj.files.length;
			}
			if(maxNum <= 0){
				toast("上传数量已达上限");
				return;
			}
			imageTool.galleryImgs(function(isError, list){
				if(list && list.length > 0){
					vueObj.uploadStatus = 1; //重置状态
					vueObj.files = vueObj.files.concat(list);
				}
			}, null, true, maxNum, null, null, null, "1", true);
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DETAIL: //相册详情查询
				vueObj.album = data.data;
				break;
			case DO_SUBMIT: //保存图片成功
				vueObj.submitNum++;
				if(vueObj.uploadStatus == 3 || vueObj.submitNum % 3 == 0){
					//如果上传完成或者上传张数达到6张，更新界面
					mui.fire(plus.webview.getWebviewById("albumDetail"), "onPhotoUploadSuccess", {album:vueObj.album});
					mui.fire(plus.webview.getWebviewById("albumDetailSelect"), "onPhotoUploadSuccess", {album:vueObj.album});
					//通知首页，防止关闭首页再进入，上传图标不显示的问题
					mui.fire(plus.webview.getWebviewById(getCache("albumHomeId")), "onPhotoUploadListener", {uploadStatus:vueObj.uploadStatus});
				}
				//关闭页面
				if(vueObj.uploadStatus == 3 && vueObj.failFiles.length == 0){
					oldBack();
				}
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
			if(data.bizCode == 300000001){ //上传超限
				imageTool.setBlockUpload(true);
				mui.fire(plus.webview.getWebviewById("albumDetail"), "onPhotoUploadSuccess", {album:vueObj.album});
				mui.fire(plus.webview.getWebviewById("albumDetailSelect"), "onPhotoUploadSuccess", {album:vueObj.album});
				mui.fire(plus.webview.getWebviewById(getCache("albumHomeId")), "onPhotoUploadListener", {uploadStatus:3});
				oldBack();
			}
		},
		/**
		 * 按钮点击事件
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'album': //相册选择
				if(vueObj.uploadStatus == 2) return;
				openWindow("albumSelect", "../album/album_select.html", false, {
					statusBarType:STATUS_BAR_DEFAULT_KEY,
					album: vueObj.album
				});
				break;
			case 'add': //添加按钮
				if(vueObj.uploadStatus == 2) return;
				vueObj.callGallery();
				break;
			case 'del': //删除
				var index = e.currentTarget.dataset.index;
				vueObj.files.splice(index, 1);
				break;
			default:
				break;
			}
		}
	}
});

//上传按钮点击监听
document.getElementById("uploadBtn").addEventListener("tap", function(e){
	vueObj.startUpload();
});

//返回按钮
var oldBack = mui.back;
mui.back = function(){
	if(vueObj.uploadStatus == 2 || vueObj.failFiles.length > 0){
		plus.webview.currentWebview().hide();
	}else{
		if(vueObj.files.length <= 0){
			oldBack();
			return;
		}
		confirmDialog("", "确定要放弃本次上传吗？", "确定", "取消", function(){
			oldBack();
		});
	}
}
