//初始化Vue
var vueObj = new Vue({
	el: '#main',
	data: {
		imgSrc:"",
		activityObj: null,
		notAlert: false,
		notAlertTxt: null,
		readbag: null
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				return false;
			}
		});
		mui.plusReady(function(){
			// 关闭侧滑返回功能
			plus.webview.currentWebview().setStyle({'popGesture':'none'});
			vueObj.activityObj = plus.webview.currentWebview().activityObj;
			statisticEvent("activityPopTime", {"activityName" : vueObj.activityObj.activityName});
			vueObj.imgSrc = vueObj.activityObj.appLogo;
			vueObj.notAlert = vueObj.activityObj.notAlert ? true : false;
			vueObj.notAlertTxt = vueObj.activityObj.notAlertTxt;
			vueObj.readbag = vueObj.activityObj.redbagAmount;
			vueObj.showActivityPop();
		});
	},
	methods: {
		/*
		 * 位置, 样式调整
		 */
		showActivityPop: function(){
			//监听图片加载完成
			document.getElementById("activityPopImg").onload = function(e){
				var parentHeight = plus.screen.resolutionHeight;
				var imgHeight = document.getElementById("activityPopImg").offsetHeight;
				document.getElementById("activityPopImg").style.padding = (parentHeight-imgHeight)/2 + "px" + " 0px";
				document.getElementById("activityCloseImg").style.top = (parentHeight-imgHeight)/2 + imgHeight + 15 + "px";
				document.getElementById("donotPop").style.top = (parentHeight-imgHeight)/2 + imgHeight - 60 + "px";
				document.getElementById("readbag").style.top = (parentHeight-imgHeight)/2 + imgHeight*0.52 + "px";
			};
		},
		/*
		 * 弹窗透明处点击
		 */ 
		onActivityClick: function(e){
			//添加统计事件
			statisticEvent("activityPopTake", {"activityName" : vueObj.activityObj.activityName});
			//活动签到
			vueObj.activitySign();
			e.stopPropagation();
		},
		/*
		 * 关闭按钮点击
		 */
		onCloseBtnClick: function(e){
			//添加统计事件
			statisticEvent("activityPopClose", {"activityName" : vueObj.activityObj.activityName});
			plus.webview.currentWebview().close();
			e.stopPropagation();
		},
		/**
		 * 不再提示按钮点击
		 */
		onNotAlertBtnClick: function(){
			//添加统计事件
			statisticEvent("activityNeverPopClick", {"activityName" : vueObj.activityObj.activityName});
			mui.fire(plus.webview.currentWebview().parent(), "onNotAlertPopListener", {});
			plus.webview.currentWebview().close();
			e.stopPropagation();
		},
		/*
		 * 领取活动点击
		 */
		activitySign: function(){
			if(vueObj.activityObj.appLink && vueObj.activityObj.appLink.indexOf("http") < 0){
				openWindow(vueObj.activityObj.appLink, vueObj.activityObj.appLink, false, {
					statusBarType: plus.webview.currentWebview().statusBarType 
				});
			}else{ 
				openWindow(vueObj.activityObj.appLink, '../common/web_page.html', false, { //权益券
					"webUrl": vueObj.activityObj.appLink,
					"imgPath": vueObj.activityObj.appLogo,
					statusBarType: plus.webview.currentWebview().statusBarType
				}, null, false);
			}
			setTimeout(function(){
				plus.webview.currentWebview().close();
			}, 500);
			
		},
	}
});
