//网络请求码
QUERY_DATA = 1001;
//分享弹框
var shareDialog;
//Vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		shareInfo: {}
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarMain();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarMain();
				}
			}, false);
			//添加统计事件
			statisticEvent("inviteHome", {"source": plus.webview.currentWebview().opener().id});
			//添加分享弹框子页面 先隐藏
			shareDialog = plus.webview.create("../common/share_dialog.html", "share_dialog", {
				top: '0px',
				bottom: '0px',
				position: 'fiexd',
				zindex: '997',
				background: 'transparent'
			});
			plus.webview.currentWebview().append(shareDialog);
			shareDialog.hide();
			//查询数据
			showWaiting();
			webCall2("/compus/redbag/getShareInfo", null, QUERY_DATA, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'strategy': //攻略
				statisticEvent("inviteRedbagClick", {type:'点击攻略'});
				openWindow("inviteStrategy", '../common/web_page.html', false, {
					"webUrl": h5Host + "/invite/h5/strategy?schoolCode=" + getCache(SCHOOL_CODE_KEY) + "&phone=" + getCache(ACCOUNT_KEY),
					statusBarType: STATUS_BAR_MAIN_KEY
				}, null, false);
				break;
			case 'qrcode': //二维码
				statisticEvent("inviteRedbagClick", {type:'点击二维码'});
				openWindow("inviteQrcode", "../app/invite_qrcode.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
				break;
			case 'ranking': //排行榜
				statisticEvent("inviteRedbagClick", {type:'点击排行榜'});
				openWindow("inviteRanking", "../app/invite_ranking.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
				break;
			case 'share': //分享
				statisticEvent("inviteRedbagClick", {type:'首页点击分享'});
				if(!shareDialog) return;
				mui.fire(shareDialog, "showMorePop",{
					href: h5Host + '/activity/h5/takeRedbag?schoolCode=' + getCache(SCHOOL_CODE_KEY) + "&phone=" + getCache(ACCOUNT_KEY), 
					title: '寒假动起来 压岁钱滚滚来', 
					content: '现金红包大派送，饭卡、话费随便充，我也在用，一起来吧！', 
					imgUrl: '_www/img/logo_small.png'
				});	
				break;
			case 'detail': //明细列表
				statisticEvent("inviteRedbagClick", {type:'明细列表'});
				if(!vueObj.shareInfo.hasActiveRedbagList) return;
				openWindow("inviteRecord", "../app/invite_record.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY,
					shareInfo: vueObj.shareInfo
				});
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DATA: //获取数据
				vueObj.shareInfo = data.data;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});

//活动规则
document.getElementById("ruleBtn").addEventListener("tap", function(){
	statisticEvent("inviteRedbagClick", {type:'活动规则'});
	openWindow("walletShareRule", '../common/web_page.html', false, {
		"webUrl": h5Host + "/activity/h5/common?activityCode=walletShareRule",
		statusBarType: STATUS_BAR_MAIN_KEY
	}, null, false);
});