//Vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		showLogo: false,
		qrCodeObj: null, //二维码生成对象
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarMain();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarMain();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//初始化qrcode
			vueObj.initQRCodeObj();
			//生成二维码
			vueObj.qrCodeObj.makeCode(h5Host + '/activity/h5/takeRedbag?schoolCode=' + getCache(SCHOOL_CODE_KEY) + "&phone=" + getCache(ACCOUNT_KEY));
		});
	},
	methods: {
		/**
		 * 保存图片
		 */
		onSaveQrcode: function(e) {
			statisticEvent("inviteRedbagClick", {type:'保存二维码图片'});
			if(!checkUserPermission("GALLERY", null, function(){
				vueObj.onSaveQrcode(e);
			})){
				return;
			}
			showWaiting();
			var bitmap = new plus.nativeObj.Bitmap('shareQrcode');
			// 将webview内容绘制到Bitmap对象中
			plus.webview.currentWebview().draw(bitmap, function(){
				bitmap.save( "_downloads/shareQrcode.jpg",{
					overwrite: true
				}, function(i){
					closeWaiting();
					toast("保存图片成功");
					//保存图片到系统相册
					plus.gallery.save(i.target, function(){
						//删除原图片
						plus.io.resolveLocalFileSystemURL(i.target, function(entry) {
							entry.remove(function(entry) {
								console.log("文件删除成功");
							}, function(e) {
								console.log("文件删除失败");
							});
						});
					});
				}, function(e){
					closeWaiting();
					toast("保存图片失败");
				});
			}, function(e){
				closeWaiting();
				toast("保存图片失败");
			});
		},
		/**
		 * qrcode生成器初始化
		 */
		initQRCodeObj: function() {
			document.getElementById("qrcodeMain").style.padding = "5px";
			var qrcode = document.getElementById("qrcode");
			var qrLogo = document.getElementById("qrLogo");
			var width = qrcode.offsetWidth;
			qrcode.style.height = width + "px";
			qrLogo.style.width = width / 5 + "px";
			qrLogo.style.height = width / 5 + "px";
			qrLogo.style.left = width / 2 - width/10 + 5 + "px";
			qrLogo.style.top = width / 2 - width/10 + 5 + "px";
			vueObj.showLogo = true;
			vueObj.qrCodeObj = new QRCode(qrcode, {
				width: width,
				height: width
			});
		}
	}
});