//网络请求码
QUERY_ADS = 1001;
//分享弹框
var shareDialog;
//Vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		realNameStatus: -1, //实名认证状态 1未实名 2申请中 3认证成功 4认证失败 //最新状态 0 编辑中 1申请中 2受理成功 3成功 4 失败
		bindCardStatus: -1, //绑卡状态 1已经绑卡 0未绑卡
		userData: {},
		showType: 'unactive', //显示红包列表
		shareInfo: {hasActiveAmount:0,notActiveAmount:0,totalAmount:0},
		listData: [],
		isFix: false,
		immersed: 0,
		authHeight: 0
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarMain();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarMain();
				}
			}, false);
			//获取用户数据
			vueObj.shareInfo = plus.webview.currentWebview().shareInfo;
			vueObj.listData = vueObj.shareInfo.notActiveRedbagList;
			vueObj.userData = getUserInfo();
			vueObj.realNameStatus = vueObj.userData.realNameStatus;
			vueObj.bindCardStatus = vueObj.userData.bindCardStatus;
			//滚动初始化
			vueObj.handleStatusBar();
			var scroll = mui('.mui-scroll-wrapper').scroll();
			var tabScrollHeight = document.getElementById("tabDiv").scrollHeight;
			document.querySelector('.mui-scroll-wrapper').addEventListener('scroll', function (e) { 
		    	if((-scroll.y) > (tabScrollHeight + vueObj.immersed)){
		    		vueObj.isFix = true;
		    	}else{
		    		vueObj.isFix = false;
		    	}
		    	if(vueObj.realNameStatus != 3 && (-scroll.y) > 0){
		    		document.getElementById("authTxt").style.display = "block";
		    	}else{
		    		document.getElementById("authTxt").style.display = "none";
		    	}
		    });
			//添加分享弹框子页面 先隐藏
			shareDialog = plus.webview.create("../common/share_dialog.html", "share_dialog", {
				top: '0px',
				bottom: '0px',
				position: 'fiexd',
				zindex: '997',
				background: 'transparent'
			});
			plus.webview.currentWebview().append(shareDialog);
			shareDialog.hide();
			//查询banner
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:1016}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'auth': //实名认证
				statisticEvent("inviteRedbagClick", {type:'点击实名认证'});
				openWindow("authFirst", "../center/auth_first.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY,
					from: 'inviteRecord'
				});
				break;
			case 'active': //已领取红包
				statisticEvent("inviteRedbagClick", {type:'点击已领取的红包'});
				vueObj.showType = 'active';
				vueObj.listData = vueObj.shareInfo.hasActiveRedbagList;
				if(vueObj.bannerLength > 1) mui('#slider').slider().gotoItem(0, 0);
				break;
			case 'unactive': //路上的红包
				statisticEvent("inviteRedbagClick", {type:'点击路上的红包'});
				vueObj.showType = 'unactive';
				vueObj.listData = vueObj.shareInfo.notActiveRedbagList;
				if(vueObj.bannerLength > 1) mui('#slider').slider().gotoItem(1, 0);
				break;
			case 'share': //分享
				statisticEvent("inviteRedbagClick", {type:'明细列表点击分享'});
				if(!shareDialog) return;
				mui.fire(shareDialog, "showMorePop",{
					href: h5Host + '/activity/h5/takeRedbag?schoolCode=' + getCache(SCHOOL_CODE_KEY) + "&phone=" + getCache(ACCOUNT_KEY), 
					title: '双11回血秘籍', 
					content: '现金红包大派送，饭卡、话费随便充，我也在用，一起来吧！', 
					imgUrl: '_www/img/logo_small.png'
				});	
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_ADS: //广告数据加载
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					mui("#slider").slider({
						interval: 0
					});
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
					mui('#slider').slider().setStopped(true);
					if(vueObj.bannerLength > 1) mui('#slider').slider().gotoItem(1, 0);
				});
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			openWindow("inviteRecordDetail", "../app/invite_record_detail.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});		
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "分享赚红包名单页", "pos": "分享赚红包名单页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && vueObj.bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_MAIN_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_MAIN_KEY
				}, null, false);
			}
		},
		handleStatusBar: function() {
			var immersed = 0;
			var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
			if(ms && ms.length >= 3) {
				immersed = parseFloat(ms[2]);
			}
			if(!immersed) {
				return;
			}
			vueObj.immersed = immersed;
			document.getElementById("authTxt").style.top = immersed + 44 + 'px';
			vueObj.authHeight = (vueObj.realNameStatus != 3 && vueObj.realNameStatus != -1) ? 35 : 0;
			document.getElementById("fixTabDiv").style.top = immersed + vueObj.authHeight + 44 + 'px';
		}
	}
});