//请求码
var QUERY_LOTTERY_INFO = 1001, LOTTERY_DRAW = 1002, UPDATE_SHARE_INFO = 1003;
var shareDialog;//分享弹框
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		showMain: false,
		topHeight: '0px',
		contentHeight: 0,
		prizeListWidth: 0,
		prizeListPaddingLeft: 0,
		prizeListPaddingTop: 0,
		prizeItemWidth: 0,
		prizeItemPadding: 0,
		prizeItemMarginLeft: 0,
		prizeItemMarginTop: 0,
		activityData: {}, //活动信息
		activeIndex: -1, //选中项
		isLottery: false, //是否开始抽奖
		lotteryData: null, //抽奖结果
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			vueObj.topHeight = 44 + window.immersed + 'px';
			vueObj.contentHeight = window.innerHeight - 44 - window.immersed;
			vueObj.prizeListWidth = window.innerWidth * 0.9147;
			vueObj.prizeListPaddingLeft = window.innerWidth * 0.064;
			vueObj.prizeListPaddingTop = window.innerWidth * 0.072;
			vueObj.prizeItemWidth = window.innerWidth * 0.24;
			vueObj.prizeItemPadding = window.innerWidth * 0.02;
			vueObj.prizeItemMarginLeft = window.innerWidth * 0.01066;
			vueObj.prizeItemMarginTop = window.innerWidth * 0.009;
			vueObj.showMain = true;
			//状态栏设置
			setStatusBarDefault();
			var self = plus.webview.currentWebview();
			self.addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//分享初始化
			initShareServices(self);
			//监听分享成功事件
			window.addEventListener("onShareSuccessListener", function(){
				webCall2("/compus/avtivity/updateAfterShare", {activityId: vueObj.activityData.id}, UPDATE_SHARE_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
			});
			//添加分享弹框子页面 先隐藏
			shareDialog = plus.webview.create("../common/share_dialog.html", "share_dialog", {
				top: '0px',
				bottom: '0px',
				position: 'fiexd',
				zindex: '997',
				background: 'transparent'
			});
			self.append(shareDialog);
			shareDialog.hide();
			//查询活动信息
			showWaiting();
			webCall2("/compus/avtivity/getLotteryActivity", {activityCode: comGetUrlParamByName(self.getURL(), "activityCode")}, QUERY_LOTTERY_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 开始抽奖 
		 */
		startLottery: function(e) {
			//判断绑卡
			var user = getUserInfo();
			if(vueObj.activityData.bindCardFlag == 0 && user.bindCardStatus == 0){
				var selfId = plus.webview.currentWebview().id;
				openBindCard(plus.webview.currentWebview().statusBarType);
			}
			if(vueObj.isLottery) return;
			vueObj.isLottery = true;
			//添加统计事件
			statisticEvent("lotteryClickTime", {"type": "点击抽奖", "activityName": vueObj.activityData.activityName});
			//调用抽奖接口
			showWaiting();
			vueObj.lotteryData = null;
			webCall2("/compus/avtivity/lotteryDraw", {activityId: vueObj.activityData.id}, LOTTERY_DRAW, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 抽奖动画
		 */
		startLotteryAnimate: function() {
			var nowIndex = 0;
			var arrayIndex = [0, 1, 2, 4, 7, 6, 5, 3];
			var lotteryInterval = setInterval(function(){
				vueObj.activeIndex = arrayIndex[nowIndex%8];
				nowIndex++;
				if((nowIndex > 40 && !vueObj.isLottery) || (vueObj.lotteryData && vueObj.lotteryData.result == 2)){
					clearInterval(lotteryInterval);
					vueObj.activeIndex = -1;
					if(vueObj.lotteryData == null) return;
					if(vueObj.lotteryData.result == 1){
						vueObj.showSuccessPop();
					}else{
						vueObj.showFailurePop();
					}
				}
			}, 50);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_LOTTERY_INFO: //获取活动信息
				//分享链接添加用户ID参数
				data.data.shareUrl = appendParamsUrl(data.data.shareUrl, {
					userId: getCache(USER_ID_KEY)
				});
				vueObj.activityData = data.data;
				break;
			case LOTTERY_DRAW: //抽奖结果
				vueObj.lotteryData = data.data;
				vueObj.startLotteryAnimate();
				setTimeout(function(){
					vueObj.isLottery = false;
				}, 500);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
			if(requestCode == LOTTERY_DRAW){
				setTimeout(function(){
					vueObj.isLottery = false;
				}, 500);
			}
		},
		/**
		 * 中奖弹窗
		 */
		showSuccessPop: function() {
			//添加统计事件
			statisticEvent("lotteryClickTime", {"type": "中奖弹窗", "activityName": vueObj.activityData.activityName});
			document.getElementById("activityPopImg").src = '';
			document.getElementById("activityPopImg").src = vueObj.lotteryData.winImg;
			document.getElementById("activityPopImg").style.width = "80.27%";
			vueObj.showActivityPop(true);
		},
		/**
		 * 失败弹窗
		 */
		showFailurePop: function() {
			//添加统计事件
			statisticEvent("lotteryClickTime", {"type": "未中奖弹窗", "activityName": vueObj.activityData.activityName});
			document.getElementById("activityPopImg").src = '';
			document.getElementById("activityPopImg").src = vueObj.lotteryData.loseBaseImg;
			document.getElementById("activityPopImg").style.width = "69%";
			vueObj.showActivityPop(false);
		},
		/**
		 * 显示弹窗
		 */
		showActivityPop: function(isSuccess) {
			//监听图片加载完成
			document.getElementById("activityPopImg").onload = function(e){
				document.getElementById("childActivityPopParent").style.display = "block";
				document.getElementById("childActivityPopover").classList.add("mui-active");
				var parentHeight = document.getElementById("childActivityPopParent").offsetHeight;
				var imgHeight = document.getElementById("activityPopImg").offsetHeight;
				document.getElementById("activityPopImg").style.marginTop = (parentHeight-imgHeight)/2 + "px";
				//document.getElementById("activityCloseImg").style.top = (parentHeight-imgHeight)/2 + imgHeight + 15 + "px";
				var activitySuccess = document.getElementById("activitySuccess");
				var activityDescTxt = document.getElementById("activityDescTxt");
				var activityShare = document.getElementById("activityShare");
				activityDescTxt.innerHTML = vueObj.lotteryData.tip.replace(/(^\s+)|(\s+$)|\s+/g, "<br>");
				if(isSuccess){
					document.getElementById("activityPrizeImg").style.height = imgHeight*0.2125 + "px";
					document.getElementById("activityPrizeImg").src = vueObj.lotteryData.compusLotteryAwardClientVO.awardLogo;
					document.getElementById("activityPrizeName").innerText = vueObj.lotteryData.compusLotteryAwardClientVO.awardName;
					activitySuccess.style.top = (parentHeight-imgHeight)/2 + imgHeight*0.15 + "px";
					activityDescTxt.style.top = (parentHeight-imgHeight)/2 + imgHeight*0.624 + "px";
					activityDescTxt.style.left = window.innerWidth*0.2 + "px";
					activityDescTxt.style.right = window.innerWidth*0.2 + "px";
					activityShare.style.bottom = (parentHeight-imgHeight)/2 + imgHeight*0.06 + "px";
					activityShare.style.left = window.innerWidth*0.099 + "px";
					activityShare.style.right = window.innerWidth*0.099 + "px";
					activitySuccess.style.display = "block";
				}else{
					activityDescTxt.style.top = (parentHeight-imgHeight)/2 + imgHeight*0.43 + "px";
					activityDescTxt.style.left = window.innerWidth*0.2 + "px";
					activityDescTxt.style.right = window.innerWidth*0.2 + "px";
					activityShare.style.bottom = (parentHeight-imgHeight)/2 + imgHeight*0.118 + "px";
					activityShare.style.left = window.innerWidth*0.15 + "px";
					activityShare.style.right = window.innerWidth*0.15 + "px";
					activitySuccess.style.display = "none";
				}
				activityDescTxt.style.display = "block";
				activityShare.style.display = "block";
			};
		},
		/**
		 * 关闭弹窗
		 */
		closeActivityPop: function() {
			document.getElementById("childActivityPopParent").style.display = "none";
			document.getElementById("childActivityPopover").classList.remove("mui-active");
			document.getElementById("activitySuccess").style.display = "none";
			document.getElementById("activityDescTxt").style.display = "none";
			document.getElementById("activityShare").style.display = "none";
		},
		/**
		 * 分享 
		 */
		onCommonShare: function(type) {
			//添加统计事件
			statisticEvent("lotteryClickTime", {"type": "点击分享", "activityName": vueObj.activityData.activityName});
			//添加统计事件
			statisticEvent("lotteryShareClickTime", {"shareType": type, "activityName": vueObj.activityData.activityName});
			vueObj.closeActivityPop();
			var params = {
				"href": vueObj.activityData.shareUrl,
				"title": vueObj.activityData.shareTitle,
				"content": vueObj.activityData.shareContent,
				"imgUrl": vueObj.activityData.shareLogo ? vueObj.activityData.shareLogo : '_www/img/logo_small.png'
			}
			switch(type) {
			case "weixin":
				shareToWeixin(params);
				break;
			case "qq":
				shareToQQ(params);
				break;
			case "group":
				shareToWeixinGroup(params);
				break;
			case "weibo":
				shareToWeibo(params);
				break;
			default:
				break;
			}
		}
	}
});

//弹窗透明处点击
document.getElementById("childActivityPopParent").addEventListener("tap", function(e){
	//添加统计事件
	statisticEvent("lotteryClickTime", {"type": "关闭弹窗", "activityName": vueObj.activityData.activityName});
	vueObj.closeActivityPop();
	e.stopPropagation();
});
//关闭按钮点击
/*document.getElementById("activityCloseImg").addEventListener("tap", function(e){
	//添加统计事件
	statisticEvent("lotteryClickTime", {"type": "关闭弹窗", "activityName": vueObj.activityData.activityName});
	vueObj.closeActivityPop();
	e.stopPropagation();
});*/
//立即使用按钮点击
document.getElementById("activityPrizeBtn").addEventListener("tap", function(e){
	//添加统计事件
	statisticEvent("redbagCouponClickTime", {"welfareName" : vueObj.lotteryData.compusLotteryAwardClientVO.welfareInfo.welfareName, "from" : "抽奖活动页"});
	vueObj.closeActivityPop();
	e.stopPropagation();
	if(vueObj.lotteryData == null || vueObj.lotteryData.compusLotteryAwardClientVO == null
		|| vueObj.lotteryData.compusLotteryAwardClientVO.welfareInfo == null) return;
	//优惠券，跳转到优惠券列表
	if(vueObj.lotteryData.compusLotteryAwardClientVO.welfareInfo.welfareType == 2){
		openWindow("redbagCouponList", "../center/redbag_coupon_list.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
		return;
	}
	//红包类型
	if(vueObj.lotteryData.compusLotteryAwardClientVO.welfareInfo.welfareType == 3){
		openWindow("walletRedbag", "../wallet/wallet_redbag.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
		return;
	}
	//权益券
	if(vueObj.lotteryData.compusLotteryAwardClientVO.welfareInfo.status == 0){
		toast("该券未生效，请参照该券有效时间");
		return;
	}
	var url = vueObj.lotteryData.compusLotteryAwardClientVO.welfareInfo.url;
	if(url && url.indexOf("http") < 0){
		openWindow(url, url, false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
	}else{ //打开优惠券列表页
		openWindow(url, '../common/web_page.html', false, { //权益券
			"webUrl": url,
			"imgPath": vueObj.lotteryData.compusLotteryAwardClientVO.welfareInfo.welfareLogo,
			statusBarType: STATUS_BAR_DEFAULT_KEY
		}, null, false);
	}
});
//分享按钮点击
document.getElementById("activityShareGroup").addEventListener("tap", function(e){
	e.stopPropagation();
	vueObj.onCommonShare("group");
});
document.getElementById("activityShareWeixin").addEventListener("tap", function(e){
	e.stopPropagation();
	vueObj.onCommonShare("weixin");
});
document.getElementById("activityShareQQ").addEventListener("tap", function(e){
	e.stopPropagation();
	vueObj.onCommonShare("qq");
});
document.getElementById("activityShareWeibo").addEventListener("tap", function(e){
	e.stopPropagation();
	vueObj.onCommonShare("weibo");
});
//标题分享按钮点击
document.getElementById("shareTitleBtn").addEventListener("tap", function(e){
	if(shareDialog && vueObj.activityData){
		//添加统计事件
		statisticEvent("lotteryClickTime", {"type": "点击抽奖", "activityName": vueObj.activityData.activityName});
		mui.fire(shareDialog, "showMorePop",{
			href: vueObj.activityData.shareUrl, 
			title: vueObj.activityData.shareTitle, 
			content: vueObj.activityData.shareContent, 
			imgUrl: vueObj.activityData.shareLogo ? vueObj.activityData.shareLogo : '_www/img/logo_small.png'
		});	
	}
});