//请求码
var DO_RECHARGE = 1001, GET_REPEAT_TOKEN = 1002, GET_PRICE_LIST = 1003, 
	QUERY_ADS = 1004, QUERY_POP_INFO = 1005;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		showContact: false, //是否显示通讯录选择（iOS1.0.0不支持）
		itemWidth: 0, //充值项宽度
		rechargePhone: "",//充值手机
		phoneArea: " ", //电话区域
		prices: [], //话费报价列表
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		activityData: null,
		moreList: [], //更多充值数据
		userData: {},
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//监听事件
			window.addEventListener("onNotAlertPopListener", function(event){
				setCache("DONOT_POP_REDBAG_TAKE_PHONE" + getCache(USER_ID_KEY), "yes");
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//版本判断
			if(plus.os.name != 'iOS' || plus.runtime.version != '1.0.0'){
				vueObj.showContact = true;
			}
			//充值项宽度
			vueObj.itemWidth = (plus.screen.resolutionWidth - 48) / 3;
			//获取用户数据
			vueObj.rechargePhone = getCache(ACCOUNT_KEY);
			vueObj.getPhoneArea();
			showWaiting();
			webCall2("/compus/advertising/getAdvertisingMap", {addressCodeList:'1009,3002,3003'}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
			//获取用户数据
			vueObj.userData = getUserInfo();
			//判断，如果用户未实名，且没有点击不再提示，则查询弹窗信息
			if(vueObj.userData.realNameStatus == 3) return;
			var popTime = getCache("POP_REDBAG_TAKE_TIME_PHONE" + getCache(USER_ID_KEY));
			if(popTime && parseInt(popTime) > 0) return; //只弹出一次
			if(getCache("DONOT_POP_REDBAG_TAKE_PHONE" + getCache(USER_ID_KEY)) == "yes") return;
			//webCall2("/compus/advertising/getAdvertisingMap", {addressCodeList: '5002'}, QUERY_POP_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 充值
		 * @param {Object} e
		 */
		doRecharge: function(e) {
			//添加统计事件
			statisticEvent("phoneRechargeBtnClick", {"clickType" : "充值按钮", "money" : e.currentTarget.dataset.money, "from" : "话费充值页"});
			document.activeElement.blur();
			//去除空格
			var phone = vueObj.rechargePhone.replace(/\s/g,"");
			if(!regexMobile(phone)){
				toast("请输入正确的手机号");
				return;
			}
			showWaiting();
			var extParams = {
				urlPath: "/compus/order/rechargePhone"
			};
			var params = {
				mobilePhone: phone,
				ruleId: e.currentTarget.dataset.ruleid,
			};
			if(plus.webview.currentWebview().id.indexOf("app_") == 0){
				params.applicationId = plus.webview.currentWebview().id.substring(4);
			}
			webCall2("/common/token/get", params, DO_RECHARGE, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, extParams);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_PRICE_LIST: //获取报价列表
				vueObj.prices = data.rows;
				break;
			case DO_RECHARGE: //调用充值
				document.activeElement.blur();
				openWindow("phoneRechargeWebPage", "../common/web_page.html", false, {
					webUrl: data.data,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case QUERY_ADS: //广告数据加载
				if(data.data['3002'] && data.data['3002'].length > 0){
					vueObj.activityData = data.data['3002'][0];
				}
				vueObj.moreList = data.data['3003'];
				vueObj.bannerRows = data.data['1009'];
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({ interval: 3000 });
					} else {
						mui("#slider").slider({ interval: 0 });
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				});
				break;
			case QUERY_POP_INFO: //查询红包弹窗信息
				var popData = data.data['5002'] && data.data['5002'].length > 0 ? data.data['5002'][0] : null;
				if(!popData) return;
				//构造弹窗
				var activityObj = {};
				var popTime = getCache("POP_REDBAG_TAKE_TIME_PHONE" + getCache(USER_ID_KEY));
				if(popTime && parseInt(popTime) > 2){
					activityObj.notAlert = true;
					activityObj.notAlertTxt = "放弃红包，不再提示？";
				}
				setCache("POP_REDBAG_TAKE_TIME_PHONE" + getCache(USER_ID_KEY), popTime ? (parseInt(popTime)+1) : 1);
				activityObj.activityName = popData.title;
				activityObj.appLogo = popData.image;
				activityObj.appLink = popData.url;
				var activityPop = plus.webview.create('../app/activity_pop.html', 'activity_pop', {
					top: '0', bottom: '0', background: 'transparent'
				},{
					activityObj:activityObj, statusBarType:getCurrentStatusBarType()
				});
				plus.webview.currentWebview().append(activityPop);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 从通讯录中选择
		 */
		onContactSelect: function(e) {
			//添加统计事件
			statisticEvent("phoneRechargeBtnClick", {"clickType" : "通讯录选择按钮", "from" : "话费充值页"});
			if(!checkUserPermission("CONTACTS", null, function(){
				if(plus.os.name == 'Android'){
					selectContactFromAndroid();
				}else{
					selectContactFromIOS();
				}
			})){ //权限判断
				return;
			}
			document.activeElement.blur();
			showWaiting();
			if(plus.os.name == 'Android'){
				selectContactFromAndroid();
			}else{
				selectContactFromIOS();
			}
			closeWaiting();
		},
		/**
		 * 处理通讯录选择返回的号码 
		 */
		handleSelectResult: function(result) {
			if(!result) return;
			var numbers = result.split(",");
			if(numbers.length < 2){
				vueObj.rechargePhone = numbers[0];
				vueObj.getPhoneArea();
				return;
			}
			var buttons = [];
			for(var i in numbers){
				buttons[i] = {id:i, title:numbers[i]};
			}
			plus.nativeUI.actionSheet({
				title: "请选择充值号码",
				cancel: "取消",
				buttons: buttons
			}, function(e){
				if(e.index > 0){
					vueObj.rechargePhone = buttons[e.index - 1].title;
					vueObj.getPhoneArea();
				}
			});
		},
		/**
		 * 输入框失去焦点
		 */
		onPhoneInput: function() {
			vueObj.getPhoneArea();
		},
		/**
		 * 获取号码归属地
		 * @param {Object} phone
		 */
		getPhoneArea: function(){
			//去除空格
			var phone = vueObj.rechargePhone.replace(/\s/g,"");
			if(!regexMobile(phone)){
				return;
			}
			mui.ajax("http://mobsec-dianhua.baidu.com/dianhua_api/open/location?tel=" + phone, {
				dataType: 'JSON',
				type: "GET",
				timeout: 15000,
				headers: {
					"X-Requested-With": ""
				},
				success: function(data){
					try {
						data = JSON.parse(data);
					} catch(e) {
						console.error(e);
					}
					
					if(data == null || !data.response || !data.response[phone]){
						vueObj.getPhonePriceList();
						return; 
					}
					var province, operator, phoneDetail;
					//手机号码详细信息
					phoneDetail = data.response[phone].detail;
					vueObj.phoneArea = "中国" + phoneDetail.operator + "(" + phoneDetail.province + ")";
					province = phoneDetail.province;
					operator = phoneDetail.operator;
					vueObj.getPhonePriceList(province, operator);
				},
				error: function(xhr, type, errorThrown) {
					vueObj.phoneArea = "解析失败";
					vueObj.getPhonePriceList();
				}
			});
		},
		/**
		 * 获取报价列表
		 */
		getPhonePriceList: function(province, operator) {
			var params = {};
			if(province){
				params.province = province;
			}
			if(operator && operator == '移动'){
				params.operator = "01";
			}else if(operator && operator == '联通'){
				params.operator = "02";
			}else if(operator && operator == '电信'){
				params.operator = "03";
			}
			//任何一个为空，则不传参数
			if(!params.province || !params.operator){
				params = {};
			}
			showWaiting();
			webCall2("/compus/phonecharge/listData", params, GET_PRICE_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "话费充值页", "pos": "话费充值页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && getUserInfo().bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});

//充值明细按钮监听
document.getElementById("listBtn").addEventListener("tap", function(){
	document.activeElement.blur();
	openWindow("rechargeCenterList", "../app/recharge_center_list.html", false, {
		statusBarType: STATUS_BAR_DEFAULT_KEY
	});
});
/*
 * 搜索框清除按钮点击
 */
mui('.mui-input-row').on('tap', '.mui-icon-clear', function() {
	vueObj.rechargePhone = "";
}, false);

/**
 * iOS通讯录选择
 */
function selectContactFromIOS() {
	var NativeJsTool = plus.ios.importClass("NativeJsTool");
    var nativeJsTool = plus.ios.newObject("NativeJsTool");
    function getPhoneNumber(e) {
    		var phoneNumber = plus.ios.invoke(nativeJsTool, "getAddressPhone");
      	outputLog("phoneNumber" + phoneNumber);
      	//返回处理手机号
	    vueObj.handleSelectResult(phoneNumber);
    }
    var delegate = plus.ios.implements("NativeJsToolDelegate", {"getAddressPhoneNumber:": getPhoneNumber});
    nativeJsTool.plusSetAttribute("delegate", delegate);
    plus.ios.invoke(nativeJsTool, "openAddressBookVc");
}

/**
 * android通讯录选择
 */
function selectContactFromAndroid() {
	var REQUESTCODE = 1000;
	main = plus.android.runtimeMainActivity();
	var Intent = plus.android.importClass('android.content.Intent');
	var ContactsContract = plus.android.importClass('android.provider.ContactsContract');
	var intent = new Intent(Intent.ACTION_PICK, ContactsContract.Contacts.CONTENT_URI);
	main.onActivityResult = function(requestCode, resultCode, data) { 
	  if (REQUESTCODE == requestCode) {
	    var phoneNumber = null;
	    var resultString = "";
	    var context = main;
	    plus.android.importClass(data);
	    var contactData = data.getData();
	    var resolver = context.getContentResolver();
	    plus.android.importClass(resolver);
	    var cursor = resolver.query(contactData, null, null, null, null);
	    plus.android.importClass(cursor);
	    cursor.moveToFirst();
	    var s_ret;
	    var givenName = cursor.getString(cursor.getColumnIndex(ContactsContract.Contacts.DISPLAY_NAME));
	    //s_ret = givenName;
	    var contactId = cursor.getString(cursor.getColumnIndex(ContactsContract.Contacts._ID));
	    var pCursor = resolver.query(ContactsContract.CommonDataKinds.Phone.CONTENT_URI,
	     	null, ContactsContract.CommonDataKinds.Phone.CONTACT_ID + " = " + contactId,
	     	null, null);
	    var i = 0;
	    while (pCursor.moveToNext()) {
	    	phoneNumber =   pCursor.getString( pCursor.getColumnIndex(ContactsContract.CommonDataKinds.Phone.NUMBER));
	     	if(i == 0){
	     		s_ret = phoneNumber;
	     	}else{
	     		s_ret += ',' + phoneNumber;
	     	}
	     	i++;
	    }
	    cursor.close();
	    pCursor.close();
	    //返回处理手机号
	    vueObj.handleSelectResult(s_ret);
	  }
	};
	main.startActivityForResult(intent, REQUESTCODE);
}