//请求码
var QUERY_ACTIVITY = 1001, QUERY_REDBAG_COUNT = 1002;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		realNameStatus: -1, //实名认证状态 1未实名 2申请中 3认证成功 4认证失败
		activityCode: null,
		from: null, //来源
		welfareData:{}, //全部数据
		showBtn: true,
		redbagCount: ''
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			mui('.mui-scroll-wrapper').scroll();
			vueObj.activityCode = comGetUrlParamByName(plus.webview.currentWebview().getURL(), "activityCode");
			vueObj.from = comGetUrlParamByName(plus.webview.currentWebview().getURL(), "from");
			if(!vueObj.from){
				vueObj.from = plus.webview.currentWebview().from;
			}
			if(!vueObj.from){
				vueObj.from = "walletRedbagTake";
			}
			vueObj.realNameStatus = getUserInfo().realNameStatus ? getUserInfo().realNameStatus : 0;
			//添加统计事件
			statisticEvent("walletOpen01");
			//加载数据
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			webCall2("/compus/avtivity/getActivityHtmlText", {
				activityCode: vueObj.activityCode
			}, QUERY_ACTIVITY, vueObj.onSuccess, vueObj.onErrorBefore);
			webCall2("/compus/redbag/getOpenWalletRedBagCount", null, QUERY_REDBAG_COUNT, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_ACTIVITY:
				//更新数据
				vueObj.welfareData = data.data;
				document.getElementById("title").innerText = data.data.activityName ? data.data.activityName : "红包壕礼";
				setTimeout(function(){
					vueObj.showBtn = true;
				}, 200);
				break;
			case QUERY_REDBAG_COUNT: //开通钱包红包发放数量
				vueObj.redbagCount = data.data;
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 领取点击
		 */
		doTake: function(e) {
			vueObj.realNameStatus = getUserInfo().realNameStatus ? getUserInfo().realNameStatus : 0;
			if (vueObj.realNameStatus == 2 || vueObj.realNameStatus == 3){ //实名认证中|已实名认证
				//分享赚红包
				openWindow("inviteHome", "../app/invite_home.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
				return;
			}
			//添加统计事件
			statisticEvent("walletOpenClickTime", {"action" : "点击领取红包", "from" : "红包壕礼页"});
			statisticEvent("walletOpen02");
			plus.nativeUI.confirm("完善信息后, 即可获得红包哦!", function(e) {
				if(e.index == 0) { //left
					//未认证, 打开认证页面
					openWindow("authFirst", "../center/auth_first.html", false, {
						statusBarType: STATUS_BAR_DEFAULT_KEY,
						from: vueObj.from
					});
				} 
			}, "", ["去完善"]);
		},
		/**
		 * 按钮跳转
		 */
		doJump: function(e) {
			vueObj.realNameStatus = getUserInfo().realNameStatus ? getUserInfo().realNameStatus : 0;
			if (vueObj.realNameStatus == 2){ //实名认证中
				toast("实名认证中, 请稍后再试");
				return;	
			}
			if (vueObj.realNameStatus != 3){ //未实名认证
				plus.nativeUI.confirm("完善信息后, 即可获得红包哦!", function(e) {
					if(e.index == 0) { //left
						//未认证, 打开认证页面
						openWindow("authFirst", "../center/auth_first.html", false, {
							statusBarType: STATUS_BAR_DEFAULT_KEY,
							from: vueObj.from
						});
					} 
				}, "", ["去完善"]);
				return;	
			}
			switch (e.currentTarget.dataset.type){
			case 'card': //一卡通
				//添加统计事件
				statisticEvent("walletOpenClickTime", {"action" : "点击一卡通充值", "from" : "红包壕礼页"});
				openWindow("rechargeCard", "../card/recharge_card.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
				break;
			case 'phone': //话费充值
				//添加统计事件
				statisticEvent("walletOpenClickTime", {"action" : "点击话费充值", "from" : "红包壕礼页"});
				openWindow("rechargeCenter", "../app/recharge_center.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
				break;
			case 'play': //娱乐充值
				//添加统计事件
				statisticEvent("walletOpenClickTime", {"action" : "点击娱乐充值", "from" : "红包壕礼页"});
				openWindow("appPlay", "../common/web_page.html", false, {
					webUrl: "https://eschool.bianwa.com/vbankprod-webapp/login.html",
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			default:
				break;
			}
		}
	}
});