//请求码
var DO_NEXT = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		cardPhone: '',
		cardNo: '',
		cardPhoneShow: '',
		source: null, //payCodeNew
		fromThirdAuth: false, //是否来自第三方
		webPageId: '', //第三方页面ID
		activeType: '', //appeal申诉
		realName: null,
		incomeAccount: null,
		accountType: null
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(vueObj.fromThirdAuth && vueObj.webPageId){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onActiveCardResult", {status: 'cancel'});
				}
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//参数
			vueObj.fromThirdAuth = plus.webview.currentWebview().fromThirdAuth;
			vueObj.webPageId = plus.webview.currentWebview().webPageId;
			vueObj.source = plus.webview.currentWebview().source;
			vueObj.cardPhone = plus.webview.currentWebview().phone;
			vueObj.cardPhoneShow = vueObj.cardPhone.substring(0,3) + "****" + vueObj.cardPhone.substring(7);
			vueObj.activeType = plus.webview.currentWebview().activeType;
			vueObj.realName = plus.webview.currentWebview().realName;
			vueObj.incomeAccount = plus.webview.currentWebview().incomeAccount;
			vueObj.accountType = plus.webview.currentWebview().accountType;
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			if(!vueObj.cardNo || !regexIdCard(vueObj.cardNo)){
				toast("请输入正确的身份证号码");
				return;
			}
			showWaiting();
			if(vueObj.activeType == 'appeal'){ //申诉并绑卡
				webCall2("/compus/user/sendAppealCardVerificationCode", {
					reservePhone: vueObj.cardPhone,
					identityNo: vueObj.cardNo,
					realName: vueObj.realName,
					incomeAccount: vueObj.incomeAccount,
					accountType: vueObj.accountType
				}, DO_NEXT, vueObj.onSuccess, vueObj.onErrorBefore);
			}else{ //卡激活
				webCall2("/compus/user/sendActiveOneCardVerificationCode", {
					reservePhone: vueObj.cardPhone,
					identityNo: vueObj.cardNo
				}, DO_NEXT, vueObj.onSuccess, vueObj.onErrorBefore);
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_NEXT: //下一步
				openWindow("activeCardSecond", "../card/active_card_second.html", false, {
					statusBarType: plus.webview.currentWebview().statusBarType,
					fromThirdAuth: vueObj.fromThirdAuth,
					webPageId: vueObj.webPageId,
					phone: vueObj.cardPhone,
					cardNo: vueObj.cardNo,
					source: vueObj.source,
					activeType: vueObj.activeType,
					realName: vueObj.realName,
					incomeAccount: vueObj.incomeAccount,
					accountType: vueObj.accountType
				});
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		}
	}
});