var DO_NEXT = 1001, GET_CODE = 1002, DO_APPEAL = 1003;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		cardPhoneShow: '',
		cardPhone: '',
		cardNo: '',
		source: null, //payCodeNew
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		smsScoded: "", //短信验证码
		fromThirdAuth: false, //是否来自第三方
		webPageId: '', //第三方页面ID
		showPwds: ['', '', '', '', '', ''], //输入的6位验证码
		activeType: '', //appeal申诉
		realName: null,
		incomeAccount: null,
		accountType: null,
		sendCount: 1, //短信验证码发送次数
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(vueObj.fromThirdAuth && vueObj.webPageId){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onActiveCardResult", {status: 'cancel'});
				}
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			setStatusBarDefault();
			//设置键盘弹出模式
			keyboardAdjustResize();
			plus.webview.currentWebview().setStyle({'popGesture': 'none'});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//接收参数
			var self = plus.webview.currentWebview();
			vueObj.fromThirdAuth = self.fromThirdAuth;
			vueObj.webPageId = self.webPageId;
			vueObj.source = self.source;
			vueObj.cardPhone = self.phone;
			vueObj.cardNo = self.cardNo;
			vueObj.cardPhoneShow = vueObj.cardPhone.substring(0,3) + "****" + vueObj.cardPhone.substring(7);
			vueObj.activeType = self.activeType;
			vueObj.realName = self.realName;
			vueObj.incomeAccount = self.incomeAccount;
			vueObj.accountType = self.accountType;
			//倒计时 上个页面已经发了验证码 直接倒计时
			vueObj.setTimeCount();
			/**进入页面弹出键盘*/
		    initNativeObjects();
		    showSoftInput();
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			if(!vueObj.smsScoded || vueObj.smsScoded.length <= 0){
				toast("请输入验证码");
				return;
			}
			document.activeElement.blur();
			showWaiting();
			if(vueObj.activeType == 'appeal'){ //申诉并绑卡
				webCall2("/compus/user/appealCard", {
					reservePhone: vueObj.cardPhone,
					identityNo: vueObj.cardNo,
					verificationCode: vueObj.smsScoded,
					realName: vueObj.realName,
					incomeAccount: vueObj.incomeAccount,
					accountType: vueObj.accountType
				}, DO_APPEAL, vueObj.onSuccess, vueObj.onErrorBefore);
			}else{
				webCall2("/compus/user/activeCardByReservePhone", {
					reservePhone: vueObj.cardPhone,
					identityNo: vueObj.cardNo,
					verificationCode: vueObj.smsScoded
				}, DO_NEXT, vueObj.onSuccess, vueObj.onErrorBefore);
			}
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在60s计时
			showWaiting();
			if(vueObj.activeType == 'appeal'){ //申诉并绑卡
				webCall2("/compus/user/sendAppealCardVerificationCode", {
					reservePhone: vueObj.cardPhone,
					identityNo: vueObj.cardNo,
					realName: vueObj.realName,
					incomeAccount: vueObj.incomeAccount,
					accountType: vueObj.accountType,
					sendCount: vueObj.sendCount
				}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
			}else{ //卡激活
				webCall2("/compus/user/sendActiveOneCardVerificationCode", {
					reservePhone: vueObj.cardPhone,
					identityNo: vueObj.cardNo,
					sendCount: vueObj.sendCount
				}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
			}
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
					document.getElementById("smsCodeBtn").style.opacity = "1";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_CODE: //获取验证码
				vueObj.sendCount++;
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			case DO_NEXT: //激活提交成功
				//更新用户信息
				var user = getUserInfo();
				user.activeStatus = 1;
				updateLoginInfo(null, user);
				if(vueObj.fromThirdAuth && vueObj.webPageId){ //JSSDK调用
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onActiveCardResult", {status: 'ok'});
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(vueObj.source == 'scan'){ //扫码页面
					openWindow("scan", "../scan/scan.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType
					});
				}else if(vueObj.source == "payCodeNew") { //一码付页面
					openWindow("payCodeNew", "../card/pay_code_new.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType
					});
				} else { //二维码页面
					openWindow("payCode", "../card/pay_code.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType
					});
				}
				closeWebview("activeCardFirst");
				closeWebview("activeCardSecond");
				break;
			case DO_APPEAL: //申诉成功
				if(vueObj.fromThirdAuth){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onBindCardResult", {status: 'ok'});
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else{
					openWindow("bindCardSuccess", "../card/bind_card_success.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType,
						bindType: "appeal"
					});
				}
				//更新用户信息
				updateLoginInfo(null, data.data);
				//刷新相关页面
				mui.fire(plus.webview.getWebviewById("card/card_main.html"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("setting"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("userInfo"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("payResult"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("appList"), "onUserInfoChange", {});
				//关闭当前页
				closeWebview("activeCardFirst");
				closeWebview("activeCardSecond");
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 输入框输入监听
		 */
		onInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9]/g, '');
			e.currentTarget.value = value;
			//最长只支持6位
			if(value.length > 6){
				e.currentTarget.value = value.substring(0, 6);
				return;
			}
			if(value.length <= 0){
				vueObj.smsScoded = '';
				for(var i=0; i<6; i++){
					Vue.set(vueObj.showPwds, i, '');
				}
				return;
			}
			vueObj.smsScoded = value;
			for(var i=0; i<6; i++){
				if(i < vueObj.smsScoded.length){
					Vue.set(vueObj.showPwds, i, vueObj.smsScoded[i]);
				}else{
					Vue.set(vueObj.showPwds, i, "");
				}
			}
			//触发确定方法
			if(value.length == 6){
				vueObj.doNext();
			}
		},
	}
}); 

/**进入页面弹出键盘*/
var initNativeObjects = function() {
    if (mui.os.android) {
        var main = plus.android.runtimeMainActivity();
        var Context = plus.android.importClass("android.content.Context");
        InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
        imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
    } else {
        nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    }
};
var showSoftInput = function() {
    var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    if (mui.os.android) {
        //强制当前webview获得焦点
        plus.android.importClass(nativeWebview);
        nativeWebview.requestFocus();
        imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
    } else {
        nativeWebview.plusCallMethod({
            "setKeyboardDisplayRequiresUserAction": false
        });
    }
    setTimeout(function() {
       //此处可写具体逻辑设置获取焦点的input
       document.getElementById("hideInput").focus();
    }, 300);
};