//请求码
var DO_BIND = 1001, GET_SCRHOOL_INFO = 1002, UPDATE_USER_INFO = 1003, GET_CODE = 1004;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		from: null, //selectSchool(来自学校选择界面)
		realName: '',
		studentNo: '',
		cardPwd: '',
		gender: '',
		genderValue: '',
		bindTitle: '',
		bindHolder: '',
		bindType: 0, //学校信息(支持绑卡类型 1一卡通账号 2学/工号 3身份证 )
		bindTypeList: [], //支持的一卡通绑定方式列表
		cardExistFlag: -1, //是否支持一卡通 1是 0否
		cardPwdStatus: -1, //一卡通绑定是否需要密码 1需要密码 0不需要密码
		bindPwdRemind: '',
		fromThirdAuth: false, //是否来自第三方
		webPageId: '', //第三方页面ID
		checkCode: null,
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		sendCount: 1, //短信验证码发送次数
		showCode: false, //是否显示验证码
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(vueObj.fromThirdAuth && vueObj.webPageId){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onBindCardResult", {status: 'cancel'});
				}
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//添加统计事件
			statisticEvent("userBindCard00");
			//参数
			vueObj.fromThirdAuth = plus.webview.currentWebview().fromThirdAuth;
			vueObj.webPageId = plus.webview.currentWebview().webPageId;
			vueObj.from = plus.webview.currentWebview().from;
			if(vueObj.from == 'selectSchool'){
				document.getElementById("jumpBtn").style.display = "block";
			}
			//查询学校信息，获取支持的绑卡方式
			showWaiting();
			webCall2("/compus/school/getSchoolInfo", null, GET_SCRHOOL_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 确认绑定
		 */
		doBind: function(e) {
			if(!vueObj.realName || vueObj.realName.length <= 0){
				toast("请输入姓名");
				return;
			}
			if(!vueObj.studentNo){
				toast(vueObj.bindHolder);
				return;
			}
			if(vueObj.bindType == 8 && !regexMobile(vueObj.studentNo)){
				toast("请输入正确的手机号");
				return;
			}
			if(vueObj.bindType == 4 && !regexIdCard(vueObj.studentNo)){
				toast("请输入正确的身份证号");
				return;
			}
			if(vueObj.showCode && !vueObj.checkCode){
				toast("请输入验证码");
				return;
			}
			vueObj.cardPwd = document.getElementById("cardPwd").value;
			if(vueObj.cardExistFlag == 1 && vueObj.cardPwdStatus == 1 && !vueObj.cardPwd){
				toast("请输入学生卡密码");
				return;
			}
			if(vueObj.cardExistFlag == 0 && !vueObj.gender){
				toast("请选择性别");
				return;
			}
			showWaiting();
			document.activeElement.blur();
			if(vueObj.cardExistFlag == 1){ //绑卡
				//添加统计事件
				statisticEvent("userBindCard02");
				var params = {
					realName: vueObj.realName,
					incomeAccount: vueObj.studentNo,
					accountType: vueObj.bindType
				};
				if(vueObj.showCode){
					params.verificationCode = vueObj.checkCode;
				}
				if(vueObj.cardPwdStatus == 1){
					params.password = vueObj.cardPwd;
				}
				webCall2("/compus/user/bindCard", params, DO_BIND, vueObj.onSuccess, vueObj.onErrorBefore);
			}else{ //完善信息
				webCall2("/compus/user/updateUserInfo", {
					userName: vueObj.realName,
					jobNo: vueObj.studentNo,
					sex: vueObj.genderValue
				}, UPDATE_USER_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_SCRHOOL_INFO: //学校信息
				vueObj.cardPwdStatus = data.data.cardPwdStatus;
				vueObj.bindPwdRemind = data.data.bindPwdRemind;
				vueObj.cardExistFlag = data.data.cardExistFlag;
				vueObj.bindTypeList = data.data.idcardBindTypeList;
				if(vueObj.cardExistFlag == 1 && vueObj.bindTypeList.length > 0){
					document.getElementById("title").innerText = "卡绑定";
					vueObj.bindType = vueObj.bindTypeList[0].code;
					vueObj.bindTitle = vueObj.bindTypeList[0].name;
					vueObj.bindHolder = vueObj.bindTypeList[0].desc;
					//添加统计事件
					statisticEvent("userBindCard01");
				}else{
					vueObj.bindType = 2;
					vueObj.bindTitle = "学/工号";
					vueObj.bindHolder = "请输入学号或工号";
					var user = getUserInfo();
					vueObj.realName = user.userName;
					vueObj.studentNo = user.jobNo;
					vueObj.gender = user.sex==1?'男':'女';
					vueObj.genderValue = user.sex;
					document.getElementById("title").innerText = vueObj.studentNo ? "编辑信息" : "完善信息";
				}
				break;
			case DO_BIND: //绑定操作
				//添加统计事件
				statisticEvent("userBindCard03");
				if(vueObj.fromThirdAuth){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onBindCardResult", {status: 'ok'});
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else{
					openWindow("bindCardSuccess", "bind_card_success.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType
					});
				}
				//更新用户信息
				updateLoginInfo(null, data.data);
				//刷新相关页面
				var wvs=plus.webview.all();
				for(var i = 0; i < wvs.length; i++) {
					//刷新学生卡首页
					if(wvs[i].getURL() && isEndSpecifiedStr(wvs[i].getURL(), "card_main.html")) {
						mui.fire(wvs[i], "onUserInfoChange", {});
						break;
					}
				}
				mui.fire(plus.webview.currentWebview().opener(), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("setting"), "onUserInfoChange", {});
				var userInfoWeb = plus.webview.getWebviewById("userInfo");
				if(userInfoWeb){
					mui.fire(userInfoWeb, "onUserInfoChange", {});
				}
				var payResultWeb = plus.webview.getWebviewById("payResult");
				if(payResultWeb){
					mui.fire(payResultWeb, "onUserInfoChange", {});
				}
				var appListWeb = plus.webview.getWebviewById("appList");
				if(appListWeb){
					mui.fire(appListWeb, "onUserInfoChange", {});
				}
				//通知充值页面 刷新余额
				if(plus.webview.currentWebview().opener()){
					var rechargeCardUrl = plus.webview.currentWebview().opener().getURL();
					var rechargeCardId = plus.webview.currentWebview().opener().id;
					if(rechargeCardUrl.indexOf("recharge_card.html") > 0 && rechargeCardId && plus.webview.getWebviewById(rechargeCardId)){
						mui.fire(plus.webview.getWebviewById(rechargeCardId), "onUserInfoChange", {});
					}
				}
				//关闭当前页 
				closeWebview("bindCard", true);
				break;
			case UPDATE_USER_INFO: //完善信息
				var user = getUserInfo();
				user.userName = vueObj.realName;
				user.jobNo = vueObj.studentNo;
				user.sex = vueObj.genderValue;
				setCache(USER_INFO_KEY, JSON.stringify(user));
				//通知页面
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onUserInfoChange", {});
				var userInfoWeb = plus.webview.getWebviewById("userInfo");
				if(userInfoWeb){
					mui.fire(userInfoWeb, "onUserInfoChange", {});
				}
				//关闭当前页
				closeWebview("bindCard");
				break;
			case GET_CODE: //获取验证码
				vueObj.sendCount++;
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			if(requestCode == DO_BIND && resultCode == 210){
				confirmDialog('', '学生卡已被' + data.data.bindPhone + '绑定，是否要申诉', '取消', '我要申诉', function cancelCallback(){
					mui.back();
				}, function sureCallback(){
					if(data.data && data.data.reservePhone){ //预留手机激活
						openWindow("activeCardFirst", "../card/active_card_first.html", false, {
							statusBarType: plus.webview.currentWebview().statusBarType,
							phone: data.data.reservePhone,
							activeType: 'appeal',
							realName: vueObj.realName,
							incomeAccount: vueObj.studentNo,
							accountType: vueObj.bindType,
							fromThirdAuth: vueObj.fromThirdAuth,
							webPageId: vueObj.webPageId,
						});
						setTimeout(function(){
							closeWebview(plus.webview.currentWebview().id);
						}, 500);
					}else{
						toast("校园一卡通系统未录入您的信息，请前往一卡通中心补录");						
					}
				});
				return;
			}
			onError(resultCode, resultMsgDesc);
			if(requestCode == DO_BIND){
				//添加统计事件
				statisticEvent("userBindCard04", {"error": resultMsgDesc});
			}
		},
		/**
		 * 绑卡类型选择
		 */
		onTypeSelect: function(e){
			if(vueObj.bindTypeList.length <= 0) return;
			var buttons = [];
			for(var i in vueObj.bindTypeList){
				buttons[i] = {id:vueObj.bindTypeList[i].code,title:vueObj.bindTypeList[i].name};
			}
			plus.nativeUI.actionSheet({
				title: "请选择绑卡类型",
				cancel: "取消",
				buttons: buttons
			}, function(e) {
				if(e.index > 0) {
					vueObj.bindType = vueObj.bindTypeList[e.index - 1].code;
					vueObj.bindTitle = vueObj.bindTypeList[e.index - 1].name;
					vueObj.bindHolder = vueObj.bindTypeList[e.index - 1].desc;
					//如果绑卡类型为手机号，则判断是否输入为手机号并且与当前登录手机号是否一致
					if(vueObj.bindType == 8 && regexMobile(vueObj.studentNo) && vueObj.studentNo != getCache(ACCOUNT_KEY)){
						vueObj.showCode = true;
					}else{
						vueObj.showCode = false;
					}
				}
			});
		},
		/*
		 * 弹出性别选择框
		 */
		onSelectSex: function(){
			var buttons = [{id: '1',title: '男'}, {id: '2',title: '女'}];
			plus.nativeUI.actionSheet({
				title: "请选择性别",
				cancel: "取消",
				buttons: buttons
			}, function(e) {
				if(e.index > 0) {
					vueObj.genderValue = buttons[e.index - 1].id;
					vueObj.gender = buttons[e.index - 1].title;
				}
			});
		},
		/**
		 * 学/工号输入框改变方法（数字和英文）
		 */
		inputJobNoChange: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9a-zA-Z]/g, '');
			vueObj.studentNo = value;
			//如果绑卡类型为手机号，则判断是否输入为手机号并且与当前登录手机号是否一致
			if(vueObj.bindType == 8 && regexMobile(vueObj.studentNo) && vueObj.studentNo != getCache(ACCOUNT_KEY)){
				vueObj.showCode = true;
			}else{
				vueObj.showCode = false;
			}
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在60s计时
			if(!vueObj.realName){
				toast("请输入姓名")
				return;
			}
			if(!vueObj.studentNo || !regexMobile(vueObj.studentNo)){
				toast("请输入正确的手机号码")
				return;
			}
			showWaiting();
			webCall2("/compus/user/sendBindCardVerificationCode", {
				realName: vueObj.realName,
				mobilePhone: vueObj.studentNo,
				sendCount: vueObj.sendCount
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		}
	}
});

//跳过按钮监听
document.getElementById("jumpBtn").addEventListener("tap", function(){
	mui.back();
});