/** 网络请求码 */
var QUERY_ADS = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		successTxt: "",
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		bindCardStatus: -1, //绑卡状态 1已经绑卡 0未绑卡
		realNameStatus: -1, //实名认证状态 1未实名 2申请中 3认证成功 4认证失败
		bindType: null, //appeal申诉
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听用户数据变化
			window.addEventListener("onUserInfoChange", function(event){
				var user = getUserInfo();
				vueObj.bindCardStatus = user.bindCardStatus ? user.bindCardStatus : vueObj.bindCardStatus;
			});
			if(plus.webview.currentWebview().bindType == "appeal"){ //申诉成功
				document.getElementById("title").innerText = "申诉成功";
				vueObj.successTxt = "申诉成功，已绑定学生卡";
			}else{
				document.getElementById("title").innerText = "学生卡绑定";
				vueObj.successTxt = "绑卡成功";
			}
			var user = getUserInfo();
			vueObj.bindCardStatus = user.bindCardStatus ? user.bindCardStatus : 0;
			vueObj.realNameStatus = user.realNameStatus;
			//查询广告
			showWaiting();
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:'k12_3001'}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 下一步，跳转到实名认证页面
		 */
		doNext: function(e) {
			openWindow("authFirst", "../center/auth_first.html", false, {
				statusBarType: plus.webview.currentWebview().statusBarType
			});
			closeWebview("bindCardSuccess");
		},
		doBack: function(e) {
			mui.back();
		},
		/**
		 * 接口请求成功
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_ADS: //广告数据加载
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;
			default:
				break;
			}
		},
		/**
		 * 接口请求失败
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "绑卡成功页", "pos": "绑卡成功页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && vueObj.bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});