var myScroll;
var isLoadingMore;
var isNoMore;
var start = 0;
var dtpicker;
//请求码
var QUERY_LIST = 1001, QUERY_ADS = 1002;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		bindCardStatus: -1, //绑卡状态 1已经绑卡 0未绑卡
		schoolName: null,
		datas: [],
		queryTime: null //查询时间，例如:2018-01-01
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			var user = getUserInfo();
			vueObj.bindCardStatus = user.bindCardStatus;
			//加载数据
			showWaiting();
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:'k12_3002'}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
			vueObj.queryTime = formatDate(new Date().getTime());
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			start = 0; //没有分页
			var qTime = vueObj.queryTime.replace("-", "").replace("-", "");
			webCall2("/compus/user/queryNo", {
				queryTime: qTime
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST:
				vueObj.schoolName = data.data;
				//更新数据
				vueObj.datas = (start == 0 ? data.rows : vueObj.datas.concat(data.rows));
				start = vueObj.datas.length;
				//无数据图
				if(vueObj.datas.length == 0) {
					setNoDataBackground(true);
				} else {
					setNoDataBackground(false);
				}
				if(vueObj.datas.length < 4){
					document.getElementById("item0mobileSpan").style.display = "none";
				}else {
					document.getElementById("item0mobileSpan").style.display = "";
				}
				closePullStatus(data.rows);
				break;
			case QUERY_ADS: //广告数据加载
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
			if(start == 0){
				document.getElementById("item0mobileSpan").style.display = "none";
			}
		},
		/**
		 * 选择日期
		 */
		selectDate: function(e) {
			if(dtpicker == null){
				dtpicker = new mui.DtPicker({
				    type: "date",//设置日历初始视图模式 
				    beginDate: new Date(2000, 01, 01),//设置开始日期 
				    endDate: new Date(),//设置结束日期 
				});
			}
			dtpicker.show(function(e) {
			    var sdate = e.text;
			    if(vueObj.queryTime == sdate) return;
			    vueObj.queryTime = sdate;
			    showWaiting();
			    vueObj.loadData();
			});
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "学生卡交易明细页", "pos": "学生卡交易明细页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && getUserInfo().bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore = false;
			setTimeout(function() {
				start = 0;
				vueObj.loadData();
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
	
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull($('#main'), pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		//if(data.length < 10) {
			document.getElementById("item0mobileSpan").innerHTML = "没有更多数据了";
			isNoMore = true;
		//} else {
		//	document.getElementById("item0mobileSpan").innerHTML = "正在加载...";
		//	isNoMore = false;
		//}
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}

// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
		//无数据时不显示上拉显示更多
		document.getElementById("item0mobileSpan").style.display = "none";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
		document.getElementById("item0mobileSpan").style.display = "";
	}
}