//请求码
var QUERY_CODE = 1001, QUERY_CODE_RESULT = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		codeType: 0, //二维码类型,0支付 1门禁
		brightness: 0, //屏幕亮度值
		nowCode: 'pay', //当前显示的二维码
		qrCodeObj: null, //二维码生成对象
		qrCodeObjPop: null,
		qrCodeStr: null, //当前的二维码字符串
		timer: null, //计时器对象
		showPop: false
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				vueObj.queryQRCodeResult();
				vueObj.clearTimeout();
				vueObj.setBrightness(true);
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			setStatusBarMain();
			//保存当前屏幕亮度
			vueObj.brightness = plus.screen.getBrightness();
			//此页面不允许侧滑返回，需要关闭timer
			//plus.webview.currentWebview().setStyle({'popGesture':'none'});
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始，清除定时器
					vueObj.queryQRCodeResult();
					vueObj.clearTimeout();
					vueObj.setBrightness(true);
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消，重新生成二维码
					vueObj.makeCode();
					vueObj.setBrightness();
					setStatusBarMain();
				}
			}, false);
			//初始化qrcode
			vueObj.initQRCodeObj();
			//程序从后台进入前台的监听事件
			window.addEventListener("resume", function(){
				vueObj.setBrightness();
				vueObj.makeCode();
			}, false);
			//程序从前台进入后台的监听事件
			window.addEventListener("pause", function(){
				vueObj.setBrightness(true);
				vueObj.queryQRCodeResult();
				vueObj.clearTimeout();
			}, false);
			//检验监听
			window.addEventListener("verifySuccess", function(){
				vueObj.showPop = false;
				//调用校验接口
				showWaiting();
				webCall2("/compus/user/device/checkPassAndGetQrCode", {
					payType: 'CARDPAY'
				}, QUERY_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
			});
			//设置屏幕亮度
			vueObj.setBrightness();
			//生成二维码
			vueObj.makeCode(true);
		});
	},
	methods: {
		/**
		 * qrcode生成器初始化
		 */
		initQRCodeObj: function() {
			//小图
			var qrcode = document.getElementById("qrcode");
			var qrLogo = document.getElementById("qrLogo");
			var width = qrcode.offsetWidth;
			qrcode.style.height = width + "px";
			qrLogo.style.width = width / 5 + "px";
			qrLogo.style.height = width / 5 + "px";
			qrLogo.style.left = width / 2 + 30 - width/10 + "px";
			qrLogo.style.top = width / 2 - width/10 + "px";
			vueObj.qrCodeObj = new QRCode(qrcode, {
				width: width,
				height: width
			});
			//大图
			var qrcodePop = document.getElementById("qrcodePop");
			var qrLogoPop = document.getElementById("qrLogoPop");
			qrcodePop.style.width = window.innerWidth * 0.7 + "px";
			qrcodePop.style.height = window.innerWidth * 0.7 + "px";
			qrcodePop.style.left =  window.innerWidth * 0.15 + "px";
			qrLogoPop.style.left = window.innerWidth / 2 - 20 + "px";
			qrLogoPop.style.top = window.innerWidth * 0.35 + 160 - 20 + "px";
			vueObj.qrCodeObjPop = new QRCode(qrcodePop, {
				width: window.innerWidth * 0.7,
				height: window.innerWidth * 0.7
			});
		},
		/**
		 * 设置屏幕亮度
		 */
		setBrightness: function(isBack, isChecked) {
			//如果是Android，并且没有验证过系统设置权限，则检验权限
			if(plus.os.name == 'Android' && !isChecked){
				checkUserPermission("SCREEN", null, function(){
					vueObj.setBrightness(isBack, true);
				});
				return;
			}
			if(isBack){
				plus.screen.setBrightness(vueObj.brightness);
				return;
			}
			if(vueObj.brightness < 0.9){
				plus.screen.setBrightness(0.9);
			}
		},
		/**
		 * 生成二维码
		 */
		makeCode: function(isFirst) {
			if(vueObj.nowCode == 'pay'){
				//document.getElementById("title").innerText = "付款码";
			}else {
				//document.getElementById("title").innerText = "门禁码";
			}
			if(isFirst) showWaiting();
			webCall2("/compus/user/getQRCode", {
				type: vueObj.codeType
			}, QUERY_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 获取二维码状态
		 */
		queryQRCodeResult: function() {
			if(!vueObj.qrCodeStr) return;
			webCall2("/compus/user/getQRCodeResult", {
				qrCode: vueObj.qrCodeStr
			}, QUERY_CODE_RESULT, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 清除自动定时器
		 */
		clearTimeout: function(){
			if(vueObj.timer){
				clearTimeout(vueObj.timer);
				vueObj.timer = null;
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_CODE: //获取二维码
				if(!data.data) return;
				vueObj.qrCodeStr = data.data;
				//生成二维码
				vueObj.qrCodeObj.makeCode(data.data);
				if(document.getElementById("payCodePopParent").style.display == 'block'){
					vueObj.qrCodeObjPop.makeCode(data.data);
				}
				//开始60秒倒计时
				vueObj.startTimer();
				//开始获取二维码状态
				setTimeout(function(){
					vueObj.queryQRCodeResult();	
				}, 5000);
				break;
			case QUERY_CODE_RESULT: //获取二维码状态
				var recflag = data.data.recflag; //0未支付1已支付2支付失败
				if(recflag == 1){
					openWindow("payResult", "../common/pay_result.html", false, {
						type: "一卡通",
						money: data.data.monDealCur,
						statusBarType: plus.webview.currentWebview().statusBarType
					}, null, true);
					vueObj.clearTimeout();
					vueObj.setBrightness(true);
					closeWebview(plus.webview.currentWebview().id);
					return;
				}else if(recflag == 2){ //支付失败，重新刷新二维码
					toast("支付失败，请重试");
					vueObj.clearTimeout();
					vueObj.makeCode();
					return;
				}
				if(vueObj.timer == null) return;
				//每隔5秒获取一次状态
				setTimeout(function(){
					vueObj.queryQRCodeResult();	
				}, 5000);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();			
			if(requestCode == QUERY_CODE && resultCode == 207){
				vueObj.setBrightness(true);
				confirmDialog('学生卡未激活', '激活后，可使用学生卡付款码', '取消', '去激活', function cancelCallback(){
					mui.back();
				}, function sureCallback(){
					if(data.data && data.data.cardActiveType == 1){ //预留手机激活
						openWindow("activeCardFirst", "../card/active_card_first.html", false, {
							statusBarType: plus.webview.currentWebview().statusBarType,
							phone: data.data.reservePhone
						});
					}else{
						openWindow("payCodeActive", "../card/pay_code_active.html", false, {
							statusBarType: plus.webview.currentWebview().statusBarType
						});
					}
					setTimeout(function(){
						closeWebview(plus.webview.currentWebview().id);
					}, 500);
				});
				return;
			}else if(resultCode == 211){ //验证指纹
				vueObj.startFinger(data.data);
			}else if(resultCode == 212){ //验证手势密码
				vueObj.startGesture(data.data);
			}
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 开始指纹验证
		 */
		startFinger: function(gesturePwd) {
			if(plus.os.name == 'Android') vueObj.showPop = true;
			plus.fingerprint.authenticate(function(e){
				console.log("success")
				vueObj.showPop = false;
				if(plus.os.name == 'Android') plus.fingerprint.cancel();
				//调用校验接口
				mui.fire(plus.webview.currentWebview(), "verifySuccess", {});
			}, function(e){
				console.log(e.code + ", " + e.message)
				vueObj.showPop = false;
				if(e.code == 5){
					if(gesturePwd){
						toast("指纹识别错误次数超过限制，请使用手势密码");
						vueObj.startGesture(gesturePwd);
						return;
					}
					if(plus.os.name == 'Android') plus.fingerprint.cancel();
					toast("指纹识别错误次数超限，请输入支付密码");
					openWindow("payCodeActive", "../card/pay_code_active.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType,
						opeType: 'pwdCheck',
						type: 'payPwd',
						selfId: plus.webview.currentWebview().id
					});
				}else if(e.code == 6){ //取消
					if(plus.os.name == 'Android') plus.fingerprint.cancel();
					mui.back();
				}else{
					toast("指纹识别不匹配");
					setTimeout(function(){
						vueObj.showPop = true;
					}, 1500);
				}
			}, {
				message: '请验证已有的指纹'
			});
		},
		/**
		 * 取消指纹验证
		 */
		cancelFinger: function(e) {
			vueObj.showPop = false;
			if(plus.os.name == 'Android') plus.fingerprint.cancel();
			mui.back();
		},
		/**
		 * 手势密码验证 
		 */
		startGesture: function(pwd){
			openWindow("payCodeLocker", "../card/pay_code_locker.html", false, {
				statusBarType: STATUS_BAR_MAIN_KEY,
				type: 'verify',
				pwd: pwd,
				selfId: plus.webview.currentWebview().id
			});
			setTimeout(function(){
				vueObj.showPop = false;
			}, 1000);
		},
		/**
		 * 点击按钮监听
		 */
		onButtonClick: function(e) {
			var code = e.currentTarget.dataset.code;
			if(code == vueObj.nowCode){
				return;
			}
			if(code == 'pay'){
				vueObj.codeType = 0;
			}else{
				vueObj.codeType = 1;
			}
			vueObj.nowCode = code;
			//更换二维码
			vueObj.makeCode();
		},
		/**
		 * 60秒倒计时
		 */
		startTimer: function() {
			console.log("==============60秒倒计时==============");
			//清除当前计时器
			vueObj.clearTimeout();
			//重新开始计时
			vueObj.timer = setTimeout(function(){
				console.log("==============开始刷新二维码==============");
				vueObj.queryQRCodeResult();
				vueObj.makeCode();
			}, 60000);
		},
		showQRCodePop: function() {
			if(!vueObj.qrCodeStr) return;
			document.getElementById("payCodePopParent").style.display = "block";
			document.getElementById("payCodePopover").classList.add("mui-active");
			document.getElementById("qrLogo").style.display = "none";
			//生成二维码
			vueObj.qrCodeObjPop.makeCode(vueObj.qrCodeStr);
		},
		closeQRCodePop: function() {
			document.getElementById("payCodePopParent").style.display = "none";
			document.getElementById("payCodePopover").classList.remove("mui-active");
			document.getElementById("qrLogo").style.display = "block";
		}
	}
});

//弹窗透明处点击
document.getElementById("payCodePopParent").addEventListener("tap", function(e){
	vueObj.closeQRCodePop();
	e.stopPropagation();
});

var refreshTime = 0;
//监听标题更多按钮
document.getElementById("moreBtn").addEventListener("tap", function(e){
	var buttons = [{id:'0', title:'刷新付款码'}, {id:'1', title:'安全设置'}];
	plus.nativeUI.actionSheet({
		cancel: "取消",
		buttons: buttons
	}, function(e){
		if(e.index <= 0) return;
		if(e.index == 1){ //刷新二维码
			//刷新间隔2秒以上
			if(new Date().getTime() - refreshTime < 2000){
				return;
			}
			refreshTime = new Date().getTime();
			vueObj.queryQRCodeResult();
			vueObj.clearTimeout();
			vueObj.makeCode();
		}else if(e.index == 2){ //安全设置
			openWindow("payCodeSetting", "../card/pay_code_setting.html", false, {
				statusBarType: STATUS_BAR_MAIN_KEY
			});
		}
	});
});