//请求码
var DO_ACTIVE = 1001, GET_SCRHOOL_INFO = 1002, DO_MODIFY = 1003;
//键盘相关参数
var nativeWebview, imm, InputMethodManager;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		pwds: '', //输入的6位密码
		payPwds: null, //支付密码
		resetPwds: null, //重置第一次输入的密码
		showPwds: ['', '', '', '', '', ''], //输入的6位密码(密文)
		bindPwdRemind: '',
		opeType: 'active', //active reset01 reset02
		type: '',
		active: 0,
		topTitle: '请输入学生卡支付密码',
		btnTxt: '提交'
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//数据接收
			if(plus.webview.currentWebview().opeType){
				vueObj.opeType = plus.webview.currentWebview().opeType;
				vueObj.type = plus.webview.currentWebview().type;
				vueObj.active = plus.webview.currentWebview().active;
			}
			vueObj.setTxtContent();
			//查询学校信息
			webCall2("/compus/school/getSchoolInfo", null, GET_SCRHOOL_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
			/**进入页面弹出键盘*/
		    initNativeObjects();
		    showSoftInput();
		});
	},
	methods: {
		/**
		 * 设置页面文案
		 */
		setTxtContent: function() {
			if(vueObj.opeType == 'active'){ //激活
				document.getElementById("title").innerText = "学生卡激活";
				vueObj.topTitle = "请输入学生卡支付密码";
				vueObj.btnTxt = "提交";
			}else if(vueObj.opeType == 'pwdCheck'){ //验证密码
				document.getElementById("title").innerText = "验证学生卡密码";
				vueObj.topTitle = "请输入学生卡支付密码";
				vueObj.btnTxt = "提交";
			}else if(vueObj.opeType == 'reset01'){ //重置密码输入密码
				document.getElementById("title").innerText = "重置密码";
				vueObj.topTitle = "请输入新密码";
				vueObj.btnTxt = "下一步";
			}else{ //重置密码输入密码
				vueObj.resetPwds = vueObj.pwds;
				document.getElementById("title").innerText = "重置密码";
				vueObj.topTitle = "请输入确认密码";
				vueObj.btnTxt = "提交";
			}
			vueObj.pwds = '';
			vueObj.showPwds = ['', '', '', '', '', ''];
			document.getElementById("hideInput").value = "";
		},
		/**
		 * 下一步
		 */
		doNext: function(e) {
			if(vueObj.pwds.length < 6) return;
			document.activeElement.blur();
			if(vueObj.opeType == 'active' || vueObj.opeType == 'pwdCheck'){ //一卡通激活
				showWaiting();
				webCall2("/compus/user/checkPwd", {password: vueObj.pwds}, DO_ACTIVE, vueObj.onSuccess, vueObj.onErrorBefore);
			}else if(vueObj.opeType == 'reset01'){ //重置密码第一次输入密码
				if(vueObj.judgeContinueRepeat(vueObj.pwds)){
					toast("密码不能是重复、连续的数字");
					return;
				}
				vueObj.opeType = "reset02";
				vueObj.setTxtContent();
			}else{ //重置密码
				if(vueObj.pwds != vueObj.resetPwds){
					toast("两次输入密码不一致，请重新输入");
					vueObj.opeType = "reset01";
					vueObj.setTxtContent();
					return;
				}
				showWaiting();
				webCall2("/compus/user/changeIdCardPassword", {
					oldPwd: vueObj.payPwds,
					newPwd: vueObj.pwds
				}, DO_MODIFY, vueObj.onSuccess, vueObj.onErrorBefore);
			}
		},
		/**
		 * 输入框输入监听
		 */
		onInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9]/g, '');
			e.currentTarget.value = value;
			//最长只支持6位
			if(value.length > 6){
				e.currentTarget.value = value.substring(0, 6);
				return;
			}
			if(value.length <= 0){
				vueObj.pwds = '';
				for(var i=0; i<6; i++){
					Vue.set(vueObj.showPwds, i, '');
				}
				return;
			}
			vueObj.pwds = value;
			for(var i=0; i<6; i++){
				if(i < vueObj.pwds.length){
					Vue.set(vueObj.showPwds, i, "●");
				}else{
					Vue.set(vueObj.showPwds, i, "");
				}
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_SCRHOOL_INFO: //学校信息
				vueObj.bindPwdRemind = data.data.bindPwdRemind;
				break;
			case DO_MODIFY: //密码重置成功
				toast("密码重置成功");
				vueObj.jumpToNext();
				break;
			case DO_ACTIVE: //学生卡激活
				if(vueObj.opeType == 'pwdCheck'){ //验证支付密码成功
					vueObj.jumpToNext();
					return;
				}
				//更新用户信息
				var user = getUserInfo();
				user.activeStatus = 1;
				updateLoginInfo(null, user);
				if(vueObj.judgeContinueRepeat(vueObj.pwds)){
					confirmDialog('', '您的学生卡密码过于简单，为了您的学生卡用卡安全，请前往修改密码', '取消', '前往修改密码', function cancelCallback(){
						//跳转页面
						vueObj.jumpToNext();
					}, function sureCallback(){
						vueObj.payPwds = vueObj.pwds;
						vueObj.opeType = "reset01";
						vueObj.setTxtContent();
					});
					return;
				}
				//跳转页面
				vueObj.jumpToNext();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 跳转下一页面
		 */
		jumpToNext: function() {
			var self = plus.webview.currentWebview();
			if(self.source && self.source == "scan") { //扫码页面
				openWindow("scan", "../scan/scan.html", false, {
					statusBarType: self.statusBarType
				});
			}else if(self.source && self.source == "payCodeNew") { //一码付页面
				openWindow("payCodeNew", "../card/pay_code_new.html", false, {statusBarType: self.statusBarType});
			}else if(vueObj.active == 1){ //关闭锁验证
				mui.fire(plus.webview.getWebviewById("payCodeSetting"), "onSwitchChange", {type:vueObj.type,action:'close'});
			}else if(vueObj.type == 'finger'){
				openWindow("payCodeFinger", "../card/pay_code_finger.html", false, {statusBarType: self.statusBarType});
			}else if(vueObj.type == 'gesture'){
				openWindow("payCodeLocker", "../card/pay_code_locker.html", false, {statusBarType: self.statusBarType});
			}else if(vueObj.type == 'payPwd'){
				mui.fire(plus.webview.getWebviewById(plus.webview.currentWebview().selfId), "verifySuccess", {});
				mui.back();
				return;
			}else{ //二维码页面
				openWindow("payCode", "../card/pay_code.html", false, {statusBarType: self.statusBarType});
			}
			//关闭当前页
			closeWebview(self.id);
		},
		/**
		 * 判断是否重复、连续的数字
		 */
		judgeContinueRepeat: function(numStr) {
			var numArray = numStr.split("");
			var isContinue = true;
			for(var i=0; i<numArray.length-2; i++){
				if((parseInt(numArray[i+1])-parseInt(numArray[i])) != (parseInt(numArray[i+2])-parseInt(numArray[i+1]))){
					isContinue = false;
					break;
				}
			}
			return isContinue;
		}
	}
});

/**进入页面弹出键盘*/
var initNativeObjects = function() {
    if (mui.os.android) {
        var main = plus.android.runtimeMainActivity();
        var Context = plus.android.importClass("android.content.Context");
        InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
        imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
    } else {
        nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    }
};
var showSoftInput = function() {
    var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    if (mui.os.android) {
        //强制当前webview获得焦点
        plus.android.importClass(nativeWebview);
        nativeWebview.requestFocus();
        imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
    } else {
        nativeWebview.plusCallMethod({
            "setKeyboardDisplayRequiresUserAction": false
        });
    }
    setTimeout(function() {
       //此处可写具体逻辑设置获取焦点的input
       document.getElementById("hideInput").focus();
    }, 300);
};