//请求码
var DO_NEXT = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		showPop: false
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//开启验证
			vueObj.startFinger();
		});
	},
	methods: {
		/**
		 * 开始验证指纹
		 */
		startFinger: function() {
			if(plus.os.name == 'Android') vueObj.showPop = true;
			plus.fingerprint.authenticate(function(e){
				console.log("success")
				vueObj.showPop = false;
				if(plus.os.name == 'Android') plus.fingerprint.cancel();
				//调用保存接口
				showWaiting();
				webCall2("/compus/user/device/save", {
					securityType: 1,
					action: 1
				}, DO_NEXT, vueObj.onSuccess, vueObj.onErrorBefore);
			}, function(e){
				console.log(e.code + ", " + e.message)
				vueObj.showPop = false;
				if(plus.os.name == 'Android') plus.fingerprint.cancel();
				if(e.code == 5){
					toast("指纹识别错误次数超过限制，请稍后再试");
				}else if(e.code == 6){
					toast("识别取消");
				}else{
					toast("指纹识别不匹配");
				}
			}, {
				message: '请验证已有的指纹，以设置指纹解锁付款码'
			});
		},
		/**
		 * 取消指纹验证
		 */
		cancelFinger: function(e) {
			vueObj.showPop = false;
			if(plus.os.name == 'Android') plus.fingerprint.cancel();
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_NEXT: //指纹修改成功
				mui.fire(plus.webview.getWebviewById("payCodeSetting"), "onSwitchChange", {type:'finger'});
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		}
	}
});