//请求码
var DO_NEXT = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		topTxt: '',
		record: [],
		type: null,
		pwd: null,
		verifyTime: 5
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//参数
			vueObj.type = plus.webview.currentWebview().type;
			vueObj.pwd = plus.webview.currentWebview().pwd;
			if(vueObj.type == 'verify'){
				document.getElementById("title").innerText = "验证手势密码";
				vueObj.topTxt = "手势密码";
			}else{
				document.getElementById("title").innerText = "开启手势密码";
				vueObj.topTxt = "设置手势密码";
			}
		});
	},
	methods: {
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_NEXT: //下一步
				mui.fire(plus.webview.getWebviewById("payCodeSetting"), "onSwitchChange", {type:'gesture'});
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 跳转密码校验
		 */
		startPwd: function() {
			openWindow("payCodeActive", "../card/pay_code_active.html", false, {
				statusBarType: plus.webview.currentWebview().statusBarType,
				opeType: 'pwdCheck',
				type: 'payPwd',
				selfId: plus.webview.currentWebview().selfId
			});
			closeWebview("payCodeLocker");
		}
	}
});

//手势处理事件
document.getElementById("holder").addEventListener('done', function(event) {
	var rs = event.detail;
	if (rs.points.length < 4) {
		toast('至少连接4个点，请重新绘制');
		vueObj.topTxt = vueObj.type=='verify' ? '手势密码' : '设置手势密码';
		vueObj.record = [];
		rs.sender.clear();
		return;
	}
	console.log(rs.points.join(''));
	if(vueObj.type == 'verify'){
		if(rs.points.join('') == vueObj.pwd){ //验证成功
			mui.fire(plus.webview.currentWebview().opener(), "verifySuccess", {});
			mui.back();
			return;
		}
		vueObj.verifyTime--;
		if(vueObj.verifyTime < 1){ //进入支付密码验证
			toast("输入错误次数超限，请输入支付密码");
			vueObj.startPwd();
			return;
		}
		vueObj.topTxt = '输入错误，还有' + vueObj.verifyTime + '次机会';
		rs.sender.clear();
		return;
	}
	vueObj.record.push(rs.points.join(''));
	if (vueObj.record.length >= 2) {
		if (vueObj.record[0] == vueObj.record[1]) {
			//调用保存接口
			showWaiting();
			webCall2("/compus/user/device/save", {
				securityType: 2,
				action: 1,
				gesturePassword: vueObj.record[0]
			}, DO_NEXT, vueObj.onSuccess, vueObj.onErrorBefore);
		} else {
			toast('两次手势设定不一致');
		}
		vueObj.topTxt = '设置手势密码';
		rs.sender.clear();
		vueObj.record = [];
	} else {
		vueObj.topTxt = '再次输入手势密码';
		rs.sender.clear();
	}
});