//请求码
var QUERY_CODE = 1001, QUERY_CODE_RESULT = 1002, QUERY_PAY_TYPES = 1003;
var refreshTime = 0;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		currentPayType:{},//当前支付方式
		codeType: 0, //二维码类型,0支付 1门禁
		brightness: 0, //屏幕亮度值
		nowCode: 'pay', //当前显示的二维码
		qrCodeObj: null, //二维码生成对象
		qrCodeObjPop: null,
		qrCodeStr: null, //当前的二维码字符串
		responseQrCodeStr: null,//响应的二维码字符串
		timer: null, //计时器对象
		resultTimer:null, //获取支付状态 计时器对象
		showPop: false
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				vueObj.queryQRCodeResult();
				vueObj.clearTimeout();
				vueObj.setBrightness(true);
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			setStatusBarMain();
			//保存当前屏幕亮度
			vueObj.brightness = plus.screen.getBrightness();
			//此页面不允许侧滑返回，需要关闭timer
			//plus.webview.currentWebview().setStyle({'popGesture':'none'});
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				closeWaiting();
				if(e.type == 'start'){ //侧滑开始，清除定时器
					vueObj.queryQRCodeResult();
					vueObj.clearTimeout();
					vueObj.setBrightness(true);
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消，重新生成二维码
					vueObj.makeCode();
					vueObj.setBrightness();
					setStatusBarMain();
				}
			}, false);
			//初始化qrcode
			vueObj.initQRCodeObj();
			//程序从后台进入前台的监听事件
			window.addEventListener("resume", function(){
				closeWaiting();
				vueObj.setBrightness(); 
				vueObj.makeCode();
			}, false);
			//程序从前台进入后台的监听事件
			window.addEventListener("pause", function(){
				closeWaiting();
				vueObj.setBrightness(true);
				vueObj.queryQRCodeResult();
				vueObj.clearTimeout();
			}, false);
			//监听验证
			window.addEventListener("verifySuccess", function(){
				vueObj.showPop = false;
				//调用校验接口
				showWaiting();
				webCall2("/compus/user/device/checkPassAndGetQrCode", {
					payType: vueObj.currentPayType.payType
				}, QUERY_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
			});
			//设置屏幕亮度
			vueObj.setBrightness();
			//获取支付方式
			vueObj.getPayTypes();
		});
	},
	methods: {
		/**
		 * qrcode生成器初始化
		 */
		initQRCodeObj: function() {
			//小图
			var qrcode = document.getElementById("qrcode");
			var qrLogo = document.getElementById("qrLogo");
			var width = qrcode.offsetWidth;
			qrcode.style.height = width + "px";
			qrLogo.style.width = width / 5 + "px";
			qrLogo.style.height = width / 5 + "px";
			qrLogo.style.left = width / 2 + 45 - width/10 + "px";
			qrLogo.style.top = width / 2 - width/10 + "px";
			//大图
			var qrcodePop = document.getElementById("qrcodePop");
			var qrLogoPop = document.getElementById("qrLogoPop");
			qrcodePop.style.width = window.innerWidth * 0.7 + "px";
			qrcodePop.style.height = window.innerWidth * 0.7 + "px";
			qrcodePop.style.left =  window.innerWidth * 0.15 + "px";
			qrLogoPop.style.left = window.innerWidth / 2 - 20 + "px";
			qrLogoPop.style.top = window.innerWidth * 0.35 + 160 - 20 + "px";
		},
		/*
		 * 设置二维码
		 */
		setQRCodeObj: function(){
			document.getElementById("qrcode").innerHTML = "";
			document.getElementById("qrcodePop").innerHTML = "";
			var qrcodePop = document.getElementById("qrcodePop");
			var qrcode = document.getElementById("qrcode");
			var width = qrcode.offsetWidth;
			vueObj.qrCodeObj = new QRCode(qrcode, {
				width: width,
				height: width
			});
			vueObj.qrCodeObjPop = new QRCode(qrcodePop, {
				width: window.innerWidth * 0.7,
				height: window.innerWidth * 0.7
			});
		},
		/*
		 * 清空二维码
		 */
		clearQRCodeObj: function() { 
			document.getElementById("qrcode").innerHTML = "";
			document.getElementById("qrcodePop").innerHTML = "";
		},
		/**
		 * 设置屏幕亮度
		 */
		setBrightness: function(isBack, isChecked) {
			//如果是Android，并且没有验证过系统设置权限，则检验权限
			if(plus.os.name == 'Android' && !isChecked){
				checkUserPermission("SCREEN", null, function(){
					vueObj.setBrightness(isBack, true);
				});
				return;
			}
			if(isBack){
				plus.screen.setBrightness(vueObj.brightness);
				return;
			}
			if(vueObj.brightness < 0.9){
				plus.screen.setBrightness(0.9);
			}
		},
		/*
		 * 获取支付方式
		 */
		getPayTypes: function(){
			showWaiting();
			webCall2("/compus/yard/getPayTypes", {}, QUERY_PAY_TYPES, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 生成二维码
		 */
		makeCode: function() {
			if(vueObj.nowCode == 'pay'){
				if(!vueObj.currentPayType || !vueObj.currentPayType.payType || vueObj.currentPayType.payType.length <= 0) {
					return;
				}
				if(vueObj.currentPayType.payType == "CARDPAY"){ //一卡通支付
					webCall2("/compus/user/getQRCode", {
						type: 0
					}, QUERY_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
				} else {
					webCall2("/compus/yard/getQrCode", {
						payType: vueObj.currentPayType.payType
					}, QUERY_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
				}
			}else {
				webCall2("/compus/user/getQRCode", {
					type: 1
				}, QUERY_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
			}
		},
		/**
		 * 获取二维码状态
		 */
		queryQRCodeResult: function() {
			if(!vueObj.qrCodeStr || vueObj.nowCode == "door") return;
			var resultUrl;
			if(vueObj.currentPayType.payType == "CARDPAY"){ //一卡通支付
				resultUrl = "/compus/user/getQRCodeResult";
			}else{
				resultUrl = "/compus/yard/getQrcodeStatus";
			}
			webCall2(resultUrl, {
				qrCode: vueObj.qrCodeStr
			}, QUERY_CODE_RESULT, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 清除自动定时器
		 */
		clearTimeout: function(){
			if(vueObj.timer){
				clearTimeout(vueObj.timer);
				vueObj.timer = null;
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			switch(requestCode) {
			case QUERY_CODE: //获取二维码
				closeWaiting();	
				if(!data.data) return;
				vueObj.qrCodeStr = data.data;
				//生成二维码
				vueObj.setQRCodeObj();
				vueObj.qrCodeObj.makeCode(data.data);
				if(document.getElementById("payCodePopParent").style.display == 'block'){
					vueObj.qrCodeObjPop.makeCode(data.data);
				}
				if(vueObj.nowCode == "door") return;
				//开始60秒倒计时
				vueObj.startTimer();
				//开始获取二维码状态
				vueObj.startIntervalResult();
				break;
			case QUERY_CODE_RESULT: //获取二维码状态
				var status = 0;
				var recflag = 0;
				if(data && data.data){
					status = data.data.status; //0未支付1待支付跳转        其他支付
					recflag = data.data.recflag; //0未支付1已支付2支付失败  一卡通支付
				}
				if(vueObj.responseQrCodeStr == vueObj.qrCodeStr && (status == 1 || recflag == 1)){ //响应的订单和之前响应的订单一样 return;
					return;
				}
				if(status == 1){
					vueObj.responseQrCodeStr = vueObj.qrCodeStr;
					showWaiting();
					var autoShow = false;
					var source = "payCodeNew";
					//支付宝支付 未安装客户端 调用H5支付
					if(vueObj.currentPayType.payType == "ALIPAY" && !vueObj.isAppExists("com.eg.android.AlipayGphone", "alipay:")){
						autoShow = true;
						source = "";
						closeWaiting();
					}
					mui.openWindow({ //加载不需要动画  默认是隐藏的
						id: "webPage",
						url: '../common/web_page.html',
						show: { 
							autoShow:autoShow,//页面loaded事件发生后自动显示，默认为true
						    aniShow:"none",//页面显示动画，默认为”slide-in-right“；
						    duration:0//页面动画持续时间，Android平台默认100毫秒，iOS平台默认200毫秒；
						},
						waiting: {
							autoShow: false
						},
						createNew: true,
						extras: {
							"source": source,
							"webUrl": data.data.yardPayUrl,
							statusBarType: STATUS_BAR_MAIN_KEY
						}
					});
					vueObj.clearTimeout();
					clearTimeout(vueObj.resultTimer);
					vueObj.resultTimer = null;
					vueObj.setBrightness(true);
					return;
				} else if(recflag == 1){ //一卡通支付成功
					vueObj.responseQrCodeStr = vueObj.qrCodeStr;
					openWindow("payResult", "../common/pay_result.html", false, {
						type: "一卡通",
						money: data.data.monDealCur,
						statusBarType: plus.webview.currentWebview().statusBarType
					}, null, true);
					vueObj.clearTimeout();
					vueObj.setBrightness(true);
					closeWebview(plus.webview.currentWebview().id);
					return;
				} else if(recflag == 2){ //支付失败，重新刷新二维码
					toast("支付失败，请重试");
					vueObj.clearTimeout();
					vueObj.makeCode();
					return;
				}
				vueObj.startIntervalResult();
				break;
			case QUERY_PAY_TYPES: //获取支付方式
				//closeWaiting();	
				if(!data || !data.rows || data.rows.length <=0) return;
				for(var i in data.rows){
					if(data.rows[i].isDefault == 0){
						if(data.rows[i].payType == "WXPAY" && !vueObj.isAppExists("com.tencent.mm", "weixin:")){ //微信支付
							vueObj.currentPayType = data.rows[0];
							payTypesObj.currentTypeIndex = 0;
							break;
						} 
						vueObj.currentPayType = data.rows[i];
						payTypesObj.currentTypeIndex = i;
						break;
					}
				}
				//如果没有默认取第一个
				if(!vueObj.currentPayType.payType){
					vueObj.currentPayType = data.rows[0];
					payTypesObj.currentTypeIndex = 0;
				}
				payTypesObj.payTypesData = data.rows;
				payTypesObj.setScrollHeight();
				//生成二维码
				vueObj.makeCode();
				break;	
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();			
			if(requestCode == QUERY_CODE && resultCode == 207){
				var title = "激活后，可使用学生卡付款码";
				if(vueObj.nowCode == "door"){
					title = "激活后，可使用学生卡门禁码";
				}
				confirmDialog('学生卡未激活', title, '取消', '去激活', function cancelCallback(){
					mui.back();
				}, function sureCallback(){
					vueObj.setBrightness(true);
					if(data.data && data.data.cardActiveType == 1){ //预留手机激活
						openWindow("activeCardFirst", "../card/active_card_first.html", false, {
							statusBarType: plus.webview.currentWebview().statusBarType,
							phone: data.data.reservePhone,
							source: "payCodeNew",
						});
					}else{
						openWindow("payCodeActive", "../card/pay_code_active.html", false, {
							source: "payCodeNew",
							statusBarType: plus.webview.currentWebview().statusBarType
						});
					}
					setTimeout(function(){
						closeWebview(plus.webview.currentWebview().id);
					}, 500);
				});
				return;
			}else if(resultCode == 211){ //验证指纹
				vueObj.startFinger(data.data);
			}else if(resultCode == 212){ //验证手势密码
				vueObj.startGesture(data.data);
			}
			onError(resultCode, resultMsgDesc);
		},
		startIntervalResult: function() {
			//每隔(一卡通2秒，其他5秒)获取一次状态
			if(vueObj.resultTimer){
				clearTimeout(vueObj.resultTimer);
				vueObj.resultTimer = null;
			}
			if(vueObj.timer == null) return;
			var intervalTime = vueObj.currentPayType.payType == "CARDPAY" ? 5000 : 2000;
			vueObj.resultTimer = setTimeout(function(){
				vueObj.queryQRCodeResult();	
			}, intervalTime);
		},
		/**
		 * 开始指纹验证
		 */
		startFinger: function(gesturePwd) {
			if(plus.os.name == 'Android') vueObj.showPop = true;
			plus.fingerprint.authenticate(function(e){
				console.log("success")
				vueObj.showPop = false;
				if(plus.os.name == 'Android') plus.fingerprint.cancel();
				//调用校验接口
				mui.fire(plus.webview.currentWebview(), "verifySuccess", {});
			}, function(e){
				console.log(e.code + ", " + e.message)
				vueObj.showPop = false;
				if(e.code == 5){
					if(gesturePwd){
						toast("指纹识别错误次数超过限制，请使用手势密码");
						vueObj.startGesture(gesturePwd);
						return;
					}
					if(plus.os.name == 'Android') plus.fingerprint.cancel();
					toast("指纹识别错误次数超限，请输入支付密码");
					openWindow("payCodeActive", "../card/pay_code_active.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType,
						opeType: 'pwdCheck',
						type: 'payPwd',
						selfId: plus.webview.currentWebview().id
					});
				}else if(e.code == 6){ //取消
					if(plus.os.name == 'Android') plus.fingerprint.cancel();
					mui.back();
				}else{
					toast("指纹识别不匹配");
					setTimeout(function(){
						vueObj.showPop = true;
					}, 1500);
				}
			}, {
				message: '请验证已有的指纹'
			});
		},
		/**
		 * 取消指纹验证
		 */
		cancelFinger: function(e) {
			vueObj.showPop = false;
			if(plus.os.name == 'Android') plus.fingerprint.cancel();
			mui.back();
		},
		/**
		 * 手势密码验证 
		 */
		startGesture: function(pwd){
			openWindow("payCodeLocker", "../card/pay_code_locker.html", false, {
				statusBarType: STATUS_BAR_MAIN_KEY,
				type: 'verify',
				pwd: pwd,
				selfId: plus.webview.currentWebview().id
			});
			setTimeout(function(){
				vueObj.showPop = false;
			}, 1000);
		},
		/*
		 * 判断是否安装有某个应该
		 */
		isAppExists: function(andAppid, iosAppid){
			if(plus.os.name == "Android") {
				var Utils = plus.android.importClass("com.app.yunma.common.Utils");
				var main = plus.android.runtimeMainActivity();
				return Utils.isAppExists(main, andAppid);
			} else {
				var NativeJsTool = plus.ios.importClass("NativeJsTool");
				var nativeJsTool = plus.ios.newObject("NativeJsTool");
				var result =  plus.ios.invoke(nativeJsTool, "isInstallApplication:", iosAppid);
				return result == 1 ? true : false;
			}
		},
		/*
		 * 刷新二维码
		 */
		refreshCode: function(){
			//刷新间隔2秒以上
			if(new Date().getTime() - refreshTime < 2000){
				return;
			}
			refreshTime = new Date().getTime();
			vueObj.queryQRCodeResult();
			vueObj.clearTimeout();
			showWaiting();
			vueObj.makeCode();
		},
		/*
		 * 支付方式点击
		 */
		payTypeClick: function(){
			payTypesObj.isShowPayTypes = true;
		},
		/**
		 * 点击按钮监听
		 */
		onButtonClick: function(e) {
			var code = e.currentTarget.dataset.code;
			if(code == vueObj.nowCode){
				return;
			}
			vueObj.qrCodeStr = null;
			vueObj.clearQRCodeObj();
			if(code == 'pay'){
				vueObj.codeType = 0;
				document.getElementById("payCode").classList.add("active");
				document.getElementById("doorCode").classList.remove("active");
				document.getElementById("title").innerText = "付款码";
			}else{
				vueObj.codeType = 1;
				document.getElementById("payCode").classList.remove("active");
				document.getElementById("doorCode").classList.add("active");
				document.getElementById("title").innerText = "门禁码";
			}
			vueObj.nowCode = code;
			//更换二维码
			showWaiting();
			vueObj.makeCode();
		},
		/**
		 * 60秒倒计时
		 */
		startTimer: function() {
			console.log("==============60秒倒计时==============");
			//清除当前计时器
			vueObj.clearTimeout();
			//重新开始计时
			vueObj.timer = setTimeout(function(){
				console.log("==============开始刷新二维码==============");
				vueObj.queryQRCodeResult();
				vueObj.makeCode();
			}, 60000);
		},
		showQRCodePop: function() {
			if(!vueObj.qrCodeStr) return;
			document.getElementById("payCodePopParent").style.display = "block";
			document.getElementById("payCodePopover").classList.add("mui-active");
			document.getElementById("qrLogo").style.display = "none";
			//生成二维码
			vueObj.qrCodeObjPop.makeCode(vueObj.qrCodeStr);
		},
		closeQRCodePop: function() {
			document.getElementById("payCodePopParent").style.display = "none";
			document.getElementById("payCodePopover").classList.remove("mui-active");
			document.getElementById("qrLogo").style.display = "block";
		}
	}
});

//弹窗透明处点击
document.getElementById("payCodePopParent").addEventListener("tap", function(e){
	vueObj.closeQRCodePop();
	e.stopPropagation();
});
//vue初始化
var payTypesObj = new Vue({
	el: "#payModeSelect",
	data: {
		isShowPayTypes: false,
		currentTypeIndex: 0,
		payTypesData: [],//支付方式数据
	},
	beforeMount: function() {
		mui.plusReady(function(){
			mui('.mui-scroll-wrapper').scroll();
		});
	},
	methods: {
		setScrollHeight:function(){
			var resolutionHeight = plus.screen.resolutionHeight;
			var scrollHeight = (payTypesObj.payTypesData.length + 1) * 54;
			if(scrollHeight > resolutionHeight * 0.7) {
				document.getElementById("superScroll").style.height = resolutionHeight * 0.7 + "px";
			} else if(scrollHeight > 270){
				document.getElementById("superScroll").style.height = scrollHeight + "px";
			}
		},
		/*
		 * 列表点击事件 
		 */
		itemClick: function(index){
			//判断是否安装微信
			if(payTypesObj.payTypesData[index].payType == "WXPAY"){ //微信支付
				var result = vueObj.isAppExists("com.tencent.mm", "weixin:");
				if (!result){ //为安装
					plus.nativeUI.confirm("您尚未安装微信或者微信版本过低，请更换其他支付方式。", function(e) {}, "", ["取消"]);
					return;
				}
			} 
			if(vueObj.currentPayType.payType == payTypesObj.payTypesData[index].payType){
				payTypesObj.isShowPayTypes = false;
				return;
			}
			vueObj.qrCodeStr = null;
			vueObj.clearQRCodeObj(); //清除二维码
			payTypesObj.currentTypeIndex = index;
			vueObj.currentPayType = payTypesObj.payTypesData[index];
			vueObj.makeCode(); 
			payTypesObj.isShowPayTypes = false;
		},
		/*
		 * X号点击事件
		 */
		closePayTypes: function(e){
			payTypesObj.isShowPayTypes = false;
			e.stopPropagation();
		},
		/*
		 * 标题点击 无反应
		 */
		titleClick: function(e){
			e.stopPropagation();
		},
	}
});

//监听标题更多按钮
document.getElementById("moreBtn").addEventListener("tap", function(e){
	var buttons = [{id:'0', title:'使用说明'}, {id:'1', title:'安全设置'}];
	plus.nativeUI.actionSheet({
		cancel: "取消",
		buttons: buttons
	}, function(e){
		if(e.index <= 0) return;
		if(e.index == 1){ //刷新二维码
			openWindow("webPage", '../common/web_page.html', false, { 
				"webUrl": h5Host + "/activity/h5/common?activityCode=payCodeIntro",
				statusBarType: STATUS_BAR_MAIN_KEY
			}, null, false);
		}else if(e.index == 2){ //安全设置
			openWindow("payCodeSetting", "../card/pay_code_setting.html", false, {
				statusBarType: STATUS_BAR_MAIN_KEY
			});
		}
	});
});