//请求码
var QUERY_INFO = 1001, FINGER_CLOSE_SETTING = 1002, GESTURE_CLOSE_SETTING = 1003;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		fingerActive: 0, //0未开启 1已开启
		gestureActive: 0 //0未开启 1已开启
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//事件监听
			window.addEventListener("onSwitchChange", function(event){
				//关闭指纹
				if(event.detail.action == 'close'){
					showWaiting();
					webCall2("/compus/user/device/save", {
						securityType: event.detail.type=='finger'?1:2,
						action: 0
					}, event.detail.type=='finger'?FINGER_CLOSE_SETTING:GESTURE_CLOSE_SETTING, vueObj.onSuccess, vueObj.onErrorBefore);
					return;
				}
				//打开指纹
				if(event.detail.type == 'finger'){
					mui("#fingerSwitch").switch().toggle();
					vueObj.fingerActive = 1;
				}else{
					mui("#gestureSwitch").switch().toggle();
					vueObj.gestureActive = 1;
				}
			});
			//加载数据
			showWaiting();
			webCall2("/compus/user/device/queryInfo", null, QUERY_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 开关切换
		 */
		onSwith: function(e) {
			var active = 0;
			switch (e.currentTarget.dataset.type){
			case 'finger': //指纹解锁
				if((!plus.fingerprint.isSupport() || !plus.fingerprint.isEnrolledFingerprints()) && vueObj.gestureActive == 0){
					confirmDialog("", "还未开通指纹解锁，尝试手势密码解锁？", "否", "是", function(){}, function(){
						openWindow("payCodeSettingPwd", "../card/pay_code_active.html", false, {
							statusBarType: STATUS_BAR_DEFAULT_KEY,
							opeType: 'pwdCheck',
							type: 'gesture',
							active: vueObj.gestureActive
						});
					});
					return;
				}
				if(!plus.fingerprint.isSupport() || !plus.fingerprint.isEnrolledFingerprints()){
					toast("该设备未开通指纹解锁")
					return;
				}
				active = vueObj.fingerActive;
				break;
			case 'gesture': //手势密码解锁
				active = vueObj.gestureActive;
				break;
			default:
				break;
			}
			//打开密码验证
			openWindow("payCodeActive", "../card/pay_code_active.html", false, {
				statusBarType: STATUS_BAR_DEFAULT_KEY,
				opeType: 'pwdCheck',
				type: e.currentTarget.dataset.type,
				active: active
			});
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_INFO: //查询开关数据
				vueObj.fingerActive = data.data.fingerprintStatus;
				vueObj.gestureActive = data.data.gestureStatus;
				break;
			case FINGER_CLOSE_SETTING: //关闭开关
				mui("#fingerSwitch").switch().toggle();
				vueObj.fingerActive = 0;
				break;
			case GESTURE_CLOSE_SETTING: //关闭开关
				mui("#gestureSwitch").switch().toggle();
				vueObj.gestureActive = 0;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		}
	}
});