//请求码
var DO_MODIFY = 1001, GET_SCRHOOL_INFO = 1002, QUERY_ADS = 1003;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		bindCardStatus: -1, //绑卡状态 1已经绑卡 0未绑卡
		userData: {},
		bindPwdRemind: ''
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//获取用户数据
			vueObj.userData = getUserInfo();
			vueObj.bindCardStatus = vueObj.userData.bindCardStatus;
			//查询学校信息
			webCall2("/compus/school/getSchoolInfo", null, GET_SCRHOOL_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:'k12_3003'}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 确认挂失
		 */
		doLose: function(e) {
			var cardPwd = document.getElementById("cardPwd").value;
			if(!cardPwd){
				toast("请输入学生卡密码");
				return;
			}
			var newCardPwd = document.getElementById("newCardPwd").value;
			if(!newCardPwd || newCardPwd.length != 6){
				toast("请输入合法的新密码");
				return;
			}
			/*if(cardPwd == newCardPwd){
				toast("新密码和原密码一致，请重新输入");
				return;
			}*/
			if(vueObj.judgeContinueRepeat(newCardPwd)){
				toast("新密码不能是重复、连续的数字");
				return;
			}
			showWaiting();
			webCall2("/compus/user/changeIdCardPassword", {
				oldPwd: cardPwd,
				newPwd: newCardPwd
			}, DO_MODIFY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_SCRHOOL_INFO: //学校信息
				vueObj.bindPwdRemind = data.data.bindPwdRemind;
				break;
			case DO_MODIFY: //密码修改成功
				toast("密码修改成功");
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				mui.back();
				break;
			case QUERY_ADS: //广告数据加载
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 输入框输入监听
		 */
		onInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			if(!stringIsNumber(value)){
				value = value.replace(/[^0-9]/g, '');
				e.currentTarget.value = value;
			}
			//最长只支持6位
			if(value.length > 6){
				e.currentTarget.value = value.substring(0, 6);
				return;
			}
		},
		/**
		 * 判断是否重复、连续的数字
		 */
		judgeContinueRepeat: function(numStr) {
			var numArray = numStr.split("");
			var isContinue = true;
			for(var i=0; i<numArray.length-2; i++){
				if((parseInt(numArray[i+1])-parseInt(numArray[i])) != (parseInt(numArray[i+2])-parseInt(numArray[i+1]))){
					isContinue = false;
					break;
				}
			}
			return isContinue;
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "学生卡密码修改页", "pos": "学生卡交密码修改页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && vueObj.bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});