//请求码
var DO_RECHARGE = 1001, QUERY_BALANCE = 1002, GET_SCRHOOL_INFO = 1003, 
	QUERY_POP_INFO = 1004, QUERY_ADS = 1005, QUERY_CARD_INFO = 1006;
//缓存姓名和学/工号
var CACHE_RECHARGE_NAME_KEY = "cache_recharege_name"; //姓名缓存KEY
var CACHE_RECHARGE_JOBNO_KEY = "cache_recharege_jobno"; //学/工号/身份证缓存KEY
var CACHE_RECHARGE_BIND_TYPE_KEY = "cache_recharege_bind_type"; //学生卡类型缓存KEY
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		testAccount: "", //是否测试账号（0是1否）
		balance:0,//余额
		bindTitle: '',
		bindHolder: '',
		bindType: 0, //学校信息(支持绑卡类型 1一卡通账号 2学/工号 3身份证 )
		bindTypeList: [], //支持的一卡通绑定方式列表
		rechargeData:{},//充值基本信息配置
		rechargeAmountList:[],//充值金额类别
		userData: {},
		selectMoney: 0, //选择的充值金额，默认100.
		isOthersRecharge: false,//是否为他人充值
		rechargeName: "",//充值姓名
		rechargeJobNo: "",//充值卡号
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		bindCardStatus: -1 //绑卡状态 1已经绑卡 0未绑卡
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//监听事件
			window.addEventListener("onNotAlertPopListener", function(event){
				setCache("DONOT_POP_REDBAG_TAKE_CARD" + getCache(USER_ID_KEY), "yes");
			});
			//监听用户绑卡成功
			window.addEventListener("onUserInfoChange", function(event){
				vueObj.userData = getUserInfo();
				vueObj.bindCardStatus = vueObj.userData.bindCardStatus;
				if(vueObj.bindCardStatus == 1){ //已绑卡绑卡
					vueObj.balance = getCardRemain();
					vueObj.queryCardBalance();
				} 
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//添加统计事件
			statisticEvent("cardRecharge01");
			//参数获取
			var type = comGetUrlParamByName(plus.webview.currentWebview().getURL(), "type");
			vueObj.isOthersRecharge = (type == 'other');
			vueObj.rechargeName = getCache(CACHE_RECHARGE_NAME_KEY);
			vueObj.rechargeJobNo = getCache(CACHE_RECHARGE_JOBNO_KEY);
			vueObj.testAccount = getCache(USER_TEST_ACCOUNT); 
			//获取用户数据
			vueObj.userData = getUserInfo();
			vueObj.bindCardStatus = vueObj.userData.bindCardStatus;
			//获取防重提交的token
			showWaiting();
			webCall2("/compus/school/getSchoolInfo", null, GET_SCRHOOL_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:'k12_3004'}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
			if(vueObj.bindCardStatus == 1){ //已绑卡绑卡
				vueObj.balance = getCardRemain();
				vueObj.queryCardBalance();
			}
			vueObj.queryCardInfo();
			//学校未选择，默认显示学/工号
			if(!getCache(SCHOOL_CODE_KEY)){
				vueObj.bindType = 2;
				vueObj.bindTitle = "学/工号";
				vueObj.bindHolder = "请输入学号或工号";
				return;
			}
			//判断，如果用户未实名，且没有点击不再提示，则查询弹窗信息
			if(vueObj.userData.realNameStatus == 3) return;
			var popTime = getCache("POP_REDBAG_TAKE_TIME_CARD" + getCache(USER_ID_KEY));
			if(popTime && parseInt(popTime) > 0) return; //只弹出一次
			if(getCache("DONOT_POP_REDBAG_TAKE_CARD" + getCache(USER_ID_KEY)) == "yes") return;
			//webCall2("/compus/advertising/getAdvertisingMap", {addressCodeList: '5001'}, QUERY_POP_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/*
		 * 查询学生卡充值基本信息
		 */
		queryCardInfo: function(){
			webCall2("/compus/recharge/config", {}, QUERY_CARD_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 查询学生卡余额
		 */
		queryCardBalance: function(){
			webCall2("/compus/user/getCardMoney", null, QUERY_BALANCE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 充值
		 * @param {Object} e
		 */
		doRecharge: function(e) {
			//如果为自己充值，判断是否绑卡
			if(!vueObj.isOthersRecharge){
				var user = getUserInfo();
				vueObj.bindCardStatus = user.bindCardStatus;
				if(vueObj.bindCardStatus == 0){ //未绑卡
					openBindCard();
					return;
				}
			}
			var money = vueObj.selectMoney;
			vueObj.rechargeName = document.getElementById("realName").value;
			if(vueObj.isOthersRecharge && (!vueObj.rechargeName || vueObj.rechargeName.length <= 0)){
				toast('姓名不能为空');
				return;
			}
			vueObj.rechargeJobNo = document.getElementById("studentNo").value;
			if(vueObj.isOthersRecharge && (!vueObj.rechargeJobNo || vueObj.rechargeJobNo.length <= 0)){
				toast(vueObj.bindHolder);
				return;
			}
			if(vueObj.isOthersRecharge && vueObj.bindType == 8 && !regexMobile(vueObj.rechargeJobNo)){
				toast("请输入正确的手机号");
				return;
			}
			if(vueObj.isOthersRecharge && vueObj.bindType == 4 && !regexIdCard(vueObj.rechargeJobNo)){
				toast("请输入正确的身份证号");
				return;
			}
			if(isNaN(parseFloat(money)) || parseFloat(money) <= 0) {
				toast('请输入正确的金额');
				return;
			}
			if(vueObj.rechargeData.isCustomAmount == 0 && ((!vueObj.testAccount && vueObj.testAccount != '0') || vueObj.testAccount == '1') && money < vueObj.rechargeData.customAmountBegin){
				toast('最低起充金额:' + vueObj.rechargeData.customAmountBegin + '元');
				return;
			}
			if(vueObj.rechargeData.isCustomAmount == 0 && parseFloat(money) > vueObj.rechargeData.customAmountEnd){
				toast('超出最大充值金额:' + vueObj.rechargeData.customAmountEnd);
				return;
			}
			//小数点不足 补足两位
			money = toDecimalTwo(money);
			document.activeElement.blur();
			//添加统计事件
			statisticEvent("cardRecharge02");
			showWaiting();
			var extParams = {
				urlPath: "/compus/order/rechargeOnCardByParam"
			};
			var params = {
				totalMoney: money,
				orderRealMoney: money,
				rechargeType: vueObj.isOthersRecharge ? '2' : '1'
			};
			if(vueObj.isOthersRecharge){
				params.incomeAccount = vueObj.rechargeJobNo;
				params.realName = vueObj.rechargeName;
				if(vueObj.bindType > 0){
					params.accountType = vueObj.bindType;
				}
				setCache(CACHE_RECHARGE_NAME_KEY, vueObj.rechargeName);
				setCache(CACHE_RECHARGE_JOBNO_KEY, vueObj.rechargeJobNo);
				setCache(CACHE_RECHARGE_BIND_TYPE_KEY, vueObj.bindType);
			}
			webCall2("/common/token/get", params, DO_RECHARGE, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, extParams);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_BALANCE://一卡通余额
				vueObj.balance = data.data;
				setCardRemain(vueObj.balance);
				break;
			case QUERY_CARD_INFO: 
				vueObj.rechargeData = data.data;
				if(!vueObj.rechargeData.rechargeAmount || vueObj.rechargeData.rechargeAmount.length <= 0) return;
				var rechargeAmountArr = vueObj.rechargeData.rechargeAmount.split("|");
				vueObj.selectMoney = rechargeAmountArr[0];
				if(rechargeAmountArr.length % 3 != 0) {
					for(var i = 0; i< rechargeAmountArr.length % 3; i++) {
						rechargeAmountArr.push(0);
					}
				}
				for(var i = 0; i < Math.ceil(rechargeAmountArr.length / 3); i++) {
					vueObj.rechargeAmountList[i] = new Array();
				}
				for(var j = 0; j < rechargeAmountArr.length; j++) {
					var index = parseInt(j / 3);
					var index1 = j % 3;
					vueObj.rechargeAmountList[parseInt(j / 3)][j % 3] = rechargeAmountArr[j];
				}
				break;
			case DO_RECHARGE: //调用充值
				//添加统计事件
				statisticEvent("cardRecharge03");
				document.activeElement.blur();
				openWindow("rechargeWebPage", "../common/web_page.html", false, {
					webUrl: data.data,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case GET_SCRHOOL_INFO: //学校信息
				vueObj.bindTypeList = data.data.idcardBindTypeList;
				if(vueObj.bindTypeList.length > 0){
					var bindType = getCache(CACHE_RECHARGE_BIND_TYPE_KEY);
					vueObj.bindType = vueObj.bindTypeList[0].code;
					vueObj.bindTitle = vueObj.bindTypeList[0].name;
					vueObj.bindHolder = vueObj.bindTypeList[0].desc;
					//检验缓存
					if(bindType){
						var isExist = false;
						for(var i in vueObj.bindTypeList){
							if((vueObj.bindTypeList[i].code+"") == bindType){
								isExist = true;
								vueObj.bindType = vueObj.bindTypeList[i].code;
								vueObj.bindTitle = vueObj.bindTypeList[i].name;
								vueObj.bindHolder = vueObj.bindTypeList[i].desc;
								break;
							}
						}
						if(!isExist){
							vueObj.rechargeJobNo = "";
						}
					}
				}
				break;
			case QUERY_POP_INFO: //查询红包弹窗信息
				var popData = data.data['5001'] && data.data['5001'].length > 0 ? data.data['5001'][0] : null;
				if(!popData) return;
				//构造弹窗
				var activityObj = {};
				var popTime = getCache("POP_REDBAG_TAKE_TIME_CARD" + getCache(USER_ID_KEY));
				if(popTime && parseInt(popTime) > 2){
					activityObj.notAlert = true;
					activityObj.notAlertTxt = "放弃红包，不再提示？";
				}
				setCache("POP_REDBAG_TAKE_TIME_CARD" + getCache(USER_ID_KEY), popTime ? (parseInt(popTime)+1) : 1);
				activityObj.activityName = popData.title;
				activityObj.appLogo = popData.image;
				activityObj.appLink = popData.url;
				var activityPop = plus.webview.create('../app/activity_pop.html', 'activity_pop', {
					top: '0', bottom: '0', background: 'transparent'
				},{
					activityObj:activityObj, statusBarType:getCurrentStatusBarType()
				});
				plus.webview.currentWebview().append(activityPop);
				break;
			case QUERY_ADS: //广告数据加载
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
			if(requestCode == DO_RECHARGE){
				//添加统计事件
				statisticEvent("cardRecharge04", {"error": resultMsgDesc});
			}
		},
		/**
		 * 充值金额选择
		 */
		onSelectMoney: function(e) {
			vueObj.selectMoney = e.currentTarget.dataset.money;
			if(!document.getElementById("money")) return;
			if(e.currentTarget.dataset.money != document.getElementById("money").value){
				document.getElementById("money").value = "";
			}
		},
		/*
		 * 为他人充值按钮点击
		 */
		doOthersRecharge: function(e){
			vueObj.isOthersRecharge = !vueObj.isOthersRecharge;	
		},
		/**
		 * 绑卡类型选择
		 */
		onTypeSelect: function(e){
			if(vueObj.bindTypeList.length <= 0) return;
			var buttons = [];
			for(var i in vueObj.bindTypeList){
				buttons[i] = {id:vueObj.bindTypeList[i].code,title:vueObj.bindTypeList[i].name};
			}
			plus.nativeUI.actionSheet({
				title: "请选择绑卡类型",
				cancel: "取消",
				buttons: buttons
			}, function(e) {
				if(e.index > 0) {
					vueObj.bindType = vueObj.bindTypeList[e.index - 1].code;
					vueObj.bindTitle = vueObj.bindTypeList[e.index - 1].name;
					vueObj.bindHolder = vueObj.bindTypeList[e.index - 1].desc;
				}
			});
		},
		/**
		 * 金额输入框改变方法
		 */
		inputMoneyChange: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			if((!vueObj.testAccount && vueObj.testAccount != '0') || vueObj.testAccount == '1'){
				value = value.replace(/[^0-9]/g, '');	
			}else{
				value = value.replace(/[^0-9.]/g, '');	
			}
			e.currentTarget.value = value;
			//限制整数位 根据返回最大金额数
			if(value) {
				value = value.substring(0, vueObj.rechargeData.customAmountEnd.toString().length);
				e.currentTarget.value = value;
			}
			vueObj.selectMoney = value;
		},
		/*
		 * 学/工号输出框改变方法
		 */
		inputStudentNoChange: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^\w\.\/]/ig, '');
			vueObj.rechargeJobNo = value;
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "学生卡充值页", "pos": "学生卡充值页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && vueObj.bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		},
		/*
		 * 失去焦点后 必须要回到顶部  否则页面会拉不下来
		 */
		onFocusout:function(){
			mui('.mui-scroll-wrapper').scroll().element.scrollTop=0;
		}
	}
});