//请求码
var DO_LOSE = 1001, GET_SCRHOOL_INFO = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		userData: {},
		bindPwdRemind: '' 
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//获取用户数据
			vueObj.userData = getUserInfo();
			//查询学校信息
			webCall2("/compus/school/getSchoolInfo", null, GET_SCRHOOL_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 确认挂失
		 */
		doLose: function(e) {
			var cardPwd = document.getElementById("cardPwd").value;
			if(!cardPwd){
				toast("请输入学生卡密码");
				return;
			}
			showWaiting();
			webCall2("/compus/user/unLossCard", {
				password: cardPwd
			}, DO_LOSE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_SCRHOOL_INFO: //学校信息
				vueObj.bindPwdRemind = data.data.bindPwdRemind;
				break;
			case DO_LOSE: //挂失操作
				toast("解除挂失成功");
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 输入框输入监听
		 */
		onInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			if(!stringIsNumber(value)){
				value = value.replace(/[^0-9]/g, '');
				e.currentTarget.value = value;
			}
			//最长只支持6位
			if(value.length > 6){
				e.currentTarget.value = value.substring(0, 6);
				return;
			}
		}
	}
});