//请求码
var QUERY_REMAIN = 1001, GET_SCRHOOL_INFO = 1002, QUERY_ADS = 1003;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		cardRemain: 0.00, //一卡通余额
		bindPwdRemind: '',//温馨提示
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarMain();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarMain();
				}
			}, false);
			//监听一卡通余额变化
			window.addEventListener("onRemainChange", function(event){
				vueObj.cardRemain = getCardRemain();
			});
			//获取用户数据
			vueObj.cardRemain = getCardRemain();
			//查询余额
			webCall2("/compus/user/getCardMoney", null, QUERY_REMAIN, vueObj.onSuccess, vueObj.onErrorBefore);
			//查询学校信息
			webCall2("/compus/school/getSchoolInfo", null, GET_SCRHOOL_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:'k12_3005'}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_REMAIN: //卡余额
				vueObj.cardRemain = data.data ? data.data : vueObj.cardRemain;
				setCardRemain(vueObj.cardRemain);
				break;
			case GET_SCRHOOL_INFO: //学校信息
				vueObj.bindPwdRemind = data.data.bindPwdRemind;
				break;
			case QUERY_ADS: //广告数据加载
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				});
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 去充值
		 */
		onRecharge: function(e) {
			openWindow("rechargeCard", 'recharge_card.html', false, {statusBarType: STATUS_BAR_MAIN_KEY}, null, true); 
			setTimeout(function(){
				closeWebview(plus.webview.currentWebview().id);
			}, 1000);
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "学生卡交易明细页", "pos": "学生卡交易明细页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && getUserInfo().bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_MAIN_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_MAIN_KEY
				}, null, false);
			}
		}
		
	}
});