var myScrolls = [];
var sliderIndex = 0;
var isLoadingMore = [];
var isNoMore = [];
var starts = [0, 0, 0, 0];
//请求码
var QUERY_ADS = 1001, QUERY_LISTS = [1002, 1003, 1004, 1005], QUERY_WECHAT_INFO = 1006, APP_BIND_WECHAT = 1007;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		bindCardStatus: -1, //绑卡状态 1已经绑卡 0未绑卡
		bannerLength: 0,
		activityCellImgHeightStyle:"",//活动图片高度
		bannerRows: [], // 广告列表数据
		datas: [[], [], [],[]]
		
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			var self = plus.webview.currentWebview();
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听微信登录返回
			window.addEventListener("onWechatLoginCallSuccessListener", function(event){
				vueObj.appBindWechat(event.detail);
			});
			initShareServices(plus.webview.currentWebview());
			vueObj.bindCardStatus = getUserInfo().bindCardStatus;
			vueObj.activityCellImgHeightStyle = "height:" + ((plus.screen.resolutionWidth - 32) / 343 * 100) + "px;";
			//加载数据
			showWaiting();
			vueObj.loadData(0);
			vueObj.loadBannerData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadBannerData: function() {
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:1020}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 加载数据
		 */
		loadData: function(index) {
			var param = {
				offset: starts[index],
				limit: 10
			};
			switch(index){
				case 1:
					param.isEnd = "1";
					break;
				case 2:
					param.type = "5";
					break;
				case 3:
					param.type = "8";
					break;
				default:
					break;
			}
			webCall2("/compus/avtivity/center/list", param, QUERY_LISTS[index], vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 *获取当前账号绑定的微信信息
		 */
		queryWechatInfo: function() {
			showWaiting();
			webCall2("/compus/avtivity/wechat/getWechatInfo", {}, QUERY_WECHAT_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * APP绑定微信
		 */
		appBindWechat: function(param) {
			webCall2("/compus/avtivity/wechat/appBind", {
				headImgUrl: param.headimgurl,
				activityCode: "appActivityCenter",
				nickName: param.nickname,
				appOpenid: param.openid,
				unionid: param.unionid,
				sex: param.sex
			}, APP_BIND_WECHAT, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_ADS:
				vueObj.bannerRows = data.rows;
				if(vueObj.bannerRows && vueObj.bannerRows.length > 0) {
					document.getElementById("tabGroup").style.top = document.getElementById("tabGroup").offsetTop + 120 + "px";
				}
				vueObj.$nextTick(function() {
					if(!vueObj.bannerRows || vueObj.bannerRows.length <= 0) return;
					mui('.top-banner').scroll({
						scrollX: true, //是否横向滚动
						indicators: false, //是否显示滚动条
						deceleration: mui.os.ios ? 0.003 : 0.0009, //阻尼系数,系数越小滑动越灵敏
						bounce: true //是否启用回弹
					});
					//懒加载图片刷新
					var bannerLazyloadApi = mui('#topBanner').imageLazyload({
						autoDestroy: false,
						placeholder: '../../home/images/home_ad_default.png'
					});
					//懒加载图片刷新
					bannerLazyloadApi.refresh(true);
				});
				break;
			case QUERY_WECHAT_INFO: 
				if(data && data.data && data.data.mobileValidated == 0){
					toast("微信已绑定");
				} else {
					onWechatLogin();//调用微信登录
				}
				break;
			case APP_BIND_WECHAT: 
				toast("微信绑定成功");
				break;
			case QUERY_LISTS[0]:
			case QUERY_LISTS[1]:
			case QUERY_LISTS[2]:
			case QUERY_LISTS[3]:
				//判断当前数据是加载的第几个tab
				var oprationIndex = 0;
				for(var i=0; i<QUERY_LISTS.length; i++){
					if(requestCode == QUERY_LISTS[i]){
						oprationIndex = i;
						break;
					}
				}
				if(oprationIndex < 0 || oprationIndex > 3) return;
				//更新数据
				vueObj.datas[oprationIndex] = ( starts[oprationIndex] == 0 ? data.rows : vueObj.datas[oprationIndex].concat(data.rows));
				//使用Set方法更新数组
				Vue.set(vueObj.datas, oprationIndex, vueObj.datas[oprationIndex]);
				starts[oprationIndex] = vueObj.datas[oprationIndex].length;
				//无数据图
				if(vueObj.datas[oprationIndex].length == 0) {
					setNoDataBackground("list" + oprationIndex, true, oprationIndex);
				} else {
					setNoDataBackground("list" + oprationIndex, false, oprationIndex);
				}
				if(vueObj.datas[oprationIndex].length < 4){
					document.getElementById("item" + oprationIndex + "mobileSpan").style.display = "none";
				}else {
					document.getElementById("item" + oprationIndex + "mobileSpan").style.display = "";
				}
				closePullStatus(data.rows, oprationIndex);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
			for(var i=0; i<QUERY_LISTS.length; i++){
				if(starts[i] == 0 && requestCode == QUERY_LISTS[i]){
					document.getElementById("item" + i + "mobileSpan").style.display = "none";
				}
			}
		},
		/**
		 * 监听slider切换
		 */
		onSliderChange: function(e) {
			sliderIndex = e.detail.slideNumber;
			//关闭下拉上拉刷新
			closePullStatus();
			//切换后数据为空，则加载数据
			if(vueObj.datas[sliderIndex].length <= 0){
				starts[sliderIndex] = 0;
				vueObj.loadData(sliderIndex);					
			}
		},
		/**
		 * 列表点击
		 */
		onActivityCellClick: function(e) {
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.logo;
			if(!linkUrl) return;
			if(linkUrl.indexOf("http") < 0) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, true);
			}else{
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, true);
			}
		},
		/**
		 * banner和广告点击监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "活动中心页", "pos": "活动中心页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(e.currentTarget.dataset.btitle == "微信登录"){ //调用微信绑定
				vueObj.queryWechatInfo();
				return;
			}
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && vueObj.bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		},
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore[sliderIndex] = false;
			setTimeout(function() {
				starts[sliderIndex] = 0;
				vueObj.loadData(sliderIndex);
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore[sliderIndex]) {
				return;
			}
			if (isNoMore[sliderIndex]) {
				myScrolls[sliderIndex].refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore[sliderIndex] = true;
				vueObj.loadData(sliderIndex);
			}, 300);
		};
	
		//初始化下拉刷新
		for (var i = 0; i < 4; i++) {
			myScrolls[i] = iscrollAssist.newVerScrollForPull($('#list' + i), pullDownAction, pullLoadMoreAction);
			myScrolls[i].refresh();
			isLoadingMore[i] = false;
			isNoMore[i]= false;
		}
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data, oprationIndex) {
	if(data){
		if(data.length < 10) {
			document.getElementById("item" + oprationIndex + "mobileSpan").innerHTML = "没有更多数据了";
			isNoMore[oprationIndex] = true;
		} else {
			document.getElementById("item" + oprationIndex + "mobileSpan").innerHTML = "正在加载...";
			isNoMore[oprationIndex] = false;
		}
		isLoadingMore[oprationIndex] = (starts[oprationIndex] > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		for(var i=0; i<myScrolls.length; i++){
			myScrolls[i].refresh();
		}
		setTimeout(function(){
			myScrolls[sliderIndex].refresh();
		}, 200);
		if(oprationIndex == null || oprationIndex < 0) return;
		var listImgLazyloadApi = mui("#list" + oprationIndex).imageLazyload({
			autoDestroy: false,
			placeholder: '../../home/images/home_ad_default.png'

		});
		listImgLazyloadApi.refresh(true);
	});
}

// 设置背景
function setNoDataBackground(elementId, isNoData, oprationIndex) {
	if(isNoData) {
		document.getElementById(elementId).style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById(elementId).style.backgroundSize = "100% auto";
		document.getElementById(elementId).style.backgroundRepeat = "no-repeat";
		document.getElementById(elementId).style.backgroundPosition = "center";
		//无数据时不显示上拉显示更多
		document.getElementById("item" + oprationIndex + "mobileSpan").style.display = "none";
	} else {
		document.getElementById(elementId).style.backgroundImage = "none";
		document.getElementById("item" + oprationIndex + "mobileSpan").style.display = "";
	}
}