var myScroll;
var isLoadingMore;
var isNoMore;
var start = 0;
//请求码
var QUERY_LIST = 1001;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		errorMessage:"",
		datas: [],
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			vueObj.errorMessage = plus.webview.currentWebview().errorMessage;
			//加载数据
			vueObj.loadData();
			//拦截超链接
			plus.webview.currentWebview().overrideUrlLoading({ 
				mode: "reject",
				effect: "touchstart"
			}, function(e) {
				// 拦截新的页面在新的webview里面加载URL页面
				if(!e.url) return;
				if(e.url.indexOf("http") < 0) return;
				openWindow(e.url, '../common/web_page.html', false, {
					"webUrl": e.url,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			});
		});  
	},
	methods: { 
		/**
		 * 加载数据
		 */
		loadData: function() {
			//测试环境和正式环境区分
			var tagsId = 1905230852514001;
			if(apiEnvironment == "TEST"){
				tagsId = 1905221749216014;
			}
			//正式和测试需要区分开来
			webCall2("/compus/article/getActicleFaqList", {
				tagsId: tagsId,
				offset: start,
				limit: 20
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode) {
			case QUERY_LIST: //列表数据加载
				vueObj.datas = (start == 0 ? data.rows : vueObj.datas.concat(data.rows));
				start = vueObj.datas.length;
				//判断有无数据
				if(vueObj.datas.length < 4) {
					document.getElementById("item0mobileSpan").style.display = "none";
				} else {
					document.getElementById("item0mobileSpan").style.display = "";
				}
				closePullStatus(data.rows);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
			if(start == 0){
				document.getElementById("item0mobileSpan").style.display = "none";
			}
		},
		/**
		 * 按钮点击分发
		 */
		onItemClick: function(e) {
			//跳转到详情页
			openWindow("questionDetail", "question_detail.html", false, {
				detailId: e.currentTarget.dataset.detailid
			});
		}
	}
});


/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {};
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		if(data.length < 20) {
			document.getElementById("item0mobileSpan").innerHTML = "没有更多数据了";
			isNoMore = true;
		} else {
			document.getElementById("item0mobileSpan").innerHTML = "正在加载...";
			isNoMore = false;
		}
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}