//请求码
var DO_SUBMIT = 1001, QUERY_OPEN_APPLY = 1002, PREDICT_APPLY = 1003,DO_APPLY = 1004;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		from: null, //来源
		schoolName: '', //学校名称
		remark:'', //认证失败原因
		realNameStatus:-1,//实名认证状态 1未实名 2申请中 3认证成功 4认证失败
		predictflag:null,//开户标识
		realName: '', //姓名
		userPhone: null,//身份证号码
		ocrRealName:null, //ocr识别的姓名
		ocrCardNo:null,//ocr识别的身份证号
		cardNo: null,
		bankNo: null,
		frontCard:null,//身份证国徽页
		frontCardCode:null,//身份证国徽页Code
		reverseCard:null,//身份证头像页
		reverseCardCode:null,//身份证头像页Code
		fromThirdAuth: false, //是否来自第三方
		fromWalletThirdAuth: false, //是否来自收银台调用第三方
		webPageId: '', //第三方页面ID
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(vueObj.fromThirdAuth && vueObj.webPageId){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onAuthResult", {status: 'cancel'});
				}
				if(vueObj.fromWalletThirdAuth && vueObj.webPageId){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onWalletAuthResult", {status: 'cancel'});
				}
				closeWaiting();
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			//设置键盘弹出模式
			keyboardAdjustResize();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					closeWaiting();
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				} 
			}, false);
			//判断实名认证状态 认证通过就返回
			vueObj.realNameStatus = getUserInfo().realNameStatus ? getUserInfo().realNameStatus : 0;
			if(vueObj.realNameStatus == 3) {
				plus.nativeUI.confirm("已经实名认证通过!", function(e) {
					if(e.index == 0) { //left
						closeWebview(plus.webview.currentWebview().id);
					}
				}, "", ["确认"]);
				return;
			} else if(vueObj.realNameStatus == 2) {
				plus.nativeUI.confirm("实名认证受理中, 请稍后再试", function(e) {
					if(e.index == 0) { //left
						closeWebview(plus.webview.currentWebview().id);
					}
				}, "", ["确认"]);
				return;
			}
			//监听确认框
			window.addEventListener("onNextListener", function(e){
				//跳转开户第二步
				openWindow("authSecond", "auth_second.html", false, {
					realName:vueObj.realName,
					userPhone:vueObj.userPhone,
					cardNo:vueObj.cardNo,
					bankNo:vueObj.bankNo,
					predictflag:vueObj.predictflag,
					frontCardCode:vueObj.frontCardCode,
					reverseCardCode:vueObj.reverseCardCode,
					fromThirdAuth: vueObj.fromThirdAuth,
					fromWalletThirdAuth: vueObj.fromWalletThirdAuth,
					webPageId: vueObj.webPageId,
					authFirstId:plus.webview.currentWebview().id,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, true);
			});
			window.addEventListener("onCancelListener", function(e){
				//重新上传，清空页面
				vueObj.frontCard = "";
				vueObj.frontCardCode = "";
				vueObj.reverseCard = "";
				vueObj.reverseCardCode = "";
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//参数
			vueObj.schoolName = getCache(SCHOOL_NAME_KEY);
			vueObj.fromThirdAuth = plus.webview.currentWebview().fromThirdAuth;
			vueObj.fromWalletThirdAuth = plus.webview.currentWebview().fromWalletThirdAuth;
			vueObj.webPageId = plus.webview.currentWebview().webPageId;
			vueObj.from = comGetUrlParamByName(plus.webview.currentWebview().getURL(), "from");
			if(!vueObj.from){
				vueObj.from = plus.webview.currentWebview().from;
			}
			if(!vueObj.from || vueObj.from == 'null' || vueObj.from == 'undefine'){
				vueObj.from = "authAPP";
			}
			//添加统计事件
			statisticEvent("walletOpen03", {"source": plus.webview.currentWebview().opener().id});
			//查询预开户信息
 			vueObj.queryUserOpenInfo();
		});
	},
	methods: {
		/*
		 * 获取身份证认证图片
		 */
		getAuthImg: function(imgUrl){ 
			return apiHost + "/common/download/showImage?imageUrl=" + imgUrl + "&id=" +getCache(USER_ID_KEY) + "&token=" + getCache(USER_TOKEN_KEY) + "&deviceId="+ getLocalDeviceId();
		},
		/*
		 * 预开户信息查询
		 */
		queryUserOpenInfo: function(){
			webCall2("/compus/wallet/queryOpenApply", {}, QUERY_OPEN_APPLY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 下一步
		 */
		doNext: function(e) {
			if(!vueObj.frontCardCode || vueObj.frontCardCode.length <= 0) {
				toast("请上传身份证头像页")
				return;
			}
			if(!vueObj.reverseCardCode || vueObj.reverseCardCode.length <= 0) {
				toast("请上传身份证国微页")
				return;
			}
			//添加统计事件
			statisticEvent("walletOpenClickTime", {"action" : "实名认证第一步-点击下一步", "from" : "实名认证第一步"});
			statisticEvent("walletOpen04");
			showWaiting();
			document.activeElement.blur();
			var params = {
				front:vueObj.frontCardCode,
				back:vueObj.reverseCardCode,
			};
			if(vueObj.from){
				params.from = vueObj.from;
			}
			webCall2("/compus/wallet/saveOpenApply", params, DO_SUBMIT, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 *预申请开户接口  协议同意完成后 调用预申请开户接口
		 */
		predictApplyAtuh: function(){
			showWaiting();
			webCall2("/compus/wallet/predictopen", {
				corpCisNo:getCache(USER_ID_KEY),//商户用户编号,传统一认证的用户id
				corpMediumId:getCache(USER_ID_KEY),//合作方介质号,传统一认证的用户id
				bindMedium: vueObj.bankNo, //银行卡号
				certNo: vueObj.cardNo, //身份证号码
				custName: vueObj.realName, //户名
				mobileNo: vueObj.userPhone, //手机号
			}, PREDICT_APPLY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 开户接口,  预开户完成后 调用申请开户接口
		 */
		applyAtuh: function(){
			showWaiting();
			webCall2("/compus/wallet/open", {
				corpCisNo:getCache(USER_ID_KEY),//商户用户编号,传统一认证的用户id
				corpMediumId:getCache(USER_ID_KEY),//合作方介质号,传统一认证的用户id
				bindMedium: vueObj.bankNo, //银行卡号
				certNo: vueObj.cardNo, //身份证号码
				custName: vueObj.realName, //户名
				mobileNo: vueObj.userPhone, //手机号
				front:vueObj.frontCardCode, // 身份证国徽页	
				back:vueObj.reverseCardCode, //身份证头像页
				predictflag:vueObj.predictflag,
			}, DO_APPLY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) { 
			closeWaiting();
			switch(requestCode) {
			case QUERY_OPEN_APPLY: //查询开户信息 图片
				if(!data || !data.data) return;
				vueObj.remark = data.data.remark ? data.data.remark : '';
				vueObj.userPhone = data.data.mobileNo ? data.data.mobileNo : vueObj.userPhone;
				vueObj.bankNo = data.data.bindMedium ? data.data.bindMedium : vueObj.bankNo;
				break;
			case DO_SUBMIT: //保存图片
				vueObj.ocrRealName = data.data.ocrName ? data.data.ocrName : "";
				vueObj.ocrCardNo = data.data.ocrCertNo ? data.data.ocrCertNo : "";
				if(!vueObj.ocrRealName || vueObj.ocrRealName.length <= 0 || !vueObj.ocrCardNo || vueObj.ocrCardNo.length <= 0) {
					toast("图片识别失败, 请重试");
					return;
				}
				//判断身份证号是否满16周岁
				if(!vueObj.isAdult(vueObj.ocrCardNo)){
					toast("上传的身份证信息需满16周岁, 才能开通宝贝钱包");
					return;
				}
				vueObj.realName = vueObj.ocrRealName;
				vueObj.cardNo = vueObj.ocrCardNo;
				//弹窗提示
				var authDialog = plus.webview.create("../common/auth_dialog.html", "authDialog", 
					{top: '0px', bottom: '0px', position: 'fiexd', zindex: '9999', background: 'transparent'},
					{type:'sure', realName:vueObj.realName, cardNo:vueObj.cardNo});
				plus.webview.currentWebview().append(authDialog);
				break;
			case PREDICT_APPLY: 
				vueObj.predictflag = data && data.data ? data.data.predictflag : vueObj.predictflag;
				if(data && data.data && data.data.predictflag == 2) {
					toast("当前无法进行开户流程");
					return;
				}else if(data && data.data && data.data.predictflag == 4) {
					toast("当前有开户申请未处理完成，2分钟后再试");
					return;
				} else if(data && data.data && data.data.predictflag == 3) { //开户成功
					//一般是这个身份证已经被其它用户实名认证了，然后用户用新的账号再次进行实名认证的情况。这种情况还是有的，比如用户换手机了。
					//修改payUser 二类户开户id  realNameStatus 实名认证
					vueObj.updateUserAuthStatus(3, data.data.mediumId);
					//认证成功 跳转成功页
					openWindow("authSuccess", "auth_success.html", false, {
						realNameStatus: 3,//认证状态
						statusBarType: plus.webview.currentWebview().statusBarType
					});
					closeWebview(plus.webview.currentWebview().id);
					return;
				}
				//进行开户接口调用
				vueObj.applyAtuh();
				break;
			case DO_APPLY: //开户
				//当前不在业务受理范围时间内
				if(data && data.data && data.data.inTime == 1) {
					openWindow("authApply","auth_apply.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType,
					});	
					closeWebview(plus.webview.currentWebview().id);
					return;
				}
				if(vueObj.predictflag != 1){
					openWindow("authThree", "auth_three.html", false, {
						realName: vueObj.realName,
						userPhone: vueObj.userPhone,
						corpSernoOriginal: data.data.corpSernoOriginal, //申请开户时返回的busisno
						smsSendNo: data.data.smsSendNo, //短信验证码编号
						fromThirdAuth: vueObj.fromThirdAuth, //是否来自第三方
						fromWalletThirdAuth: vueObj.fromWalletThirdAuth, //是否来自第三方
						webPageId: vueObj.webPageId, //第三方id
						authSecondId: plus.webview.currentWebview().id,//可能是从消息中心跳转过来的 所以要把当前这个页面id传过去
						statusBarType: plus.webview.currentWebview().statusBarType,
					}, null, true);		
					return;
				}
				//修改payUser 二类户开户id  realNameStatus 实名认证
				if(data.data.succeccFlag && data.data.succeccFlag == 2) { //认证成功
					vueObj.updateUserAuthStatus(3, data.data.mediumId);
				} else {  // 不成功\遗账状态 需要后台等待之后才能查询是否开户成功
					vueObj.updateUserAuthStatus(2);
				}
				var userInfo = getUserInfo();
				//认证成功 跳转成功页
				openWindow("authSuccess", "auth_success.html", false, {
					realNameStatus: userInfo.realNameStatus,//认证状态
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				closeWebview(plus.webview.currentWebview().id);
			 break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			if(data && data.alertType == 1){ 
				openWindow("authError", "auth_error.html", false, {
					errorMessage: resultMsgDesc,//失败原因
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				return;
			}
			if(requestCode == DO_SUBMIT && data && data.bizCode == "2122"){
				plus.nativeUI.alert("身份证已过期, 请重新上传", function(){
					vueObj.ocrRealName = "";
					vueObj.ocrCardNo = "";
					vueObj.frontCard = "";
					vueObj.frontCardCode = "";
					vueObj.reverseCard = "";
					vueObj.reverseCardCode = "";
				}, "有效期异常", "重新上传");
				return;
			} 
			onError(resultCode, resultMsgDesc);
		},
		/*
		 *身份证国徽页选择
		 */
		onSelectCardFrontImg: function(e) {
			//添加统计事件
			statisticEvent("walletOpenClickTime", {"action" : "实名认证第二步-点击拍正面照", "from" : "实名认证第二步"});
			//调用公共图片选择上传
			popCompressSelectPic(function(isError, list) {
				if(list == null || list.length < 1) {
					return;
				} 
				console.log('上传图片网络地址：' + list[0].imgUrl);
				console.log('上传图片本地地址：' + list[0].localPath);
				vueObj.frontCardCode = list[0].imgUrl ? list[0].imgUrl : vueObj.frontCardCode;
				vueObj.frontCard = list[0].localPath ? list[0].localPath : vueObj.frontCard;
				//调用接口设置头像
			}, true , "group2", "front");
		},
		/*
		 *身份证头像页选择
		 */
		onSelectCardReverseImg: function(e) {
			//添加统计事件
			statisticEvent("walletOpenClickTime", {"action" : "实名认证第一步-点击拍反面照", "from" : "实名认证第一步"});
			//调用公共图片选择上传
			popCompressSelectPic(function(isError, list) {
				if(list == null || list.length < 1) {
					return;
				}
				console.log('上传图片网络地址：' + list[0].imgUrl);
				console.log('上传图片本地地址：' + list[0].localPath);
				vueObj.reverseCardCode = list[0].imgUrl ? list[0].imgUrl : vueObj.reverseCardCode;
				vueObj.reverseCard = list[0].localPath ? list[0].localPath: vueObj.reverseCard;
				//调用接口设置头像
			}, true, "group2", "back");
		},
		/*
		 * 更新用户状态
		 */
		updateUserAuthStatus: function(status, mediumId){
			//修改payUser 二类户开户id  realNameStatus 实名认证
			var userInfo = getUserInfo();
			if(mediumId && mediumId.length > 0){
				userInfo.payUser = mediumId;
			}
			userInfo.realNameStatus = status;
			userInfo.realUserName = vueObj.realName;
			updateLoginInfo(null, userInfo);	
			mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onUserInfoChange", {
				isAuthSuccess: true
			});
			//第三方应用 开户状态
			if(vueObj.fromThirdAuth) {
				mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onAuthResult", {
					status: status == 3 ? "ok" : "cancel"
				});
			}
			//第三方应用 开户状态
			if(vueObj.fromWalletThirdAuth) {
				mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onWalletAuthResult", {
					status: status == 3 ? "ok" : "cancel"
				});
			}
			//实名认证成功 判断是否红包页面存在  存在刷新红包页面
			if(plus.webview.getWebviewById("walletRedbag") && status == 3 ){
				mui.fire(plus.webview.getWebviewById("walletRedbag"), "onRedbagActiveStatus", {});
			}
		},
		/*
	     * 判断用户是否已满16周岁
	     */
	    isAdult: function(idCard){
	      	if(!idCard || idCard.length < 18){
	      		return true;
	      	}
	      	var nowDate = new Date();
	      	var nowyear = nowDate.getFullYear(); 
	      	var nowmonth = nowDate.getMonth() + 1;
	      	var nowDay = nowDate.getDate();
	      	var userYear = parseInt(idCard.substr(6, 4));
	      	var userMonth = parseInt(idCard.substr(10, 2));
	      	var userDay = parseInt(idCard.substr(12, 2));
	      	if(nowyear- userYear < 16){
	        	return false;
	      	}
	      	if(nowyear - userYear == 16) {//如果年份差等于18，则比较月份
            	if (userMonth > nowmonth){//年份等于18时，当前月份小于出生月份，则返回false，未成年
                	return false; 
            	} else if (nowmonth == userMonth){ //如果月份也相等，则比较日期
                	if (userDay > nowDay){ //年份等于18，月份相等时，如果当前日期小于出生日期，则返回false，未成年
                    	return false;
                	}
           		}
	      	} 
	      return true;
	    }
	}
});
