//请求码
var DO_SUBMIT = 1001;
var authDialog;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		frontCard:null,//身份证正面照
		frontCardCode:null,//身份证正面照Code
		reverseCard:null,//身份证反面照
		reverseCardCode:null,//身份证反面照Code
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				closeWaiting();
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				} 
			}, false);
			window.addEventListener("onNextListener", function(e){
				plus.nativeUI.alert("上传成功，等待审核中，预计24小时后可以使用。", function(){
					mui.back();
				}, "通知", "好的, 那我等等");
			});
			window.addEventListener("onCancelListener", function(e){
				//重新上传，清空页面
				vueObj.frontCard = "";
				vueObj.frontCardCode = "";
				vueObj.reverseCard = "";
				vueObj.reverseCardCode = "";
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//初始化确认弹窗
			authDialog = plus.webview.create("../common/auth_dialog.html", "authDialog", {top: '0px', bottom: '0px', position: 'fiexd', zindex: '9999', background: 'transparent'});
			plus.webview.currentWebview().append(authDialog);
			authDialog.hide();
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			if(!vueObj.frontCardCode || vueObj.frontCardCode.length <= 0) {
				toast("请上传身份证正面照")
				return;
			}
			if(!vueObj.reverseCardCode || vueObj.reverseCardCode.length <= 0) {
				toast("请上传身份证反面照")
				return;
			}
			showWaiting();
			document.activeElement.blur();
			webCall2("/compus/wallet/uploadCertImage", {
				front:vueObj.frontCardCode,
				back:vueObj.reverseCardCode,
			}, DO_SUBMIT, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) { 
			closeWaiting();
			switch(requestCode) {
			case DO_SUBMIT: //保存图片
				var ocrRealName = data.data.custName;
				var ocrCardNo = data.data.certNo;
				if(!ocrRealName || ocrRealName.length <= 0 || !ocrCardNo || ocrCardNo.length <= 0) {
					toast("图片识别失败, 请重试");
					return;
				}
				//判断身份证号是否满16周岁
				if(!vueObj.isAdult(vueObj.ocrCardNo)){
					toast("上传的身份证信息需满16周岁");
					return;
				}
				//弹窗提示
				mui.fire(authDialog, "showAuthPop", {type:'sure', realName:ocrRealName, cardNo:ocrCardNo});
				break;
			 break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			if(requestCode == DO_SUBMIT && data && data.bizCode == "2122"){
				plus.nativeUI.alert("身份证已过期, 请重新上传", function(){
					vueObj.frontCard = "";
					vueObj.frontCardCode = "";
					vueObj.reverseCard = "";
					vueObj.reverseCardCode = "";
				}, "有效期异常", "重新上传");
				return;
			} 
			onError(resultCode, resultMsgDesc);
		},
		/*
		 *身份证正面选择
		 */
		onSelectCardFrontImg: function(e) {
			//调用公共图片选择上传
			popCompressSelectPic(function(isError, list) {
				if(list == null || list.length < 1) {
					return;
				} 
				console.log('上传图片网络地址：' + list[0].imgUrl);
				console.log('上传图片本地地址：' + list[0].localPath);
				vueObj.frontCardCode = list[0].imgUrl ? list[0].imgUrl : vueObj.frontCardCode;
				vueObj.frontCard = list[0].localPath ? list[0].localPath : vueObj.frontCard;
				//调用接口设置头像
			}, true , "group2", "front");
		},
		/*
		 *身份证反面选择
		 */
		onSelectCardReverseImg: function(e) {
			//调用公共图片选择上传
			popCompressSelectPic(function(isError, list) {
				if(list == null || list.length < 1) {
					return;
				}
				console.log('上传图片网络地址：' + list[0].imgUrl);
				console.log('上传图片本地地址：' + list[0].localPath);
				vueObj.reverseCardCode = list[0].imgUrl ? list[0].imgUrl : vueObj.reverseCardCode;
				vueObj.reverseCard = list[0].localPath ? list[0].localPath: vueObj.reverseCard;
				//调用接口设置头像
			}, true, "group2", "back");
		},
		/*
	     * 判断用户是否已满16周岁
	     */
	    isAdult: function(idCard){
	      	if(!idCard || idCard.length < 18){
	      		return true;
	      	}
	      	var nowDate = new Date();
	      	var nowyear = nowDate.getFullYear(); 
	      	var nowmonth = nowDate.getMonth() + 1;
	      	var nowDay = nowDate.getDate();
	      	var userYear = parseInt(idCard.substr(6, 4));
	      	var userMonth = parseInt(idCard.substr(10, 2));
	      	var userDay = parseInt(idCard.substr(12, 2));
	      	if(nowyear- userYear < 16){
	        	return false;
	      	}
	      	if(nowyear - userYear == 16) {//如果年份差等于18，则比较月份
            	if (userMonth > nowmonth){//年份等于18时，当前月份小于出生月份，则返回false，未成年
                	return false; 
            	} else if (nowmonth == userMonth){ //如果月份也相等，则比较日期
                	if (userDay > nowDay){ //年份等于18，月份相等时，如果当前日期小于出生日期，则返回false，未成年
                    	return false;
                	}
           		}
	      	} 
	      return true;
	    }
	}
});
