//请求码
var PREDICT_APPLY = 1001, DO_APPLY = 1002, QUERY_OPEN_APPLY = 1003;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		realNameStatus:-1,//实名认证状态 1未实名 2申请中 3认证成功 4认证失败
		eacctStatus: 0, //钱包状态 0未开通 1启用 2销户 3关闭
		realName: '',//姓名
		cardNo: null,//身份证号
		cardNoShow: null,//身份证号
		ocrRealName:null, //ocr识别的姓名
		ocrCardNo:null,//ocr识别的身份证号
		bankNo: null,//银行卡号
		userPhone: null,//手机号
		predictflag:null,//开户标识
		frontCardCode:null,//身份证国徽页Code
		reverseCardCode:null,//身份证头像页Code
		remark:'', //认证失败原因
		tipsExplain:{},//提示说明文案
		fromThirdAuth: false, //是否来自第三方
		fromWalletThirdAuth: false, //是否来自收银台调用第三方
		webPageId: '', //第三方页面ID
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(vueObj.fromWalletThirdAuth && vueObj.webPageId && vueObj.eacctStatus == 2){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onWalletAuthResult", {status: 'cancel'});
				}
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//添加统计事件
			statisticEvent("walletOpen05", {"source": plus.webview.currentWebview().opener().id});
			vueObj.realNameStatus = getUserInfo().realNameStatus ? getUserInfo().realNameStatus : 0;
			vueObj.eacctStatus = getUserInfo().eacctStatus ? getUserInfo().eacctStatus : 0;
			if(vueObj.eacctStatus != 2){
				if(vueObj.realNameStatus == 3){
				 	plus.nativeUI.confirm("已经实名认证通过!", function(e) {
						if(e.index == 0) { //left
							closeWebview(plus.webview.currentWebview().id);
						}
					}, "", ["确认"]);
					return;
				}else if(vueObj.realNameStatus == 2){
				 	plus.nativeUI.confirm("实名认证受理中, 请稍后再试", function(e) {
						if(e.index == 0) { //left
							closeWebview(plus.webview.currentWebview().id);
						}
					}, "", ["确认"]);
					return;
				}
			}
			//接收参数
			var self = plus.webview.currentWebview();
			vueObj.predictflag = self.predictflag;
			vueObj.realName = self.realName;
			vueObj.userPhone = self.userPhone;
			vueObj.cardNo = self.cardNo;
			vueObj.bankNo = self.bankNo;
			vueObj.frontCardCode = self.frontCardCode ? self.frontCardCode : "";
			vueObj.reverseCardCode = self.reverseCardCode ? self.reverseCardCode : "";
			vueObj.fromThirdAuth = self.fromThirdAuth;
			vueObj.fromWalletThirdAuth = self.fromWalletThirdAuth;
			vueObj.webPageId = self.webPageId;
			vueObj.handleCardNo();
			if(plus.webview.currentWebview().source == "walletMain"){//已销户
				//查询预开户信息
				vueObj.queryUserOpenInfo();
			}
		});
	},
	methods: {
		/*
		 * 预开户信息查询
		 */
		queryUserOpenInfo: function(){
			webCall2("/compus/wallet/queryOpenApply", {}, QUERY_OPEN_APPLY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 下一步
		 */
		doNext: function(e) {
			document.activeElement.blur();
			//身份证号处理  小写x变大写X
			vueObj.cardNo = vueObj.cardNo.replace("x","X");
			vueObj.bankNo = document.getElementById("bankNo").value;
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.realName || vueObj.realName.length <= 0){
				toast("请输入姓名");
				return;
			}
			if(!vueObj.cardNo || !regexIdCard(vueObj.cardNo)){
				toast("请输入正确的身份证号");
				return;
			}
			if(!vueObj.bankNo || !regexBankCardNo(vueObj.bankNo)){
				toast("请输入正确的银行卡号")
				return;
			}
			if(!vueObj.userPhone || !regexMobile(vueObj.userPhone)){
				toast("请输入正确的手机号码")
				return;
			}
			//添加统计事件
			statisticEvent("walletOpenClickTime", {"action" : "实名认证第二步-点击下一步", "from" : "实名认证第二步"});
			statisticEvent("walletOpen06");
			//进行预开户申请
			vueObj.predictApplyAtuh();
		},
		/*
		 *预申请开户接口  协议同意完成后 调用预申请开户接口
		 */
		predictApplyAtuh: function(){
			showWaiting();
			document.activeElement.blur();
			webCall2("/compus/wallet/predictopen", {
				corpCisNo:getCache(USER_ID_KEY),//商户用户编号,传统一认证的用户id
				corpMediumId:getCache(USER_ID_KEY),//合作方介质号,传统一认证的用户id
				bindMedium: vueObj.bankNo, //银行卡号
				certNo: vueObj.cardNo, //身份证号码
				custName: vueObj.realName, //户名
				mobileNo: vueObj.userPhone, //手机号
			}, PREDICT_APPLY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 开户接口,  预开户完成后 调用申请开户接口
		 */
		applyAtuh: function(){
			showWaiting();
			webCall2("/compus/wallet/open", {
				corpCisNo:getCache(USER_ID_KEY),//商户用户编号,传统一认证的用户id
				corpMediumId:getCache(USER_ID_KEY),//合作方介质号,传统一认证的用户id
				bindMedium: vueObj.bankNo, //银行卡号
				certNo: vueObj.cardNo, //身份证号码
				custName: vueObj.realName, //户名
				mobileNo: vueObj.userPhone, //手机号
				front:vueObj.frontCardCode, // 身份证国徽页	
				back:vueObj.reverseCardCode, //身份证头像页
				predictflag:vueObj.predictflag,
			}, DO_APPLY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_OPEN_APPLY: //预开户查询出来的信息
				if(!data || !data.data) return;
				if(vueObj.isExpiryDate(data.data.expiryDate)){//身份证已过期
					return;
				}
				vueObj.remark = data.data.remark ? data.data.remark : '';
				vueObj.realName = data.data.custName ? data.data.custName : vueObj.realName;
				vueObj.bankNo = data.data.bindMedium ? data.data.bindMedium : vueObj.bankNo;
				vueObj.ocrRealName = data.data.ocrName ? data.data.ocrName : vueObj.ocrRealName;
				vueObj.ocrCardNo = data.data.ocrCertNo ? data.data.ocrCertNo : vueObj.ocrCardNo;
				vueObj.cardNo = data.data.certNo ? data.data.certNo : vueObj.cardNo;
				vueObj.userPhone = data.data.mobileNo ? data.data.mobileNo : vueObj.userPhone;
				vueObj.frontCardCode= data.data.front ? data.data.front : vueObj.frontCardCode;
				vueObj.reverseCardCode= data.data.back ? data.data.back : vueObj.reverseCardCode;
				vueObj.predictflag = data.data.predictflag != null ? data.data.predictflag : "";
				vueObj.handleCardNo();
				break;
			case PREDICT_APPLY:
				vueObj.predictflag = data && data.data ? data.data.predictflag : vueObj.predictflag;
				if(data && data.data && data.data.predictflag == 2) {
					toast("当前无法进行开户流程");
					return;
				} else if(data && data.data && data.data.predictflag == 4) {
					toast("当前有开户申请未处理完成，2分钟后再试");
					return;
				} else if(data && data.data && data.data.predictflag == 3) { //开户成功
					//一般是这个身份证已经被其它用户实名认证了，然后用户用新的账号再次进行实名认证的情况。这种情况还是有的，比如用户换手机了。
					//修改payUser 二类户开户id  realNameStatus 实名认证
					vueObj.updateUserAuthStatus(3, data.data.mediumId);
					//认证成功 跳转成功页
					openWindow("authSuccess", "auth_success.html", false, {
						realNameStatus: 3,//认证状态
						source:plus.webview.currentWebview().source,
						statusBarType: plus.webview.currentWebview().statusBarType
					});
					if(plus.webview.getWebviewById(plus.webview.currentWebview().authFirstId)){
						closeWebview(plus.webview.currentWebview().authFirstId);
					}
					closeWebview(plus.webview.currentWebview().id);
					return;
				}
				//进行开户接口调用
				vueObj.applyAtuh();
				break;
			case DO_APPLY: //认证申请 
				//当前不在业务受理范围时间内
				if(data && data.data && data.data.inTime == 1) {
					openWindow("authApply","auth_apply.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType,
					});	
					if(plus.webview.getWebviewById(plus.webview.currentWebview().authFirstId)){
						closeWebview(plus.webview.currentWebview().authFirstId);
					}
					closeWebview(plus.webview.currentWebview().id);
					return;
				}
				if(vueObj.predictflag != 1){
					openWindow("authThree", "auth_three.html", false, {
						realName: vueObj.realName,
						userPhone: vueObj.userPhone,
						corpSernoOriginal: data.data.corpSernoOriginal, //申请开户时返回的busisno
						smsSendNo: data.data.smsSendNo, //短信验证码编号
						fromThirdAuth: vueObj.fromThirdAuth, //是否来自第三方
						fromWalletThirdAuth: vueObj.fromWalletThirdAuth, //是否来自第三方
						webPageId: vueObj.webPageId, //第三方id
						authFirstId: plus.webview.currentWebview().authFirstId,
						authSecondId: plus.webview.currentWebview().id,
						source:plus.webview.currentWebview().source,
						statusBarType: plus.webview.currentWebview().statusBarType,
					}, null, true);		
					return;
				}
				//修改payUser 二类户开户id  realNameStatus 实名认证
				if(data.data.succeccFlag && data.data.succeccFlag == 2) { //认证成功
					vueObj.updateUserAuthStatus(3, data.data.mediumId);
				} else {  // 不成功\遗账状态 需要后台等待之后才能查询是否开户成功
					vueObj.updateUserAuthStatus(2);
				}
				var userInfo = getUserInfo();
				//认证成功 跳转成功页
				openWindow("authSuccess", "auth_success.html", false, {
					realNameStatus: userInfo.realNameStatus,//认证状态
					source:plus.webview.currentWebview().source,
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				if(plus.webview.getWebviewById(plus.webview.currentWebview().authFirstId)){
					closeWebview(plus.webview.currentWebview().authFirstId);
				}
				closeWebview(plus.webview.currentWebview().id);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			if(data && data.alertType == 1){ 
				openWindow("authError", "auth_error.html", false, {
					errorMessage: resultMsgDesc,//失败原因
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				return;
			} 
			onError(resultCode, resultMsgDesc);
		},
		/*
		 * 小icon点击事件
		 */
		onIconClick: function(e){
			document.activeElement.blur();
			vueObj.bankNo = document.getElementById("bankNo").value;
			vueObj.userPhone = document.getElementById("userPhone").value;
			switch (e.currentTarget.dataset.type){ 
			case "name":
				vueObj.tipsExplain = {
					title:"持卡人说明",
					explainOne:"持卡人姓名, 是您在办理银行卡时所填写的姓名",
					explainTwo:"如果您修改过姓名, 请联系银行处理",
					explainThree:"获取更多帮助, 请致电400-100-9591",
				}
				document.getElementById("explainPopParent").style.display = "block";
				document.getElementById("explainChildPopParent").classList.add("mui-active");
				break;
			case "identity":
				openWindow("authSecond", "auth_second.html", false, {
					authFirstId: plus.webview.currentWebview().id,
					frontCardCode:vueObj.frontCardCode,
					reverseCardCode:vueObj.reverseCardCode,
					source:"authCardIcon", //通过身份证icon 打开上传身份证页面
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, true);
				break;
			case "bank":
				vueObj.cardNo = vueObj.cardNo.replace("x","X");
				vueObj.bankNo = document.getElementById("bankNo").value;
				vueObj.userPhone = document.getElementById("userPhone").value;
				//调用公共图片选择上传
				popCompressSelectPic(function(isError, list) {
					if(list == null || list.length < 1) {
						return;
					} 
					console.log('上传图片网络地址：' + list[0].imgUrl);
					console.log('上传图片本地地址：' + list[0].localPath);
					//去除空格
					if(list[0].imgUrl && list[0].imgUrl.length > 0){
						vueObj.bankNo = list[0].imgUrl.replace(/\s|\xA0/g,"");
					}
				}, true , null, "bank", true);
				break;
			case "phone":
				vueObj.tipsExplain = {
					title:"手机号说明",
					explainOne:"银行预留手机是您在办理银行卡时所填写的手机号",
					explainTwo:"没有预留, 手机号码忘记或者停用, 请联系发行卡更新处理",
					explainThree:"获取更多帮助, 请致电400-100-9591",
				};
				document.getElementById("explainPopParent").style.display = "block";
				document.getElementById("explainChildPopParent").classList.add("mui-active");
				break;
			case "security":	
				vueObj.tipsExplain = {
					title:"安全保障",
					explainOne:"易12账户体系接受人行监管, 享受银行级别资金安全监控",
					explainTwo:"高强度数据加密, 保护用户隐私",
					explainThree:"了解详情, 请致电客服400-100-9591",
				};
				document.getElementById("explainPopParent").style.display = "block";
				document.getElementById("explainChildPopParent").classList.add("mui-active");
				break;
			default:
				break;	
			}
		},
		/*
		 * 协议点击
		 */
		onProtocolClick: function(e) {
			document.activeElement.blur();
			if(e.currentTarget.dataset.protocol == "auth"){ //身份认证协议
				openWindow('protocol', 'auth_protocol.html', false, {statusBarType:STATUS_BAR_DEFAULT_KEY}, null, false);
			} else { //支付协议
				openWindow('protocol', 'auth_protocol.html', false, {statusBarType:STATUS_BAR_DEFAULT_KEY}, null, false);
			}
		},
		/*
		 * 说明提示按钮点击
		 */
		onExplainBtnClick: function(e){
			document.getElementById("explainPopParent").style.display = "none";
			document.getElementById("explainChildPopParent").classList.remove("mui-active");
		},
		/*
		 * 更新用户状态
		 */
		updateUserAuthStatus: function(status, mediumId){
			if(vueObj.eacctStatus == 2 && status == 2){
				if(!vueObj.fromWalletThirdAuth) return;
				mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onWalletAuthResult", {
					status: "cancel"
				});
				return;
			}
			//修改payUser 二类户开户id  realNameStatus 实名认证
			var userInfo = getUserInfo();
			if(mediumId && mediumId.length > 0){
				userInfo.payUser = mediumId;
			}
			if(status == 3){//认证成功 刷新钱包状态
				userInfo.eacctStatus = 1;
			}
			userInfo.realNameStatus = status;
			userInfo.realUserName = vueObj.realName;
			updateLoginInfo(null, userInfo);	
			//开户成功  刷新个人中心页面
			mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onUserInfoChange", {
				isAuthSuccess: true
			});
			//第三方应用 开户状态
			if(vueObj.fromThirdAuth) {
				mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onAuthResult", {
					status: status == 3 ? "ok" : "cancel"
				});
			}
			//第三方应用 开户状态
			if(vueObj.fromWalletThirdAuth) {
				mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onWalletAuthResult", {
					status: status == 3 ? "ok" : "cancel"
				});
			}
			//实名认证成功 判断是否红包页面存在  存在刷新红包页面
			if(plus.webview.getWebviewById("walletRedbag") && status == 3 ){
				mui.fire(plus.webview.getWebviewById("walletRedbag"), "onRedbagActiveStatus", {});
			}
			//实名认证成功 判断是否钱包页面存在  存在刷新钱包页面
			if(plus.webview.getWebviewById("walletMain") && status == 3 ){
				mui.fire(plus.webview.getWebviewById("walletMain"), "onWalletOpenSuccess", {});
			}
		},
		/**
		 * 身份证输入框改变方法
		 */
		inputCardChange: function(e) {
			var value = e.currentTarget.value;
			e.currentTarget.value = value.replace(/[^0-9xX]/g, '');
		},
		/**
		 * 处理身份证号码
		 */
		handleCardNo: function() {
			if(vueObj.cardNo && vueObj.cardNo.length > 8){
				vueObj.cardNoShow = vueObj.cardNo.substring(0, 4) + "**********" + vueObj.cardNo.substring(vueObj.cardNo.length-4);
			}
		},
		/*
		 * 判断用户身份证是否过期
		 */
		isExpiryDate: function(expiryDate){
			if(!expiryDate || expiryDate.toString().length != 8){
				return false;
			}
			var nowDate = new Date();
			var nowyear = nowDate.getFullYear(); 
			var nowmonth = nowDate.getMonth() + 1;
			var nowDay = nowDate.getDate();
			nowyear = nowyear.toString();
			if(nowmonth < 10){
				nowmonth = "0" + nowmonth.toString();
			}
			if(nowDay < 10){
				nowDay = "0" + nowDay.toString();
			}
			var nowTime = parseInt(nowyear + nowmonth + nowDay);
			expiryDate = parseInt(expiryDate);
			if(nowTime < expiryDate){ //当前日期小于过期日期
				return false;
			}
			plus.nativeUI.alert("身份证已过期, 请重新上传", function() {
				openWindow("authFirst", "auth_first.html", false, {
					fromThirdAuth: vueObj.fromThirdAuth,
					fromWalletThirdAuth: vueObj.fromWalletThirdAuth,
					webPageId: vueObj.webPageId,
					source: plus.webview.currentWebview().source,
					statusBarType: plus.webview.currentWebview().statusBarType
				}, null, true);
				setTimeout(function() {
					closeWebview(plus.webview.currentWebview().id);
				}, 300);
			}, "有效期异常", "重新上传");
			return true;
		}
	}
});
//弹窗透明处点击
document.getElementById("explainPopParent").addEventListener("tap", function(e){
	e.stopPropagation();
});