/** 网络请求码 */
var QUERY_ADS = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		authStatusIcon:"",//图片
		authTitle:"",//标题
		authBtnTitle:"", //按钮标题
		reward:null, //开户成功, 奖励红包
		realNameStatus:-1,//是否开户成功 实名认证状态 1未实名 2申请中 3认证成功 4认证失败
		errorMessage:"",//错误提示
		bannerLength: 0, //
		bannerRows: [], // 广告列表数据
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			vueObj.realNameStatus = plus.webview.currentWebview().realNameStatus;
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				} else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false); 
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.eacctStatus = getUserInfo().eacctStatus ? getUserInfo().eacctStatus : 0;
			if(plus.webview.currentWebview().source == "walletMain"){//已销户
				document.getElementById("title").innerHTML = "开通钱包";
			} else{
				document.getElementById("title").innerHTML = "实名认证";
			}
			vueObj.errorMessage = plus.webview.currentWebview().errorMessage;
			vueObj.reward = plus.webview.currentWebview().reward;
			if(vueObj.realNameStatus == 3) {
				if(vueObj.reward && vueObj.reward > 0 && plus.webview.currentWebview().isNew == "1"){
					vueObj.authTitle = "恭喜你, 红包激活成功";
				} else if(plus.webview.currentWebview().source == "walletMain"){
					vueObj.authTitle = "恭喜你, 开通钱包成功";
				}else {
					vueObj.authTitle = "恭喜你, 认证成功";
				}
				vueObj.authStatusIcon = "images/auth_success_icon.png"
				vueObj.authBtnTitle = "返回";
			} else{
				vueObj.authStatusIcon = "images/auth_success_icon.png"
				vueObj.authTitle = "认证申请成功, 请等待";
				vueObj.authBtnTitle = "返回";
			}
			//查询广告
			showWaiting();
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:'k12_4001'}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 接口请求成功
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_ADS: //广告数据加载
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;
			default:
				break;
			}
		},
		/**
		 * 接口请求失败
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 使用规则
		 */
		onRuleClick: function(){
			var linkUrl = h5Host + "/activity/h5/common?activityCode=wallet1003";
			openWindow(linkUrl, '../common/web_page.html', false, {
				"webUrl": linkUrl,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			}, null, false);	
		},
		/**
		 * 学生卡
		 */
		onCardClick: function(){
			//添加统计事件
			statisticEvent("walletOpenClickTime", {"action" : "点击一卡通充值", "from" : "实名认证成功页"});
			openWindow("rechargeCard", "../card/recharge_card.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
		},
		/**
		 * 话费充值
		 */
		onPhoneClick: function(){
			//添加统计事件
			statisticEvent("walletOpenClickTime", {"action" : "点击话费充值", "from" : "实名认证成功页"});
			openWindow("rechargeCenter", "../app/recharge_center.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
		},
		/**
		 * 变蛙会员充值
		 */
		onRechargeClick: function(){
			//添加统计事件
			statisticEvent("walletOpenClickTime", {"action" : "点击会员充值", "from" : "实名认证成功页"});
			openWindow("webPage", '../common/web_page.html', false, {
				"webUrl": "https://eschool.bianwa.com/vbankprod-webapp/login.html",
				statusBarType: STATUS_BAR_DEFAULT_KEY
			}, null, false);	
		},
		
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "开通钱包成功页", "pos": "认证成功页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && getUserInfo().bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		},
		/**
		 * 返回首页
		 */
		doNext: function(e) {
			closeWebview("authSuccess");
		}
	}
});
//分享按钮监听
document.getElementById("shareBtn").addEventListener("tap", function(){
	openWindow("inviteHome", "../app/invite_home.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
});