var DO_AUTH = 1001, GET_CODE = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		eacctStatus: 0, //钱包状态 0未开通 1启用 2销户 3关闭
		userPhone:"",
		realName:"",
		corpSernoOriginal: null, //申请开户返回的交易流水单号
		smsSendNo: null, //申请开户时返回的短信验证码编号
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		smsScoded:"", //短信验证码
		fromThirdAuth: false, //是否来自第三方
		fromWalletThirdAuth: false, //是否来自第三方
		webPageId: '', //第三方页面ID
		showPwds: ['', '', '', '', '', ''], //输入的6位验证码

	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				return false;
			}
		});
		mui.plusReady(function(){
			setStatusBarDefault();
			//设置键盘弹出模式
			keyboardAdjustResize();
			plus.webview.currentWebview().setStyle({'popGesture': 'none'});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//添加统计事件
			statisticEvent("walletOpen07");
			/**进入页面弹出键盘*/
		    initNativeObjects();
		    showSoftInput();
		    vueObj.eacctStatus = getUserInfo().eacctStatus ? getUserInfo().eacctStatus : 0;
			//接收参数
			var self = plus.webview.currentWebview();
			vueObj.realName = self.realName;
			vueObj.userPhone = self.userPhone.substring(0, 3) + "*****" + self.userPhone.substring(7, 11);
			vueObj.corpSernoOriginal = self.corpSernoOriginal;
			vueObj.smsSendNo = self.smsSendNo; 
			vueObj.fromThirdAuth = self.fromThirdAuth;
			vueObj.fromWalletThirdAuth = self.fromWalletThirdAuth;
			vueObj.webPageId = self.webPageId;
			//倒计时 上个页面已经发了验证码 直接倒计时
			vueObj.setTimeCount();
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			if(!vueObj.smsScoded || vueObj.smsScoded.length <= 0){
				toast("请输入验证码");
				return;
			}
			document.activeElement.blur();
			//添加统计事件
			statisticEvent("walletOpenClickTime", {"action" : "实名认证第三步-提交验证码", "from" : "实名认证第三步"});
			statisticEvent("walletOpen08");
			showWaiting();
			webCall2("/compus/wallet/scodeVerify", {
				corpSernoOriginal: vueObj.corpSernoOriginal,//开户返回的交易流水单号
				smsSendNo: vueObj.smsSendNo,
				smsScoded: vueObj.smsScoded 
			}, DO_AUTH, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在60s计时
			showWaiting();
			webCall2("/compus/wallet/scodeSend", {
				corpSernoOriginal:vueObj.corpSernoOriginal
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 收不到验证码 点击
		 */
		onUngetCode: function(){
			//跳转到收不到验证码常见问题详情页
			openWindow("questionDetail", "question_detail.html", false, {
				detailId: 1905230928263016
			});
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 180;
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
					document.getElementById("smsCodeBtn").style.opacity = "1";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_CODE: //获取验证码
				vueObj.smsSendNo = data.data.smsSendNo;
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			case DO_AUTH: //实名认证验证
				//当前不在业务受理范围时间内
				if(data && data.data && data.data.inTime == 1) {
					openWindow("authApply","auth_apply.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType,
					});	
					if(plus.webview.getWebviewById(plus.webview.currentWebview().authFirstId)){
						closeWebview(plus.webview.currentWebview().authFirstId);
					}
					closeWebview(plus.webview.currentWebview().authSecondId);
					closeWebview("authThree", true);
					return;
				}
				//修改payUser 二类户开户id  realNameStatus 实名认证
				if(data.data.successFlag && data.data.successFlag == 2) { //认证成功
					//添加统计事件
					statisticEvent("walletOpenClickTime", {"action" : "实名认证第三步-认证成功", "from" : "实名认证第三步"});
					statisticEvent("walletOpen09");
					vueObj.updateUserAuthStatus(3, data.data.mediumId);
				} else {//不成功/遗账状态 需要后台等待之后才能查询是否开户成功
					//添加统计事件
					statisticEvent("walletOpenClickTime", {"action" : "实名认证第三步-认证申请中", "from" : "实名认证第三步"});
					if(vueObj.eacctStatus != 2){
						vueObj.updateUserAuthStatus(2);
					}
				}
				var userInfo = getUserInfo();
				var param = {
					realNameStatus: userInfo.realNameStatus,//认证状态
					source:plus.webview.currentWebview().source,
					statusBarType: plus.webview.currentWebview().statusBarType
				}
				if(data && data.data) {
					param.isNew = data.data.isNew ? String(data.data.isNew): null;//0 是新红包 1待激活的红包
					param.reward = data.data.redbagAmount;//奖励红包
				}
				//认证成功 跳转成功页
				openWindow("authSuccess", "auth_success.html", false, param);
				if(plus.webview.getWebviewById(plus.webview.currentWebview().authFirstId)){
					closeWebview(plus.webview.currentWebview().authFirstId);
				}
				closeWebview(plus.webview.currentWebview().authSecondId);
				closeWebview("authThree", true);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			if(data && data.alertType == 1){ 
				statisticEvent("walletOpenClickTime", {"action" : "实名认证第三步-认证失败", "from" : "实名认证第三步"});
				openWindow("authError", "auth_error.html", false, {
					errorMessage: resultMsgDesc,//失败原因
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				closeWebview("authThree", true);
				return;
			}
			onError(resultCode, resultMsgDesc);
		},
		/*
		 * 更新用户状态
		 */
		updateUserAuthStatus: function(status, mediumId){
			if(vueObj.eacctStatus == 2 && status == 2){
				if(!vueObj.fromWalletThirdAuth) return;
				mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onWalletAuthResult", {
					status: "cancel"
				});
				return;
			}
			//修改payUser 二类户开户id  realNameStatus 实名认证
			var userInfo = getUserInfo();
			if(mediumId && mediumId.length > 0){
				userInfo.payUser = mediumId;
			}
			if(status == 3){//认证成功 刷新钱包状态
				userInfo.eacctStatus = 1;
			}
			userInfo.realNameStatus = status;
			userInfo.realUserName = vueObj.realName;
			updateLoginInfo(null, userInfo);	
			mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onUserInfoChange", {
				isAuthSuccess: true
			});
			//第三方应用 开户状态
			if(vueObj.fromThirdAuth) {
				mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onAuthResult", {
					status: status == 3 ? "ok" : "cancel"
				});
			}
			//第三方应用 开户状态
			if(vueObj.fromWalletThirdAuth) {
				mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onWalletAuthResult", {
					status: status == 3 ? "ok" : "cancel"
				});
			}
			//实名认证成功 判断是否红包页面存在  存在刷新红包页面
			if(plus.webview.getWebviewById("walletRedbag") && status == 3 ){
				mui.fire(plus.webview.getWebviewById("walletRedbag"), "onRedbagActiveStatus", {});
			}
			//实名认证成功 判断是否钱包页面存在  存在刷新钱包页面
			if(plus.webview.getWebviewById("walletMain") && status == 3 ){
				mui.fire(plus.webview.getWebviewById("walletMain"), "onWalletOpenSuccess", {});
			}
		},
		/**
		 * 输入框输入监听
		 */
		onInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9]/g, '');
			e.currentTarget.value = value;
			//最长只支持6位
			if(value.length > 6){
				e.currentTarget.value = value.substring(0, 6);
				return;
			}
			if(value.length <= 0){
				vueObj.smsScoded = '';
				for(var i=0; i<6; i++){
					Vue.set(vueObj.showPwds, i, '');
				}
				return;
			}
			vueObj.smsScoded = value;
			for(var i=0; i<6; i++){
				if(i < vueObj.smsScoded.length){
					Vue.set(vueObj.showPwds, i, vueObj.smsScoded[i]);
				}else{
					Vue.set(vueObj.showPwds, i, "");
				}
			}
			//触发确定方法
			if(value.length == 6){
				vueObj.doNext();
			}
		},
	}
}); 

/**进入页面弹出键盘*/
var initNativeObjects = function() {
    if (mui.os.android) {
        var main = plus.android.runtimeMainActivity();
        var Context = plus.android.importClass("android.content.Context");
        InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
        imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
    } else {
        nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    }
};
var showSoftInput = function() {
    var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    if (mui.os.android) {
        //强制当前webview获得焦点
        plus.android.importClass(nativeWebview);
        nativeWebview.requestFocus();
        imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
    } else {
        nativeWebview.plusCallMethod({
            "setKeyboardDisplayRequiresUserAction": false
        });
    }
    setTimeout(function() {
       //此处可写具体逻辑设置获取焦点的input
       document.getElementById("hideInput").focus();
    }, 300);
};