/** 网络请求码 */
var QUERY_USER_INFO = 1001, CHANGE_IDENTITY = 1002, QUERY_AUTH = 1003;
var myScroll;
var isPull = true;
var vueObj = new Vue({
	el: '#main',
	data: {
		realNameStatus: -1, //实名认证状态  0 编辑中 1申请中 2受理成功 3成功 4 失败
		isFirstLoad: true,
		headImg: null, //用户头像
		nickName: null, //用户昵称
		userPhone: null, //用户手机
		defaultLoadImg: "../../img/default_load_img.png",
		identitys: [], //身份列表
		defIdentity: null, //默认身份
		supportAuth: true, //是否支持实名认证
		supportAuthUrl: null, //实名认证跳转链接
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(plus.os.name == 'Android'){
					mui.fire(plus.webview.getWebviewById("main"), "mainBack", {});
				}
				return false;
			}
		});
		mui.plusReady(function() {
			//处理状态栏
			vueObj.handleStatusBar();
			window.addEventListener("userPhoneChange", function(event){
				vueObj.userPhone = getCache(USER_PHONE_KEY);
			});
			//用户数据
			vueObj.initData();
			//监听数据变化
			window.addEventListener("onUserInfoChange", function(event){
				vueObj.initData();
			});
			//接收身份列表数据
			window.addEventListener("onReceiveIdentitys", function(event){
				vueObj.identitys = event.detail.identitys;
				vueObj.setDefaultIdentity();
			});
			window.addEventListener("onSchoolChange", function(event){
				vueObj.initData();
				if(vueObj.realNameStatus != 3){ 
					webCall2("/compus/advertising/getAdvertisingMap", {addressCodeList: 'k12_6001'}, QUERY_AUTH, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
				}
			});
		});
	},
	methods: {
		/**
		 * 第一次加载数据（main中tab切换调用）
		 */
		firstLoadData: function() {
			if(!vueObj.isFirstLoad) return;
			vueObj.isFirstLoad = false;
			vueObj.pulldownRefresh();
			//获取缓存中身份列表
			if(getCache(IDENTITY_LIST_DATA)){
				vueObj.identitys = JSON.parse(getCache(IDENTITY_LIST_DATA));
				vueObj.setDefaultIdentity();
			}
		},
		/**
		 * 设置默认身份
		 */
		setDefaultIdentity: function() {
			vueObj.defIdentity = null;
			if(!vueObj.identitys) return;
			for(var i in vueObj.identitys){
				if(vueObj.identitys[i].isDefault == 0){
					vueObj.defIdentity = vueObj.identitys[i];
				}
			}
		},
		/**
		 * 初始化数据
		 */
		initData: function() {
			vueObj.realNameStatus = getUserInfo().realNameStatus ? getUserInfo().realNameStatus : 0;
			vueObj.headImg = getCache(IMAGE_URL_KEY);
			vueObj.nickName = getCache(NICK_NAME_KEY);
			vueObj.userPhone = getCache(USER_PHONE_KEY);
		},
		/**
		 * 下拉刷新具体业务实现
		 */
		pulldownRefresh: function() {
			//未认证，查询是否支持认证
			if(vueObj.realNameStatus != 3){ 
				webCall2("/compus/advertising/getAdvertisingMap", {addressCodeList: 'k12_6001'}, QUERY_AUTH, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
			}
			//请求用户信息
			webCall2("/compus/user/getUserById", null, QUERY_USER_INFO, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_USER_INFO: //用户信息查询
				updateLoginInfo(null, data.data);
				vueObj.initData();
				break;
			case CHANGE_IDENTITY: //切换身份成功
				updateLoginInfo(null, data.data);
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onSchoolChange", {});
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onIdentityChange", {});
				mui.fire(plus.webview.getWebviewById("message/message_main.html"), "onIdentityChange", {});
				break;
			case QUERY_AUTH: //查看是否支持认证
				//实名认证
				vueObj.supportAuth = false;
				if(data.data['k12_6001'] && data.data['k12_6001'].length > 0){
					vueObj.supportAuth = true;
					vueObj.supportAuthUrl = data.data['k12_6001'][0].url;
				}
				break;
			default:
				break;
			}
			vueObj.closePullStatus();
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			vueObj.closePullStatus();
		},
		/**
		 * 关闭上拉/下拉刷新 
		 */
		closePullStatus: function(data) {
			if(!isPull) return;
			//刷新列表
			Vue.nextTick(function(){
				isPull = false;
				setTimeout(function(){
					myScroll.refresh();
				}, 200); 
			});
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			//添加统计事件
			statisticEvent("centerButtonClick", {"btnType" : e.currentTarget.dataset.type});
			switch (e.currentTarget.dataset.type){
			case "userInfo": //个人资料
				openWindow("userInfo", "user_info.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
				break;
			case "identity": //身份信息
				openWindow("identityInfo", "identity_info.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY,
					identity: vueObj.defIdentity
				});
				break;
			case "addIdentity": //绑定新身份
				openWindow("selectSchool", "../login/select_school.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY,
					from: 'student'
				});
				break;
			case "order": //交易记录
				openWindow("orderList", "order_list.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
				break;
			case "feedback": //意见反馈
				openWindow("feedback", "feedback.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
				break;
			case "question": //常见问题
				openWindow("questionMain", "question_main.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
				break;
			case "setting": //设置
				openWindow("setting", "../setting/setting.html", false, {statusBarType: STATUS_BAR_MAIN_KEY});
				break;
			case "service": //客服电话
				plus.device.dial("400-100-9591", true);
				break;
			case "changeIdentity": //切换身份
				var identity = vueObj.identitys[e.currentTarget.dataset.index];
				if(!identity || identity.isDefault == 0) return;
				showWaiting("切换中...");
				webCall2("/kt/user/changeIdentity", {
					identityId: identity.identityId,
					identityType: identity.identityType,
					schoolCode: identity.schoolCode
				}, CHANGE_IDENTITY, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
				break;
			case "xueji": //
				if(getCache(SCHOOL_CODE_KEY) != 'qzez' && getCache(SCHOOL_CODE_KEY) != '2019040801'){
					toast("学校未开通该功能");
					return;
				}
				openWindow("xueji", "../common/web_page.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY,
					webUrl: "http://xjys.zjxueji.com"
				});
				break;
			case "zonghe": //
				if(getCache(SCHOOL_CODE_KEY) != 'qzez' && getCache(SCHOOL_CODE_KEY) != '2019040801'){
					toast("学校未开通该功能");
					return;
				}
				openWindow("zonghe", "../common/web_page.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY,
					webUrl: "http://243223t3m6.zicp.vip:8090/index!waphome.action"
				});
				break;
			case "chengji": //
				if(getCache(SCHOOL_CODE_KEY) != 'qzez' && getCache(SCHOOL_CODE_KEY) != '2019040801'){
					toast("学校未开通该功能");
					return;
				}
				openWindow("xueji", "../common/web_page.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY,
					webUrl: "https://h5.xiaofubao.com/activity/h5/common?activityCode=K12_KSCJFX"
				});
				break;
			case "chengzhang": //成长相册
				openWindow("albumHome", "../album/album_home.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY
				});
				break;
			case "wallet": //宝贝钱包
				openWindow("walletMain", "../wallet/wallet_main.html", false, {
					statusBarType: STATUS_BAR_MAIN_KEY
				});
				break;
			case "plan": //成长计划
				openWindow("walletIntroduce", "../common/web_page.html", false, {
					webUrl: h5Host + '/auth/h5/walletIntroduceYi12?activityCode=yi12WalletIntroduce',
					statusBarType: STATUS_BAR_MAIN_KEY
				});
				break;
			default:
				toast("开通中");
				break;
			}
		},
		handleStatusBar: function() {
			var immersed = 0;
			var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
			if(ms && ms.length >= 3) {
				immersed = parseFloat(ms[2]);
			}
			if(!immersed) {
				return;
			}
			document.getElementById("topBar").style.height = immersed + 'px';
		}
	}
});

/**iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isPull = true;
			vueObj.pulldownRefresh();
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, null);
		myScroll.refresh();
	});
})(mui);