//请求码
var DO_FEEDBACK = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		imgHeight: '0px', //图片调试
		uploadUrls: [], //上传的图片地址
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//获取图片高度
			vueObj.imgHeight = document.getElementById("selectImg").offsetWidth + "px";
		});
	},
	methods: {
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.code){
			case "select": //选择照片
				//调用公共图片选择上传
				popCompressSelectPic(function(isError, list){
					if(list == null || list.length < 1) {
						return;
					}
					console.log('上传图片网络地址：' + list[0].imgUrl);
					console.log('上传图片本地地址：' + list[0].localPath);
					vueObj.uploadUrls.push(list[0].imgUrl)
				});
				break;
			case "delete": //删除照片
				vueObj.uploadUrls.splice(e.currentTarget.dataset.index, 1);
				break;
			case "submit": //提交
				var theme = document.getElementById("theme").value;
				if(!theme){
					toast("请输入标题");
					return;
				}
				var desc = document.getElementById("desc").value;
				if(!desc){
					toast("请输入问题描述信息");
					return;
				}
				document.activeElement.blur();
				showWaiting();
				var extParams = {
					urlPath: "/compus/feedback/save"
				}
				webCall2("/common/token/get", {
					title: replaceEmojiToStr(theme),
					content: desc,
					imgUrl: vueObj.uploadUrls.join()
				}, DO_FEEDBACK, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, extParams);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_FEEDBACK: //提交成功
				toast("感谢您的意见和建议");
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});