//请求码
var FEEDBACK_DETAIL = 1001, FEEDBACK_SOLVED = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		imgHeight:"",//图片高度
		headImg:'',//用户头像
		feedbackData:{},
		contentIsShowAll:false, //反馈内容是否显示查看全文
		replyIsShowAll:false, //回复内容是否显示查看全文
		feedbackId: null,
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../home/images/home_ad_default.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			var self = plus.webview.currentWebview();
			//状态栏设置
			setStatusBarDefault();
			self.addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll(); 
			//计算图片高度
			var height = (plus.screen.resolutionWidth - 92) / 4;
			vueObj.imgHeight = "height:"+ height +"px;";
			//获取当前用户头像
			vueObj.headImg = getCache(IMAGE_URL_KEY);
			//加载数据
			showWaiting();
			vueObj.feedbackId = vueObj.getParamByName(self.id, "id");
			vueObj.onLoadData();
		});
	},
	methods: {
		/*
		 * 反馈详情请求
		 */
		onLoadData: function(){
			webCall2("/compus/feedback/detail", {
					"feedbackId": vueObj.feedbackId,
				}, FEEDBACK_DETAIL, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 处理反馈结果
		 */
		onProcessResult: function(status){
			showWaiting();
			webCall2("/compus/feedback/processResult", {
					"feedbackId": vueObj.feedbackId,
					"status" : status
				}, FEEDBACK_SOLVED, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case FEEDBACK_DETAIL: 
				vueObj.feedbackData = data.data;
				Vue.nextTick(function(){
					// 判断文字是否需要隐藏
					vueObj.judgeContentHide();
				});
				break;
			case FEEDBACK_SOLVED:
				vueObj.feedbackData.status = 2;
				toast("提交成功");
				break;	
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/*
		 *   判断文字是否需要隐藏
		 */
		judgeContentHide: function(){
			var feedbackContent = document.getElementById("feedbackContent");
			var processContent = document.getElementById("processContent");
			if(feedbackContent.offsetHeight > 60) {
				vueObj.contentIsShowAll = true;
			}
			if(processContent.offsetHeight > 60) {
				vueObj.replyIsShowAll = true;
			}
		},
		/*
		 * 显示时间
		 */
		showTime: function(time){
			return time ? time.substring(0, 16) : "";
		},
		/*
		 * 图片点击
		 */
		onImgTap: function(clickIndex){
			plus.nativeUI.previewImage([vueObj.feedbackData.imgUrlList[clickIndex]], {"indicator":"none"});
		},
		/*
		 * 反馈内容显示全部
		 */
		onContentClick: function(time){
			vueObj.contentIsShowAll = false;
		},
		/*
		 * 回复内容显示全部
		 */
		onReplyClick: function(time){
			vueObj.replyIsShowAll = false;
		},
		/*
		 * 已解决按钮点击
		 */
		onSolvedClick: function(){
			vueObj.onProcessResult(2);
		},
		/*
		 * 未解决按钮点击
		 */
		onUnsolvedClick: function(){
			vueObj.onProcessResult(3);
		},
		/**
		 * 获取参数
		 */
		getParamByName: function (url, name) {
			if(!url || url.indexOf("?") < 0) return null;
			var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
			var r = url.split("?")[1].match(reg);
			if(r != null) return decodeURI(r[2]);
			return null;
		},
	}
});
