var mUploadUrl, sex, birthday;
//请求码
var UPDATE_IDENTITY = 1001, QUERY_IDENTITY_INFO = 1002, DO_UNBIND = 1003;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		identity: {}, //身份信息
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			window.addEventListener("onRelationshipChange", function(event){
				//加载身份信息
				vueObj.loadIdentityInfo();
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.identity = plus.webview.currentWebview().identity;
			//加载身份信息
			vueObj.loadIdentityInfo();
		}); 
	},
	methods: {
		//加载身份信息
		loadIdentityInfo: function(){
			showWaiting();
			webCall2("/kt/user/myIdentityDetail", {
				identityId: vueObj.identity.identityId,
				identityType: vueObj.identity.identityType
			}, QUERY_IDENTITY_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		updateIdentityInfo: function() {
			showWaiting();
			var params = {identityId:vueObj.identity.identityId, identityType:vueObj.identity.identityType};
			if(mUploadUrl) params.headImg = mUploadUrl;
			if(sex) params.sex = sex;
			if(birthday) params.birthday = birthday;
			webCall2("/kt/user/updateIdentity", params, UPDATE_IDENTITY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.code){
			case 'photo': //头像更换
				//调用公共图片选择上传
				popCompressSelectPic(function(isError, list){
					if(list == null || list.length < 1) {
						return;
					}
					console.log('上传图片网络地址：' + list[0].imgUrl);
					console.log('上传图片本地地址：' + list[0].localPath);
					mUploadUrl = list[0].imgUrl;
					if(!mUploadUrl) return;
					//调用接口设置头像
					vueObj.updateIdentityInfo();
				}, null, null, null, null, null, null, null, "0");
				break;
			case 'sex': //性别
				// 弹出系统选择按钮框
				plus.nativeUI.actionSheet({
					cancel: "取消",
					buttons: [{title: "男"}, {title: '女'}]
				}, function(e) {
					if(e.index == 2) {
						sex = "女";
						vueObj.updateIdentityInfo();
					} else if(e.index == 1) {
						sex = "男";
						vueObj.updateIdentityInfo();
					}
				});
				break;
			case 'birthday': //生日
				var dDate = new Date();
				plus.nativeUI.pickDate(function(e) {
					var d = e.date;
					var month = d.getMonth() + 1;
					var day = d.getDate();
					month = month < 10 ? ("0" + month) : month;
					day = day < 10 ? ("0" + day) : day;
					birthday = d.getFullYear() + "-" + month + "-" + day;
					vueObj.updateIdentityInfo();
				}, function(e) {
				}, {
					title: "请选择生日",
					date: dDate,
					maxDate: dDate
				});
				break;
			case 'relation': //关系
				//跳转到关系选择
				openWindow("bindRelation", "../login/bind_relation.html", false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY,
					opeType: 'update',
					schoolCode: vueObj.identity.schoolCode,
					relationship: vueObj.identity.relationship,
					relationshipName: vueObj.identity.relationshipName,
					identityId: vueObj.identity.identityId,
					identityType: vueObj.identity.identityType
				});
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case UPDATE_IDENTITY: //更新用户头像信息
				if(mUploadUrl) Vue.set(vueObj.identity, "headImg", mUploadUrl);
				if(sex) Vue.set(vueObj.identity, "sex", sex);
				if(birthday) Vue.set(vueObj.identity, "birthday", birthday);
				mUploadUrl = null;
				sex = null;
				birthday = null;
				break;
			case QUERY_IDENTITY_INFO: //查询身份信息
				vueObj.identity = data.data;
				break;
			case DO_UNBIND: //解绑身份成功
				if(data.data) updateLoginInfo(null, data.data);
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onIdentityChange", {});
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		}
	}
});

//解绑身份
document.getElementById("unbindBtn").addEventListener("tap", function(){
	confirmDialog("", "确认要解绑该身份信息吗？", "解绑", "取消", function(){
		showWaiting("正在解绑...");
		webCall2("/kt/user/unBindIdentity", {
			identityId: vueObj.identity.identityId,
			identityType: vueObj.identity.identityType,
			schoolCode: vueObj.identity.schoolCode
		}, DO_UNBIND, vueObj.onSuccess, vueObj.onErrorBefore);
	});
});