var myScroll;
var isLoadingMore;
var isNoMore;
var start = 0;
var dtpicker;
//请求码
var QUERY_LIST = 1001, DELETE_TRADE_ORDER = 1002, QUERY_ADS = 1003;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		datas: [],
		deleteOrderIndex: null,//订单删除的下标
		queryMonth: '' //查询时间，例如:2018-11
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听变化
			window.addEventListener("onOrderChange", function(event){
				start = 0;
				vueObj.loadData();
			});
			//加载数据
			vueObj.queryMonth = formatMonth(new Date().getTime());
			vueObj.loadData();
			vueObj.loadBannerData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			webCall2("/compus/order/queryTradePage", {
				offset: start,
				limit: 10,
				month: vueObj.queryMonth
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 加载广告数据
		 */
		loadBannerData: function() {
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:1018}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 删除订单
		 */
		deleteTradeOrder: function(orderId) {
			webCall2("/compus/order/deleteTradeOrder", {
				orderId: orderId
			}, DELETE_TRADE_ORDER, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST:
				//更新数据
				vueObj.datas = (start == 0 ? data.rows : vueObj.datas.concat(data.rows));
				start = vueObj.datas.length;
				vueObj.dataChangeJudge();
				closePullStatus(data.rows);
				break;
			case DELETE_TRADE_ORDER:
				//更新数据
				vueObj.datas.splice(vueObj.deleteOrderIndex, 1);
				vueObj.dataChangeJudge();
				break;
			case QUERY_ADS: //更新为已读成功
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;	
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
			if(start == 0){
				document.getElementById("item0mobileSpan").style.display = "none";
			}
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			//无数据图
			if(vueObj.datas.length == 0) {
				setNoDataBackground(true);
			} else {
				setNoDataBackground(false);
			}
			if(vueObj.datas.length < 4) {
				document.getElementById("item0mobileSpan").style.display = "none";
			} else {
				document.getElementById("item0mobileSpan").style.display = "";
			}
		},
		/**
		 * 选择月份
		 */
		selectDate: function(e) {
			if(dtpicker == null){
				dtpicker = new mui.DtPicker({
				    type: "month",//设置日历初始视图模式 
				    beginDate: new Date(2000, 01, 01),//设置开始日期 
				    endDate: new Date(),//设置结束日期 
				});
			}
			dtpicker.show(function(e) {
			    var sdate = e.text;
			    if(vueObj.queryMonth == sdate) return;
			    vueObj.queryMonth = sdate;
			    showWaiting();
			    start = 0;
			    vueObj.loadData();
			});
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			openWindow("orderDetail", "../common/order_detail.html", false, {
				tranNo: e.currentTarget.parentNode.dataset.tranno,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			});
		},
		/**
		 * 列表删除按钮点击
		 */
		onItemDeleteClick: function(e) {
			var li = e.currentTarget.parentNode;
			var orderId = li.dataset.orderid;
			vueObj.deleteOrderIndex = li.dataset.index;
			confirmDialog("", "确认删除该条记录?", "确认", "取消", function sureCallback(){
				vueObj.deleteTradeOrder(orderId);
			});
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "交易记录列表页", "pos": "交易记录列表页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && getUserInfo().bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore = false;
			setTimeout(function() {
				start = 0;
				vueObj.loadData();
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
	
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		if(data.length < 10) {
			document.getElementById("item0mobileSpan").innerHTML = "没有更多数据了";
			isNoMore = true;
		} else {
			document.getElementById("item0mobileSpan").innerHTML = "正在加载...";
			isNoMore = false;
		}
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}

// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
		//无数据时不显示上拉显示更多
		document.getElementById("item0mobileSpan").style.display = "none";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
		document.getElementById("item0mobileSpan").style.display = "";
	}
}
/*
 * 点击屏幕任何区域 关闭左滑删除的按钮
 */
document.addEventListener('tap', function() {
	if(!document.querySelector('.mui-selected')) return;
	document.querySelector('.mui-selected').children[0].children[0].setAttribute('style', 'transform: translate(0px, 0px);')
	document.querySelector('.mui-selected').children[1].setAttribute('style', 'transform: translate(0px, 0px);')
});
