//请求码
var QUERY_DETAIL = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		detailId: null, //文章ID
		detailData: {} //数据
	},
	beforeMount: function() {
		mui.plusReady(function(){
			var self = plus.webview.currentWebview();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//参数
			vueObj.detailId = plus.webview.currentWebview().detailId;
			//加载数据
			vueObj.loadData();
			//拦截超链接
			self.overrideUrlLoading({ 
				mode: "reject",
				effect: "touchstart"
			}, function(e) {
				// 拦截新的页面在新的webview里面加载URL页面
				if(!e.url) return;
				if(e.url.indexOf("http") < 0) return;
				openWindow(e.url, '../common/web_page.html', false, {
					"webUrl": e.url,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			});
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			showWaiting();
			webCall2("/compus/article/getArticleDetail", {
				articleId: vueObj.detailId
			}, QUERY_DETAIL, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DETAIL: //数据加载
				vueObj.detailData = data.data;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});