//请求码
var QUERY_LIST = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		searchText: null, //搜索关键字
		tagsId: null, //分类编码
		datas: [], //数据列表
	},
	beforeMount: function() {
		mui.plusReady(function(){
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//显示标题
			vueObj.searchText = plus.webview.currentWebview().searchText;
			vueObj.tagsId = plus.webview.currentWebview().tagsId;
			var title = plus.webview.currentWebview().title;
			if(title){
				document.getElementById("title").innerText = title;
			}else {
				document.getElementById("title").innerText = "常见问题";
			}
			//加载数据
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			showWaiting();
			var url;
			var params = {
				offset: 0,
				limit: 1000
			}
			if(vueObj.tagsId){
				url = "/compus/article/getActicleFaqList";
				params.tagsId = vueObj.tagsId;
			}else{
				url = "/compus/article/fastSearchFaqList";
				params.searchText = vueObj.searchText;
			}
			webCall2(url, params, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_LIST: //列表数据加载
				vueObj.datas = data.rows;
				//判断有无数据
				var mainDiv = document.getElementById("main");
				if(vueObj.datas.length <= 0){
					mainDiv.style.backgroundImage = "url(../../img/no_content_bg.png)";
					mainDiv.style.backgroundSize = "100% auto";
					mainDiv.style.backgroundRepeat = "no-repeat";
					mainDiv.style.backgroundPosition = "center";
				}else{
					mainDiv.style.backgroundImage = "none";
				}
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 按钮点击分发
		 */
		onItemClick: function(e) {
			//跳转到详情页
			openWindow("questionDetail", "question_detail.html", false, {
				detailId: e.currentTarget.dataset.detailid
			});
		}
	}
});