//请求码
var QUERY_LIST = 1001, QUERY_CATEGORY = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		hotDatas: [], //热门问题列表
		cateDatas: [] //分类列表
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//根据登录状态更新界面
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			showWaiting(2);
			webCall2("/compus/article/getHotArticleList", null, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
			webCall2("/compus/article/getTwoTagsList", {firtTagsId:20000}, QUERY_CATEGORY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_LIST: //加载热门问题
				vueObj.hotDatas = data.rows;
				break;
			case QUERY_CATEGORY: //加载分类列表
				vueObj.cateDatas = data.rows;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			//跳转到问题列表页
			openWindow("questionList", "question_list.html", false, {
				tagsId: e.currentTarget.dataset.tagsid,
				title: e.currentTarget.dataset.title
			});
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			//跳转到详情页
			openWindow("questionDetail", "question_detail.html", false, {
				detailId: e.currentTarget.dataset.detailid
			});
		},
		/**
		 * 搜索框键盘输入监听
		 */
		onSearchKeydown: function(e) {
			if(e.keyCode != 13) return;
			var searchText = document.getElementById("searchInput").value;
			if(!searchText){
				toast("请输入搜索内容");
				return;
			}
			document.activeElement.blur();
			//执行搜索
			openWindow("questionList", "question_list.html", false, {
				searchText: searchText,
				title: '常见问题'
			});
		}
	}
});