var myScroll;
var isLoadingMore;
var isNoMore;
var start = 0;
//请求码
var QUERY_LIST = 1001;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		datas: [],
		clickObj: null
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//加载数据
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			webCall2("/compus/avtivity/getMyWelfareList", {
				welfareType: 1,
				offset: start,
				limit: 10
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST:
				//更新数据
				vueObj.datas = (start == 0 ? data.rows : vueObj.datas.concat(data.rows));
				start = vueObj.datas.length;
				vueObj.dataChangeJudge();
				closePullStatus(data.rows);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
			closePullStatus();
			vueObj.dataChangeJudge();
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			//无数据图
			if(vueObj.datas.length == 0) {
				setNoDataBackground(true);
			} else {
				setNoDataBackground(false);
			}
			if(vueObj.datas.length < 4) {
				document.getElementById("item0mobileSpan").style.display = "none";
			} else {
				document.getElementById("item0mobileSpan").style.display = "";
			}
		},
		/**
		 * 列表点击
		 */
		doUse: function(e) {
			var index = e.currentTarget.dataset.index;
			var clickObj = vueObj.datas[index];
			//添加统计事件
			statisticEvent("redbagCouponClickTime", {"welfareName" : clickObj.welfareName, "from" : "第三方权益列表页"});
			//未生效
			if(clickObj.status == 0){
				toast("该券未生效，请参照该券有效时间");
				return;
			}
			//待使用
			if(clickObj.status != 1) return;
			if(clickObj.url && clickObj.url.indexOf("http") < 0){ //内部链接
				openWindow(clickObj.url, clickObj.url, false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
			}else{ //网页链接
				openWindow(clickObj.url, '../common/web_page.html', false, {
					"webUrl": clickObj.url,
					"imgPath": clickObj.welfareLogo,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore = false;
			setTimeout(function() {
				start = 0;
				vueObj.loadData();
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
	
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		if(data.length < 10) {
			document.getElementById("item0mobileSpan").innerHTML = "没有更多数据了";
			isNoMore = true;
		} else {
			document.getElementById("item0mobileSpan").innerHTML = "正在加载...";
			isNoMore = false;
		}
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}

// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
		//无数据时不显示上拉显示更多
		document.getElementById("item0mobileSpan").style.display = "none";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
		document.getElementById("item0mobileSpan").style.display = "";
	}
}