var mUploadUrl;
//请求码
var UPDATE_HEAD_IMG = 1001, QUERY_USER_INFO = 1002, UN_BIND_CARD = 1003;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		userData: {}, //用户信息
		cardSchoolType: null, //1001：学校不支持一卡通
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听用户数据变化
			window.addEventListener("onUserInfoChange", function(event){
				vueObj.userData = getUserInfo();
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.userData = getUserInfo();
			//监听数据变化
			window.addEventListener("onNickNameChange", function(event){
				vueObj.userData.nickName = event.detail.nickName;
				setCache(USER_INFO_KEY, JSON.stringify(vueObj.userData));
				vueObj.userData = getUserInfo();
				updateRongIMUserinfo();
			});
			window.addEventListener("onSchoolChange", function(event){
				vueObj.userData.schoolCode = event.detail.schoolCode;
				vueObj.userData.schoolName = event.detail.schoolName;
				setCache(USER_INFO_KEY, JSON.stringify(vueObj.userData));
			});
			//一卡通状态
			vueObj.cardSchoolType = getCache(CARD_SCHOOL_TYPE_KEY);
			window.addEventListener("onCardSchoolTypeChange", function(event){
				vueObj.cardSchoolType = event.detail.cardSchoolType;
			});
			//加载用户信息
			showWaiting();
			webCall2("/compus/user/getUserById", null, QUERY_USER_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.code){
			case 'photo': //头像更换
				//调用公共图片选择上传
				popCompressSelectPic(function(isError, list){
					if(list == null || list.length < 1) {
						return;
					}
					console.log('上传图片网络地址：' + list[0].imgUrl);
					console.log('上传图片本地地址：' + list[0].localPath);
					mUploadUrl = list[0].imgUrl;
					if(!mUploadUrl) return;
					//调用接口设置头像
					showWaiting();
					webCall2("/compus/user/updateUserInfo", {
						headImg: mUploadUrl
					}, UPDATE_HEAD_IMG, vueObj.onSuccess, vueObj.onErrorBefore);
				}, null, null, null, null, null, null, null, "0");
				break;
			case 'nickName': //编辑昵称
				openWindow("userInfoEdit", "user_info_edit.html", false, null);
				break;
			case 'school': //更换学校
				if(vueObj.userData.bindCardStatus == 1){ //绑卡后不能修改学校信息
					return;
				}
				openWindow("selectSchool", "../login/select_school.html", false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY,
					from:'userinfo'
				});
				break;
			case 'realName': //真实姓名
				
				break;
			case 'stuNo': //卡解绑 / 绑卡
				if(vueObj.cardSchoolType != 1001) return;
				if(vueObj.userData.bindCardStatus == 1){ //解绑操作
					confirmDialog('', '确定要解绑学生卡吗？', '确认', '取消', function sureCallback(){
						showWaiting();
						//调用退出登录接口
						webCall2("/compus/user/unBindCard", {}, UN_BIND_CARD, vueObj.onSuccess, vueObj.onErrorBefore);
					}, function cancelCallback(){
					});
				}else{ //跳转到绑卡页面
					openBindCard(null, true);
				}
				break;
			case 'dorm': //宿舍地址
				
				break;
			case 'code': //二维码
				openWindow("personCode", "../message/person_code.html", false, null);
				break;
			case 'auth': //实名信息
				openWindow("authInfo", "auth_info.html", false, null);
				break;
			case 'more': //更多资料
				openWindow("userInfoMore", "user_info_more.html", false, null);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case UPDATE_HEAD_IMG: //更新用户头像信息
				setCache(IMAGE_URL_KEY, mUploadUrl);
				Vue.set(vueObj.userData, "headImg", mUploadUrl);
				setCache(USER_INFO_KEY, JSON.stringify(vueObj.userData));
				mui.fire(plus.webview.getWebviewById("card/card_main.html"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onUserInfoChange", {});
				updateRongIMUserinfo();
				break;
			case QUERY_USER_INFO: //查询用户信息
				vueObj.userData = data.data;
				updateLoginInfo(null, data.data);
				//刷新相关页面
				mui.fire(plus.webview.getWebviewById("card/card_main.html"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onUserInfoChange", {});
				break;
			case UN_BIND_CARD: //学生卡解绑成功
				toast("解绑成功");
				vueObj.userData = data.data;
				updateLoginInfo(null, data.data);
				//更新相关页面
				mui.fire(plus.webview.getWebviewById("card/card_main.html"), "onUserInfoChange", {});
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onUserInfoChange", {doRemind:true});
				mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onUserInfoChange", {});
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		}
	}
});