//请求码
var UPDATE_USER_INFO = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		areaCode: null, //传递的参数
		areaName: '', //传递的参数
		marriageId: null,
		marriageName: '',
		height: null,
		weight: null,
		address: null
	},
	beforeMount: function() {
		mui.plusReady(function(){
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//初始化信息
			var user = getUserInfo();
			vueObj.areaCode = user.areaCode;
			vueObj.areaName = user.areaName;
			vueObj.marriageId = user.marryStatus;
			if(vueObj.marriageId == 0){
				vueObj.marriageName = "未婚";
			}else{
				vueObj.marriageName = "已婚";
			}
			vueObj.height = user.height;
			vueObj.weight = user.weight;
			vueObj.address = user.address;
			//监听地址选择返回
			window.addEventListener("onAddressSelect", function(event){
				vueObj.areaCode = event.detail.areaCode;
				vueObj.areaName = event.detail.provinceName + event.detail.cityName + event.detail.areaName;
			});
		});
	},
	methods: {
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.code){
			case "address": //选择地区
				openWindow("selectProvince", "../common/select_list.html", false, {
					type: "province"
				});
				break;
			case "marriage": //选择婚姻状况
				var buttons = [{id:'0', title:'未婚'}, {id:'1', title:'已婚'}];
				plus.nativeUI.actionSheet({
					title: "请选择",
					cancel: "取消",
					buttons: buttons
				}, function(e){
					if(e.index > 0){
						vueObj.marriageId = buttons[e.index - 1].id;
						vueObj.marriageName = buttons[e.index - 1].title;
					}
				});
				break;
			case "submit": //提交
				var params = {};
				if(vueObj.areaCode){
					params.areaCode = vueObj.areaCode;
					params.areaName = vueObj.areaName;
				}
				if(vueObj.marriageId){
					params.marryStatus = vueObj.marriageId;
				}
				vueObj.height = document.getElementById("height").value;
				if(vueObj.height){
					params.height = vueObj.height;
				}
				vueObj.weight = document.getElementById("weight").value;
				if(vueObj.weight){
					params.weight = vueObj.weight;
				}
				vueObj.address = document.getElementById("addressDetail").value;
				if(vueObj.address){
					params.address = vueObj.address;
				}
				showWaiting();
				document.activeElement.blur();
				webCall2("/compus/user/updateUserInfo", params, UPDATE_USER_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case UPDATE_USER_INFO: //更新用户信息
				var user = getUserInfo();
				user.areaCode = vueObj.areaCode;
				user.areaName = vueObj.areaName;
				user.marryStatus = vueObj.marriageId;
				user.height = vueObj.height;
				user.weight = vueObj.weight;
				user.address = vueObj.address;
				setCache(USER_INFO_KEY, JSON.stringify(user));
				mui.fire(plus.webview.getWebviewById("userInfo"), "onUserInfoChange", {});
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 输入身高监听
		 */
		onHeightInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9]/g, '');
			if(value.length > 3) {
				value = value.substring(0, 3);
			}
			vueObj.height = value;
		},
		/**
		 * 输入体重监听
		 */
		onWeightInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9.]/g, '');
			e.currentTarget.value = value;
			//控制输入两位小数
			value = value + '';
			var values = value.split('.');
			//控制整数位位数
			if(values[0].length > 3) {
				values[0] = values[0].substring(0, 3);
			}
			if(values.length > 1) {
				if(values[1].length > 2) {
					value = values[0] + '.' + values[1].substring(0, 2);
				} else {
					value = values[0] + '.' + values[1];
				}
			} else {
				value = values[0];
			}
			vueObj.weight = value;
		}
	}
});