//请求码
var QUERY_DETAIL = 1001, QUERY_ADS = 1002;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		tranNo: null, //订单编号
		orderData: {} //订单数据
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//监听变化
			window.addEventListener("onOrderChange", function(event){
				vueObj.loadData();
			});
			//参数接收
			vueObj.tranNo = plus.webview.currentWebview().tranNo;
			//加载数据
			showWaiting();
			vueObj.loadData();
			vueObj.loadBannerData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			webCall2("/compus/order/queryTradeDetail", {
				tranNo: vueObj.tranNo
			}, QUERY_DETAIL, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 加载广告数据
		 */
		loadBannerData: function() {
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:1019}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口请求成功
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_DETAIL: //数据加载
				vueObj.orderData = data.data;
				break;
			case QUERY_ADS: //更新为已读成功
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				}) 
				break;	
			default:
				break;
			}
		},
		/**
		 * 接口请求失败
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 订单操作
		 */
		onOperation: function(e) {
			openWindow(vueObj.orderData.payAgainUrl, "web_page.html", false, {
				webUrl: vueObj.orderData.payAgainUrl,
				statusBarType: plus.webview.currentWebview().statusBarType
			});
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "订单详情页", "pos": "订单详情页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && getUserInfo().bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, 'web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});