/** 网络请求码 */
var QUERY_ADS = 1001, QUERY_POP_INFO = 1002;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		appName: null,
		payType: null,
		money: null,
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		bindCardStatus: -1 //绑卡状态 1已经绑卡 0未绑卡
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听用户数据变化
			window.addEventListener("onUserInfoChange", function(event){
				var user = getUserInfo();
				vueObj.bindCardStatus = user.bindCardStatus;
			});
			//监听事件
			window.addEventListener("onNotAlertPopListener", function(event){
				setCache("DONOT_POP_REDBAG_TAKE_PAY_RESULT" + getCache(USER_ID_KEY), "yes");
			});
			var user = getUserInfo();
			vueObj.bindCardStatus = user.bindCardStatus;
			//参数接收
			vueObj.payType = plus.webview.currentWebview().type;
			vueObj.money = plus.webview.currentWebview().money;
			vueObj.appName = plus.webview.currentWebview().appName;
			//查询广告
			showWaiting();
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:'k12_4004'}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
			//通知订单页
			var orderDetailWeb = plus.webview.getWebviewById("orderDetail");
			var orderListWeb = plus.webview.getWebviewById("orderList");
			if(orderDetailWeb){
				mui.fire(orderDetailWeb, "onOrderChange", {});
			}
			if(orderListWeb){
				mui.fire(orderListWeb, "onOrderChange", {});
			}
			//判断是否第三方调起
			if(vueObj.appName == 'HMZKAPP'){
				confirmDialog("", "支付成功，是否返回【恒镁智卡】APP?", "返回", "留在易12", function(){
					plus.runtime.openURL("hmxd://third/yunma?code=01");
				});
				return;
			}
			//判断，如果用户未实名，并且时间在7:30到19:30，且没有点击不再提示，则查询弹窗信息
			if(getUserInfo().realNameStatus == 3) return;
			if(getCache("DONOT_POP_REDBAG_TAKE_PAY_RESULT" + getCache(USER_ID_KEY)) == "yes") return;
			//webCall2("/compus/advertising/getAdvertisingMap", {addressCodeList: 'k12_4005'}, QUERY_POP_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/**
		 * 接口请求成功
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_ADS: //广告数据加载
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;
			case QUERY_POP_INFO: //查询红包弹窗信息
				var popData = data.data['k12_4005'] && data.data['k12_4005'].length > 0 ? data.data['k12_4005'][0] : null;
				if(!popData) return;
				//构造弹窗
				var activityObj = {};
				var popTime = getCache("POP_REDBAG_TAKE_TIME_PAY_RESULT" + getCache(USER_ID_KEY));
				if(popTime && parseInt(popTime) > 2){
					activityObj.notAlert = true;
					activityObj.notAlertTxt = "放弃红包，不再提示？";
				}
				setCache("POP_REDBAG_TAKE_TIME_PAY_RESULT" + getCache(USER_ID_KEY), popTime ? (parseInt(popTime)+1) : 1);
				activityObj.activityName = popData.title;
				activityObj.appLogo = popData.image;
				activityObj.appLink = popData.url;
				var activityPop = plus.webview.create('../app/activity_pop.html', 'activity_pop', {
					top: '0', bottom: '0', background: 'transparent'
				},{
					activityObj:activityObj, statusBarType:getCurrentStatusBarType()
				});
				plus.webview.currentWebview().append(activityPop);
				break;	
			default:
				break;
			}
		},
		/**
		 * 接口请求失败
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "支付成功页", "pos": "支付成功页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && vueObj.bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});