/** 网络请求码 */
var QUERY_APP = 1002;
var myScroll;
//初始化Vue
var vueObj = new Vue({
	el: '#main',
	data: {
		wgtVersion: null,
		bindCardStatus: -1, //绑卡状态 1已经绑卡 0未绑卡
		appDatas: [] //应用列表
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听用户数据变化
			window.addEventListener("onUserInfoChange", function(event){
				var user = getUserInfo();
				vueObj.bindCardStatus = user.bindCardStatus;
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			var user = getUserInfo();
			vueObj.bindCardStatus = user.bindCardStatus;
			// 获取本地应用资源版本号
			plus.runtime.getProperty(plus.runtime.appid, function(inf) {
				vueObj.wgtVersion = inf.version;
			});
			//加载应用数据
			vueObj.pulldownRefresh();
		});
	},
	methods: {
		/**
		 * 下拉刷新具体业务实现
		 */
		pulldownRefresh: function() {
			//加载应用数据
			webCall2("/compus/application/getAppList", null, QUERY_APP, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			//添加统计事件
			statisticEvent("appClickTime", {"appName" : e.currentTarget.dataset.appname, "from" : "应用列表页"});
			var usable = e.currentTarget.dataset.usable;
			if(usable == 1){
				toast("学校尚未开放此功能");
				return;
			}
			var appid = e.currentTarget.dataset.appid;
			var type = e.currentTarget.dataset.type;
			var url = e.currentTarget.dataset.url;
			var bindStatus = e.currentTarget.dataset.bind;
			if(bindStatus == 0 && vueObj.bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			var identity = e.currentTarget.dataset.identity;
			if(identity == 0 && getUserInfo().identityExist == 1){ //没有默认身份
				confirmDialog("", "你还未绑定默认身份，是否去绑定？或切换已有身份为默认身份?", "去切换", "去绑定", function(){
				}, function(){
					openWindow("selectSchool", "../login/select_school.html", false, {
						statusBarType: STATUS_BAR_DEFAULT_KEY,
						from: 'student'
					});
				});
				return;
			}
			var edu = e.currentTarget.dataset.edu;
			if(edu == 0){ //选择教育局
				openWindow("selectEducation", "../login/select_education.html", false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY,
					applicationId: appid
				});
				return;
			}
			if(type == 0){
				openWindow("app_" + appid, url, false, {statusBarType:STATUS_BAR_DEFAULT_KEY, appName: e.currentTarget.dataset.appname});
			}else{
				openWindow("app_" + appid, "../common/web_page.html", false, {
					webUrl: url,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
			}
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_APP: //查询应用
				for(var i=0; i<data.rows.length; i++){
					var appList = data.rows[i].appList;
					data.rows[i].appList = []; var j = 0;
					for(var k=0; k<appList.length; k++){
						var app = appList[k];
						if(!app.minVersion || !compareVersions(vueObj.wgtVersion, app.minVersion)){
							data.rows[i].appList[j] = app; j++;
						}
					}
				}
				vueObj.appDatas = data.rows;
				break;
			default:
				break;
			}
			vueObj.closePullStatus();
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
			vueObj.closePullStatus();
		},
		/**
		 * 关闭上拉/下拉刷新 
		 */
		closePullStatus: function(data) {
			//刷新列表
			Vue.nextTick(function(){
				myScroll.refresh();
			});
		}
	}
});

/**iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			vueObj.pulldownRefresh();
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, null);
		myScroll.refresh();
	});
})(mui);