/** 网络请求码 */
var QUERY_ADS = 1001, QUERY_APP = 1002, QUERY_LATEST_ACTIVITY = 1003, QUERY_UNREAD_MSG = 1004, 
	QUERY_NOTICE_INFO = 1005, QUERY_SAFE_LIST = 1006, QUERY_AFTER_LIST = 1007, QUERY_IDENTITY = 1008,
	CHANGE_IDENTITY = 1009;
var myScroll;
var pullNum = 4;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		wgtVersion: null,
		bindCardStatus: -1, //绑卡状态 1已经绑卡 0未绑卡
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		hotDatas: [], //热门活动数据
		hotWidth: 0, //热门活动宽度
		appDatas: [], //应用列表
		bottomMsgNoticeStyle:"",//底部消息提醒样式
		noticeData:null, //首页公告数据
		safeList: [], //安全学习数据
		afterList: [], //课后热议数据
		showExchangePop: false, //是否显示身份切换
		identitys: [], //身份列表
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(plus.os.name == 'Android'){
					mui.fire(plus.webview.getWebviewById("main"), "mainBack", {});
				}
				return false;
			}
		});
		mui.plusReady(function() {
			setTimeout(function(){
				//关闭启动页
				plus.navigator.closeSplashscreen();
			}, 200);
			//处理状态栏
			vueObj.handleStatusBar();
			vueObj.hotWidth = (plus.screen.resolutionWidth - 40) / 2;
			//设置学校名称
			window.addEventListener("onSchoolChange", function(event){
				//用户信息
				var user = getUserInfo();
				vueObj.bindCardStatus = user.bindCardStatus;
				//重新加载数据
				vueObj.refreshData();
				//查询公告信息
				vueObj.noticeData = null;
				if(schoolName && schoolName.length > 0){
					webCall2("/compus/announcement/getAnnouncement", null, QUERY_NOTICE_INFO, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
				}
				vueObj.queryIdentity();
				//头部信息设置
				vueObj.updateNowIdentity();
			});
			//身份变化
			window.addEventListener("onIdentityChange", function(event){
				vueObj.queryIdentity();
				//头部信息设置
				vueObj.updateNowIdentity();
			});
			//监听用户数据变化
			window.addEventListener("onUserInfoChange", function(event){
				var user = getUserInfo();
				vueObj.bindCardStatus = user.bindCardStatus;
			});
			//加载首页缓存数据
			if(getCache(HOME_APPS_DATA)){//首页应用
				vueObj.appDatas = JSON.parse(getCache(HOME_APPS_DATA));
			}
			if(getCache(HOME_BANNERS_DATA)){//首页banner
				vueObj.bannerDataManage(JSON.parse(getCache(HOME_BANNERS_DATA)));
			}
			if(getCache(IDENTITY_LIST_DATA)){//身份列表
				vueObj.identitys = JSON.parse(getCache(IDENTITY_LIST_DATA));
			}
			
			var user = getUserInfo();
			vueObj.bindCardStatus = user.bindCardStatus;
			// 获取本地应用资源版本号
			plus.runtime.getProperty(plus.runtime.appid, function(inf) {
				vueObj.wgtVersion = inf.version;
			});
			//加载数据
			vueObj.refreshData();
			//获取用户最新参加的活动
			//webCall2("/compus/user/getUserLastActivity", null, QUERY_LATEST_ACTIVITY, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
			//查询未读消息数目
			//webCall2("/compus/user/message/getMsgCount", null, QUERY_UNREAD_MSG, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
			//查询公告信息
			webCall2("/compus/announcement/getAnnouncement", null, QUERY_NOTICE_INFO, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
			//查询身份列表
			vueObj.queryIdentity();
			vueObj.updateNowIdentity();
		});
	},
	methods: {
		/**
		 * 当前身份信息设置
		 */
		updateNowIdentity: function() {
			//身份
			var user = getUserInfo();
			var identityExist = user.identityExist; // 默认身份存在状态 0是1否
			var identityName = user.identityName;
			var identityRelationship = user.identityRelationship;
			var identityType = user.identityType;
			
			var identityNameTxt = document.getElementById("identityName");
			var identityArrow = document.getElementById("identityArrow");
			var schoolNameTxt = document.getElementById("schoolNameTxt");
			var identityBind = document.getElementById("identityBind");
			identityNameTxt.style.display = "none";
			identityArrow.style.display = "none";
			schoolNameTxt.style.display = "none";
			identityBind.style.display = "none";
			if(identityExist == 0){ //有默认身份
				identityNameTxt.style.display = "block";
				identityArrow.style.display = "block";
				identityNameTxt.innerText = "您好，" + identityName + (identityType==1?identityRelationship:"老师");
			} else if(!getCache(SCHOOL_CODE_KEY)){ //未选择学校
				identityBind.style.display = "block";
			}else{ //未绑定身份，但选择了学校
				schoolNameTxt.style.display = "block";
				document.getElementById("schoolName").innerText = getCache(SCHOOL_NAME_KEY);
				document.getElementById("bindTxt").innerText = vueObj.identitys.length > 0 ? "点击切换" : "去绑定身份信息";
			}
		},
		/**
		 * 查询身份列表
		 */
		queryIdentity: function() {
			webCall2("/kt/user/myIdentityList", null, QUERY_IDENTITY, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
		},
		/**
		 * 重新加载界面数据
		 */
		refreshData: function() {
			vueObj.pulldownRefresh();
		},
		/**
		 * 下拉刷新具体业务实现
		 */
		pulldownRefresh: function() {
			//pullNum = 2;
			//if(getCache(SCHOOL_CODE_KEY)){
				pullNum = 4;
				webCall2("/compus/article/getHomeActicleList", {offset: 0,limit: 10,tagsId: 10003}, QUERY_SAFE_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
				webCall2("/compus/article/getHomeActicleList", {offset: 0,limit: 10,tagsId: 10004}, QUERY_AFTER_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
			//}
			//查询首页应用
			webCall2("/compus/application/getHomeAppList", {offset:0,limit:11}, QUERY_APP, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
			//查询首页Banner
			webCall2("/compus/advertising/getAdvertisingMap", {
				addressCodeList: getCache(SCHOOL_CODE_KEY) ? 'k12_1001,k12_1002' : 'k12_1001'
			}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_APP: //查询应用
				var apps = []; var j = 0;
				for(var i=0; i<data.rows.length; i++){
					var app = data.rows[i];
					if(!app.minVersion || !compareVersions(vueObj.wgtVersion, app.minVersion)){
						apps[j] = app; j++;
					}
				}
				vueObj.appDatas = apps;
				setCache(HOME_APPS_DATA, JSON.stringify(apps));
				break;
			case QUERY_UNREAD_MSG: //查询未读消息数目
				setUnReadCount(data.data);
				mui.fire(plus.webview.getWebviewById("main"), "onUnreadCountChange", {});
				break;
			case QUERY_LATEST_ACTIVITY: //查询用户最新参加的活动
				if(data.data){
					setTimeout(function(){
						mui.fire(plus.webview.getWebviewById("main"), "openActivityPopListener", data.data);
					}, 1000);
				}
				break;
			case QUERY_NOTICE_INFO: //查询公告信息
				if(data.data){
					//如果有缓存 并且id相等 就用原来的数据
					if(getCache(HOME_NOTICE_ID) != data.data.id) {
						vueObj.noticeData = data.data;
					} 
				}
				break;	
			case QUERY_ADS: //banner查询成功
				setCache(HOME_BANNERS_DATA, JSON.stringify(data.data));
				vueObj.bannerDataManage(data.data);
				break;
			case QUERY_SAFE_LIST: //安全学习
				vueObj.safeList = data.rows;
				break;
			case QUERY_AFTER_LIST: //课后热议
				vueObj.afterList = data.rows;
				break;
			case QUERY_IDENTITY: //身份列表
				vueObj.identitys = data.rows;
				//缓存到本地
				setCache(IDENTITY_LIST_DATA, JSON.stringify(data.rows));
				//传递给我的页面
				mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onReceiveIdentitys", {
					identitys: data.rows
				});
				vueObj.updateNowIdentity();
				//判断，如果有身份信息，并且用户没有默认学校和默认身份，则切换到第一个身份
				if(vueObj.identitys.length > 0 && !getCache(SCHOOL_CODE_KEY) && getUserInfo().identityExist == 1){
					showWaiting();
					webCall2("/kt/user/changeIdentity", {
						identityId: vueObj.identitys[0].identityId,
						identityType: vueObj.identitys[0].identityType,
						schoolCode: vueObj.identitys[0].schoolCode
					}, CHANGE_IDENTITY, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
				}
				break;
			case CHANGE_IDENTITY: //切换身份成功
				updateLoginInfo(null, data.data);
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onSchoolChange", {});
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onIdentityChange", {});
				mui.fire(plus.webview.getWebviewById("message/message_main.html"), "onIdentityChange", {});
				break;
			default:
				break;
			}
			vueObj.closePullStatus();
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			//onError(resultCode, resultMsgDesc);
			vueObj.closePullStatus();
		},
		/**
		 * 关闭上拉/下拉刷新 
		 */
		closePullStatus: function(data) {
			pullNum--;
			if(pullNum > 0) return;
			//刷新列表
			Vue.nextTick(function(){
				myScroll.refresh();
				//监听图片加载
		        var imgs = document.getElementsByClassName("load-img");
		        for(var i in imgs){
		            imgs[i].onload = function () {
		                myScroll.refresh();
		            }
		        }
			});
		},
		/*
		 * banner广告数据处理
		 */
		bannerDataManage: function(data){
			vueObj.hotDatas = data['k12_1002'] ? data['k12_1002'] : [];
			vueObj.bannerRows = data['k12_1001'];
			vueObj.bannerLength = vueObj.bannerRows.length;
			vueObj.$nextTick(function() {
				// banner多余1条时才循环播放
				if(vueObj.bannerLength > 1) {
					mui("#slider").slider({
						interval: 3000
					});
				} else {
					mui("#slider").slider({
						interval: 0
					});
				}
				//懒加载图片刷新
				var imgLazyloadApi = mui('#slider').imageLazyload({
					autoDestroy: false,
					placeholder: '../../img/banner_default.png'
				});
				//懒加载图片刷新
				imgLazyloadApi.refresh(true);
			})
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			//添加统计事件
			statisticEvent("homeButtonClickTime", {"btnType":e.currentTarget.dataset.type});
			switch (e.currentTarget.dataset.type){
			case "bindCard": //绑定学生卡
				openBindCard(null, true);
				break;
			case "changeIdentity": //切换身份
				var identity = vueObj.identitys[e.currentTarget.dataset.index];
				if(!identity || identity.isDefault == 0) return;
				showWaiting("切换中...");
				webCall2("/kt/user/changeIdentity", {
					identityId: identity.identityId,
					identityType: identity.identityType,
					schoolCode: identity.schoolCode
				}, CHANGE_IDENTITY, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
				break;
			default:
				break;
			}
		},
		/**
		 * 首页应用列表点击
		 */
		onAPPClick: function(e) {
			switch (e.currentTarget.dataset.type){
			case 'all': //全部应用
				openWindow("appList", "app_list.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
				break;
			default:
				//添加统计事件
				statisticEvent("appClickTime", {"appName" : e.currentTarget.dataset.appname, "from" : "首页"});
				var index = e.currentTarget.dataset.index;
				var app = vueObj.appDatas[index];
				if(app.serviceUsable == 1){
					toast("学校尚未开放此功能");
					return;
				}
				if(app.validBindStatus == 0 && vueObj.bindCardStatus == 0){ //未绑卡
					openBindCard();
					return;
				}
				if(app.needBindIdenity == 0 && getUserInfo().identityExist == 1){ //没有默认身份
					confirmDialog("", "你还未绑定默认身份，是否去绑定？或切换已有身份为默认身份?", "去切换", "去绑定", function(){
					}, function(){
						openWindow("selectSchool", "../login/select_school.html", false, {
							statusBarType: STATUS_BAR_DEFAULT_KEY,
							from: 'student'
						});
					});
					return;
				}
				if(app.needSelectEdu == 0){ //选择教育局
					openWindow("selectEducation", "../login/select_education.html", false, {
						statusBarType: STATUS_BAR_DEFAULT_KEY,
						applicationId: app.applicationId
					});
					return;
				}
				if(app.appType == 0){
					openWindow("app_" + app.applicationId, app.appUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY, appName: e.currentTarget.dataset.appname});
				}else{
					openWindow("app_" + app.applicationId, "../common/web_page.html", false, {
						webUrl: app.appUrl,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					});
				}
				break;
			}
		},
		/*
		 * 公告点击和叉号点击
		 */
		onNoticeClick: function(e){
			switch (e.currentTarget.dataset.type){
			case 'content': //内容点击
				if(!vueObj.noticeData.url || vueObj.noticeData.url.length <= 0){
					return;
				}
				if(vueObj.noticeData.url.indexOf("http") < 0) { //应用数据型 或 数据型
					openWindow(vueObj.noticeData.url, vueObj.noticeData.url, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
				}else{
					openWindow(vueObj.noticeData.url, '../common/web_page.html', false, {
						"webUrl": vueObj.noticeData.url,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, false);
				}
				break;
			case 'delete': //叉号点击
				setCache(HOME_NOTICE_ID, vueObj.noticeData.id);
				vueObj.noticeData = null;
				break;
			default:
				break;
			}
		},
		/**
		 * banner和广告点击监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "首页", "pos": e.currentTarget.dataset.pos});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && vueObj.bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		},
		/**
		 * 文章点击 
		 */
		onItemClick: function(e) {
			openWindow("newsNoticeDetail", "../home/news_notice_detail.html", false, {
				detailId: e.currentTarget.dataset.detailid,
				type: e.currentTarget.dataset.type,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			});
		},
		onExchangeClick: function(e) {
			vueObj.showExchangePop = false;
		},
		handleStatusBar: function() {
			var immersed = 0;
			var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
			if(ms && ms.length >= 3) {
				immersed = parseFloat(ms[2]);
			}
			if(!immersed) {
				return;
			}
			document.getElementById("exchangePop").style.top = 44 + immersed + 'px';
		}
	}
});

/**iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			vueObj.pulldownRefresh();
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, null);
		myScroll.refresh();
	});
})(mui);

/**
 * 网络状态监听
 */
document.addEventListener("netchange", function() { //监听网络变化事件
	var types = {};
	types[plus.networkinfo.CONNECTION_UNKNOW] = "Unknown connection";
	types[plus.networkinfo.CONNECTION_NONE] = "No connection";
	types[plus.networkinfo.CONNECTION_ETHERNET] = "Ethernet connection";
	types[plus.networkinfo.CONNECTION_WIFI] = "WiFi connection";
	types[plus.networkinfo.CONNECTION_CELL2G] = "Cellular 2G connection";
	types[plus.networkinfo.CONNECTION_CELL3G] = "Cellular 3G connection";
	types[plus.networkinfo.CONNECTION_CELL4G] = "Cellular 4G connection";
	if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE || plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_UNKNOW) {
		//vueObj.netWorkTips = true;
	} else {
		//vueObj.netWorkTips = false;
	}
	console.log(types[plus.networkinfo.getCurrentType()]);
}, false);

//身份点击
document.getElementById("identityDiv").addEventListener("tap", function(e){
	var user = getUserInfo();
	var identityExist = user.identityExist; // 默认身份存在状态 0是1否
	if(identityExist == 0 || vueObj.identitys.length > 0){ //有默认身份，可切换身份
		vueObj.showExchangePop = !vueObj.showExchangePop;
	} else if(!getCache(SCHOOL_CODE_KEY)){ //未选择学校，没有默认身份，跳转学校选择
		openWindow("selectSchool", "../login/select_school.html", false, {
			statusBarType: STATUS_BAR_DEFAULT_KEY,
			from: 'student'
		});
	}else{ //择了学校，未绑定身份，跳转绑定身份界面
		openWindow("bindStudent", "../login/bind_student.html", false, {
			statusBarType: STATUS_BAR_DEFAULT_KEY
		});
	}
});
//添加点击
document.getElementById("addBtn").addEventListener("tap", function(e){
	vueObj.showExchangePop = false;
	openWindow("selectSchool", "../login/select_school.html", false, {
		statusBarType: STATUS_BAR_DEFAULT_KEY,
		from: 'student'
	});
});