//请求码
var QUERY_DETAIL = 1001;
//初始化Vue
var vueObj = new Vue({
	el: '#main',
	data: {
		type: 'news', //详情类型
		detailId: '', //文章ID
		article: {} //文章实体
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//数据处理
			var self = plus.webview.currentWebview();
			vueObj.type = self.type;
			vueObj.detailId = self.detailId;
			if(!vueObj.detailId){
				vueObj.detailId = comGetUrlParamByName(self.getURL(), "detailId");
			}
			if(!vueObj.type){
				vueObj.type = comGetUrlParamByName(self.getURL(), "type");
			}
			if(vueObj.type == 'news'){
				document.getElementById("title").innerText = "新闻详情";
			}else if(vueObj.type == 'safe'){
				document.getElementById("title").innerText = "安全学习";
			}else if(vueObj.type == 'after'){
				document.getElementById("title").innerText = "课后热议";
			}else{
				document.getElementById("title").innerText = "公告详情";
			}
			//加载详情数据
			vueObj.loadData();
			//拦截超链接
			self.overrideUrlLoading({
				mode: "reject",
				effect: "touchstart"
			}, function(e) {
				// 拦截新的页面在新的webview里面加载URL页面
				if(!e.url) return;
				if(e.url.indexOf("http") < 0) return;
				openWindow(e.url, '../common/web_page.html', false, {
					"webUrl": e.url,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			});
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			showWaiting();
			webCall2("/compus/article/getArticleDetail", {
				articleId: vueObj.detailId
			}, QUERY_DETAIL, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DETAIL: //详情查询
				vueObj.article = data.data;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		}
	}
});