var myScrolls = [];
var sliderIndex = 0;
var isLoadingMore = [];
var isNoMore = [];
var starts = [0, 0];
//请求码
var QUERY_LISTS = [1001, 1002];
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		datas: [[], []]
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#list0').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/banner_default.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			var self = plus.webview.currentWebview();
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置标题
			if(!self.appName){
				self.appName = "新闻公告";
			}
			document.getElementById("title").innerText = self.appName;
			//加载数据
			vueObj.loadData(0);
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function(index) {
			var tagsId;
			switch (index){
			case 0: //加载新闻列表
				tagsId = 10001;
				break;
			case 1: //加载公告列表
				tagsId = 10002;
				break;
			default:
				break;
			}	
			webCall2("/compus/article/getActicleNoticeList", {
				offset: starts[index],
				limit: 10,
				tagsId: tagsId
			}, QUERY_LISTS[index], vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LISTS[0]:
			case QUERY_LISTS[1]:
				//判断当前数据是加载的第几个tab
				var oprationIndex = 0;
				for(var i=0; i<QUERY_LISTS.length; i++){
					if(requestCode == QUERY_LISTS[i]){
						oprationIndex = i;
						break;
					}
				}
				if(oprationIndex < 0 || oprationIndex > 1) return;
				//更新数据
				vueObj.datas[oprationIndex] = ( starts[oprationIndex] == 0 ? data.rows : vueObj.datas[oprationIndex].concat(data.rows));
				//使用Set方法更新数组
				Vue.set(vueObj.datas, oprationIndex, vueObj.datas[oprationIndex]);
				
				starts[oprationIndex] = vueObj.datas[oprationIndex].length;
				//无数据图
				if(vueObj.datas[oprationIndex].length == 0) {
					setNoDataBackground("list" + oprationIndex, true, oprationIndex);
				} else {
					setNoDataBackground("list" + oprationIndex, false, oprationIndex);
				}
				if(vueObj.datas[oprationIndex].length < 4){
					document.getElementById("item" + oprationIndex + "mobileSpan").style.display = "none";
				}else {
					document.getElementById("item" + oprationIndex + "mobileSpan").style.display = "";
				}
				closePullStatus(data.rows, oprationIndex);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
			for(var i=0; i<QUERY_LISTS.length; i++){
				if(starts[i] == 0 && requestCode == QUERY_LISTS[i]){
					document.getElementById("item" + i + "mobileSpan").style.display = "none";
				}
			}
		},
		/**
		 * 监听slider切换
		 */
		onSliderChange: function(e) {
			sliderIndex = e.detail.slideNumber;
			//关闭下拉上拉刷新
			closePullStatus();
			//切换后数据为空，则加载数据
			if(vueObj.datas[sliderIndex].length <= 0){
				starts[sliderIndex] = 0;
				vueObj.loadData(sliderIndex);					
			}
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			openWindow("newsNoticeDetail", "news_notice_detail.html", false, {
				detailId: e.currentTarget.dataset.detailid,
				type: e.currentTarget.dataset.type,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			});
		}
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore[sliderIndex] = false;
			setTimeout(function() {
				starts[sliderIndex] = 0;
				vueObj.loadData(sliderIndex);
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore[sliderIndex]) {
				return;
			}
			if (isNoMore[sliderIndex]) {
				myScrolls[sliderIndex].refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore[sliderIndex] = true;
				vueObj.loadData(sliderIndex);
			}, 300);
		};
	
		//初始化下拉刷新
		for (var i = 0; i < 2; i++) {
			myScrolls[i] = iscrollAssist.newVerScrollForPull($('#list' + i), pullDownAction, pullLoadMoreAction);
			myScrolls[i].refresh();
			isLoadingMore[i] = false;
			isNoMore[i]= false;
		}
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data, oprationIndex) {
	if(data){
		if(data.length < 10) {
			document.getElementById("item" + oprationIndex + "mobileSpan").innerHTML = "没有更多数据了";
			isNoMore[oprationIndex] = true;
		} else {
			document.getElementById("item" + oprationIndex + "mobileSpan").innerHTML = "正在加载...";
			isNoMore[oprationIndex] = false;
		}
		isLoadingMore[oprationIndex] = (starts[oprationIndex] > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		for(var i=0; i<myScrolls.length; i++){
			myScrolls[i].refresh();
		}
		setTimeout(function(){
			myScrolls[sliderIndex].refresh();
		}, 200);
	});
}

// 设置背景
function setNoDataBackground(elementId, isNoData, oprationIndex) {
	if(isNoData) {
		document.getElementById(elementId).style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById(elementId).style.backgroundSize = "100% auto";
		document.getElementById(elementId).style.backgroundRepeat = "no-repeat";
		document.getElementById(elementId).style.backgroundPosition = "center";
		//无数据时不显示上拉显示更多
		document.getElementById("item" + oprationIndex + "mobileSpan").style.display = "none";
	} else {
		document.getElementById(elementId).style.backgroundImage = "none";
		document.getElementById("item" + oprationIndex + "mobileSpan").style.display = "";
	}
}