//请求码
var QUERY_DETAIL = 1001;
//初始化Vue
var vueObj = new Vue({
	el: '#main',
	data: {
		summary: null //学校简介
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			var self = plus.webview.currentWebview();
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//设置标题
			if(!self.appName){
				self.appName = "学校简介";
			}
			document.getElementById("title").innerText = self.appName;
			//加载学校数据
			showWaiting();
			webCall2("/compus/school/getSchoolIntro", null, QUERY_DETAIL, vueObj.onSuccess, vueObj.onErrorBefore);
			//拦截超链接
			self.overrideUrlLoading({
				mode: "reject",
				effect: "touchstart"
			}, function(e) {
				// 拦截新的页面在新的webview里面加载URL页面
				if(!e.url) return;
				if(e.url.indexOf("http") < 0) return;
				openWindow(e.url, '../common/web_page.html', false, { 
					"webUrl": e.url,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			});
		});
	},
	methods: {
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DETAIL: //学校查询
				vueObj.summary = data.data.schoolSummary;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});
