/** 网络请求码 */
var QUERY_BANNER = 1001, QUERY_CAR_TICKET = 1002;
var myScroll;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		bindCardStatus: -1, //绑卡状态 1已经绑卡 0未绑卡
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		appRows: [], //应用数据
		carTicketParam: null, //汽车票 后面拼接的参数
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function() {
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听用户数据变化
			window.addEventListener("onUserInfoChange", function(event){
				var user = getUserInfo();
				vueObj.bindCardStatus = user.bindCardStatus;
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			var user = getUserInfo();
			vueObj.bindCardStatus = user.bindCardStatus;
			//加载应用数据
			vueObj.pulldownRefresh();
		});
	},
	methods: {
		/**
		 * 下拉刷新具体业务实现
		 */
		pulldownRefresh: function() {
			//查询首页Banner
			webCall2("/compus/advertising/getAdvertisingMap", {addressCodeList: 'k12_4006,2002'}, QUERY_BANNER, vueObj.onSuccess, vueObj.onErrorBefore);
			webCall2("/compus/tongcheng/busticket/encrypt", {}, QUERY_CAR_TICKET, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			switch(requestCode) {
			case QUERY_BANNER: //banner查询成功
				vueObj.appRows = data.data['2002'];
				vueObj.bannerRows = data.data['k12_4006'];
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({ interval: 3000 });
					} else {
						mui("#slider").slider({ interval: 0 });
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;
			case QUERY_CAR_TICKET:
				vueObj.carTicketParam = data.data;
				break;
			default:
				break;
			}
			vueObj.closePullStatus();
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
			vueObj.closePullStatus();
		},
		/**
		 * 关闭上拉/下拉刷新 
		 */
		closePullStatus: function(data) {
			//刷新列表
			Vue.nextTick(function(){
				myScroll.refresh();
			});
		},
		/**
		 * banner和广告点击监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "出行票务页", "pos": "出行票务页"});
			vueObj.showRemain = false;
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && vueObj.bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			//汽车票应用后面片接参数
			if(e.currentTarget.dataset.btitle == "汽车票" && vueObj.carTicketParam) {
				if(linkUrl.indexOf("?") > 0){
					linkUrl = linkUrl + "&" + vueObj.carTicketParam;
				} else {
					linkUrl = linkUrl + "?" + vueObj.carTicketParam;
				}
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});

/**iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			vueObj.pulldownRefresh();
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, null);
		myScroll.refresh();
	});
})(mui);