//请求码
var DO_BIND = 1001, QUERY_RELATIONSHIP = 1002, UPDATE_IDENTITY = 1003;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		datas: [], //关系列表数据
		schoolCode: null, //学校编号
		identityType: 1, //身份类型 1学生 2老师
		name: null, //姓名
		identityCard: null, //身份证号
		relationship: null, //关系
		relationshipName: null, //关系
		opeType: null, //操作类型 update:更新关系
		identityId: null,
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function() {
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//参数
			vueObj.schoolCode = plus.webview.currentWebview().schoolCode;
			vueObj.identityType = plus.webview.currentWebview().identityType;
			vueObj.name = plus.webview.currentWebview().name;
			vueObj.identityCard = plus.webview.currentWebview().identityCard;
			vueObj.opeType = plus.webview.currentWebview().opeType;
			vueObj.identityId = plus.webview.currentWebview().identityId;
			vueObj.relationship = plus.webview.currentWebview().relationship;
			vueObj.relationshipName = plus.webview.currentWebview().relationshipName;
			//加载关系数据
			showWaiting();
			webCall2("/kt/user/getIdentityRelationshipList", null, QUERY_RELATIONSHIP, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		onButtonClick: function(e){
			switch (e.currentTarget.dataset.type){
			case "ralation": //关系选择
				vueObj.relationship = e.currentTarget.dataset.text;
				vueObj.relationshipName = e.currentTarget.dataset.name;
				break;
			case "bind": //绑定
				if(!vueObj.relationship){
					toast("请选择与学生的关系");
					return;
				}
				showWaiting("正在提交...");
				//修改关系
				if(vueObj.opeType == 'update'){
					webCall2("/kt/user/updateIdentity", {
						identityId: vueObj.identityId,
						identityType: vueObj.identityType,
						relationship: vueObj.relationship
					}, UPDATE_IDENTITY, vueObj.onSuccess, vueObj.onErrorBefore);
					return;
				}
				//绑定身份
				webCall2("/kt/user/bindIdentity", {
					schoolCode: vueObj.schoolCode,
					name: vueObj.name,
					identityCard: vueObj.identityCard,
					identityType: vueObj.identityType,
					relationship: vueObj.relationship
				}, DO_BIND, vueObj.onSuccess, vueObj.onErrorBefore);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode){
			case QUERY_RELATIONSHIP: //关系列表
				vueObj.datas = data.rows;
				break;
			case UPDATE_IDENTITY: //修改关系
				//更新本地用户缓存
				var user = getUserInfo();
				user.identityRelationship = vueObj.relationshipName;
				updateLoginInfo(null, user);
				//通知相关页面
				mui.fire(plus.webview.getWebviewById("identityInfo"), "onRelationshipChange", null);
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onIdentityChange", null);
				mui.back();
				break;
			case DO_BIND: //绑定成功
				//更新用户信息
				if(data.data){
					updateLoginInfo(null, data.data);
				}
				//融云IM连接
				connectRongIM();
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onIdentityChange", {});
				openWindow("bindSuccess", "../login/bind_success.html", false, {
					statusBarType: plus.webview.currentWebview().statusBarType,
					identityType: vueObj.identityType
				});
				closeWebview("bindStudent");
				closeWebview("bindRelation");
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});