//请求码
var DO_BIND = 1001, DO_VALID = 1002;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		schoolCode: null, //学校编号
		identityType: 1, //身份类型 1学生 2老师
		name: null, //姓名
		identityCard: null, //身份证号
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function() {
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//设置键盘弹出模式
			keyboardAdjustResize();
			//参数
			vueObj.schoolCode = getCache(SCHOOL_CODE_KEY);
		});
	},
	methods: {
		onButtonClick: function(e){
			switch (e.currentTarget.dataset.type){
			case "type": //类型选择
				vueObj.identityType = e.currentTarget.dataset.value;
				break;
			case "bind": //绑定
				if(!vueObj.schoolCode){
					toast("请选择学校");
					mui.back();
					return;
				}
				if(!vueObj.name){
					toast("请输入姓名");
					return;
				}
				if(!vueObj.identityCard){
					toast("请输入身份证号码");
					return;
				}
				if(!regexIdCard(vueObj.identityCard)){
					toast("请输入正确的身份证号码");
					return;
				}
				document.activeElement.blur();
				if(vueObj.identityType == 1){ //学生
					showWaiting("正在提交...");
					webCall2("/kt/user/validIdentity", {
						name: vueObj.name,
						identityCard: vueObj.identityCard,
						identityType: vueObj.identityType
					}, DO_VALID, vueObj.onSuccess, vueObj.onErrorBefore);
					return;
				}
				//教师直接提交
				showWaiting("正在绑定...");
				webCall2("/kt/user/bindIdentity", {
					schoolCode: vueObj.schoolCode,
					name: vueObj.name,
					identityCard: vueObj.identityCard,
					identityType: vueObj.identityType
				}, DO_BIND, vueObj.onSuccess, vueObj.onErrorBefore);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode){
			case DO_BIND: //绑定成功
				document.activeElement.blur();
				//更新用户信息
				if(data.data){
					updateLoginInfo(null, data.data);
				}
				//融云IM连接
				connectRongIM();
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onIdentityChange", {});
				openWindow("bindSuccess", "../login/bind_success.html", false, {
					statusBarType: plus.webview.currentWebview().statusBarType,
					identityType: vueObj.identityType
				});
				closeWebview("bindStudent");
				break;
			case DO_VALID: //身份校验成功
				document.activeElement.blur();
				//跳转到关系选择
				openWindow("bindRelation", "../login/bind_relation.html", false, {
					statusBarType: plus.webview.currentWebview().statusBarType,
					schoolCode: vueObj.schoolCode,
					name: vueObj.name,
					identityCard: vueObj.identityCard,
					identityType: vueObj.identityType
				});
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});

//跳过
document.getElementById("jumpBtn").addEventListener("tap", function(){
	mui.back();
});