//请求码
var DO_LOGIN = 1001, GET_CODE = 1002, GET_PIC_CODE = 1003;
//vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		userPhone: null,
		checkCode: null,
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		nowEnv: 'RELEASE', //当前API环境
		userFlag: '', //新用户/老用户
		showThrid: true, //是否显示第三第方登录
		wxUser: null, //微信登录信息
		sendCount: 1, //短信验证码发送次数
		isShowWechatLogin: false, //是否显示微信登录
		loginType: null,//当前点击是微信还是正常登陆
		securityObj: {},
	},
	beforeMount: function(){
		mui.plusReady(function(){
			setTimeout(function(){
				//关闭启动页
				plus.navigator.closeSplashscreen();
			}, 200);
			unfullscreen();
			setStatusBarDefault();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//第三方登录初始化 返回是否安装了微信
			if(plus.os.name == "iOS"){
				initShareServicesAndInstalledWechat(plus.webview.currentWebview(), function(isInstalledWechat){
					if(isInstalledWechat){
						vueObj.isShowWechatLogin = true;
					} else {
						vueObj.isShowWechatLogin = false;
					}
				});
			} else {
				initShareServices(plus.webview.currentWebview());
				vueObj.isShowWechatLogin = true;
			}
			//微信登录回调监听
			window.addEventListener("onWechatLoginCallSuccessListener", function(event){
				vueObj.wxUser = event.detail;
				if(!vueObj.wxUser) return;
				showWaiting();
				webCall2("/login/authLogin", {
					application: "wechat",
					openid: event.detail.openid,
					unionid: event.detail.unionid
				}, DO_LOGIN, vueObj.onSuccess, vueObj.onErrorBefore);
			});
			//添加统计事件
			statisticEvent("userLoginCode01");
			//设置键盘弹出模式
			keyboardAdjustResize();
			plus.webview.currentWebview().setStyle({'popGesture':'none'});
			//初始显示手机号
			var cachePhone = getCache(ACCOUNT_KEY);
			if(cachePhone){
				document.getElementById("userPhone").value = cachePhone;
			}
			vueObj.onProtocolPopManager();
			//设置系统环境
			vueObj.nowEnv = apiEnvironment;
			//触发启动页广告事件
			mui.fire(plus.webview.currentWebview().opener(), "onStartAdClickListener", {});
		});
	},
	methods: {
		/**
		 * 登录
		 */
		onLogin: function(){
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone){
				toast("手机号码不能为空");
				return;
			}else if(!regexMobile(vueObj.userPhone) ){
				toast("请输入正确的手机号码");
				return;
			}
			vueObj.checkCode = document.getElementById("checkCode").value;
			if(!vueObj.checkCode){
				toast("验证码不能为空");
				return;
			}
			//注册协议
			if(!document.getElementById("protocolCkb").checked){
				toast("请勾选易12用户服务协议");
				return;
			}
			//判断协议弹框
			if(!vueObj.onProtocolPopManager('normalLogin')){
				return;
			}
			//添加统计事件
			statisticEvent("userLoginCode03", {"userFlag": vueObj.userFlag});
			document.activeElement.blur();
			showWaiting();
			webCall2("/login/doLoginByVerificationCode", {
				mobilePhone: vueObj.userPhone,
				verificationCode: vueObj.checkCode,
				clientId: getClientId(),
				osType: plus.os.name,
				osVersion: plus.os.version,
				mobileType: plus.device.model
			}, DO_LOGIN, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(event, picCode){
			if(vueObj.timeCount != 0) return; //正在60s计时
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone || !regexMobile(vueObj.userPhone)){
				toast("请输入正确的手机号码")
				return;
			}
			showWaiting();
			if(picCode){
				webCall2("/compus/user/sendLoginVerificationCode", {
					mobilePhone: vueObj.userPhone,
					sendCount: vueObj.sendCount,
					securityToken: vueObj.securityObj.securityToken,
					appSecurityToken: vueObj.securityObj.appSecurityToken,
					imageCaptchaValue: picCode
				}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
				return;
			}
			webCall2("/common/security/token", {
				mobilePhone: vueObj.userPhone,
				sendCount: vueObj.sendCount,
				sceneCode: "app_user_login"
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, {urlPath: "/compus/user/sendLoginVerificationCode"});
		},
		/**
		 * 获取图形验证码
		 */
		onGetPicCode: function(){
			webCall2("/common/security/imageCaptcha", {
				securityToken: vueObj.securityObj.securityToken
			}, GET_PIC_CODE, vueObj.onSuccess, vueObj.onErrorBefore, null, null, 1500);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "获取验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode){
			case DO_LOGIN:
				if(!data.data.id){ //第三方登录未绑定手机
					openWindow("bindPhone", "../login/bind_phone.html", false, {
						statusBarType:STATUS_BAR_DEFAULT_KEY,
						wxUser: vueObj.wxUser
					});
					return;
				}
				//更新登录信息
				updateLoginInfo(data.data.account, data.data);
				//添加统计事件
				statisticEvent("userLoginCode04", {"userFlag": vueObj.userFlag});
				//清空消息
				clearPushMessage();
				//融云IM连接
				connectRongIM();
				//跳转到首页
				openWindow('main', '../main.html', false, {statusBarType:STATUS_BAR_DEFAULT_KEY}, null, true);
				closeWebview("loginByCode", true);
				break;
			case GET_CODE: //获取验证码
				vueObj.sendCount++;
				vueObj.userFlag == (data.data && data.data.userExists) ? '用户登录' : '用户注册';
				document.getElementById("picCodeId").style.display = "none";
				document.activeElement.blur();
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			case GET_PIC_CODE: //获取图形验证码
				vueCodeObj.imgData = data.data;
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data){
			closeWaiting();
			//需要图形验证码
			if(requestCode == GET_CODE && resultCode == 'code' && data && data.data){
				vueObj.securityObj = data.data;
				document.activeElement.blur();
				vueCodeObj.code = null;
				document.getElementById("picCodeId").style.display = "block";
				vueObj.onGetPicCode();
				return;
			}else if(requestCode == GET_CODE && data && data.bizCode == "10040"){
				toast(resultMsgDesc);
				vueCodeObj.code = null;
				vueObj.onGetPicCode();
				return;
			}
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 选择系统环境
		 */
		onSelectEnv: function() {
			var buttons = [{id:'TEST', title:'测试环境(TEST)'}, {id:'STABLE', title:'稳定环境(STABLE)'}, {id:'PRE', title:'预发环境(PRE)'},
				{id:'GRAY', title:'灰度环境(GRAY)'}, {id:'PRO', title:'生产环境(PRO)'}];
			plus.nativeUI.actionSheet({
				title: "请选择",
				cancel: "取消",
				buttons: buttons
			}, function(e){
				if(e.index > 0){
					vueObj.nowEnv = buttons[e.index - 1].id;
					setCache(USER_SELECT_API_EVN, vueObj.nowEnv);
					initHost();
					setRongIMDomain();
				}
			});
		},
		/**
		 * 微信登录点击 
		 */
		onWeixinLogin: function() {
			onWechatLogin();
		},
		//注册服务协议
		onRegisterProtocol: function(){
			openWindow('protocol', 'protocol.html', false, {statusBarType:STATUS_BAR_DEFAULT_KEY}, null, false);
		},
		//隐私政策
		onPrivateProtocol: function(){
			openWindow("privateProtocol", "../common/web_page.html", false, {
				webUrl: "https://h5.xiaofubao.com/activity/h5/common?activityCode=y12PrivateInfo",
				statusBarType: STATUS_BAR_DEFAULT_KEY
			});
		},
		/*
		 * 是否弹出服务协议和隐私协议弹框
		 */
		onProtocolPopManager: function(loginType){
			vueObj.loginType = loginType ? loginType : "";
			if(!getCache(LOGIN_PRIVATEP_ROTOCOL)){
				vueObj.isOpenProtocolPop(true);
				return false;
			} 
			return true;
		},
		/*
		 * 协议弹框开关
		 */
		isOpenProtocolPop: function(isShow){
			if(isShow){
				document.activeElement.blur();
				document.getElementById("protocolPopSuperParent").style.display = "block";				
				document.getElementById("protocolPopSuper").classList.add("mui-active");
			} else {
				document.getElementById("protocolPopSuperParent").style.display = "none";				
				document.getElementById("protocolPopSuper").classList.remove("mui-active");
			}
		}
	}
});
//返回键处理
mui.back = function() {
	//退出应用到后台
	var main = plus.android.runtimeMainActivity();
	main.moveTaskToBack(false);
};

//Android监听软键盘
var originalHeight = document.documentElement.clientHeight ||document.body.clientHeight;
window.onresize = function(){
    //键盘弹起与隐藏都会引起窗口的高度发生变化
	var resizeHeight=document.documentElement.clientHeight || document.body.clientHeight;
	if(resizeHeight-0 < originalHeight-0){
	     //当软键盘弹起，在此处操作
		vueObj.showThrid = false;
	}else{
	 	//当软键盘收起，在此处操作
	 	vueObj.showThrid = true;
	}
}

//vue初始化
var portocolObj = new Vue({
	el: '#protocolPopSuperParent',
	data: {},
	beforeMount: function(){},
	methods: {
		onButtonClick:function(e){
			switch (e.currentTarget.dataset.type){
				case 'close':
					vueObj.isOpenProtocolPop(false);
					break;
				case 'agree':
					document.getElementById("protocolCkb").checked = true;
					setCache(LOGIN_PRIVATEP_ROTOCOL, true);
					vueObj.isOpenProtocolPop(false);
					if(vueObj.loginType == "normalLogin"){
						vueObj.onLogin();
					}
					break;
				case "protocol":	//服务协议
					document.activeElement.blur();
					openWindow('protocol', 'protocol.html', false, {statusBarType:STATUS_BAR_DEFAULT_KEY}, null, false);
					break;
				case "private": //隐私协议	
					document.activeElement.blur();
					openWindow("privateProtocol", "../common/web_page.html", false, {
						webUrl: "https://h5.xiaofubao.com/activity/h5/common?activityCode=y12PrivateInfo",
						statusBarType: STATUS_BAR_DEFAULT_KEY
					});
					break;	
				default:
					break;
			}
		}
	}
});
//vue初始化
var vueCodeObj = new Vue({
	el: '#picCodeId',
	data: {imgData:null, code: null},
	methods: {
		onButtonClick:function(e){
			switch (e.currentTarget.dataset.type){
			case 'close': //关闭弹窗
				document.getElementById("picCodeId").style.display = "none";
				document.activeElement.blur();
				break;
			case 'refresh': //刷新验证码
				vueObj.onGetPicCode();
				break;
			case 'submit': //提交验证
				if(!vueCodeObj.code){
					toast("请输入验证码");
					return;
				}
				if(commonTrim(vueCodeObj.code).length < 4){
					toast("请输入合法的验证码");
					return;
				}
				vueObj.onGetCode(null, vueCodeObj.code);
				break;
			default:
				break;
			}
		}
	}
});