//请求码
var QUERY_LIST = 1001, UPDATE_SCHOOL_INFO = 1002;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		from: null, //'userinfo' 'noSchool'
		selectSchoolName: null,
		selectSchoolCode: null,
		position: null, //当前位置信息
		address:"",//当前地址
		longitude:null,//经度
		latitude:null,//纬度
		provCode:null,//省编码
		cityCode:null,//市编码
		searchSchoolName:null,//学校名称搜索
		datas: [], //学校列表
		type:0, //查询类型 1按省市查询，2按经纬度查询,3学校名称
		fromThirdAuth: false, //是否来自第三方
		webPageId: '', //第三方页面ID
		searchTime: null
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(vueObj.fromThirdAuth && vueObj.webPageId){ 
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onSchoolSelectResult", {status: 'cancel'});
				}
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				//如果是来自登录页，则进入首页
				if(vueObj.from == 'login'){
					openWindow('main', '../main.html', false, {statusBarType:STATUS_BAR_DEFAULT_KEY}, null, true);
					closeWebview("selectSchool");
					return false;
				}
				return true;
			}
		});
		mui.plusReady(function() {
			//设置键盘弹出模式
			keyboardAdjustResize();
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听数据变化
			window.addEventListener("onUserCityChange", function(event){
				vueObj.provinceCode = event.detail.provinceCode;
				vueObj.cityCode = event.detail.cityCode;
				document.getElementById("title").innerHTML = event.detail.city;
				vueObj.loadData(1);
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//接收参数
			vueObj.from = plus.webview.currentWebview().from;
			if(vueObj.from == 'login'){
				// 关闭侧滑返回功能
				plus.webview.currentWebview().setStyle({'popGesture':'none'});
			}
			vueObj.fromThirdAuth = plus.webview.currentWebview().fromThirdAuth;
			vueObj.webPageId = plus.webview.currentWebview().webPageId;
			//先获取位置信息
			vueObj.getUserPosition();
		});
	},
	methods: {
		/*
		 * 获取用户位置信息
		 * 没有授权就提示去授权, 否则提示去选择地区
		 */
		getUserPosition: function() {
			if(!checkUserPermission("LOCATION", null, function(){
				vueObj.getUserPosition();
			}, getUserLocationFail)){
				vueObj.address = "定位失败";
				return;
			} 
			showWaiting();
			plus.geolocation.getCurrentPosition(function(p) {
				closeWaiting();
				console.log("Geolocation info: " + JSON.stringify(p));
				setCache(LOCATION_POSITION_KEY, JSON.stringify(p));
				vueObj.position = p;
				vueObj.longitude = p.coords.longitude;
				vueObj.latitude = p.coords.latitude;
				vueObj.address = (p.address.province ? p.address.province : '') +(p.address.city ? p.address.city : '') + (p.address.district ? p.address.district : '');
				vueObj.address = vueObj.address ? vueObj.address : p.addresses;
				vueObj.loadData(2);
			}, function(e) {
				closeWaiting();
				console.log("Gelocation Error: code - " + e.code + "; message - " + e.message);
				toast("定位失败，请检查您的定位权限是否被禁止");
				setNoDataBackground("main", true);
			}, {
				provider: 'amap' //amap>baidu>system
			});
		},
		/**
		 * 加载数据
		 * type 查询类型 1按省市查询，2按经纬度查询,3学校名称
		 */
		loadData: function(type) {
			showWaiting();
			vueObj.type = type;
			var param = {"type":type};
			if(type == 1) {
				param.provCode = vueObj.provCode;
				param.cityCode = vueObj.cityCode;
			} else if(type == 2) {
				param.longitude = vueObj.longitude;
				param.latitude = vueObj.latitude;
			} else if(type == 3) {
				param.schoolName = vueObj.searchSchoolName;
			}
			webCall2("/compus/school/getOnlineSchoolListByParam", param, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 搜索框数据变化
		 */
		inputChange: function(e){
			var keyword = e.currentTarget.value;
			if(!keyword){ //搜索框为空，则加载附近数据
				if(vueObj.latitude) vueObj.loadData(2);
				return;
			}
			if(keyword.length < 2){
				toast("请至少输入2个字");
				return;
			}
			if(vueObj.searchTime) clearTimeout(vueObj.searchTime);
			vueObj.searchTime = setTimeout(function(){
				vueObj.searchSchoolName = keyword;
				vueObj.loadData(3);
			}, 1000);
		},
		/*
		 * 学校搜索查询
		 */
		matchSchoolArray: function(keyword){
			//提示输入关键字
			if(!keyword || keyword.length <= 0){
				toast("请输入关键字");
				return;
			}
			vueObj.searchSchoolName = keyword;
			vueObj.loadData(3);
		}, 
		/**
		 * 选择学校
		 */
		onSelect: function(e) {
			vueObj.selectSchoolName = e.currentTarget.dataset.sname;
			vueObj.selectSchoolCode = e.currentTarget.dataset.code;
			showWaiting();
			webCall2("/compus/user/changeSchool", {
				schoolCode: vueObj.selectSchoolCode,
				clientId: getClientId()
			}, UPDATE_SCHOOL_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode){
			case QUERY_LIST: //查询学校列表
				vueObj.datas = data.rows;
				//无数据图
				if(vueObj.datas.length == 0) {
					setNoDataBackground("main", true);
				} else {
					setNoDataBackground("main", false);
				}
				break;
			case UPDATE_SCHOOL_INFO: //更新用户学校
				setCache(SCHOOL_CODE_KEY, vueObj.selectSchoolCode);
				setCache(SCHOOL_NAME_KEY, vueObj.selectSchoolName);
				//更新用户信息
				updateLoginInfo(null, data.data);
				//通知相关页面
				mui.fire(plus.webview.getWebviewById("userInfo"), "onSchoolChange", {
					schoolCode:vueObj.selectSchoolCode,
					schoolName:vueObj.selectSchoolName
				});
				mui.fire(plus.webview.getWebviewById("home/home_main.html"), "onSchoolChange", {
					schoolCode:vueObj.selectSchoolCode,
					schoolName:vueObj.selectSchoolName
				});
				mui.fire(plus.webview.currentWebview().opener(), "onSchoolChange2", {
					schoolCode:vueObj.selectSchoolCode,
					schoolName:vueObj.selectSchoolName
				});
				mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onSchoolChange", {
					schoolCode:vueObj.selectSchoolCode,
					schoolName:vueObj.selectSchoolName
				});
				if(vueObj.from == 'userinfo' && vueObj.fromThirdAuth && vueObj.webPageId){//第三方调用选择学校
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onSchoolSelectResult", {
						status: 'ok',
						schoolCode:vueObj.selectSchoolCode,
						schoolName:vueObj.selectSchoolName
					});
					closeWebview(plus.webview.currentWebview().id);
					return;
				}
				if(vueObj.from == 'noSchool' && data.data.bindCardStatus != 1){ //未绑卡，则跳转到绑卡页面
					var selfId = plus.webview.currentWebview().id;
					openWindow("bindCard", "../card/bind_card.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType,
						fromThirdAuth: plus.webview.currentWebview().fromThirdAuth,
						webPageId: plus.webview.currentWebview().webPageId,
						from: "selectSchool"
					});
					setTimeout(function(){
						closeWebview(selfId);
					}, 1000);
				}else if(vueObj.from == 'student'){ //绑定身份信息
					var selfId = plus.webview.currentWebview().id;
					openWindow("bindStudent", "../login/bind_student.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType,
						fromThirdAuth: plus.webview.currentWebview().fromThirdAuth,
						webPageId: plus.webview.currentWebview().webPageId,
						from: "selectSchool"
					});
					setTimeout(function(){
						closeWebview(selfId);
					}, 1000);
				}else if(vueObj.from == 'login'){
					var selfId = plus.webview.currentWebview().id;
					openWindow('main', '../main.html', false, {statusBarType:STATUS_BAR_DEFAULT_KEY}, null, true);
					closeWebview(selfId);
				}else{
					mui.back();
				}
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc){
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/*
		 * 切换地区
		 */
		onSelectCity: function(){
			document.activeElement.blur();
			openWindow("schoolProvince", "school_province.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
		},
		/*
		 * 定位点击
		 */
		onLocationClick:function(){
			//如果有定位信息  不再进行定位
			if(vueObj.position) return;
			vueObj.getUserPosition(); 
		},
	}
});
/*
 * 选择地区按钮点击
 */
document.getElementById("changeCityBtn").addEventListener("tap", function(){
	document.activeElement.blur();
	openWindow("schoolProvince", "school_province.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
});
/*
 * 监听软键盘上的搜索按钮
 */
/*document.getElementById("searchInput").addEventListener("keydown", function(e) {
	if(13 == e.keyCode) { //点击了“搜索”  
		var inputValue = document.getElementById('searchInput').value;
		vueObj.matchSchoolArray(e.currentTarget.value);
		document.activeElement.blur(); //隐藏软键盘 
	}
}, false);*/
/*
 * 获取权限失败
 */
function getUserLocationFail() {
	//toast("请选择地区查询学校");
}
// 设置背景
function setNoDataBackground(elementId, isNoData) {
	if(isNoData) {
		document.getElementById(elementId).style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById(elementId).style.backgroundSize = "100% auto";
		document.getElementById(elementId).style.backgroundRepeat = "no-repeat";
		document.getElementById(elementId).style.backgroundPosition = "center";
		document.getElementById(elementId).style.backgroundPositionY = "80px";
	} else {
		document.getElementById(elementId).style.backgroundImage = "none";
	}
}
