//请求码
var QUERY_CLASS_LIST = 1001;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		type:"0",// 1转发 选择联系人
		hasNewFriendMsg:false,//是否有好友请求
		friendsData:[],//好友列表数据
		classData:[],//班级列表
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/default_user_icon.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听好友请求红点
			window.addEventListener("onFriendApplyChange", function(event){
				vueObj.hasNewFriendMsg = event.detail.hasNewFriendMsg == "yes" ? true : false;
			});
			//监听好友信息更新
			window.addEventListener("onFriendInfoUpdate", function(event){
				var name = event.detail.name;
				var portraitUri = event.detail.portraitUri;
				var userId = event.detail.userId;
				for(var i = 0; i < vueObj.friendsData.length; i++){
					var friendInfo = vueObj.friendsData[i];
					if(friendInfo.userId == userId){
						friendInfo.name = name;
						friendInfo.portraitUri = portraitUri;
						Vue.set(vueObj.friendsData, i, friendInfo);
						return;
					}
				}
			});
			//监听好友备注名称修改
			window.addEventListener("onFriendNameChange", function(event){
				var userId = event.detail.friendId;
				var name = event.detail.displayName;
				for(var i = 0; i < vueObj.friendsData.length; i++){
					var friendInfo = vueObj.friendsData[i];
					if(friendInfo.userId == userId){
						friendInfo.name = name;
						Vue.set(vueObj.friendsData, i, friendInfo);
						return;
					}
				}
			});
			//监听删除好友
			window.addEventListener("onDeleteFriend", function(event){
				var userId = event.detail.friendId;
				for(var i = 0; i < vueObj.friendsData.length; i++){
					var friendInfo = vueObj.friendsData[i];
					if(friendInfo.userId == userId){
						vueObj.friendsData.splice(i, 1);
						return;
					}
				}
			});
			var header = document.querySelector('header.mui-bar');
			var list = document.getElementById('list');
			list.style.height = (document.body.offsetHeight - header.offsetHeight) + 'px';
			vueObj.hasNewFriendMsg = comGetPageParam("hasNewFriendMsg") == "yes" ? true : false;
			vueObj.type = comGetPageParam("type");
			if(vueObj.type == "1"){//转发
				initChatSingleDetailPlugin();
				document.getElementById("addBtn").style.display = "none";
			}
			//加载数据
			vueObj.loadFriendsData();
			vueObj.loadClassData();
			vueObj.addPageEvent();
		});
	},
	methods: {
		/**
		 * 添加Android自定义事件 
		 */
		addPageEvent: function(){
			if(plus.os.name != 'Android') return;
			var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
			SealAppContext.getInstance().putFireEvent(plus.webview.currentWebview().id, plus.android.implements("cn.rongcloud.im.callback.PageFireCallback", {
				"onFire": function(eventName, detailStr) {
					mui.fire(plus.webview.currentWebview(), eventName, JSON.parse(detailStr));
				}
			}));
		},
		/*
		 * 获取好友列表数据
		 */
		loadFriendsData: function(){
			if(plus.os.name == "iOS"){
				initRYIMAddressPlugin();
				iOSGetAddressBookData(function(result){
					vueObj.friendsData = result;
                		Vue.nextTick(function(){
						//创建页面索引
						window.indexedList = new mui.IndexedList(list);
					});
				})
			} else {
				//回调实现
				var callback = plus.android.implements("cn.rongcloud.im.callback.FriendListCallback", {
					"onResult": function(loadSuccess, result) {
						console.error("getFriendList: " + result)
						if(loadSuccess) {
							vueObj.friendsData = JSON.parse(result);
							Vue.nextTick(function(){
								//创建页面索引
								window.indexedList = new mui.IndexedList(list);
							});
						}
					}
				});
				//调用
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().getFriendList(callback);
			}
		},
		/*
		 * 班级
		 */
		loadClassData:function(){
			//转发不需要班级
			if(vueObj.type == "1"){return;}
			showWaiting();
			webCall2("/kt/class/getClassList", {
				userId:getCache(USER_ID_KEY)
			}, QUERY_CLASS_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_CLASS_LIST:
				vueObj.classData = data.rows;
				Vue.nextTick(function(){
					//创建页面索引
					window.indexedList = new mui.IndexedList(list);
				});
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			switch (e.currentTarget.dataset.type){
				case "new": //新的联系人
					if(vueObj.hasNewFriendMsg){
						vueObj.hasNewFriendMsg = false;
						mui.fire(plus.webview.getWebviewById("message/message_main.html"), "onContactDotChange", {});
						setCache("hasNewFriendMsg", "no");
						if(plus.os.name == "iOS"){
							plus.ios.invoke("NativeJsTool", "setCacheWithValue:key:", "no", getCache(USER_ID_KEY)+"hasNewFriendMsg");
						}
					}
					openWindow("newFriend", "../message/new_friend.html", false, {
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				case "group"://群聊
					openWindow("groupList", "../message/group_list.html", false, {
						type: vueObj.type,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				case "class"://班级
					openWindow("classMemberList", "../message/class_member_list.html", false, {
						className:e.currentTarget.dataset.value,
						classId:e.currentTarget.dataset.classId,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				case "friend"://好友
					var userId = e.currentTarget.dataset.userId;
					if(vueObj.type == "1"){//转发
						var tipString = '确定发送给' + e.currentTarget.dataset.value + '?';
						confirmDialog('转发', tipString, '取消', '发送', function cancelCallback(){}, function sureCallback(){
							if(plus.os.name == "iOS"){
								iOSForwardMessage(userId, "1", function(result){
									if(result == 0){
										closeWebview(plus.webview.currentWebview().id);
									} else {
										toast("转发失败, 请重试");
									}
								});
							} else {
								var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
								SealAppContext.getInstance().transpondMessage(userId, 1, plus.webview.currentWebview().id);
							}
						});
						return;
					}
					openWindow("personDetail", "../message/person_detail.html", false, {
						type:"1",
						userId: userId,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				default:
					break;
			}
			
		},
	}
});
// 监听搜索输入框的键盘事件
document.getElementById("searchInput").addEventListener("keydown", function(e) {
	// 键盘 return 事件
	if(13 == e.keyCode) {
		//隐藏软键盘
		document.activeElement.blur();
	}
}, false);
/**
 * 用户触摸列表界面，主动移除输入框焦点
 */
document.addEventListener("touchstart", function(e) {
	if(document.getElementById("searchInput") == e.target || document.getElementsByClassName("mui-icon-clear")[0] == e.target){
		return;
	}
	document.activeElement.blur();
});
/*
 * 添加好友点击
 */
document.getElementById("addBtn").addEventListener("tap", function(){
	document.activeElement.blur();
	openWindow("newFriendAdd", "../message/new_friend_add.html", false, {
		statusBarType: STATUS_BAR_DEFAULT_KEY
	}, null, true);
});