/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		targetId:"",//好友id或群Id
		targetType:"",//单聊1 群聊3
		targetName:"",//好友名称或者群名称
		searchValue:"",//搜索内容
		searchData:[],//搜索数据
		isShowSearchItem:true,//是否显示搜索的item
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/default_user_icon.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			initChatSingleDetailPlugin();
			vueObj.targetId = comGetPageParam("targetId");
			vueObj.targetType = comGetPageParam("targetType");
			vueObj.targetName = comGetPageParam("targetName");
		});
	},
	methods: {
		/*
		 * 搜索
		 */
		searchChatData: function(keyword){
			vueObj.isShowSearchItem = false;
			//隐藏软键盘
			document.activeElement.blur();
			if(!keyword || keyword.length <= 0){
				return;
			}
			if(plus.os.name == "iOS"){
				iOSSearchChatContent(vueObj.targetId, keyword, vueObj.targetType, function(result){
					vueObj.searchData = result;
					vueObj.dataChangeJudge();
				});
			} else {
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().searchChatMessage(vueObj.targetId, parseInt(vueObj.targetType), keyword, plus.android.implements("cn.rongcloud.im.callback.MessageCallback", {
					"onResult": function(loadSuccess, jsonList) {
						if(loadSuccess){
							vueObj.searchData = JSON.parse(jsonList);
						}
						vueObj.dataChangeJudge();
					}
				}));
			}
		},
		//搜索item点击
		onSearchItemClick: function(){
			vueObj.searchChatData(vueObj.searchValue);
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(index) {
			var item = vueObj.searchData[index];
			if(plus.os.name == "iOS"){
				plus.ios.invoke("RYImTool", "startConversation:withTargetId:title:time:", vueObj.targetType, vueObj.targetId.toString(), vueObj.targetName, item.time ? item.time.toString() : (item.receivedTime ? item.receivedTime.toString() : ''));
			} else{
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().startConversation(plus.android.runtimeMainActivity(), parseInt(vueObj.targetType), vueObj.targetId, vueObj.targetName);
			}
		},
		/**
		 * 搜索框变化
		 */
		onInputChange:function(e){
			vueObj.isShowSearchItem = true;
			vueObj.searchData = [];
		},
		/**
		 * 获取格式化的时间
		 * @param {Object} timeMillis
		 */
		getDateShow: function(timeMillis){
			return formatDateShow(timeMillis);
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			//无数据图
			if(vueObj.searchData.length == 0) {
				setNoDataBackground(true);
			} else {
				setNoDataBackground(false);
			}
		},
	}
});
// 监听搜索输入框的键盘事件
document.getElementById("searchInput").addEventListener("keydown", function(e) {
	// 键盘 return 事件
	if(13 == e.keyCode) {
		vueObj.searchChatData(vueObj.searchValue);
	}
}, false);
/**
 * 用户触摸列表界面，主动移除输入框焦点
 */
document.addEventListener("touchstart", function(e) {
	if(document.getElementById("searchInput") == e.target || (document.getElementsByClassName("mui-icon-clear") && document.getElementsByClassName("mui-icon-clear")[0] == e.target)){
		return;
	}
	document.activeElement.blur();
}); 
/*
 * 搜索框清除按钮点击
 */
mui('.mui-search').on('tap', '.mui-icon-clear', function(e) {
	vueObj.searchValue = "";
	vueObj.searchData = [];
}, false);
// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		//页面有输入框 会把无数据背景图顶下来
		if(plus.os.name == "iOS") return;
 		document.getElementById("main").style.backgroundPosition = "center";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
	}
}