//请求码
var QUERY_GROUP_INFO = 1001, QUIT_GROUP = 1002, DISSMISS_GROUP = 1003;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		groupId:"",//群id
		groupInfo:{},//群信息
		memberLsit:[],//群成员列表
		isTop:false,//置顶
		noticeStatus:false,//消息免打扰
		isCreator:false,//是否是群主创建者
		showMemberCount:8,//要展示几个用户
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听群名称数据变化
			window.addEventListener("onGroupNameChange", function(event){
				Vue.set(vueObj.groupInfo, "groupName", event.detail.groupName);
				if(plus.os.name == "iOS"){
					plus.ios.invoke("RYIMDataTool", "updateGroupInfo:", JSON.stringify(vueObj.groupInfo));
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().updateGroupInfo(vueObj.groupInfo.id, vueObj.groupInfo.groupName, vueObj.groupInfo.groupUserId+"");
				}
			});
			//监听群公告数据变化
			window.addEventListener("onGroupNoticeChange", function(event){
				Vue.set(vueObj.groupInfo, "groupNotice", event.detail.groupNotice);
			});
			//监听群成员数据变化
			window.addEventListener("onGroupMemberChange", function(event){
				if(event.detail.type && event.detail.type == "groupAdminChange"){//群转让
					vueObj.isCreator = false;
					vueObj.groupInfo.groupUserId = event.detail.userId;
					if(plus.os.name == "iOS"){
						plus.ios.invoke("RYIMDataTool", "updateGroupInfo:", JSON.stringify(vueObj.groupInfo));	
					} else {
						var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
						SealAppContext.getInstance().updateGroupInfo(vueObj.groupInfo.id, vueObj.groupInfo.groupName, event.detail.userId+"");
					}
				}
				if(plus.os.name == "iOS"){
					//获取群成员列表
					iOSGetGroupMemberList(vueObj.groupId, function(result){
						vueObj.memberLsit = result;
					});
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().getGroupMembers(vueObj.groupId, plus.android.implements("cn.rongcloud.im.callback.GroupMemberCallback", {
						"onResult": function(loadSuccess, jsonList) {
							console.error("getGroupMembers: " + jsonList)
							if(loadSuccess){
								vueObj.memberLsit = JSON.parse(jsonList);
							}
						}
					}));
				}
			});
			//监听群成员备注名称修改
			window.addEventListener("onGroupMemberDisplayNameChange", function(event){
				var displayName = event.detail.displayName;
				var userId = event.detail.userId;
				if(userId == getCache(USER_ID_KEY)){
					Vue.set(vueObj.groupInfo, "displayName", displayName);
				}
				for(var i = 0; i < vueObj.memberLsit.length; i++){
					var memberInfo = vueObj.memberLsit[i];
					if(memberInfo.userId == userId){
						memberInfo.name = displayName;
						Vue.set(vueObj.memberLsit, i, memberInfo);
						return;
					}
				}
			});
			//监听群成员信息刷新新
			window.addEventListener("onGroupMemberUpdate", function(event){
				var displayName = event.detail.name;
				var userId = event.detail.userId;
				var portraitUri = event.detail.headImg;
				for(var i = 0; i < vueObj.memberLsit.length; i++){
					var memberInfo = vueObj.memberLsit[i];
					if(memberInfo.userId == userId){
						memberInfo.name = displayName ? displayName: memberInfo.name;
						memberInfo.portraitUri = portraitUri ? portraitUri : memberInfo.portraitUri;
						Vue.set(vueObj.memberLsit, i, memberInfo);
						return;
					}
				}
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.groupId = comGetPageParam("groupId");
			//加载数据
			initChatSingleDetailPlugin();
			vueObj.loadGroupData();
			vueObj.addPageEvent();
		});
	},
	methods: {
		/**
		 * 添加Android自定义事件 
		 */
		addPageEvent: function(){
			if(plus.os.name != 'Android') return;
			var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
			SealAppContext.getInstance().putFireEvent(plus.webview.currentWebview().id, plus.android.implements("cn.rongcloud.im.callback.PageFireCallback", {
				"onFire": function(eventName, detailStr) {
					mui.fire(plus.webview.currentWebview(), eventName, JSON.parse(detailStr));
				}
			}));
		},
		/*
		 * 获取群信息数据
		 */
		loadGroupData: function(){
			vueObj.queryGroupInfo();
			if(plus.os.name == "iOS"){
				showWaiting();
				//获取群成员列表
				iOSGetGroupMemberList(vueObj.groupId, function(result){
					closeWaiting();
					vueObj.memberLsit = result;
				});
				//获取会话通知状态
				iOSGetChatNotificationStatus(vueObj.groupId, "3", function(result){
					vueObj.noticeStatus = result == 1 ? true : false;
				});
				//获取会话置顶状态
				iOSGetChatIsTop(vueObj.groupId, "3", function(result){
					vueObj.isTop = result == 0 ? true : false;
				});
			} else{
				//获取群成员列表
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().getGroupMembers(vueObj.groupId, plus.android.implements("cn.rongcloud.im.callback.GroupMemberCallback", {
					"onResult": function(loadSuccess, jsonList) {
						console.error("getGroupMembers: " + jsonList)
						if(loadSuccess){
							vueObj.memberLsit = JSON.parse(jsonList);
						}
					}
				}));
				//获取通知状态
				var notificationCallback = plus.android.implements("cn.rongcloud.im.callback.ConversationNotificationStatusCallback", {
					"onResult": function(isNotNotification) {
						console.error("isNotNotification: " + isNotNotification)
						vueObj.noticeStatus = isNotNotification;
					}
				});
				SealAppContext.getInstance().getConversationNotificationStatus(vueObj.groupId, 3, notificationCallback);
				//获取会话置顶状态
				var topCallback = plus.android.implements("cn.rongcloud.im.callback.ConversationTopCallback", {
					"onResult": function(isTop) {
						console.error("isTop: " + isTop)
						vueObj.isTop = isTop;
					}
				});
				SealAppContext.getInstance().getConversationTop(vueObj.groupId, 3, topCallback);
			}
		},
		/*
		 * 查询群信息
		 */
		queryGroupInfo:function(){
			showWaiting();
			webCall2("/im/group/getById", {groupId:vueObj.groupId}, QUERY_GROUP_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 退出群聊
		 */
		quitGroup:function() {
			showWaiting();
			webCall2("/im/group/member/quit", {
				groupId:vueObj.groupId, 
				userIds: getCache(USER_ID_KEY),
			}, QUIT_GROUP, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 解散群
		 */
		dismissGroup:function() {
			showWaiting();
			webCall2("/im/group/dismiss", {groupId:vueObj.groupId}, DISSMISS_GROUP, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_GROUP_INFO://群信息
				vueObj.groupInfo = data.data;
				//更新本地群数据
				if(plus.os.name == "iOS"){
					plus.ios.invoke("RYIMDataTool", "updateGroupInfo:", JSON.stringify(vueObj.groupInfo));
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().updateGroupInfo(vueObj.groupInfo.id, vueObj.groupInfo.groupName, vueObj.groupInfo.groupUserId+"");
				}
				if(getCache(USER_ID_KEY) == vueObj.groupInfo.groupUserId) {
					vueObj.isCreator = true;
				}
				if(vueObj.isCreator) {
					vueObj.showMemberCount = 8;
				} else if(vueObj.groupInfo.groupType == 1) {
					vueObj.showMemberCount = 9;
				} else {
					vueObj.showMemberCount = 10;
				}
				break;
			case QUIT_GROUP://退出群
				toast("退出成功");
				excuteFireEvent("groupList", "onGroupListChange", {groupId:vueObj.groupId});
				if(plus.os.name == "iOS"){
					plus.ios.invoke("RYIMDataTool", "quitGroup:", vueObj.groupId);
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().quitGroup(vueObj.groupId);
				}
				break;
			case DISSMISS_GROUP://解散群
				toast("解散成功");
				excuteFireEvent("groupList", "onGroupListChange", {groupId:vueObj.groupId});
				if(plus.os.name == "iOS"){
					plus.ios.invoke("RYIMDataTool", "quitGroup:", vueObj.groupId);
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().quitGroup(vueObj.groupId);
				}
				break;	
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			switch (e.currentTarget.dataset.type){
				case "member": //群成员头像点击
					openWindow("personDetail", "../message/person_detail.html", false, {
						userId:e.currentTarget.dataset.memberId,
						type:"1",
						groupNickName: e.currentTarget.dataset.name,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break
				case "more": //群成员列表
					openWindow("groupMember", "../message/group_member_list.html", false, {
						memberList: JSON.stringify(vueObj.memberLsit),
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break	
				case "add": //添加群成员
					openWindow("selectPersonAdd", "../message/select_person.html", false, {
						groupId:vueObj.groupId,
						groupName:vueObj.groupInfo.groupName,
						type:"1",
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break
				case "delete": //删除群成员
					openWindow("selectPersonDel", "../message/select_person.html", false, {
						groupId:vueObj.groupId,
						type:"2",
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break
				case "name": //群名称
					if(!vueObj.isCreator){
						toast("只有群主可以修改群组名称")
						return;
					} 
					openWindow("editGroupInfo", "../message/edit_group_info.html", false, {
						groupName:vueObj.groupInfo.groupName,
						groupId:vueObj.groupId,
						type: "1",
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				case "displayName": //群用户昵称
					openWindow("personRemark", "../message/person_remark.html", false, {
						displayName:vueObj.groupInfo.displayName,
						groupId:vueObj.groupId,
						type: "3",
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;	
				case "code": //群二维码
					openWindow("personCode", "../message/person_code.html", false, {
						type:"1",
						groupId: vueObj.groupId,
						showName:vueObj.groupInfo.groupName,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				case "notice": //群公告
					if(!vueObj.isCreator && (!vueObj.groupInfo.groupNotice || vueObj.groupInfo.groupNotice.length <= 0)){
						toast("只有群主才能修改群公告");
						return;
					}
					openWindow("editGroupNotice", "../message/edit_group_notice.html", false, {
						groupId: vueObj.groupId,
						groupName:vueObj.groupInfo.groupName,
						creatorId:vueObj.groupInfo.groupUserId,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				case "admin": //群转让
					openWindow("selectPersonAdmin", "../message/select_person.html", false, {
						groupId:vueObj.groupId,
						type:"4",
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;	
				case "top": //置顶
					var isActive = document.getElementById("topSwitch").classList.contains("mui-active");
					if(plus.os.name == "iOS"){
						iOSSetChatIsTop(vueObj.groupId, isActive ? '0' : '1', "3");	
					} else {
						var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
						SealAppContext.getInstance().setConversationTop(vueObj.groupId, 3, isActive);
					}
					break;
				case "push"://消息免打扰
					var isActive = document.getElementById("noticeSwitch").classList.contains("mui-active");
					if(plus.os.name == "iOS"){
						iOSSetChatNotificationStatus(vueObj.groupId, isActive ? '0' : '1', "3");	
					} else {
						var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
						SealAppContext.getInstance().setConversationNotificationStatus(vueObj.groupId, 3, isActive);
					}
					break;
				case "search"://查找
					openWindow("chatContentSearchGroup", "../message/chat_content_search.html", false, {
						targetId:vueObj.groupId,
						targetType:"3",
						targetName:vueObj.groupInfo.groupName,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				case "complaint"://投诉
					
					break;
				case "clear"://清空聊天记录
					plus.nativeUI.actionSheet({
						cancel: "取消",
						buttons:  [{
							title: "清空聊天记录"
						}]
					}, function(e){
						if(e.index == 1){
							showWaiting();
							if(plus.os.name == "iOS"){
								iOSClearChatRecord(vueObj.groupId, "3",function(result){
									closeWaiting();
									if(result == 0){
										toast("清除聊天记录成功");
									} else {
										toast("清除聊天记录失败");
									}
								});
							} else {
								var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
								SealAppContext.getInstance().clearMessages(vueObj.groupId, 3);
								closeWaiting();
							}
						}
					});
					break;
				case "quit"://退出
					var title = "确定退出该群聊?";
					if(vueObj.isCreator){
						title = "确定解散该群聊?";
					}
					confirmDialog("", title, "取消", "确定",  function(){},function(){
						if(vueObj.isCreator){ //解散群
							vueObj.dismissGroup();
							return;
						}
						//退出群
						vueObj.quitGroup();
					});
					break;
				default:
					break;
			}
		},
	}
});