/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		friendId:"",//好友id
		friendInfo:{},//好友信息
		isTop:false,//置顶
		noticeStatus:false,//消息免打扰
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/default_user_icon.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听好友备注名称修改
			window.addEventListener("onFriendNameChange", function(event){
				Vue.set(vueObj.friendInfo, "name", event.detail.displayName);
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.friendId = comGetPageParam("friendId");
			//加载数据
			initChatSingleDetailPlugin();
			vueObj.loadFriendsData();
			vueObj.addPageEvent();
		});
	},
	methods: {
		/**
		 * 添加Android自定义事件 
		 */
		addPageEvent: function(){
			if(plus.os.name != 'Android') return;
			var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
			SealAppContext.getInstance().putFireEvent(plus.webview.currentWebview().id, plus.android.implements("cn.rongcloud.im.callback.PageFireCallback", {
				"onFire": function(eventName, detailStr) {
					mui.fire(plus.webview.currentWebview(), eventName, JSON.parse(detailStr));
				}
			}));
		},
		/*
		 * 获取好友列表数据
		 */
		loadFriendsData: function(){
			if(plus.os.name == "iOS"){
				//获取好友信息
				iOSGetFriendInfoData(vueObj.friendId, function(result){
					vueObj.friendInfo = result;
				});
				//获取会话通知状态
				iOSGetChatNotificationStatus(vueObj.friendId, "1", function(result){
					vueObj.noticeStatus = result == 1 ? true : false;
				});
				//获取会话置顶状态
				iOSGetChatIsTop(vueObj.friendId, "1", function(result){
					vueObj.isTop = result == 0 ? true : false;
				});
			} else{
				//获取好友信息
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				vueObj.friendInfo = JSON.parse(SealAppContext.getInstance().getFriendInfo(vueObj.friendId));
				//获取通知状态
				var notificationCallback = plus.android.implements("cn.rongcloud.im.callback.ConversationNotificationStatusCallback", {
					"onResult": function(isNotNotification) {
						console.error("isNotNotification: " + isNotNotification)
						vueObj.noticeStatus = isNotNotification;
					}
				});
				SealAppContext.getInstance().getConversationNotificationStatus(vueObj.friendId, 1, notificationCallback);
				//获取会话置顶状态
				var topCallback = plus.android.implements("cn.rongcloud.im.callback.ConversationTopCallback", {
					"onResult": function(isTop) {
						console.error("isTop: " + isTop)
						vueObj.isTop = isTop;
					}
				});
				SealAppContext.getInstance().getConversationTop(vueObj.friendId, 1, topCallback);
			}
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			switch (e.currentTarget.dataset.type){
				case "friend": //好友头像点击
					openWindow("personDetail", "../message/person_detail.html", false, {
						userId: vueObj.friendId,
						type:"1",
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				case "top": //置顶
					var isActive = document.getElementById("topSwitch").classList.contains("mui-active");
					if(plus.os.name == "iOS"){
						iOSSetChatIsTop(vueObj.friendId, isActive ? '0' : '1', "1");	
					}else{
						var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
						SealAppContext.getInstance().setConversationTop(vueObj.friendId, 1, isActive);
					}
					break;
				case "push"://消息免打扰
					var isActive = document.getElementById("noticeSwitch").classList.contains("mui-active");
					if(plus.os.name == "iOS"){
						iOSSetChatNotificationStatus(vueObj.friendId, isActive ? '0' : '1', "1");	
					}else{
						var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
						SealAppContext.getInstance().setConversationNotificationStatus(vueObj.friendId, 1, isActive);
					}
					break;
				case "search"://查找
					openWindow("chatContentSearchSingle", "../message/chat_content_search.html", false, {
						targetId:vueObj.friendId,
						targetType:"1",
						targetName:vueObj.friendInfo.name,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				case "complaint"://投诉
					
					break;
				case "clear"://清空聊天记录
					plus.nativeUI.actionSheet({
						cancel: "取消",
						buttons:  [{
							title: "清空聊天记录"
						}]
					}, function(e){
						if(e.index == 1){
							showWaiting();
							if(plus.os.name == "iOS"){
								iOSClearChatRecord(vueObj.friendId, "1", function(result){
									closeWaiting();
									if(result == 0){
										toast("清除聊天记录成功");
									} else {
										toast("清除聊天记录失败");
									}
								});
							} else {
								var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
								SealAppContext.getInstance().clearMessages(vueObj.friendId, 1);
								closeWaiting();
							}
						}
					});
					break;	
				default:
					break;
			}
		},
	}
});