//请求码
var QUERY_FAMILY_LIST = 1001;
var searchValue = "";//搜索文字
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		classId:"",//班级id
		className:"",//班级名称
		familyData:[],//家长列表数据
		orgFamilyData:[],//家长列表数据
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/default_user_icon.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.classId = comGetPageParam("classId");
			vueObj.className = comGetPageParam("className");
			//加载数据
			vueObj.loadTeacherList();
		});
	},
	methods: {
		/*
		 * 获取老师列表数据
		 */
		loadTeacherList: function(){
			showWaiting();
			webCall2("/kt/class/getFamiliyList", {
				classId:vueObj.classId,
			}, QUERY_FAMILY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_FAMILY_LIST:
				vueObj.familyData = data.rows;
				vueObj.orgFamilyData = data.rows;
				vueObj.dataChangeJudge();
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			var userId = e.currentTarget.dataset.userId;
			var hasJoin = e.currentTarget.dataset.hasJoin;
			var name = e.currentTarget.dataset.name;
			if(hasJoin != 0 || !userId || userId.length <= 0) {
				toast("该家长还未注册App");
				return;
			}
			openWindow("personDetail", "../message/person_detail.html", false, {
				type: "3",
				userId: userId,
				classId: vueObj.classId,
				className: vueObj.className,
				identityName:name,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			}, null, true);
		},
		/*
		 * 搜索框变化
		 */
		onInputChange: function(e){
			vueObj.onMatchList(e.currentTarget.value);
		},
		/*
		 * 搜索
		 */
		onMatchList: function(keyword){
			if(keyword == searchValue){
				return;
			}
			searchValue = keyword;
			//搜索出来的结果
			var searchArray = [];
			if(!keyword || keyword.length <= 0) {
				vueObj.familyData = vueObj.orgFamilyData;
				return;
			}
			for(var i in vueObj.orgFamilyData) {
				var item = vueObj.orgFamilyData[i];
				if(item.name.indexOf(keyword) < 0) {
					continue
				}
				searchArray.push(item);
			}
			vueObj.familyData = searchArray;
			vueObj.dataChangeJudge();
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			//无数据图
			if(vueObj.familyData.length == 0) {
				setNoDataBackground(true);
			} else {
				setNoDataBackground(false);
			}
		},
	}
});
// 监听搜索输入框的键盘事件
document.getElementById("searchInput").addEventListener("keydown", function(e) {
	// 键盘 return 事件
	if(13 == e.keyCode) {
		//隐藏软键盘
		document.activeElement.blur();
	}
}, false);
/**
 * 用户触摸列表界面，主动移除输入框焦点
 */
document.addEventListener("touchstart", function(e) {
	if(document.getElementById("searchInput") == e.target || document.getElementsByClassName("mui-icon-clear")[0] == e.target){
		return;
	}
	document.activeElement.blur();
});
/*
 * 搜索框清除按钮点击
 */
mui('.mui-search').on('tap', '.mui-icon-clear', function(e) {
	vueObj.onMatchList("");
}, false);
// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		//页面有输入框 会把无数据背景图顶下来
		if(plus.os.name == "iOS") return;
 		document.getElementById("main").style.backgroundPosition = "center";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
	}
}