//请求码
var QUERY_TEACHER_LIST = 1001, QUERY_STUDENT_LIST = 1002;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		classId:"",//班级id
		className:"",//班级名称
		teacherData:[],//老师列表数据
		studentData:[],//学生列表
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/default_user_icon.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			vueObj.classId = comGetPageParam("classId");
			vueObj.className = comGetPageParam("className");
			document.getElementById("title").innerHTML = vueObj.className;
			var header = document.querySelector('header.mui-bar');
			var list = document.getElementById('list');
			list.style.height = (document.body.offsetHeight - header.offsetHeight) + 'px';
			//加载数据
			vueObj.loadTeacherList();
			vueObj.loadStudentList();
		});
	},
	methods: {
		/*
		 * 获取老师列表数据
		 */
		loadTeacherList: function(){
			showWaiting();
			webCall2("/kt/class/getTeacherList", {
				classId:vueObj.classId,
			}, QUERY_TEACHER_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 获取学生列表数据
		 */
		loadStudentList:function(){
			showWaiting();
			webCall2("/kt/class/getStudentList", {
				classId:vueObj.classId, 
			}, QUERY_STUDENT_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_TEACHER_LIST:
				vueObj.teacherData = data.rows;
				Vue.nextTick(function(){
					//创建页面索引
					window.indexedList = new mui.IndexedList(list);
				});
				break;
			case QUERY_STUDENT_LIST:
				vueObj.studentData = data.rows;
				Vue.nextTick(function(){
					//创建页面索引
					window.indexedList = new mui.IndexedList(list);
				});
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			switch (e.currentTarget.dataset.type){
				case "teacher": //老师
					var userId = e.currentTarget.dataset.userId;
					var hasJoin = e.currentTarget.dataset.hasJoin;
					var name = e.currentTarget.dataset.value;
					if(hasJoin != 0 || !userId || userId.length <= 0 ){
						toast("该老师还未注册App");
						return;
					} 
					openWindow("personDetail", "../message/person_detail.html", false, {
						type:"2",
						userId: userId,
						classId: vueObj.classId,
						className:vueObj.className,
						identityName:name,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true); 
					break;
				case "student"://学生
					var studentId = e.currentTarget.dataset.studentId;
					openWindow("classStudentDetail", "../message/class_student_detail.html", false, {
						studentId: studentId,
						classId: vueObj.classId,
						className:vueObj.className,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				default:
					break;
			}
			
		},
	}
});
// 监听搜索输入框的键盘事件
document.getElementById("searchInput").addEventListener("keydown", function(e) {
	// 键盘 return 事件
	if(13 == e.keyCode) {
		//隐藏软键盘
		document.activeElement.blur();
	}
}, false);
/**
 * 用户触摸列表界面，主动移除输入框焦点
 */
document.addEventListener("touchstart", function(e) {
	if(document.getElementById("searchInput") == e.target || document.getElementsByClassName("mui-icon-clear")[0] == e.target){
		return;
	}
	document.activeElement.blur();
});
/*
 *右上角按钮点击
 */
document.getElementById("saveBtn").addEventListener("tap", function(){
	openWindow("classFamilyList", "../message/class_family_list.html", false, {
		classId:vueObj.classId,
		className:vueObj.className,
		statusBarType: STATUS_BAR_DEFAULT_KEY
	}, null, true);
});