//请求码
var QUERY_STUDENT_INFO = 1001, QUERY_STUDENT_FAMILY = 1002;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		studentId:"", //学生id
		classId:"",//班级id
		className:"",//班级名称
		studentName:"",//姓名
		datas:[],//家长列表
		userInfo:{},//学生信息
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/default_user_icon.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.studentId = comGetPageParam("studentId");
			vueObj.classId = comGetPageParam("classId");
			vueObj.className = comGetPageParam("className");
			//获取学生信息 
			vueObj.loadStudentInfo();
			vueObj.loadStudentFamilyList();
		});
	},
	methods: {
		/*
		 * 获取学生信息
		 */
		loadStudentInfo: function(){
			webCall2("/kt/user/studentDetail", {
				studentId:vueObj.studentId,
			}, QUERY_STUDENT_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 获取学生家长列表
		 */
		loadStudentFamilyList: function(){
			webCall2("/kt/user/getStudentFamilyList", {
				studentId:vueObj.studentId,
			}, QUERY_STUDENT_FAMILY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_STUDENT_INFO://学生信息
				vueObj.userInfo = data.data;
				break;
			case QUERY_STUDENT_FAMILY://学生家长列表
				vueObj.datas = data.rows;
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 
		 */
		onItemClick: function(index) {
			var item = vueObj.datas[index];
			if(item.hasJoin != 0 || !item.userId || item.userId.length <= 0) {
				toast("该家长还未注册App");
				return;
			}
			openWindow("personDetail", "../message/person_detail.html", false, {
				type: "3",
				userId: item.userId,
				className: vueObj.className,
				classId:vueObj.classId,
				identityName: item.name + (item.relationshipName ? '（' + item.relationshipName + '）' : ''),
				statusBarType: STATUS_BAR_DEFAULT_KEY
			}, null, true);
		},
	}
});