//请求码
var QUERY_GROUP_INFO = 1001, GROUP_ADD_MEMBER = 1002;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		groupId:"",//群id
		groupInfo:"",//群名称
		isJoin: false,
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.groupId = comGetPageParam("groupId");
			vueObj.queryGroupInfo();
			vueObj.onIsJoinGroup();
		});
	},
	methods: {
		/*
		 * 获取是否已经加入了群聊
		 */
		onIsJoinGroup:function(){
			if(!vueObj.groupId)return;
			if(plus.os.name == "iOS"){
				initChatSingleDetailPlugin();
				iOSIsJoinGroup(vueObj.groupId ,function(result){
					vueObj.isJoin = (result == 0 ? true : false);
				});
			} else {
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				vueObj.isJoin = SealAppContext.getInstance().judgeIsJoinGroup(vueObj.groupId, getCache(USER_ID_KEY));
			}
		},
		/*
		 * 查询群信息
		 */
		queryGroupInfo:function(){
			webCall2("/im/group/getById", {groupId:vueObj.groupId}, QUERY_GROUP_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 加入群聊
		 */
		groupAddMember:function(){
			showWaiting();
			var params = {};
			params.groupId = vueObj.groupId;
			params.groupName = vueObj.groupInfo.groupName;
			params.userIds =  getCache(USER_ID_KEY);
			webCall2("/im/group/member/add", params, GROUP_ADD_MEMBER, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_GROUP_INFO://查询群信息
				vueObj.groupInfo = data.data;
				break;
			case GROUP_ADD_MEMBER://加入群聊
				if(plus.os.name == "iOS"){
					plus.ios.invoke("RYImTool", "startConversation:withTargetId:title:", "3", vueObj.groupId, vueObj.groupInfo.groupName);
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().startConversation(plus.android.runtimeMainActivity(), 3, vueObj.groupId, vueObj.groupInfo.groupName);
				}
				closeWebview(plus.webview.currentWebview().id);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		onAddBtnClick:function(){
			if(vueObj.isJoin){ 
				if(plus.os.name == "iOS"){
					plus.ios.invoke("RYImTool", "startConversation:withTargetId:title:", "3", vueObj.groupId, vueObj.groupInfo.groupName);
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().startConversation(plus.android.runtimeMainActivity(), 3, vueObj.groupId, vueObj.groupInfo.groupName);
				}
				return;				
			}
			vueObj.groupAddMember();
		}
	}
});
