//请求码
var QUERY_GROUP_LIST = 1001;
var searchValue = "";//搜索文字
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		type:"0", //// 1转发 选择群组
		groupsData:[],//好友列表数据
		orgGroupsData:[],//好友列表数据
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/default_user_icon.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听群列表数据变化
			window.addEventListener("onGroupListChange", function(event){
				for(var i = 0; i < vueObj.groupsData.length; i++){
					if(event.detail.groupId == vueObj.groupsData[i].groupId){
						vueObj.groupsData.splice(i, 1);
						break;
					}
				}
				for(var i = 0; i < vueObj.orgGroupsData.length; i++){
					if(event.detail.groupId == vueObj.orgGroupsData[i].groupId){
						vueObj.orgGroupsData.splice(i, 1);
						break;
					}
				}
				vueObj.dataChangeJudge();
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.type = comGetPageParam("type");
			//加载数据
			vueObj.loadFGroupsData();
			vueObj.addPageEvent();
		});
	},
	methods: {
		/**
		 * 添加Android自定义事件 
		 */
		addPageEvent: function(){
			if(plus.os.name != 'Android') return;
			var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
			SealAppContext.getInstance().putFireEvent(plus.webview.currentWebview().id, plus.android.implements("cn.rongcloud.im.callback.PageFireCallback", {
				"onFire": function(eventName, detailStr) {
					mui.fire(plus.webview.currentWebview(), eventName, JSON.parse(detailStr));
				}
			}));
		},
		/*
		 * 获取群聊列表数据
		 */
		loadFGroupsData: function(){
			if(plus.os.name == "iOS"){
                initChatSingleDetailPlugin();
                iOSGetGroupLsit(function(result){
                		vueObj.groupsData = result;
                		vueObj.orgGroupsData = result;
                		vueObj.dataChangeJudge();
                });
			} else{
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().getGroupList(plus.android.implements("cn.rongcloud.im.callback.GroupCallback", {
					"onResult": function(loadSuccess, jsonList) {
						if(loadSuccess){
							vueObj.groupsData = JSON.parse(jsonList);
							vueObj.orgGroupsData = vueObj.groupsData;
						}
						vueObj.dataChangeJudge();
					}
				}));
			}
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			var groupId = e.currentTarget.dataset.groupId;
			var groupName = e.currentTarget.dataset.groupName;
			if(vueObj.type == "1") { //转发
				var tipString = '确定发送到' + groupName + '?';
				confirmDialog('转发', tipString, '取消', '发送', function cancelCallback() {}, function sureCallback() {
					if(plus.os.name == "iOS") {
						iOSForwardMessage(groupId, "3", function(result) {
							if(result == 0) {
								closeWebview("addressBook");
								closeWebview(plus.webview.currentWebview().id);
							} else {
								toast("转发失败, 请重试");
							}
						});
					} else {
						var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
						SealAppContext.getInstance().transpondMessage(groupId, 3, plus.webview.currentWebview().id);
					}
				});
				return;
			}
			if(plus.os.name == 'iOS'){
				plus.ios.invoke("RYImTool", "startConversation:withTargetId:title:", "3", groupId.toString(), groupName);
			}else{
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().startConversation(plus.android.runtimeMainActivity(), 3, groupId.toString(), groupName);
			}
		},
		/*
		 * 搜索框变化
		 */
		onInputChange: function(e){
			vueObj.onMatchList(e.currentTarget.value);
		},
		/*
		 * 搜索
		 */
		onMatchList: function(keyword){
			if(keyword == searchValue){
				return;
			}
			searchValue = keyword;
			//搜索出来的结果
			var searchArray = [];
			if(!keyword || keyword.length <= 0) {
				vueObj.groupsData = vueObj.orgGroupsData;
				return;
			}
			for(var i in vueObj.orgGroupsData) {
				var item = vueObj.orgGroupsData[i];
				if(item.groupName.indexOf(keyword) < 0) {
					continue
				}
				searchArray.push(item);
			}
			vueObj.groupsData = searchArray;
			vueObj.dataChangeJudge();
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			//无数据图
			if(vueObj.groupsData.length == 0) {
				setNoDataBackground(true);
			} else {
				setNoDataBackground(false);
			}
		},
	}
});
// 监听搜索输入框的键盘事件
document.getElementById("searchInput").addEventListener("keydown", function(e) {
	// 键盘 return 事件
	if(13 == e.keyCode) {
		//隐藏软键盘
		document.activeElement.blur();
	}
}, false);
/**
 * 用户触摸列表界面，主动移除输入框焦点
 */
document.addEventListener("touchstart", function(e) {
	if(document.getElementById("searchInput") == e.target || (document.getElementsByClassName("mui-icon-clear") && document.getElementsByClassName("mui-icon-clear")[0] == e.target)){
		return;
	}
	document.activeElement.blur();
}); 
/*
 * 搜索框清除按钮点击
 */
mui('.mui-search').on('tap', '.mui-icon-clear', function(e) {
	vueObj.onMatchList("");
}, false);
// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		//页面有输入框 会把无数据背景图顶下来
		if(plus.os.name == "iOS") return;
 		document.getElementById("main").style.backgroundPosition = "center";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
	}
}