//请求码
var QUERY_DETAIL = 1001, QUERY_ADS = 1002;
//初始化Vue
var vueObj = new Vue({
	el: '#main',
	data: {
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		logo:"../../img/default_photo_icon.png",//
		detailId: '', //消息ID
		data: {content:''} //消息实体
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//数据处理
			var self = plus.webview.currentWebview();
			vueObj.logo = self.logo ? self.logo : vueObj.logo; 
			vueObj.detailId = self.detailId;
			//加载详情数据
			vueObj.loadData();
			vueObj.loadBannerData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			showWaiting();
			webCall2("/compus/user/message/view", {
				messageId: vueObj.detailId
			}, QUERY_DETAIL, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		* 加载广告数据
	 	*/
		 loadBannerData: function() {
		 	webCall2("/compus/advertising/getAdvertisingList", {
		 		addressCode: 1017
		 	}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
		 },
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DETAIL: //详情查询
				data.data.content = data.data.content.replace(new RegExp("\r\n","g"), "<br/>");
				data.data.content = data.data.content.replace(new RegExp("\n","g"), "<br/>");
				data.data.content = data.data.content.replace(new RegExp("\r","g"), "<br/>");
				vueObj.data = data.data;
				break;
			case QUERY_ADS: //更新为已读成功
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;	
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			closeWaiting();
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "消息详情页", "pos": "消息详情页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && getUserInfo().bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});