var myScroll;
var isLoadingMore;
var isNoMore;
var start = 0;
//请求码
var QUERY_LIST = 1001, DELETE_MSG = 1002, UPDATE_READED = 1003, BATCH_UPDATE_READED = 1004,
	BATCH_DELETE_MSG = 1005;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		datas: [],
		messageCode:null,//消息类型
		logo:"../../img/default_photo_icon.png",//消息logo
		redDotStatus:0,//红点状态 1不显示 2显示红点 3显示红点和未读消息 ,
		showStatus:0,//显示样式 1全部显示 2只显示内容 ,
		deleteMsgIndex: null,//消息删除的下标
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//数据处理
			var self = plus.webview.currentWebview();
			vueObj.messageCode = self.messageCode;
			vueObj.logo = self.logo ? self.logo : vueObj.logo;
			vueObj.redDotStatus = self.redDotStatus;
			vueObj.showStatus = self.showStatus;
			//标题
			document.getElementById("title").innerText = self.messageName ? self.messageName : '消息列表'
			//加载详情数据
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			webCall2("/compus/user/message/findPageWithMsgCount", {
				messageCode: vueObj.messageCode,
				offset: start,
				limit: 15 //防止有的手机过长 10条数据到不了底部
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 删除单个消息
		 */
		deleteMsg:function(msgId){
			showWaiting();
			webCall2("/compus/user/message/deleteMessageById", {
				messageId:msgId
			}, DELETE_MSG, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST: //消息查询成功
				//更新未读消息数
				if(start == 0){
					setUnReadCount(data.data);
					mui.fire(plus.webview.getWebviewById("main"), "onUnreadCountChange", {});
				}
				//更新数据
				vueObj.datas = (start == 0 ? data.rows : vueObj.datas.concat(data.rows));
				start = vueObj.datas.length;
				vueObj.dataChangeJudge();
				closePullStatus(data.rows);
				break;
			case DELETE_MSG: //消息删除成功
				var messageObj = vueObj.datas[vueObj.deleteMsgIndex];
				//未读消息设置 刷新相关页
				if(messageObj.hasRead == 1){
					var count = parseInt(getUnReadCount());
					setUnReadCount(count - 1);
					mui.fire(plus.webview.getWebviewById("main"), "onUnreadCountChange",{});
					mui.fire(plus.webview.getWebviewById("message/message_main.html"), "onUnreadCountChange",{});
				}
				//更新数据
				vueObj.datas.splice(vueObj.deleteMsgIndex, 1);
				vueObj.dataChangeJudge();
				closePullStatus();
				if(vueObj.datas && vueObj.datas.length >= 7) return;
				start = 0;
				vueObj.loadData();
				break;
			case UPDATE_READED: //更新为已读成功
				//刷新相关页
				var count = parseInt(getUnReadCount());
				setUnReadCount(count - 1);
				mui.fire(plus.webview.getWebviewById("main"), "onUnreadCountChange",{});
				mui.fire(plus.webview.getWebviewById("message/message_main.html"), "onUnreadCountChange",{});
				break;
			case BATCH_UPDATE_READED: //批量已读成功
				for(var i in vueObj.datas){
					vueObj.datas[i].hasRead = 0;
					Vue.set(vueObj.datas, i, vueObj.datas[i]);
				}
				mui.fire(plus.webview.getWebviewById("message/message_main.html"), "onMsgContentChange", {});
				break;
			case BATCH_DELETE_MSG: //清空全部消息成功
				vueObj.datas = [];
				vueObj.dataChangeJudge();
				mui.fire(plus.webview.getWebviewById("message/message_main.html"), "onMsgContentChange", {});
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
			if(start == 0){
				document.getElementById("item0mobileSpan").style.display = "none";
			}
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			//无数据图
			if(vueObj.datas.length == 0) {
				setNoDataBackground(true);
			} else {
				setNoDataBackground(false);
			}
			if(vueObj.datas.length < 7) {
				document.getElementById("item0mobileSpan").style.display = "none";
			} else {
				document.getElementById("item0mobileSpan").style.display = "";
			}
		},
		/**
		 * 详情点击
		 */
		onItemClick: function(e) {
			var detailId = e.currentTarget.parentNode.dataset.detailid;
			var messageType = e.currentTarget.parentNode.dataset.messagetype;
			var messageBusType = e.currentTarget.parentNode.dataset.messageBusType;
			var clickIndex = e.currentTarget.parentNode.dataset.index;
			var logo = e.currentTarget.parentNode.dataset.logo;
			var msgObj = vueObj.datas[clickIndex];
			if(messageBusType == 1 && msgObj.contentExt){ //支付类
				var params = {
					tranNo: JSON.parse(msgObj.contentExt).tranNo,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				};
				openWindow("orderDetail", "../common/order_detail.html", false, params);
			} else if(messageBusType == 3 && msgObj.contentExt){ //充值提现类消息
				openWindow("messageDetail", "message_detail.html", false, {
					logo:logo,
					detailId: detailId,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
			} else if(messageType == 2){ //外链跳转类
				var linkUrl = msgObj.linkUrl;
				openWindow(linkUrl, "../common/web_page.html", false, {
					webUrl: linkUrl,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
			} else if(messageType == 3){//内链跳转类
				var linkUrl = msgObj.linkUrl;
				openWindow(linkUrl, linkUrl, false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
			} else{ //系统类和个人类
				openWindow("messageDetail", "message_detail.html", false, {
					logo:logo,
					detailId: detailId,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
			}
			//处理未读消息
			vueObj.handUnReadMsg(clickIndex);
		},
		/**
		 * 列表删除按钮点击
		 */
		onItemDeleteClick: function(e) {
			var li = e.currentTarget.parentNode;
			var detailId = li.dataset.detailid;
			vueObj.deleteMsgIndex = li.dataset.index;
			confirmDialog("", "确认删除该条消息?", "确认", "取消", function sureCallback(){
				vueObj.deleteMsg(detailId);
			});
		},
		/**
		 * 处理未读消息为已读
		 */
		handUnReadMsg: function(clickIndex) {
			var msgObj = vueObj.datas[clickIndex];
			if(msgObj == null || msgObj.hasRead != 1) return;
			webCall2("/compus/user/message/readById", {
				messageId: msgObj.id
			}, UPDATE_READED, vueObj.onSuccess, vueObj.onErrorBefore);
			//更改列表状态
			var messageObj = vueObj.datas[clickIndex];
			messageObj.hasRead = 0;
			Vue.set(vueObj.datas, clickIndex, messageObj);
		},
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore = false;
			setTimeout(function() {
				start = 0;
				vueObj.loadData();
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
	
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		if(data.length < 10) {
			document.getElementById("item0mobileSpan").innerHTML = "没有更多数据了";
			isNoMore = true;
		} else {
			document.getElementById("item0mobileSpan").innerHTML = "正在加载...";
			isNoMore = false;
		}
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}

// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
		//无数据时不显示上拉显示更多
		document.getElementById("item0mobileSpan").style.display = "none";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
		document.getElementById("item0mobileSpan").style.display = "";
	}
}
/*
 * 点击屏幕任何区域 关闭左滑删除的按钮
 */
document.addEventListener('tap', function() {
	if(!document.querySelector('.mui-selected')) return; 
	document.querySelector('.mui-selected').children[0].children[0].setAttribute('style', 'transform: translate(0px, 0px);')
	document.querySelector('.mui-selected').children[1].setAttribute('style', 'transform: translate(0px, 0px);')
});

//监听标题更多按钮
document.getElementById("moreBtn").addEventListener("tap", function(e){
	var buttons = [{id:'0', title:'批量设为已读'}, {id:'1', title:'清空全部消息'}];
	if(vueObj.redDotStatus == 3){
		buttons = [{id:'0', title:'批量设为已读'}];
	}
	plus.nativeUI.actionSheet({
		cancel: "取消",
		buttons: buttons
	}, function(e){
		if(e.index <= 0 || vueObj.datas.length <= 0) return;
		if(e.index == 1){ //设置消息为已读
			showWaiting();
			webCall2("/compus/user/message/readByReceive", {
				messageCode: vueObj.messageCode
			}, BATCH_UPDATE_READED, vueObj.onSuccess, vueObj.onErrorBefore);
		}else if(e.index == 2){ //清空全部消息
			confirmDialog("", "确定要清空全部消息吗？", "确定", "取消", function(){
				showWaiting();
				webCall2("/compus/user/message/deleteMessageByReceive", {
					messageCode: vueObj.messageCode
				}, BATCH_DELETE_MSG, vueObj.onSuccess, vueObj.onErrorBefore);
			});
		}
	});
});