//请求码
var QUERY_LIST = 1001, DELETE_MSG = 1002, UPDATE_READED = 1003;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		datas: [],
		clickIndex: 0,//点击消息的下标
		showMorePop: false, //是否显示更多弹窗
		identityType: -1, //默认身份类型 1家长 2老师 
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(plus.os.name == 'Android'){
					mui.fire(plus.webview.getWebviewById("main"), "mainBack", {});
				}
				return false;
			}
		});
		mui.plusReady(function(){
			vueObj.handleStatusBar();
			//监听未读消息数目变化
			window.addEventListener("onUnreadCountChange", function(event){
				var messageObj = vueObj.datas[vueObj.clickIndex];
				messageObj.unreadCount = messageObj.unreadCount > 0 ? messageObj.unreadCount - 1 : 0 ;
				Vue.set(vueObj.datas, vueObj.clickIndex, messageObj);
			});
			//身份变化
			window.addEventListener("onIdentityChange", function(event){
				vueObj.identityType = getUserInfo().identityType;
			});
			//关闭更多弹框
			window.addEventListener("closeMsgMorePop", function(event){
				vueObj.showMorePop = false;
			});
			//好友红点关闭
			window.addEventListener("onContactDotChange", function(event){
				document.getElementById("contactDot").style.display = "none";
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.identityType = getUserInfo().identityType;
			//iOS 融云插件初始化
			initRYIMPlugin();
			//添加IM监听
			vueObj.addRongIMListener();
			vueObj.setContactDot();
		});
	},
	methods: {
		/**
		 * 第一次加载数据（main中tab切换调用）
		 */
		firstLoadData: function() {
			if(vueObj.datas.length == 0){
				vueObj.loadData();
			}
		},
		/**
		 * 加载数据
		 */
		loadData: function() {
			if(plus.os.name == 'iOS'){
				showWaiting();
				//消息列表监听
				iOSGetChatListData(function(result){
					closeWaiting();
					vueObj.datas = result;
//					Vue.set(vueObj, "datas", result);
					vueObj.dataChangeJudge();
				});
			}else{
				//回调实现
				var callback = plus.android.implements("cn.rongcloud.im.callback.ConversationListCallback", {
					"onResult": function(loadSuccess, result) {
						console.error("getConversationList: " + loadSuccess)
						console.error("getConversationList: " + result)
						if(loadSuccess) {
							vueObj.datas = JSON.parse(result);
						}
						vueObj.dataChangeJudge();
					}
				});
				//调用
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().getConversationList(callback);
			}
		},
		/**
		 * 设置新好友红点状态
		 */
		setContactDot: function(hasNewFriendMsg) {
			if(plus.os.name == "iOS"){
				if(hasNewFriendMsg == "yes") {
					document.getElementById("contactDot").style.display = "block";
				} else{
					document.getElementById("contactDot").style.display = "none";
                }
				
			} else {
				if(getCache("hasNewFriendMsg") == 'yes'){
					document.getElementById("contactDot").style.display = "block";
				}else{
					document.getElementById("contactDot").style.display = "none";
				}
			}
			if(plus.webview.getWebviewById("addressBook") && document.getElementById("contactDot").style.display == "block"){ //通知通讯录界面 刷新好友请求红点
				mui.fire(plus.webview.getWebviewById("addressBook"), "onFriendApplyChange", {
					hasNewFriendMsg: 'yes'
				});
			}
			if(plus.webview.getWebviewById("newFriend") && document.getElementById("contactDot").style.display == "block"){ //通知通讯录界面 刷新好友请求红点
				mui.fire(plus.webview.getWebviewById("newFriend"), "onFriendListUpdate", {});
			}
			
		},
		/**
		 * 添加IM监听
		 */
		addRongIMListener: function() {
			if(plus.os.name == 'iOS'){
				//未读消息数监听
				iOSGetUnreadNum(function(result){
					console.log("================onCountChanged: " + result)
					setUnReadCount(result);
					mui.fire(plus.webview.getWebviewById("main"), "onUnreadCountChange", {});
				});
				//好友请求监听
				iOSHasNewFriendMsg(function(result){
					vueObj.setContactDot(result);
				});
				//好友状态变化监听
				iOSOnFriendStatusChangeCallback(function(result){
					if(plus.webview.getWebviewById("newFriend")){
						mui.fire(plus.webview.getWebviewById("newFriend"), "onFriendListUpdate", {});
					}
				});
				//本地登出监听
				iOSLogoutCallback(function(result){
					if(result == "logout"){
						commonDoLogout();
					}
				});
			}else{
				//刷新监听回调
				var refreshCallback = plus.android.implements("cn.rongcloud.im.callback.ConversationListRefreshCallback", {
					"refreshContactsDotStatus": function() {
						console.log("================onNewFriendMsg")
						vueObj.setContactDot();
					},"onRefresh": function() {
						console.log("================onRefresh")
						vueObj.loadData();
					},
					"onRefreshItem": function(type, targetId, name, portraitUrl, userId){ //type 1私聊用户 3群信息 -1群用户信息
						console.log("================onRefreshUser")
						for(var i in vueObj.datas){
							var msg = vueObj.datas[i];
							if(msg.objectName != "RC:GrpNtf" && type == -1 && msg.conversationType == 3 && targetId == msg.targetId && userId == msg.senderUserId && userId != getCache(USER_ID_KEY) && name != null){
								if(msg.content.indexOf(name) < 0) msg.content = name + "：" + msg.content;
								continue;
							}
							if(type != msg.conversationType) continue;
							if(msg.conversationType == 1 && ((msg.direction==1 && targetId == msg.targetId) || (msg.direction==2 && targetId == msg.senderUserId))
								|| msg.conversationType == 3 && msg.targetId == targetId){
								Vue.set(msg, "showName", name);
								Vue.set(msg, "portraitUrl", portraitUrl);
								if(type == 3) break;
							}
						}
					}
				});
				//未读消息数监听
				var unReadObserver = plus.android.implements("io.rong.imkit.manager.IUnReadMessageObserver", {
					"onCountChanged": function(unReadNum) {
						console.log("================onCountChanged: " + unReadNum)
						setUnReadCount(unReadNum);
						mui.fire(plus.webview.getWebviewById("main"), "onUnreadCountChange", {});
						vueObj.loadData();
					}
				});
				//IM本地接口调用登出
				var logoutCallback = plus.android.implements("cn.rongcloud.im.callback.RongLogoutCallback", {
					"onLogout": function() {
						console.log("================rong local Logout")
						commonDoLogout();
					}
				});
				//调用
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().addRongIMListeners(unReadObserver, refreshCallback, logoutCallback);
			}
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST: //消息查询成功
				//更新未读消息数
				setUnReadCount(data.data);
				mui.fire(plus.webview.getWebviewById("main"), "onUnreadCountChange", {});
				//更新数据
				vueObj.datas = data.rows;
				vueObj.dataChangeJudge();
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			//onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			//无数据图
			if(vueObj.datas.length == 0) {
				setNoDataBackground(true);
			} else {
				setNoDataBackground(false);
			}
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			vueObj.clickIndex = e.currentTarget.dataset.index;
			var targetId = vueObj.datas[vueObj.clickIndex].targetId;
			var type = vueObj.datas[vueObj.clickIndex].conversationType;
			var title = vueObj.datas[vueObj.clickIndex].showName;
			//未读消息数置为0
			vueObj.datas[vueObj.clickIndex].unreadMessageCount = 0;
			//打开聊天界面
			if(plus.os.name == 'iOS'){
				iOSOpenChatView(type, targetId, title);
			}else{ 
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().startConversation(plus.android.runtimeMainActivity(), type, targetId, title);
			}
			//@消息
			if(vueObj.datas[vueObj.clickIndex].hasUnreadMentioned == 'true'){
				vueObj.datas[vueObj.clickIndex].hasUnreadMentioned = null;
			}
		},
		/*
		 * 删除聊天列表
		 */
		onItemDeleteClick: function(index){
			var item = vueObj.datas[index];
			confirmDialog('', '确认删除该会话？', '确认', '取消', function sureCallback(){
				if(plus.os.name == "iOS"){
					iOSDeleteChatLsitCallback(item.targetId, item.conversationType,function(result){
						if(result == 0){ //删除成功
							vueObj.datas.splice(index, 1);
						} else {
							toast("删除失败, 请重试");
						}
					});
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().deleteConversation(item.targetId, item.conversationType, plus.android.implements("cn.rongcloud.im.callback.ConversationListCallback", {
						"onResult": function(delSuccess, result) {
							if(delSuccess) {
								vueObj.datas.splice(index, 1);
							} else {
								toast("删除失败, 请重试");
							}
						}
					}));
				}
			});
		},
		/**
		 * 获取格式化的时间
		 * @param {Object} timeMillis
		 */
		getDateShow: function(timeMillis){
			return formatDateShow(timeMillis);
		},
		/**
		 * 按钮点击监听
		 */
		onButtonClick: function(e) {
			vueObj.showMorePop = false;
			switch (e.currentTarget.dataset.type){
			case 'work': //发布作业
				toast("开通中");
				break;
			case 'group': //发起群聊
				openWindow("selectPerson", "../message/select_person.html", false, {
					type:"3",
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case 'friend': //添加好友
				openWindow("newFriendAdd", "../message/new_friend_add.html", false, {
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				break;
			case 'scan': //扫一扫
				openWindow("scan", "../scan/scan.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
				break;
			default:
				break;
			}
		},
		/*
		 * 搜索框点击
		 */
		onSearchInputClick: function(e){
			openWindow("messageSearch", "../message/message_search.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
		},
		handleStatusBar: function() {
			var immersed = 0;
			var ms = (/Html5Plus\/.+\s\(.*(Immersed\/(\d+\.?\d*).*)\)/gi).exec(navigator.userAgent);
			if(ms && ms.length >= 3) {
				immersed = parseFloat(ms[2]);
			}
			if(!immersed) {
				return;
			}
			document.getElementById("morePop").style.top = 44 + immersed + 'px';
		}
	}
});
// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
	}
}
/*
 * 点击屏幕任何区域 关闭左滑删除的按钮
 */
document.addEventListener('tap', function() {
	if(!document.querySelector('.mui-selected')) return; 
	document.querySelector('.mui-selected').children[0].children[0].setAttribute('style', 'transform: translate(0px, 0px);')
	document.querySelector('.mui-selected').children[1].setAttribute('style', 'transform: translate(0px, 0px);')
});
//通讯录
document.getElementById("contactBtn").addEventListener("tap", function(){
	openWindow("addressBook", "../message/address_book.html", false, {
		hasNewFriendMsg: document.getElementById("contactDot").style.display == "block" ? 'yes' : "no",  
		statusBarType: STATUS_BAR_DEFAULT_KEY
	}, false, true);
});
//+点击
document.getElementById("addBtn").addEventListener("tap", function(e){
	vueObj.showMorePop = !vueObj.showMorePop;
	 e.stopPropagation();  
});
//header点击 小弹框消失
document.getElementById("header").addEventListener("tap", function(){
	vueObj.showMorePop = false;
});
/*
 * 点击屏幕任何区域 关闭左滑删除的按钮
 */
document.addEventListener('tap', function() {
	if(!document.querySelector('.mui-selected')) return; 
	document.querySelector('.mui-selected').children[0].children[0].setAttribute('style', 'transform: translate(0px, 0px);')
	document.querySelector('.mui-selected').children[1].setAttribute('style', 'transform: translate(0px, 0px);')
});