var myScroll;
//请求码
var QUERY_LIST = 1001, DELETE_MSG = 1002, UPDATE_READED = 1003, QUERY_ADS = 1004;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		bannerLength: 0,
		bannerRows: [], // 广告列表数据
		datas: [],
		clickMsgIndex: 0,//点击消息的下标
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(plus.os.name == 'Android'){
					mui.fire(plus.webview.getWebviewById("main"), "mainBack", {});
				}
				return false;
			}
		});
		mui.plusReady(function(){
			//监听未读消息数目变化
			window.addEventListener("onUnreadCountChange", function(event){
				var messageObj = vueObj.datas[vueObj.clickMsgIndex];
				messageObj.unreadCount = messageObj.unreadCount > 0 ? messageObj.unreadCount - 1 : 0 ;
				Vue.set(vueObj.datas, vueObj.clickMsgIndex, messageObj);
			});
			//监听消息内容变化
			window.addEventListener("onMsgContentChange", function(event){
				vueObj.loadData();
			});
		});
	},
	methods: {
		/**
		 * 第一次加载数据（main中tab切换调用）
		 */
		firstLoadData: function() {
			if(vueObj.datas.length == 0){
				vueObj.loadData();
			}
			if(vueObj.bannerLength <= 0){
				vueObj.loadBannerData();
			}
		},
		/**
		 * 加载数据
		 */
		loadData: function() {
			webCall2("/compus/user/message/findGroupPageWithMsgCount", {
				offset: 0,
				limit: 1000
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
		},
		/**
		 * 加载广告数据
		 */
		loadBannerData: function() {
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:1015}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore, null, null, null, null, true);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST: //消息查询成功
				//更新未读消息数
				setUnReadCount(data.data);
				mui.fire(plus.webview.getWebviewById("main"), "onUnreadCountChange", {});
				//更新数据
				vueObj.datas = data.rows;
				vueObj.dataChangeJudge();
				closePullStatus();
				break;
			case QUERY_ADS: //更新为已读成功
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			//onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			//无数据图
			if(vueObj.datas.length == 0) {
				setNoDataBackground(true);
			} else {
				setNoDataBackground(false);
			}
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			vueObj.clickMsgIndex = e.currentTarget.dataset.index;
			var msgObj = vueObj.datas[vueObj.clickMsgIndex];
			openWindow("messageList", 'message_list.html', false, {
				"messageCode": msgObj.messageCode,
				"messageName": msgObj.messageName,
				"showStatus": msgObj.showStatus,
				"redDotStatus": msgObj.redDotStatus,
				"logo": msgObj.logo,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			}, null, false);
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "消息中心页", "pos": "消息中心页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && getUserInfo().bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore = false;
			setTimeout(function() {
				start = 0;
				vueObj.loadData();
				vueObj.loadBannerData();
			}, 300);
		};
		var pullLoadMoreAction = function() {};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus() {
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}

// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
	}
}
/*
 * 点击屏幕任何区域 关闭左滑删除的按钮
 */
document.addEventListener('tap', function() {
	if(!document.querySelector('.mui-selected')) return; 
	document.querySelector('.mui-selected').children[0].children[0].setAttribute('style', 'transform: translate(0px, 0px);')
	document.querySelector('.mui-selected').children[1].setAttribute('style', 'transform: translate(0px, 0px);')
});