/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		searchFriendList:[],//搜索好友的数据
		searchGroupList:[],//搜索群的数据
		searchChatList:[],//搜索聊天的数据
		searchValue:"",//搜索内容
		orgSearchValue:"",//搜索的内容
		isShowSearchItem:true,//是否显示搜索的item
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/default_user_icon.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				document.activeElement.blur();
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			/**进入页面弹出键盘*/
		    initNativeObjects();
		    showSoftInput();
			initChatSingleDetailPlugin();
		});
	},
	methods: {
		/*
		 * 搜索
		 */
		searchChatData: function(keyword){
			vueObj.isShowSearchItem = false;
			//隐藏软键盘
			document.activeElement.blur();
			if(!keyword || keyword.length <= 0){
				vueObj.searchFriendList = [];
				vueObj.searchGroupList = [];
				vueObj.searchChatList = [];
				vueObj.dataChangeJudge();
				return;
			}
			if(keyword == vueObj.orgSearchValue){//和上次搜索的一样
				return;
			}
			vueObj.orgSearchValue = keyword;
			if(plus.os.name == "iOS"){
				iOSMessageSearchContent(keyword, function(result){
					vueObj.searchFriendList = result.friendList ? result.friendList : [];
					vueObj.searchGroupList = result.groupList ? result.groupList : [];
					vueObj.searchChatList = result.chatList ? result.chatList : [];
					vueObj.dataChangeJudge();
				});
			} else {
				//调用
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().searchHome(keyword, plus.android.implements("cn.rongcloud.im.callback.SearchCallback", {
					"onFriendResult": function(result) {
						vueObj.searchFriendList = result ? JSON.parse(result) : [];
						vueObj.dataChangeJudge();
					},
					"onGroupResult": function(result) {
						vueObj.searchGroupList = result ? JSON.parse(result) : [];
						vueObj.dataChangeJudge();
					},
					"onChatResult": function(result) {
						vueObj.searchChatList = result ? JSON.parse(result) : [];
						vueObj.dataChangeJudge();
					}
				}));
			}
		},
		//搜索item点击
		onSearchItemClick: function(){
			vueObj.searchChatData(vueObj.searchValue);
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			var index = e.currentTarget.dataset.index;
			var item = {};
			switch (e.currentTarget.dataset.type){
				case "friend":
					item = vueObj.searchFriendList[index];
					break;
				case "group":
					item = vueObj.searchGroupList[index];
					break;
				case "chat":
					item = vueObj.searchChatList[index];
					if(item.count > 1){
						openWindow("messageSearchMore", "../message/message_search_more.html", false, {
							type:"3",
							searchValue:vueObj.orgSearchValue,
							result: JSON.stringify(item),
							statusBarType: STATUS_BAR_DEFAULT_KEY
						}, null, true);
						return;	
					}
					break;	
				default:
					break;
			}
			if(!item.targetId)return;
			if(plus.os.name == "iOS"){
				plus.ios.invoke("RYImTool", "startConversation:withTargetId:title:time:", item.conversationType.toString(), item.targetId, item.name, item.time ? item.time.toString() : "");
			} else{
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().startConversation(plus.android.runtimeMainActivity(), parseInt(item.conversationType), item.targetId, item.name);
			}
		},
		onMoreBtnClick:function(e){
			var resultArray = [];
			var type = "0";
			switch (e.currentTarget.dataset.type){
				case "friend":
					type = "0";
					resultArray = vueObj.searchFriendList;
					break;
				case "group":
					type = "1";
					resultArray = vueObj.searchGroupList;
					break;
				case "chat":
					type = "2";
					resultArray = vueObj.searchChatList;
					break;	
				default:
					break;
			}
			openWindow("messageSearchMore", "../message/message_search_more.html", false, {
				type: type,
				searchValue:vueObj.orgSearchValue,
				resultList: JSON.stringify(resultArray),
				statusBarType: STATUS_BAR_DEFAULT_KEY
			}, null, true);
		},
		/**
		 * 搜索框变化
		 */
		onInputChange:function(e){
			vueObj.isShowSearchItem = true;
		},
		/**
		 * 获取格式化的时间
		 * @param {Object} timeMillis
		 */
		getDateShow: function(timeMillis){
			return formatDateShow(timeMillis);
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			//无数据图
			if((vueObj.searchFriendList.length + vueObj.searchGroupList.length + vueObj.searchChatList.length)== 0) {
				setNoDataBackground(true);
			} else {
				setNoDataBackground(false);
			}
		},
	}
});
// 监听搜索输入框的键盘事件
document.getElementById("searchInput").addEventListener("keydown", function(e) {
	// 键盘 return 事件
	if(13 == e.keyCode) {
		vueObj.searchChatData(vueObj.searchValue);
	}
}, false);
/**
 * 用户触摸列表界面，主动移除输入框焦点
 */
document.addEventListener("touchstart", function(e) {
	if(document.getElementById("searchInput") == e.target || (document.getElementsByClassName("mui-icon-clear") && document.getElementsByClassName("mui-icon-clear")[0] == e.target)){
		return;
	}
	document.activeElement.blur();
}); 
/*
 * 搜索框清除按钮点击
 */
mui('.mui-search').on('tap', '.mui-icon-clear', function(e) {
	vueObj.searchValue = "";
}, false);
// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		//页面有输入框 会把无数据背景图顶下来
		if(plus.os.name == "iOS") return;
 		document.getElementById("main").style.backgroundPosition = "center";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
	}
}

/**进入页面弹出键盘*/
var initNativeObjects = function() {
    if (mui.os.android) {
        /*var main = plus.android.runtimeMainActivity();
        var Context = plus.android.importClass("android.content.Context");
        InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
        imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);*/
    } else {
        nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    }
};
var showSoftInput = function() {
    var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    if (mui.os.android) {
        //强制当前webview获得焦点
        /*plus.android.importClass(nativeWebview);
        nativeWebview.requestFocus();
        imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);*/
    } else {
        nativeWebview.plusCallMethod({
            "setKeyboardDisplayRequiresUserAction": false
        });
    }
    setTimeout(function() {
       //此处可写具体逻辑设置获取焦点的input
       document.getElementById("searchInput").focus();
    }, 300);
};