/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		type:"", //0好友 1群聊 2聊天记录 3单个聊天的内容
		result:{},//多条聊天记录
		resultList:[],//搜索好友的数据
		searchValue:"",//搜索内容
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/default_user_icon.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.type = comGetPageParam("type");
			vueObj.searchValue = comGetPageParam("searchValue");
			if(vueObj.type == 3){ //搜索
				vueObj.result = comGetPageParam("result");
				initChatSingleDetailPlugin();
				vueObj.searchChatData(vueObj.searchValue);
				return;
			}
			vueObj.resultList = JSON.parse(comGetPageParam("resultList"));
		});
	},
	methods: {
		/*
		 * 搜索
		 */
		searchChatData: function(keyword){
			if(!keyword || keyword.length <= 0){
				return;
			}
			if(plus.os.name == "iOS"){
				iOSSearchChatContent(vueObj.result.targetId, keyword, vueObj.result.conversationType.toString(), function(result){
					vueObj.resultList = result;
				});
			} else {
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().setChatRefreshCallback(plus.android.implements("cn.rongcloud.im.callback.ConversationRefreshCallback", {
					"onRefreshItem": function(userId, name, portraitUrl) {
						if(!vueObj.resultList || vueObj.resultList.length < 1) return;
						for(var i in vueObj.resultList){
							if(vueObj.resultList[i].userId == userId){
								Vue.set(vueObj.resultList[i], "name", name);
								Vue.set(vueObj.resultList[i], "portraitUrl", portraitUrl);
							}
						}
					}
				}));
				SealAppContext.getInstance().searchChatMessage(vueObj.result.targetId, parseInt(vueObj.result.conversationType), keyword, plus.android.implements("cn.rongcloud.im.callback.MessageCallback", {
					"onResult": function(loadSuccess, jsonList) {
						if(loadSuccess){
							vueObj.resultList = JSON.parse(jsonList);
						}
					}
				}));
			}
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			var index = e.currentTarget.dataset.index;
			var item = vueObj.resultList[index];
			switch (e.currentTarget.dataset.type){
				case "friend":
					break;
				case "group":
					break;
				case "chat":
					if(item.count > 1){
						openWindow("messageSearchMoreNew", "../message/message_search_more.html", false, {
							type:"3",
							searchValue:vueObj.searchValue,
							result: JSON.stringify(item),
							statusBarType: STATUS_BAR_DEFAULT_KEY
						}, null, true);
						return;	
					} 
					break;	
				case "detail":
					item.name = vueObj.result.name;
					item.targetId = vueObj.result.targetId;
					item.conversationType = vueObj.result.conversationType;
					break;	
				default:
					break;
			}
			if(!item.targetId)return;
			if(plus.os.name == "iOS"){
				plus.ios.invoke("RYImTool", "startConversation:withTargetId:title:time:", item.conversationType.toString(), item.targetId, item.name, item.time ? item.time.toString() : "");
			} else{
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().startConversation(plus.android.runtimeMainActivity(), parseInt(item.conversationType), item.targetId, item.name);
			}
		},
		/**
		 * 获取格式化的时间
		 * @param {Object} timeMillis
		 */
		getDateShow: function(timeMillis){
			return formatDateShow(timeMillis);
		},
	}
});