//请求码
var SEARCH_USER_INFO = 1001;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		friendsData:[],//列表数据
		selectIndex:null,//选择的下标
		searchValue:"",//搜索内容
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			
		});
	},
	methods: {
		/*
		 * 搜索用户
		 */
		searchUser: function(value){
			//隐藏软键盘
			document.activeElement.blur();
			if(!value || value <= 0){ //手机号为空
				return;
			} else if(!regexMobile(value)){//验证手机号
				toast("请输入正确的手机号码");
				return;
			}
			showWaiting();
			webCall2("/im/user/queryUser", {
				mobilePhone: value
			}, SEARCH_USER_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case SEARCH_USER_INFO://搜索用户
				if(!data.data || !data.data.id){
					toast("该用户不存在");
					return;
				}
				openWindow("personDetail", "../message/person_detail.html", false, {
					type:"1",
					userId: data.data.id,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, true);
				vueObj.searchValue = "";
				//必须重置className 否则输入框上面的icon回不去
				document.getElementById("searchDiv").className = "mui-input-row mui-search";
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		//搜索item点击
		onSearchItemClick: function(){
			vueObj.searchUser(vueObj.searchValue);
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e) {
			switch (e.currentTarget.dataset.type){
				case "code"://二维码
					openWindow("personCode", "../message/person_code.html", false, null);
					break;
				case "scan": //扫一扫
					openWindow("scan", "../scan/scan.html", false, {statusBarType: STATUS_BAR_DEFAULT_KEY});
					break;
				case "address": //手机联系人
					if(!checkUserPermission("CONTACTS", null, function(){
						if(plus.os.name == 'Android'){
							selectContactFromAndroid();
						}else{
							selectContactFromIOS();
						}
					})){ //权限判断
						return;
					}
					if(plus.os.name == 'Android'){
						selectContactFromAndroid();
					}else{
						selectContactFromIOS();
					}
					break;	
				default:
					break;
			}
			
		},
		/**
		 * 处理通讯录选择返回的号码 
		 */
		handleSelectResult: function(result) {
			if(!result) return;
			var numbers = result.split(",");
			if(numbers.length < 2){
				//去除空格
				var phone = numbers[0].replace(/\s/g,"");
				if(!regexMobile(phone)){
					toast("手机号码格式不正确");
					return;
				}
				vueObj.searchUser(phone);
				return;
			}
			var buttons = [];
			for(var i in numbers){
				buttons[i] = {id:i, title:numbers[i]};
			}
			plus.nativeUI.actionSheet({
				title: "请选择手机号码",
				cancel: "取消",
				buttons: buttons
			}, function(e){
				if(e.index > 0){
					var phone = buttons[e.index - 1].title.replace(/\s/g,"");
					if(!regexMobile(phone)){
						toast("手机号码格式不正确");
						return;
					}
					vueObj.searchUser(phone);
				}
			});
		},
	}
});
// 监听搜索输入框的键盘事件
document.getElementById("searchInput").addEventListener("keydown", function(e) {
	// 键盘 return 事件
	if(13 == e.keyCode) {
		vueObj.searchUser(vueObj.searchValue);
	}
}, false);
/**
 * 用户触摸列表界面，主动移除输入框焦点
 */
document.addEventListener("touchstart", function(e) {
	if(document.getElementById("searchInput") == e.target || (document.getElementsByClassName("mui-icon-clear") && document.getElementsByClassName("mui-icon-clear")[0] == e.target)){
		return;
	}
	document.activeElement.blur();
}); 
/*
 * 搜索框清除按钮点击
 */
mui('.mui-search').on('tap', '.mui-icon-clear', function(e) {
	vueObj.searchValue = "";
}, false);

/**
 * iOS通讯录选择
 */
function selectContactFromIOS() {
	var NativeJsTool = plus.ios.importClass("NativeJsTool");
    var nativeJsTool = plus.ios.newObject("NativeJsTool");
    function getPhoneNumber(e) {
    		var phoneNumber = plus.ios.invoke(nativeJsTool, "getAddressPhone");
      	//返回处理手机号
	    vueObj.handleSelectResult(phoneNumber);
    }
    var delegate = plus.ios.implements("NativeJsToolDelegate", {"getAddressPhoneNumber:": getPhoneNumber});
    nativeJsTool.plusSetAttribute("delegate", delegate);
    plus.ios.invoke(nativeJsTool, "openAddressBookVc");
}

/**
 * android通讯录选择
 */
function selectContactFromAndroid() {
	var REQUESTCODE = 1000;
	main = plus.android.runtimeMainActivity();
	var Intent = plus.android.importClass('android.content.Intent');
	var ContactsContract = plus.android.importClass('android.provider.ContactsContract');
	var intent = new Intent(Intent.ACTION_PICK, ContactsContract.Contacts.CONTENT_URI);
	main.onActivityResult = function(requestCode, resultCode, data) { 
	  if (REQUESTCODE == requestCode) {
	    var phoneNumber = null;
	    var resultString = "";
	    var context = main;
	    plus.android.importClass(data);
	    var contactData = data.getData();
	    var resolver = context.getContentResolver();
	    plus.android.importClass(resolver);
	    var cursor = resolver.query(contactData, null, null, null, null);
	    plus.android.importClass(cursor);
	    cursor.moveToFirst();
	    var s_ret;
	    var givenName = cursor.getString(cursor.getColumnIndex(ContactsContract.Contacts.DISPLAY_NAME));
	    //s_ret = givenName;
	    var contactId = cursor.getString(cursor.getColumnIndex(ContactsContract.Contacts._ID));
	    var pCursor = resolver.query(ContactsContract.CommonDataKinds.Phone.CONTENT_URI,
	     	null, ContactsContract.CommonDataKinds.Phone.CONTACT_ID + " = " + contactId,
	     	null, null);
	    var i = 0;
	    while (pCursor.moveToNext()) {
	    	phoneNumber =   pCursor.getString( pCursor.getColumnIndex(ContactsContract.CommonDataKinds.Phone.NUMBER));
	     	if(i == 0){
	     		s_ret = phoneNumber;
	     	}else{
	     		s_ret += ',' + phoneNumber;
	     	}
	     	i++;
	    }
	    cursor.close();
	    pCursor.close();
	    //返回处理手机号
	    vueObj.handleSelectResult(s_ret);
	  }
	};
	main.startActivityForResult(intent, REQUESTCODE);
}