//请求码
var QUERY_USER_INFO = 1001, QUERY_FRIEND_INFO = 1002, QUERY_USER_INENTITY = 1003;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		type:"1", //类型 1好友详情 2老师详情 3家长详情
		isFriend:false, //是否为好友
		isMyself:true, //是否为自己
		groupNickName:"",//群昵称
		userId:"",//用户id
		userInfo:{},//用户信息
		classId:"",//班级id
		className:"",//班级名称
		identityName:"",//老师或家长显示的姓名
		childrenList:[],//孩子列表
		classList:[],//任教班级列表
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听数据变化
			window.addEventListener("onFriendNameChange", function(event){
				Vue.set(vueObj.userInfo, "displayName", event.detail.displayName);
				if(plus.os.name == "iOS"){
					plus.ios.invoke("RYIMDataTool", "updateFriendInfo:", JSON.stringify(vueObj.userInfo));
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().refreshFriendInfo(JSON.stringify(vueObj.userInfo));
				}
			});
			//删除好友监听
			window.addEventListener("onDeleteFriend", function(event){
				vueObj.isFriend = false;
				document.getElementById("addBtn").style.display = "none";
			});
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.userId = comGetPageParam("userId");
			vueObj.type = comGetPageParam("type") ? comGetPageParam("type") : vueObj.type;
			vueObj.classId = comGetPageParam("classId");
			vueObj.className = comGetPageParam("className");
			vueObj.identityName = comGetPageParam("identityName");
			vueObj.groupNickName = comGetPageParam("groupNickName");
			//初始化Plugin
			initChatSingleDetailPlugin();
			//获取是否好友
			vueObj.loadIsFriend();
			//获取用户身份 
			vueObj.loadUserIdentity();
			vueObj.addPageEvent();
		});
	},
	methods: {
		/**
		 * 添加Android自定义事件 
		 */
		addPageEvent: function(){
			if(plus.os.name != 'Android') return;
			var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
			SealAppContext.getInstance().putFireEvent(plus.webview.currentWebview().id, plus.android.implements("cn.rongcloud.im.callback.PageFireCallback", {
				"onFire": function(eventName, detailStr) {
					mui.fire(plus.webview.currentWebview(), eventName, JSON.parse(detailStr));
				}
			}));
		},
		/*
		 * 判断用户是否为好友
		 */
		loadIsFriend: function(){
			if(vueObj.userId == getCache(USER_ID_KEY)){ //用户本人
				vueObj.isMyself = true;
				vueObj.isFriend = false;
				vueObj.loadData();
				return;
			} 
			vueObj.isMyself = false;
			if(plus.os.name == "iOS"){
				//获取好友信息
				iOSGetUserIsFriend(vueObj.userId.toString(), function(result){
					vueObj.isFriend = result == 0 ? true : false;
					vueObj.loadData();
				});
			} else {
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				vueObj.isFriend = SealAppContext.getInstance().isFriendsRelationship(vueObj.userId);
				vueObj.loadData();
			}
		},
		/*
		 * 获取用户身份
		 */
		loadUserIdentity: function(){
			if(vueObj.type != 2 && vueObj.type != 3) return;
			webCall2("/kt/user/getClassIdentityList", {
				userId:vueObj.userId,
				classId: vueObj.classId,
			}, QUERY_USER_INENTITY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 获取用户信息数据
		 */
		loadData: function(){
			if(vueObj.isFriend){
				document.getElementById("addBtn").style.display = "block";
				var params = {};
				params.ownerId = getCache(USER_ID_KEY);
				params.friendId = vueObj.userId;
				webCall2("/im/user/friend/findFriendByFriendId", params, QUERY_FRIEND_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
			} else {
				var params = {};
				params.userId = vueObj.userId;
				webCall2("/im/user/getById", params, QUERY_USER_INFO, vueObj.onSuccess, vueObj.onErrorBefore);
			}
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_USER_INFO://用户信息
				vueObj.userInfo = data.data;
				//手机号脱敏 就不刷新
				if(vueObj.isPhoneNumber(vueObj.userInfo.nickName)) {
					vueObj.userInfo.nickName = vueObj.groupNickName ? vueObj.groupNickName : vueObj.userInfo.nickName;
					return;
				}
				//通知群聊界面 刷新用户信息
				if(plus.webview.getWebviewById("chatGroupDetail")){ 
					mui.fire(plus.webview.getWebviewById("chatGroupDetail"), "onGroupMemberUpdate", {
						userId: vueObj.userId,
						name: vueObj.userInfo.nickName,
						headImg: vueObj.userInfo.headImg
					});
				}
				if(plus.os.name == "iOS"){
					plus.ios.invoke("RYIMDataTool", "updateUserInfo:", JSON.stringify(vueObj.userInfo));
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().refreshUsreInfo(JSON.stringify(vueObj.userInfo));
				}
				break;
			case QUERY_FRIEND_INFO://好友信息
				vueObj.userInfo = data.data;
				if(plus.webview.getWebviewById("addressBook")){ //通知通讯录界面 刷新用户信息
					mui.fire(plus.webview.getWebviewById("addressBook"), "onFriendInfoUpdate", {
						friendId: vueObj.userId,
						name: data.data.displayName ? data.data.displayName : data.data.nickName,
						portraitUri:  data.data.headImg
					});
				}
				//通知群聊界面 刷新用户信息
				if((data.data.displayName && data.data.displayName.length > 0) || !vueObj.isPhoneNumber(data.data.nickName)){ 
					mui.fire(plus.webview.getWebviewById("chatGroupDetail"), "onGroupMemberUpdate", {
						userId: vueObj.userId,
						name: data.data.displayName ? data.data.displayName : data.data.nickName,
						headImg: data.data.headImg
					});
				}
				if(plus.os.name == "iOS"){
					plus.ios.invoke("RYIMDataTool", "updateFriendInfo:", JSON.stringify(vueObj.userInfo));
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().refreshFriendInfo(JSON.stringify(vueObj.userInfo));
				}
				break;
			case QUERY_USER_INENTITY://查询用户身份
				vueObj.childrenList = data.data.studentInfoList ? data.data.studentInfoList : [];
				vueObj.classList = data.data.teacherInfoList ? data.data.teacherInfoList : [];
				break;	
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 设置备注
		 */
		onItemClick: function(e) {
			openWindow("personRemark", "../message/person_remark.html", false, {
				type:"1",
				friendId:vueObj.userId,
				displayName:vueObj.userInfo.displayName,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			}, null, true);
		},
		/*
		 * 按钮点击
		 */
		onBtnClick: function(){
			if(!vueObj.isFriend){//非好友
				openWindow("personRemark", "../message/person_remark.html", false, {
					friendId:vueObj.userId,
					type:"2",
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, true);
				return;
			}
			//打开聊天界面
			if(plus.os.name == "iOS"){
				plus.ios.invoke("RYImTool", "startConversation:withTargetId:title:", "1", vueObj.userId.toString(), vueObj.userInfo.displayName ? vueObj.userInfo.displayName : vueObj.userInfo.nickName);
			} else{
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().startConversation(plus.android.runtimeMainActivity(), 1, vueObj.userId+"", vueObj.userInfo.displayName ? vueObj.userInfo.displayName : vueObj.userInfo.nickName);
			}
		},
		/*
		 * 是否是手机号脱敏 
		 * 是就不进行数据刷新
		 */
		isPhoneNumber:function(phone){
			if(!phone){
				return true;
			}
			if(phone.length == 11 && phone.substr(0, 1) == "1" &&  phone.substr(3, 4) == "****"){
		        return true;
		    }
   			return false;
		},
	}
});
/*
 * 设置按钮点击
 */
document.getElementById("addBtn").addEventListener("tap", function(){
	document.activeElement.blur();
	openWindow("perosonDetailSetting", "../message/person_detail_setting.html", false, {
		friendId: vueObj.userId,
		displayName: vueObj.userInfo.displayName,
		statusBarType: STATUS_BAR_DEFAULT_KEY
	}, null, true);
});