//请求码
var QUERY_FRIEND_BLACK = 1001, ADD_FRIEND_BLACK = 1002, DELETE_FRIEND_BLACK = 1003, QUERY_DELETE_FRIEND = 1004;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		friendId:"",//好友id
		displayName:"",//好友备注
		isBlack: false, //是否已加入黑名单
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.friendId = comGetPageParam("friendId");
			vueObj.displayName = comGetPageParam("displayName");
			//初始化Plugin
			initChatSingleDetailPlugin();
			vueObj.loadFriendBlack();
		});
	},
	methods: {
		/*
		 * 获取好友黑名单
		 */
		loadFriendBlack: function(){
			showWaiting();
			webCall2("/im/user/blacklist/findByUserIdAndFriendId", {
				userId: getCache(USER_ID_KEY),
				friendId: vueObj.friendId,
			}, QUERY_FRIEND_BLACK, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 添加好友黑名单
		 */
		addFriendBlack: function(){
			showWaiting();
			webCall2("/im/user/blacklist/add", {
				userId: getCache(USER_ID_KEY),
				friendId: vueObj.friendId,
			}, ADD_FRIEND_BLACK, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 删除好友黑名单
		 */
		deleteFriendBlack: function(){
			showWaiting();
			webCall2("/im/user/blacklist/delete", {
				userId: getCache(USER_ID_KEY),
				friendId: vueObj.friendId,
			}, DELETE_FRIEND_BLACK, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 删除好友
		 */
		deleteFriend: function(){
			showWaiting();
			webCall2("/im/user/friend/deleteFriend", {
				ownerId: getCache(USER_ID_KEY),
				friendId: vueObj.friendId,
				joinStatus: "30",
			}, QUERY_DELETE_FRIEND, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_FRIEND_BLACK://黑名单信息
				if(vueObj.friendId == data.data.friendId){
					vueObj.isBlack = true;
				}
				break;
			case ADD_FRIEND_BLACK://添加黑名单
				if(plus.os.name == "iOS"){
					iOSAddFriendBlack(vueObj.friendId, function(){});
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().addToBlacklist(vueObj.friendId);
				}
				break;	
			case DELETE_FRIEND_BLACK://删除黑名单
				if(plus.os.name == "iOS"){
					iOSDeleteFriendBlack(vueObj.friendId, function(){});
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().removeFromBlacklist(vueObj.friendId);
				}
				break;	
			case QUERY_DELETE_FRIEND://删除好友
				toast("删除成功");
				excuteFireEvent("addressBook", "onDeleteFriend", {friendId: vueObj.friendId});
				excuteFireEvent("personDetail", "onDeleteFriend", {});
				if(plus.os.name == "iOS"){
					plus.ios.invoke("RYIMDataTool", "deleteFriend:", vueObj.friendId.toString());
				} else {
					var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
					SealAppContext.getInstance().deleteFriend(vueObj.friendId);
				}
				closeWebview(plus.webview.currentWebview().id);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
			if(resultCode == ADD_FRIEND_BLACK || resultCode == DELETE_FRIEND_BLACK){
				mui("#blackSwitch").switch().toggle();
			}
		},
		/**
		 * 
		 */
		onItemClick: function(e) {
			switch (e.currentTarget.dataset.type){
				case "remark"://设置备注
					openWindow("personRemark", "../message/person_remark.html", false, {
						type:"1",
						friendId: vueObj.friendId,
						displayName: vueObj.displayName,
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;
				case "black"://黑名单
					var isActive = document.getElementById("blackSwitch").classList.contains("mui-active");
					if(isActive){
						plus.nativeUI.actionSheet({
							title: "加入黑名单",
							cancel: "取消",
							buttons:  [{
								title: "确定"
							}]
						}, function(e){
							if(e.index == 1){ 
								vueObj.addFriendBlack();
							} else {
								mui("#blackSwitch").switch().toggle();
							}
						});
					} else {
						vueObj.deleteFriendBlack();
					}
					break;
				case "delete"://删除好友
					plus.nativeUI.actionSheet({
						title: "删除好友",
						cancel: "取消",
						buttons:  [{
							title: "确定"
						}]
					}, function(e){
						if(e.index == 1){
							vueObj.deleteFriend();
						}
					});
					break;	
				default:
					break;
			}
			
		}
	}
});
