//请求码
var EDIT_PERSON_REMARK = 1001, QUERY_ADD_FRIEND = 1002, EIDT_GROUP_DISPLAY_NAME = 1003;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		type:"1",// 1 好友备注 2添加好友申请 3群昵称
		displayName:"",//备注名称
		changeName:"",//修改后的名称
		friendId:"",//用户id
		groupId:"",//群id
		placeholderText:"添加备注名",//placeholder文案
		title:"设置备注",//标题
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.type = comGetPageParam("type");
			vueObj.friendId = comGetPageParam("friendId");
			vueObj.displayName = comGetPageParam("displayName");
			vueObj.groupId = comGetPageParam("groupId");
			if(vueObj.type == 2){//添加好友
				document.getElementById("title").innerHTML = "朋友验证";
				document.getElementById("saveBtn").innerHTML = "发送";
				vueObj.placeholderText = "请输入内容";
				vueObj.title = "你需要发送验证申请，等待对方通过";
			} else if(vueObj.type == 3){//群昵称
				document.getElementById("title").innerHTML = "我在本群的昵称";
				document.getElementById("saveBtn").innerHTML = "完成";
				vueObj.placeholderText = "请输入群昵称";
				vueObj.title = "设置群昵称";
			}
		});
	},
	methods: {
		/*
		 * 添加好友
		 */
		addFriend:function(value){
			if(!value || value.length <= 0){
				toast("内容不能为空");
				return;
			}
			showWaiting();
			var params = {};
			params.ownerId = getCache(USER_ID_KEY);
			params.friendId = vueObj.friendId;
			params.joinStatus = "10";
			params.joinMessage = value;
			webCall2("/im/user/friend/addFriendApply", params, QUERY_ADD_FRIEND, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 设置好友备注
		 */
		setFriendRemark: function(value){
			if(!value || value.length <= 0){
				toast("备注不能为空");
				return;
			}
			if(value == vueObj.displayName){
				closeWebview(plus.webview.currentWebview().id);
				return;
			}
			showWaiting();
			var params = {};
			params.ownerId = getCache(USER_ID_KEY);
			params.friendId = vueObj.friendId;
			params.displayName = value;
			vueObj.changeName = value;
			webCall2("/im/user/friend/update", params, EDIT_PERSON_REMARK, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 设置群昵称
		 */
		setGroupNickName: function(value){
			if(!value || value.length <= 0){
				toast("昵称不能为空");
				return;
			}
			if(value == vueObj.displayName){
				closeWebview(plus.webview.currentWebview().id);
				return;
			}
			showWaiting();
			var params = {};
			params.groupId = vueObj.groupId;
			params.displayName = value;
			params.userIds = getCache(USER_ID_KEY);
			vueObj.changeName = value;
			webCall2("/im/group/member/update", params, EIDT_GROUP_DISPLAY_NAME, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case EDIT_PERSON_REMARK://修改备注
				excuteFireEvent("personDetail", "onFriendNameChange", {displayName:vueObj.changeName});
				excuteFireEvent("addressBook", "onFriendNameChange", {friendId:vueObj.friendId,displayName:vueObj.changeName});
				excuteFireEvent("chatSingleDetail", "onFriendNameChange", {displayName:vueObj.changeName});
				excuteFireEvent("groupMemberList", "onGroupMemberDisplayNameChange", {userId:vueObj.friendId,displayName:vueObj.changeName});
				excuteFireEvent("chatGroupDetail", "onGroupMemberDisplayNameChange", {userId:vueObj.friendId,displayName:vueObj.changeName});
				closeWebview(plus.webview.currentWebview().id);
				break;
			case QUERY_ADD_FRIEND://添加好友
				toast("已发送好友邀请");
				excuteFireEvent("newFriend", "onFriendListUpdate", {});
				closeWebview(plus.webview.currentWebview().id);
				break;
			case EIDT_GROUP_DISPLAY_NAME://设置群昵称
				excuteFireEvent("chatGroupDetail", "onGroupMemberDisplayNameChange", {userId: getCache(USER_ID_KEY),displayName:vueObj.changeName});
				closeWebview(plus.webview.currentWebview().id);
				break;	
				
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
	}
});
/*
 * 保存按钮点击
 */
document.getElementById("saveBtn").addEventListener("tap", function(){
	document.activeElement.blur();
	var value = document.getElementById("editInput").value;
	if(vueObj.type == 2){//添加好友
		vueObj.addFriend(value);
	} else if(vueObj.type == 3) {
		vueObj.setGroupNickName(value);
	} else {
		vueObj.setFriendRemark(value);
	}
	
});
/**
 * 用户触摸列表界面，主动移除输入框焦点
 */
document.addEventListener("touchstart", function(e) {
	if(document.getElementById("editInput") == e.target || (document.getElementsByClassName("mui-icon-clear") && document.getElementsByClassName("mui-icon-clear")[0] == e.target)){
		return;
	}
	document.activeElement.blur();
}); 