//请求码
var GROUP_ADD_MEMBER = 1001, GROUP_DELETE_MEMBER = 1002, GROUP_ADMIN_CHANGE = 1003;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		type:"",//添加群成员1 删除群成员2 创建群3 转让群4
		groupId:"",//群id
		groupName:"",//群名称
		personData:[],//群成员列表数据
		selectId:"",//选择的id
	},
	updated: function() {
		//懒加载图片刷新
		var imgLazyloadApi = mui('#main').imageLazyload({
			autoDestroy: false,
			placeholder: '../../img/default_user_icon.png'
		});
		imgLazyloadApi.refresh(true);
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(comGetPageParam("statusBarType"));
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(comGetPageParam("statusBarType"));
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.type = comGetPageParam("type");
			vueObj.groupId = comGetPageParam("groupId");
			vueObj.groupName = comGetPageParam("groupName");
			if(vueObj.type == 4){
				document.getElementById("title").innerHTML = "选择新群主";
			}
			//加载数据
			initChatSingleDetailPlugin();
			vueObj.loadSelectPersonData();
		});
	},
	methods: {
		/*
		 * 获取要展示的数据
		 */
		loadSelectPersonData: function(){
			if(plus.os.name == "iOS"){
				showWaiting();
				iOSLoadSelectPersonData(vueObj.type, vueObj.groupId,function(result){
					closeWaiting();
					vueObj.personData = result;
					vueObj.dataChangeJudge();
				});
			} else{
				var SealAppContext = plus.android.importClass("cn.rongcloud.im.SealAppContext");
				SealAppContext.getInstance().getGroupFriends(parseInt(vueObj.type), vueObj.groupId, plus.android.implements("cn.rongcloud.im.callback.GroupMemberCallback", {
					"onResult": function(loadSuccess, jsonList) {
						console.error("getGroupFriends: " + jsonList)
						if(loadSuccess){
							vueObj.personData = JSON.parse(jsonList);
						}
						vueObj.dataChangeJudge();
					}
				}));
			}
		},
		/*
		 * 添加群成员
		 */
		groupAddMember:function(userIds){
			showWaiting();
			var params = {};
			params.groupId = vueObj.groupId;
			params.groupName = vueObj.groupName;
			params.userIds = userIds.join(',');
			webCall2("/im/group/member/add", params, GROUP_ADD_MEMBER, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 删除群成员
		 */
		groupDeleteMember:function(userIds){
			showWaiting();
			var params = {};
			params.groupId = vueObj.groupId;
			params.userIds = userIds.join(',');
			webCall2("/im/group/member/kickOut", params, GROUP_DELETE_MEMBER, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 群转让
		 */
		groupAdminChange:function(userIds){
			showWaiting();
			var params = {};
			params.newOwnerId = userIds.join('');
			params.groupId = vueObj.groupId;
			vueObj.selectId = userIds.join('');
			webCall2("/im/group/changeOwner", params, GROUP_ADMIN_CHANGE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case GROUP_ADD_MEMBER:
				excuteFireEvent("chatGroupDetail", "onGroupMemberChange", {});
				closeWebview(plus.webview.currentWebview().id);
				break;
			case GROUP_DELETE_MEMBER:
				excuteFireEvent("chatGroupDetail", "onGroupMemberChange", {});
				closeWebview(plus.webview.currentWebview().id);
				break;	
			case GROUP_ADMIN_CHANGE: //群主转让
				excuteFireEvent("chatGroupDetail", "onGroupMemberChange", {
					type: "groupAdminChange",
					userId: vueObj.selectId
				});
				closeWebview(plus.webview.currentWebview().id);
				break;		
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 列表点击
		 */
		onItemClick: function(e){
			vueObj.onCheckSingle();
			var checkboxArray = [].slice.call(e.currentTarget.querySelectorAll('input[type="checkbox"]'));
			if(checkboxArray.length <= 0){
				return;
			}
			var check = checkboxArray[0];
			check.checked = !check.checked;
			vueObj.onCheckBoxChange();
		},
		/*
		 * checkBox点击
		 */
		onCheckBoxTap: function(e){
			vueObj.onCheckSingle();
			var check = e.currentTarget;
			check.checked = !check.checked;
			vueObj.onCheckBoxChange();
			e.stopPropagation();
		}, 
		/*
		 * chexcBox变化
		 */
		onCheckBoxChange: function(){
			var main = document.getElementById('main');
			var count = main.querySelectorAll('input[type="checkbox"]:checked').length;
			var saveBtn = document.getElementById('saveBtn');
			if(count) {
				saveBtn.style.display = "block";
			} else {
				saveBtn.style.display = "none";
			}
		},
		/*
		 * check单选
		 */
		onCheckSingle: function(){
			if(vueObj.type != 4) return;
			var main = document.getElementById('main');
			var checkArray = main.querySelectorAll('input[type="checkbox"]:checked');
			for(var i = 0; i < checkArray.length;i++){
				var checkBox = checkArray[i];
				checkBox.checked = false;
			}
		},
		/*
		 * 选择成员之后操作
		 */
		onSeletePerson:function(checkedValues, checkedName){
			switch (vueObj.type){
				case "1"://添加群成员
					vueObj.groupAddMember(checkedValues);
					break;
				case "2"://删除群成员
					vueObj.groupDeleteMember(checkedValues);
					break;
				case "3"://创建群
					//把自己当id加进去
					checkedValues.unshift(getCache(USER_ID_KEY));
					openWindow("editGroupInfo", "../message/edit_group_info.html", false, {
						type: "2",
						friendsId:JSON.stringify(checkedValues),
						statusBarType: STATUS_BAR_DEFAULT_KEY
					}, null, true);
					break;	
				case "4"://选择新群主
					confirmDialog("", "确定要选择" + checkedName + "为新群主, 你将自动放弃群主身份?", "取消", "确定",  function(){},function(){
						vueObj.groupAdminChange(checkedValues);
					});
					break;		
				default:
					break;
			}
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			//无数据图
			if(vueObj.personData.length == 0) {
				setNoDataBackground(true);
			} else {
				setNoDataBackground(false);
			}
		},
	}
});
/*
 * 确定按钮点击
 */
document.getElementById("saveBtn").addEventListener("tap", function(){
	var main = document.getElementById('main');
	var checkboxArray = [].slice.call(main.querySelectorAll('input[type="checkbox"]'));
	var checkedValues = [];
	var checkedName = [];
	checkboxArray.forEach(function(box) {
		if(box.checked) {
			checkedValues.push(box.parentNode.dataset.userId);
			checkedName.push(box.parentNode.dataset.userName);
		}
	});
	if(checkedValues.length > 0) {
		vueObj.onSeletePerson(checkedValues, checkedName);
	} else {
		toast("请选择联系人");
	}
});
// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "repeat";
		//页面有输入框 会把无数据背景图顶下来
		if(plus.os.name == "iOS") return;
 		document.getElementById("main").style.backgroundPosition = "center";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
	}
}