var self = null;
var scan = null, bCancel = false;
//请求码
var SCAN_QR_CODE = 1001, CHECK_QR_CODE = 1002;
//vue初始化
var vueObj = new Vue({
	el: '#main',
	data: {
		bindCardStatus: -1, //绑卡状态 1已经绑卡 0未绑卡
		needResult: 0, //jssdk: 0应用处理 1直接返回
		webPageId: null, //jssdk调用的父页面ID
		lightMgr: null, //android光线传感器
		lightInterval: null,
		showLight: false, //是否显示开启闪光灯
		openFlash: false //是否开启闪光灯,默认不开启
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				vueObj.stopScan();
				vueObj.stopLight();
				if(vueObj.needResult == 1 && vueObj.webPageId){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onScanQRCodeResult", {
						status: 'cancel'
					});
				}
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			setStatusBarBlack();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					vueObj.stopScan();
					vueObj.stopLight();
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarBlack();
					vueObj.startScan();
					vueObj.startLight();
				}
			}, false);
			//监听关闭事件
			window.addEventListener("onScanCloseListener", function(){
				closeWebview(self.id);
			});
			//程序从后台进入前台的监听事件
			window.addEventListener("resume", function(){
				vueObj.startScan();
				vueObj.startLight();
			}, false);
			//程序从前台进入后台的监听事件
			window.addEventListener("pause", function(){
				vueObj.stopScan();
				vueObj.stopLight();
			}, false);
			// 获取窗口对象
			self = plus.webview.currentWebview();
			//参数
			vueObj.needResult = self.needResult;
			vueObj.webPageId = self.webPageId;
			var user = getUserInfo();
			vueObj.bindCardStatus = user.bindCardStatus;
			//相机权限判断
			if(!checkUserPermission("CAMERA", null, function(){
				vueObj.initScan();
			}, function(){
				mui.back();
			})){ return; }
			// 扫码初始化
			vueObj.initScan();
			//获取灯光强度
			//vueObj.addLightSensorListener();
		});
	},
	methods: {
		/**
		 * 扫码初始化
		 */
		initScan: function() {
			setTimeout(function(){
				var scanMain = document.getElementById("scanMain");
				scanMain.removeAttribute("disabled");
				scan = new plus.barcode.Barcode('scanMain', [plus.barcode.QR, plus.barcode.EAN8, plus.barcode.EAN13], {
					frameColor: '#FE2140',
					scanbarColor: '#FE2140'
				});
				scan.onmarked = vueObj.onmarked;
				// 开始扫描
				vueObj.startScan();
			}, 300);
		},
		/**
		 * 开始扫描
		 */
		startScan: function() {
			if(!scan) return;
			scan.cancel();
			scan.start();
		},
		/**
		 * 停止扫描
		 */
		stopScan: function() {
			if(!scan) return;
			scan.cancel();
		},
		/**
		 * 二维码扫描成功
		 */
		onmarked: function(type, result, file) {
			result = result.replace(/\n/g, '');
			console.log("scaned('" + type + "','" + result + "','" + file + "');");
			if(!result){
				toast("扫描失败，请重试");
				vueObj.startScan();
				return;
			}
			//判断由谁处理
			//由JSSDK调用方处理
			if(vueObj.needResult == 1 && vueObj.webPageId){
				mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onScanQRCodeResult", {
					result: result,
					status: 'ok'
				});
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				closeWebview(self.id);
				return;
			}
			//由APP处理
			var rArray = result.split(",");
			if(rArray.length == 2 && stringIsNumber(rArray[1])){ //判断是否正元二维码
				if(vueObj.bindCardStatus == 0){ //未绑卡
					openBindCard(plus.webview.currentWebview().statusBarType);
					setTimeout(function(){
						closeWebview(self.id);
					}, 1000);
					return;
				}
				showWaiting();
				webCall2("/compus/user/scanQrCode", {
					qrCode: result
				}, SCAN_QR_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
				return;
			}
			//调用解码接口
			showWaiting();
			webCall2("/compus/scan/checkIn", {
				qrCode: result
			}, CHECK_QR_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 从相册中选择二维码图片
		 */
		scanPicture: function() {
			plus.gallery.pick(function(path) {
				plus.barcode.scan(path, vueObj.onmarked, function(error) {
					plus.nativeUI.alert('无法识别此图片');
				});
			}, function(err) {
				console.log('Failed: ' + err.message);
			});
		},
		/**
		 * 切换开关
		 */
		scanSwitch: function() {
			if(bCancel) {
				vueObj.startScan();
				btCancel && (btCancel.innerText = '暂　停');
			} else {
				vueObj.stopScan();
				btCancel && (btCancel.innerText = '开　始');
			}
			bCancel = !bCancel;
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case SCAN_QR_CODE: //二维码解析结果
				if(data.data && (data.data.codeType == 1 || data.data.codeType == 3)){ //消费码 个人码
					openWindow(data.data.payUrl, "../common/web_page.html", false, {
						webUrl: data.data.payUrl,
						statusBarType: plus.webview.currentWebview().statusBarType
					});
				}else if(data.data && data.data.codeType == 2){ //门禁码
					openWindow("scanOpenDoor", "scan_open_door.html", false, {
						statusBarType: plus.webview.currentWebview().statusBarType
					});
				}else{
					vueObj.startScan();
				}
				break;
			case CHECK_QR_CODE: //服务端解析二维码
				if(data.data.type == 1){ //内部链接
					openWindow(data.data.content, data.data.content, false, {
						statusBarType: plus.webview.currentWebview().statusBarType
					});
				}else if(data.data.type == 2){ //http链接
					openWindow(data.data.content, "../common/web_page.html", false, {
						webUrl: getUnionUrl(data.data.content),
						statusBarType: plus.webview.currentWebview().statusBarType
					});
				}else if(data.data.type == 3){ //第三方接口透传码
					toast(data.data.content);
					mui.back();
				}else if(data.data.type == 4){ //未识别内容
					confirmDialog("", data.data.content, "取消", "复制", function(){
						mui.back();
					}, function(){
						copyLink(data.data.content);
						mui.back();
					});
				}
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			if(requestCode == SCAN_QR_CODE && resultCode == 207){ 
				confirmDialog('校园卡未激活', '激活后，可使用校园卡扫码功能', '取消', '去激活', function cancelCallback() {
					mui.back();
				}, function sureCallback() {
					if(data.data && data.data.cardActiveType == 1){ //预留手机激活
						openWindow("activeCardFirst", "../card/active_card_first.html", false, {
							statusBarType: plus.webview.currentWebview().statusBarType,
							source: "scan",
							phone: data.data.reservePhone
						});
					}else{
						openWindow("payCodeActive", "../card/pay_code_active.html", false, {
							source: "scan",
							statusBarType: plus.webview.currentWebview().statusBarType
						});
					}
					setTimeout(function() {
						closeWebview(plus.webview.currentWebview().id);
					}, 500);
				});
				return;
			}
			onError(resultCode, resultMsgDesc);
			if(requestCode == SCAN_QR_CODE || requestCode == CHECK_QR_CODE){
				setTimeout(function(){
					vueObj.startScan(); //重新开始扫描
				}, 2000);
			}
		},
		/**
		 * 监听灯光强度
		 */
		addLightSensorListener: function() {
			if(plus.os.name == 'Android'){
				var LightSensorManager = plus.android.importClass("com.app.yunma.common.LightSensorManager");
				vueObj.lightMgr = LightSensorManager.getInstance();
				vueObj.lightMgr.start(plus.android.runtimeMainActivity());
			}
			vueObj.startLight();
		},
		/**
		 * 开始检测灯光
		 */
		startLight: function() {
			if(vueObj.lightInterval) clearInterval(vueObj.lightInterval);
			if(vueObj.lightMgr == null) return;
			vueObj.lightInterval = setInterval(function(){
				var androidLux = vueObj.lightMgr.getLux();
				vueObj.showLight = androidLux < 10;
			}, 2000);
		},
		/**
		 * 停止检测灯光
		 */
		stopLight: function() {
			if(vueObj.lightInterval) clearInterval(vueObj.lightInterval);
			vueObj.lightInterval = null;
			if(vueObj.lightMgr != null) vueObj.lightMgr.stop();
		},
		/**
		 * 灯光切换
		 */
		changeLight: function() {
			vueObj.openFlash = !vueObj.openFlash;
			scan.setFlash(vueObj.openFlash);
		}
	}
});

//相册按钮监听
document.getElementById("photoBtn").addEventListener("tap", function(){
	//相册权限判断
	if(!checkUserPermission("GALLERY", null, function(){
		vueObj.scanPicture();
	})){
		return;
	}
	vueObj.scanPicture();
});