var myScroll;
//请求码
var QUERY_LIST = 1001, SET_DEFAULT_ADDRESS = 1002, DELETE_USER_ADDRESS = 1003;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		datas: [],
		isFirst: true,//是不是第一次进来 然后请求的列表数据 那样没有数据 需要进入新增地址页面
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听变化
			window.addEventListener("onAddressChange", function(event){
				vueObj.loadData();
			});
		 	document.getElementById("scroller").style.minHeight = plus.screen.resolutionHeight + "px";
			//加载数据
			showWaiting();
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			webCall2("/compus/user/shippingaddress/findPage", {
				offset: 0,
				limit: 10
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST:
				//更新数据
				vueObj.datas = data.rows;
				if(vueObj.datas && vueObj.datas.length < 5) { //收货地址大于5 不显示添加按钮
					document.getElementById("addBtn").style.display = "inline-block";
				} else {
					document.getElementById("addBtn").style.display = "none";
				}
				if(!vueObj.datas || vueObj.datas.length <= 0){ //没有收货地址 直接跳转至编辑地址页面
					setNoDataBackground(true);
					if(vueObj.isFirst)  {//第一次进来没有数据进入新增界面
						confirmDialog('', '您还没有收货地址, 是否去新增收货地址？', '取消', '确认', null,function sureCallback(){
							openWindow("addReceiptAddress", "add_receipt_address.html", false, {
								defaultStatus: true,
								statusBarType: STATUS_BAR_DEFAULT_KEY
							});
						});
					}
				} else {
					setNoDataBackground(false);
				}
				vueObj.isFirst = false;
				closePullStatus();
				break;
			case SET_DEFAULT_ADDRESS://设置默认地址
				//加载数据
				showWaiting();
				vueObj.loadData();
				break;	
			case DELETE_USER_ADDRESS://删除地址
				//加载数据
				vueObj.deleteAddress = true;
				showWaiting();
				vueObj.loadData();
				break;	
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
		},
		/*
		 * 删除地址
		 */
		onDeleteAddress: function(index){
			confirmDialog('', '确定删除该收货地址？', '确认', '取消', function sureCallback(){
				var item = vueObj.datas[index];
				showWaiting();
				webCall2("/compus/user/shippingaddress/deleteById", {
					addressId: item.id,
				}, DELETE_USER_ADDRESS, vueObj.onSuccess, vueObj.onErrorBefore);
			});
		},
		/*
		 * 设为默认地址
		 */
		onSetDetault: function(index){
			var item = vueObj.datas[index];
			showWaiting();
			webCall2("/compus/user/shippingaddress/setDefault", {
				addressId: item.id,
			}, SET_DEFAULT_ADDRESS, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 列表点击
		 */
		onItemClick: function(index){
			var item = vueObj.datas[index]; 
			openWindow("addReceiptAddress", "add_receipt_address.html", false, {
				addressItem:item,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			});
		},
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			vueObj.loadData();
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, null);
		myScroll.refresh();
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}

// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
	}
}
//添加按钮监听
document.getElementById("addBtn").addEventListener("tap", function(){
	openWindow("addReceiptAddress", "add_receipt_address.html", false, {
		defaultStatus: vueObj.datas.length > 0 ? false: true,
		statusBarType: STATUS_BAR_DEFAULT_KEY
	});
});
/*
 * 点击屏幕任何区域 关闭左滑删除的按钮
 */
document.addEventListener('tap', function() {
	if(!document.querySelector('.mui-selected')) return; 
	document.querySelector('.mui-selected').children[0].children[0].setAttribute('style', 'transform: translate(0px, 0px);')
	document.querySelector('.mui-selected').children[1].setAttribute('style', 'transform: translate(0px, 0px);')
});