//请求码
var DO_LOGOUT = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		userPhone: null, //用户手机号
		cacheSize: '', //缓存大小
		currentVersion: '', //当前版本
		hasNewVersion: false, //是否有新版本
		newVersionUrl: null, //新版本下载地址
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//监听手机号变化
			window.addEventListener("userPhoneChange", function(event){
				vueObj.userPhone = getCache(USER_PHONE_KEY);
			});
			window.addEventListener("onPwdSettingSuccess", function(event){
				showWaiting();
				//调用退出登录接口
				webCall2("/login/logout", {}, DO_LOGOUT, vueObj.onSuccess, vueObj.onErrorBefore);
			});
			vueObj.userPhone = getCache(USER_PHONE_KEY);
			//检测版本
			vueObj.currentVersion = plus.runtime.version;
			window.getAppVersion(function(versionData){
				if(versionData && versionData.version){
					vueObj.hasNewVersion = window.isHaveNewVersion(vueObj.currentVersion, versionData.version);
					if(vueObj.hasNewVersion){
						vueObj.currentVersion = versionData.version;
						vueObj.newVersionUrl = versionData.url;
					}
				}
			});
		});
	},
	methods: {
		/**
		 * 按钮点击分发
		 */
		onButtonClick: function(e) {
			switch (e.currentTarget.dataset.code){
			case "phone": //更换手机号
				openWindow("modifyPhoneFirst", "../setting/modify_phone_first.html", false, null);
				break;
			case "pwd": //修改登录密码
				openWindow("modifyPwd", "../login/modify_pwd.html", false, null);
				break;
			case "payPwd": //修改支付密码
				openWindow("payPwdFirst", "../wallet/pay_pwd_first.html", false, null);
				break;
			case "address": //收货地址
				openWindow("receiptAddressList", "../setting/receipt_address_list.html", false, null);
				break;
			case "protocol": //用户协议
				openWindow('protocol', '../login/protocol.html', false, null);
				break;
			case "about": //关于
				if(vueObj.hasNewVersion){
					plus.runtime.openURL(vueObj.newVersionUrl);
					return;
				}
				openWindow("about", "../setting/about.html", false, null); 
				break;
			case "clear": //清除缓存
				vueObj.clearLocalCache();
				break;
			case "loginout": //退出登录
				vueObj.doLogout();
				break;
			default:
				break;
			}
		},
		/**
		 * 登出接口
		 */
		doLogout: function(){
			confirmDialog('', '是否要退出当前账号？', '确认', '取消', function sureCallback(){
				showWaiting();
				//调用退出登录接口
				webCall2("/login/logout", {}, DO_LOGOUT, vueObj.onSuccess, vueObj.onErrorBefore);
			}, function cancelCallback(){
				
			});
		},
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case DO_LOGOUT: //登出成功
				//清空消息
				clearPushMessage();
				//清除微信授权
				clearWxLogin();
				//清理本地信息
				clearLoginInfo();
				loginoutRongIM(false);
				//清理缓存
				plus.navigator.removeAllCookie();
				plus.cache.clear();
				//跳转到登录页
				openWindow("loginByCode", "../login/login_by_code.html", false, null);
				//关闭页面
				closeWebviewWhenLoginOut();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc){
			closeWaiting();
			if(resultCode == 213){ //未设置登录密码
				openWindow("settingPwd", "../setting/setting_pwd.html", false, {
					statusBarType: getCurrentStatusBarType()
				}, null, true);
			}			
			onError(resultCode, resultMsgDesc);
		}, 
		/**
		 * 本地缓存清除
		 */
		clearLocalCache: function() {
			mui.confirm('是否要清理缓存？', '', ['取消', '确认'], function (e) {
				if(e.index != 1) return;
				showWaiting();
				clearCache(function(){
					closeWaiting();
					toast('缓存已清理');
					//点击清除就直接清0
					vueObj.cacheSize = '0B';
				});
			});
		}
	}
});
