//请求码
var DO_APPLY = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		realName: null,// 真实姓名
		bankNo: null, //银行卡号
		userPhone: null, //手机号码
		mediumId: null, //二类户开户时返回的mediumId
		smsSendNo: null, //申请开户时返回的短信验证码编号
		fromWalletThirdAuth: false, //是否来自第三方
		webPageId: '', //第三方页面ID
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(vueObj.fromWalletThirdAuth && vueObj.webPageId){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onWalletAddBankResult", {status: 'cancel'});
				}
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//接收参数
			vueObj.mediumId = getCache(USER_MEDIUM_ID_KEY);
			vueObj.realName = getUserInfo().realUserName;
			vueObj.fromWalletThirdAuth = plus.webview.currentWebview().fromWalletThirdAuth;
			vueObj.webPageId = plus.webview.currentWebview().webPageId;
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			vueObj.realName = document.getElementById("realName").value;
			vueObj.bankNo = document.getElementById("bankNo").value;
			if(!vueObj.bankNo || !regexBankCardNo(vueObj.bankNo)){
				toast("请输入正确的银行卡号")
				return;
			}
			vueObj.userPhone = document.getElementById("userPhone").value;
			if(!vueObj.userPhone || !regexMobile(vueObj.userPhone)){
				toast("请输入正确的手机号码")
				return;
			}
			showWaiting();
			document.activeElement.blur();
			//添加银行卡申请
			webCall2("/compus/wallet/binding", {
				mediumId: vueObj.mediumId,
				bindMedium: vueObj.bankNo,
				mobileNo: vueObj.userPhone,
				custName:vueObj.realName,
			}, DO_APPLY, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_APPLY: //绑卡申请
				openWindow("bankAddSecond", "bank_add_second.html", false, {
					realName: vueObj.realName,
					bankNo: vueObj.bankNo,
					userPhone: vueObj.userPhone,
					smsSendNo: data.data.smsSendNo, //短信验证码编号
					corpSernoOriginal:data.data.corpSernoOriginal, //流水单号
					fromWalletThirdAuth: vueObj.fromWalletThirdAuth, //是否来自第三方
					webPageId: vueObj.webPageId, //第三方id
					statusBarType: plus.webview.currentWebview().statusBarType
				}, null, true);
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			if(data && data.alertType == 1){ 
				openWindow("authError", "../center/auth_error.html", false, {
					errorMessage: resultMsgDesc,//失败原因
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				return;
			} 
			onError(resultCode, resultMsgDesc);	
		},
		/*
		 * 银行卡icon 点击
		 */
		onBankIconClick: function(e) {
			document.activeElement.blur();
			vueObj.bankNo = document.getElementById("bankNo").value;
			vueObj.userPhone = document.getElementById("userPhone").value;
			//调用公共图片选择上传
			popCompressSelectPic(function(isError, list) {
				if(list == null || list.length < 1) {
					return;
				} 
				console.log('上传图片网络地址：' + list[0].imgUrl);
				console.log('上传图片本地地址：' + list[0].localPath);
				//去除空格
				if(list[0].imgUrl && list[0].imgUrl.length > 0){
					vueObj.bankNo = list[0].imgUrl.replace(/\s|\xA0/g,"");
				}
			}, true , null, "bank", true);
		},
	}
});