var DO_BIND = 1001, GET_CODE = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		realName: null,
		bankNo: null,
		userPhone: null,
		corpSernoOriginal:null, //申请开户返回的交易流水单号
		smsSendNo: null, //申请开户时返回的短信验证码编号
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		fromWalletThirdAuth: false, //是否来自第三方
		webPageId: '', //第三方页面ID
	},
	beforeMount: function() {
		mui.plusReady(function(){
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//接收参数
			var self = plus.webview.currentWebview();
			vueObj.realName = self.realName;
			vueObj.bankNo = self.bankNo;
			vueObj.userPhone = self.userPhone;
			vueObj.corpSernoOriginal = self.corpSernoOriginal;
			vueObj.smsSendNo = self.smsSendNo;
			vueObj.fromWalletThirdAuth = plus.webview.currentWebview().fromWalletThirdAuth;
			vueObj.webPageId = plus.webview.currentWebview().webPageId;
			//倒计时 上个页面接口 已经发送验证码了
			vueObj.setTimeCount();
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			var checkCode = document.getElementById("checkCode").value;
			if(!checkCode){
				toast("请输入验证码");
				return;
			}
			showWaiting();
			document.activeElement.blur();
			webCall2("/compus/wallet/scodeVerify", {
				corpSernoOriginal:vueObj.corpSernoOriginal,
				smsSendNo: vueObj.smsSendNo,
				smsScoded: checkCode
			}, DO_BIND, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在60s计时
			showWaiting();
			webCall2("/compus/wallet/scodeSend", { 
				corpSernoOriginal:vueObj.corpSernoOriginal,
			}, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case GET_CODE: //获取验证码
				vueObj.smsSendNo = data.data.smsSendNo;
				toast("验证码发送成功");
				//倒计时
				vueObj.setTimeCount();
				break;
			case DO_BIND: //绑卡验证
				var title = "绑定成功"
				var source = "";
				//successFlag 1 绑卡申请成功, 2绑卡成功
				if(data.data.successFlag && data.data.successFlag == 1){
					title = "绑卡申请成功"
				} 
				if(plus.webview.getWebviewById("walletMain")) {
					source = "walletMain";
				}
				openWindow("bankAddSuccess", "bank_add_success.html", false, {
					source:source,
					title:title,
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				if(plus.webview.getWebviewById("bankList")){
					mui.fire(plus.webview.getWebviewById("bankList"), "onBankAddSuccess", {});
				}
				if(plus.webview.getWebviewById("walletMain")){
					mui.fire(plus.webview.getWebviewById("walletMain"), "onBankAddSuccess", {});
				}
				//第三方应用 绑卡状态
				if(data.data.successFlag && data.data.successFlag == 2 && vueObj.fromWalletThirdAuth){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onWalletAddBankResult", {status: 'ok'});		
				}
				closeWebview("bankAddFirst");
				closeWebview("bankAddSecond");
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			if(data && data.alertType == 1){ 
				openWindow("authError", "../center/auth_error.html", false, {
					errorMessage: resultMsgDesc,//失败原因
					statusBarType: STATUS_BAR_DEFAULT_KEY
				});
				return;
			} 
			onError(resultCode, resultMsgDesc);	
		}
	}
});