//请求码
var UNTIE_BANK_CARD = 1001, QUERY_REMAIN = 1002;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		bankItem:null,
		logoUrl:"",//银行icon
		bindMedium:"",//银行卡号
		mediumChannelName:"",//银行名称
		payLimit:"",//日限额
		onceLimit:"",//单笔限额
		remainValue:null,//钱包余额
		isLastBank:false,//是否只有一张银行卡
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function() {
			setStatusBarMain();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarMain();
				}
			}, false);
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//监听余额变动
			window.addEventListener("onWalletReaminChange", function(event){
				vueObj.remainValue = event.detail.remainValue;
			});
			vueObj.bankItem = plus.webview.currentWebview().bankItem;
			vueObj.remainValue = plus.webview.currentWebview().remainValue;
			vueObj.isLastBank = plus.webview.currentWebview().isLastBank;
			vueObj.mediumChannelName = vueObj.bankItem.mediumChannelName;
			vueObj.bindMedium = vueObj.bankItem.bindMedium;
			vueObj.logoUrl = vueObj.bankItem.logoUrl;
			vueObj.payLimit = vueObj.bankItem.payLimit;
			vueObj.onceLimit = vueObj.bankItem.onceLimit ? vueObj.bankItem.onceLimit : "";
			if(vueObj.isLastBank && (!vueObj.remainValue || vueObj.remainValue <= 0)){
				vueObj.queryWalletValue();
			}
		}); 
	},
	methods: {
		/*
		 * 查询当前用户钱包余额
		 */
		queryWalletValue: function(){
			webCall2("/compus/wallet/queryBalance", {
				"mediumId":getCache(USER_MEDIUM_ID_KEY), //客户二类账号唯一编码
			}, QUERY_REMAIN, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/*
		 * 解绑银行卡
		 */
		onUntieBank:function(){
			if (vueObj.isLastBank && vueObj.remainValue > 0){ //
				confirmDialog('', '钱包余额' + vueObj.remainValue + ', 不可以解绑银行卡, 请先提现', '去提现', '取消解绑', function sureCallback(){
					openWindow("walletWithdraw", "wallet_withdraw.html", false, {
						remainValue: vueObj.remainValue,
						statusBarType:STATUS_BAR_MAIN_KEY
					});
				});
				return;
			}
			var confirm = "确定解绑该银行卡吗？";
			if(vueObj.isLastBank) {
				confirm = "解除绑定后，无法使用钱包进行支付，确定要解绑吗？"
			}
			confirmDialog('', confirm, '残忍的解绑', '不,我还要留着', function sureCallback(){
				showWaiting();
				webCall2("/compus/wallet/deleteBinding", {
					mediumId:getCache(USER_MEDIUM_ID_KEY),//二类户开户id
					bindMediumId:vueObj.bankItem.id//银行卡id
				}, UNTIE_BANK_CARD, vueObj.onSuccess, vueObj.onErrorBefore);	
			});
		}, 
		/**
		 * 接口访问成功返回
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch(requestCode){
			case UNTIE_BANK_CARD: 
				if(plus.webview.getWebviewById("bankList")){
					mui.fire(plus.webview.getWebviewById("bankList"), "onBankDeleteSuccess", {});
				}
				//钱包状态不一致 更新用户钱包状态
				if(data && data.data && data.data.eacctStatus >= 0){
					var userInfo = getUserInfo();
					userInfo.eacctStatus = data.data.eacctStatus;
					updateLoginInfo(null, userInfo);	
				}
				mui.back();
				break;
			case QUERY_REMAIN: 
				vueObj.remainValue = data.data && data.data.accountBalance ? data.data.accountBalance : 0.0;
				break;	
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 */
		onErrorBefore: function(resultCode, resultMsgDesc){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
	}
});