var QUERY_LIST = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		bankData:[],//银行卡数据列表
		deleteIndex:null, //解绑的下标
		mediumId: null, //二类户开户时返回的mediumId
		source: "",//父页面 入口判断是否是选择银行卡页面进来的
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//监听银行卡添加成功
			window.addEventListener("onBankAddSuccess", function(event){
				vueObj.loadBankList(); 
			});
			//监听银行卡解绑成功
			window.addEventListener("onBankDeleteSuccess", function(event){
				vueObj.bankData.splice(vueObj.deleteIndex, 1);
				//无数据图
				if(vueObj.bankData.length == 0) {
					setNoDataBackground(true);
				} else {
					setNoDataBackground(false);
				}
			});
			vueObj.mediumId = getCache(USER_MEDIUM_ID_KEY);
			vueObj.bankData = plus.webview.currentWebview().bankData;
			vueObj.source = plus.webview.currentWebview().source;
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			if(vueObj.bankData && vueObj.bankData.length > 0) return;
			vueObj.loadBankList(); 
		});
	},
	methods: {
		/*
		 * 银行卡列表查询
		 */
		loadBankList: function(){
			webCall2("/compus/wallet/bindingQuery", {
				mediumId: vueObj.mediumId,//二类户开户id
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_LIST: //银行卡列表
				vueObj.bankData = data.rows; 
				if(data.rows.length >= 5) {
					document.getElementById("addBtn").style.display = "none";
				}
				//无数据图
				if(vueObj.bankData.length == 0) {
					setNoDataBackground(true);
				} else {
					setNoDataBackground(false);
				}
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 *银行卡点击
		 */
		onItemClick: function(index){
			if(vueObj.source && vueObj.source.length > 0){
				vueObj.onSelectBank(index);
				return; 
			}
			var item = vueObj.bankData[index]; 
			vueObj.deleteIndex = index;
			openWindow("bankDetail", "bank_detail.html", false, {
				bankItem: item, 
				isLastBank:vueObj.bankData && vueObj.bankData.length > 1 ? false : true,
				remainValue:plus.webview.currentWebview().remainValue,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			});
		}, 
		/*
		 * 银行卡选择 返回充值或体现页面
		 */
		onSelectBank: function(index){
			//触发监听的自定义事件
			var opener = plus.webview.currentWebview().opener();
			if(opener){
				mui.fire(opener, "onBankSelectBack", {
					selectIndex:index 
				});
			}
			setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
			//关闭页面
			mui.back();
		},
		/*
		 * 返回item背景图和高度 style
		 */
		onBankItemStyle: function(bankCoding){
			var itemHeightStyle ="height:" +  (plus.screen.resolutionWidth / 375 * 120) + "px;";
			switch (bankCoding){ 
				case "ICBC": //工商
					return itemHeightStyle + "background-image: url(images/bank_gs_bg.png);";
					break;
				case "ABC"://农业
					return itemHeightStyle + "background-image: url(images/bank_ny_bg.png);";
					break;
				case "BOC"://中国银行
					return itemHeightStyle + "background-image: url(images/bank_zg_bg.png);";
					break;
				case "CCB"://建设
					return itemHeightStyle + "background-image: url(images/bank_js_bg.png);";
					break;
				case "COMM"://交通
					return itemHeightStyle + "background-image: url(images/bank_jt_bg.png);";
					break;
				case "PSBC"://邮政
					return itemHeightStyle + "background-image: url(images/bank_yz_bg.png);";
					break;	
				default:
					break;
			}
		},
	}
});

//添加按钮监听
document.getElementById("addBtn").addEventListener("tap", function(){
	if(getUserInfo().eacctStatus == 2){//已销户
		confirmDialog('', "钱包已关闭，去开通钱包添加银行卡", '取消', '开通钱包', function(){}, function sureCallback(){
			openWindow("authSecond", "../center/auth_second.html", false, {
				source:"walletMain",
				statusBarType: STATUS_BAR_DEFAULT_KEY
			});
		});
		return;
	}
	openWindow("bankAddFirst", "bank_add_first.html", false, {
		statusBarType: STATUS_BAR_DEFAULT_KEY
	});
});

// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
		document.getElementById("main").style.backgroundColor = "#F7F7F7";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
		document.getElementById("main").style.backgroundPosition = "center";
		document.getElementById("main").style.backgroundColor = "#FFFFFF";
	}
}