var DO_AUTH = 1001, GET_CODE = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		userPhone: null, //用户手机号
		timeCount: 0, // 定时器计数
		timer: null, // 定时器
		code:null, //验证码编码
		sendCount: 1, //短信验证码发送次数
		fromThirdAuth: false, //是否来自第三方
		webPageId: '' //第三方页面ID
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(vueObj.fromThirdAuth && vueObj.webPageId){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onSetPayPwdResult", {status: 'cancel'});
				}
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//设置键盘弹出模式
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.userPhone = getCache(USER_PHONE_KEY);
			//接收参数
			vueObj.fromThirdAuth = plus.webview.currentWebview().fromThirdAuth;
			vueObj.webPageId = plus.webview.currentWebview().webPageId;
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			var checkCode = document.getElementById("checkCode").value;
			if(!checkCode){
				toast("请输入验证码");
				return;
			}
			//验证验证码
			document.activeElement.blur();
			var params = {
				mediumId: getCache(USER_MEDIUM_ID_KEY),
				code: vueObj.code,
				verifyCode: checkCode
			};
			webCall2("/compus/wallet/checkVerifycode", params, DO_AUTH, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 获取验证码
		 */
		onGetCode: function(){
			if(vueObj.timeCount != 0) return; //正在60s计时
			showWaiting();
			var params = {
				mediumId:getCache(USER_MEDIUM_ID_KEY),
				sendCount: vueObj.sendCount
			};
			webCall2("/compus/wallet/sendVerifycode", params, GET_CODE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 启动定时器并更新 smsCodeBtn 状态
		 */
		setTimeCount: function(){
			vueObj.timeCount = 60;
			document.getElementById("smsCodeBtn").classList.add("sending");
			document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
			vueObj.timer = setInterval(function(){
				if(vueObj.timeCount == 0){
					clearInterval(vueObj.timer);
					document.getElementById("smsCodeBtn").classList.remove("sending");
					document.getElementById("smsCodeBtn").innerHTML = "发送验证码";
				}else{
					vueObj.timeCount--;
					document.getElementById("smsCodeBtn").innerHTML = vueObj.timeCount + " 秒后重试";
				}
			}, 1000);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_AUTH: //验证验证码
				openWindow("payPwdSecond", "pay_pwd_second.html", false, {
					fromThirdAuth: vueObj.fromThirdAuth, //是否来自第三方
					webPageId: vueObj.webPageId, //第三方id
					changePwdToken: data.data,
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				break;
			case GET_CODE: //获取验证码
				vueObj.sendCount++;
				toast("验证码发送成功");
				vueObj.code = data.data;
				//倒计时
				vueObj.setTimeCount();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});