//键盘相关参数
var nativeWebview, imm, InputMethodManager;
//请求码
var DO_SUBMIT = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		firstPwds: null, //第一次输入的6位密码
		pwds: '', //输入的6位密码
		showPwds: ['', '', '', '', '', ''], //输入的6位密码(密文)
		changePwdToken: null,//手机校验时返回的token
		fromThirdAuth: false, //是否来自第三方
		webPageId: '' //第三方页面ID
	},
	beforeMount: function() {
		mui.plusReady(function(){
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//接收参数
			vueObj.firstPwds = plus.webview.currentWebview().pwds;
			/**进入页面弹出键盘*/
		    initNativeObjects();
		    showSoftInput();
		    //接收参数
		    vueObj.changePwdToken = plus.webview.currentWebview().changePwdToken;
			vueObj.fromThirdAuth = plus.webview.currentWebview().fromThirdAuth;
			vueObj.webPageId = plus.webview.currentWebview().webPageId;
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			if(vueObj.pwds.length < 6) return;
			if(vueObj.pwds != vueObj.firstPwds){
				toast("两次输入的密码不一致");
				vueObj.resetPwd();
				return;
			}
			document.activeElement.blur();
			var params = {
				mediumId: getCache(USER_MEDIUM_ID_KEY),
				changePwdToken: vueObj.changePwdToken,
				newPassword: vueObj.pwds
			};
			webCall2("/compus/wallet/changepwd", params, DO_SUBMIT, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 重置密码
		 */
		resetPwd: function(e) {
			document.getElementById("pwdInput").value = '';
			vueObj.pwds = '';
			for(var i=0; i<6; i++){
				Vue.set(vueObj.showPwds, i, '');
			}
		},
		/**
		 * 输入框输入监听
		 */
		onInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9]/g, '');
			e.currentTarget.value = value;
			//最长只支持6位
			if(value.length > 6){
				e.currentTarget.value = value.substring(0, 6);
				return;
			}
			if(value.length <= 0){
				vueObj.resetPwd();
				return;
			}
			vueObj.pwds = value;
			for(var i=0; i<6; i++){
				if(i < vueObj.pwds.length){
					Vue.set(vueObj.showPwds, i, "●");
				}else{
					Vue.set(vueObj.showPwds, i, "");
				}
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_SUBMIT: //设置密码
				closeWebview("payPwdThird");
				toast("设置成功");
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				//密码设置成功 第三方打开的 回调设置成功状态
				if(vueObj.fromThirdAuth && vueObj.webPageId){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onSetPayPwdResult", {status: 'ok'});
				}
				mui.back();
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});


/**进入页面弹出键盘*/
var initNativeObjects = function() {
    if (mui.os.android) {
        var main = plus.android.runtimeMainActivity();
        var Context = plus.android.importClass("android.content.Context");
        InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
        imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
    } else {
        nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    }
};
var showSoftInput = function() {
    var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    if (mui.os.android) {
        //强制当前webview获得焦点
        plus.android.importClass(nativeWebview);
        nativeWebview.requestFocus();
        imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
    } else {
        nativeWebview.plusCallMethod({
            "setKeyboardDisplayRequiresUserAction": false
        });
    }
    setTimeout(function() {
       //此处可写具体逻辑设置获取焦点的input
       document.getElementById("pwdInput").focus();
    }, 300);
};