var DO_AUTH = 1001;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		changePwdToken: null, // 手机校验时返回的token
		fromThirdAuth: false, //是否来自第三方
		webPageId: '' //第三方页面ID
	},
	beforeMount: function() {
		mui.init({ 
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//接收参数
			vueObj.changePwdToken = plus.webview.currentWebview().changePwdToken;
			vueObj.fromThirdAuth = plus.webview.currentWebview().fromThirdAuth;
			vueObj.webPageId = plus.webview.currentWebview().webPageId;
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			//身份证号处理  小写x变大写X
			var cardNo = document.getElementById("cardNo").value;
			cardNo = cardNo.replace("x","X");
			if(!cardNo || !regexIdCard(cardNo)){
				toast("请输入正确的身份证号");
				return;
			}
			document.activeElement.blur();
			var params = {
				mediumId: getCache(USER_MEDIUM_ID_KEY), //二类户id
				changePwdToken: vueObj.changePwdToken, // 手机校验时返回的token
				cardNo: cardNo, //身份证号码
			};
			webCall2("/compus/wallet/checkcard", params, DO_AUTH, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case DO_AUTH: //身份证号验证
				openWindow("payPwdThird", "pay_pwd_third.html", false, {
					fromThirdAuth: vueObj.fromThirdAuth, //是否来自第三方
					webPageId: vueObj.webPageId, //第三方id
					changePwdToken: data.data,
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				setTimeout(function(){
					closeWebview("payPwdFirst");
					closeWebview("payPwdSecond");
				}, 1000);
				
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		}
	}
});