//键盘相关参数
var nativeWebview, imm, InputMethodManager;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		pwds: '', //输入的6位密码
		userPhone: null, //用户手机号
		showPwds: ['', '', '', '', '', ''], //输入的6位密码(密文)
		fromThirdAuth: false, //是否来自第三方
		webPageId: '', //第三方页面ID
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				if(vueObj.fromThirdAuth && vueObj.webPageId){
					mui.fire(plus.webview.getWebviewById(vueObj.webPageId), "onSetPayPwdResult", {status: 'cancel'});
				}
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			/**进入页面弹出键盘*/
		    initNativeObjects();
		    showSoftInput();
		    //接收参数
			vueObj.fromThirdAuth = plus.webview.currentWebview().fromThirdAuth;
			vueObj.webPageId = plus.webview.currentWebview().webPageId;
			vueObj.userPhone = getCache(USER_PHONE_KEY).replace(/^(\d{4})\d{4}(\d+)/,"$1****$2");
		});
	},
	methods: {
		/**
		 * 下一步
		 */
		doNext: function(e) {
			if(vueObj.pwds.length < 6) return;
			if(vueObj.judgeContinueRepeat(vueObj.pwds)){
				toast("支付密码不能是重复、连续的数字");
				return;
			}
			document.activeElement.blur();
			openWindow("payPwdFourth", "pay_pwd_fourth.html", false, {
				fromThirdAuth: vueObj.fromThirdAuth, //是否来自第三方
				webPageId: vueObj.webPageId, //第三方id
				pwds: vueObj.pwds,
				changePwdToken: plus.webview.currentWebview().changePwdToken,
				statusBarType: plus.webview.currentWebview().statusBarType
			});
		},
		/**
		 * 输入框输入监听
		 */
		onInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9]/g, '');
			e.currentTarget.value = value;
			//最长只支持6位
			if(value.length > 6){
				e.currentTarget.value = value.substring(0, 6);
				return;
			}
			if(value.length <= 0){
				vueObj.pwds = '';
				for(var i=0; i<6; i++){
					Vue.set(vueObj.showPwds, i, '');
				}
				return;
			}
			vueObj.pwds = value;
			for(var i=0; i<6; i++){
				if(i < vueObj.pwds.length){
					Vue.set(vueObj.showPwds, i, "●");
				}else{
					Vue.set(vueObj.showPwds, i, "");
				}
			}
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case '': //
				
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 判断是否重复、连续的数字
		 */
		judgeContinueRepeat: function(numStr) {
			var numArray = numStr.split("");
			var isContinue = true;
			for(var i=0; i<numArray.length-2; i++){
				if((parseInt(numArray[i+1])-parseInt(numArray[i])) != (parseInt(numArray[i+2])-parseInt(numArray[i+1]))){
					isContinue = false;
					break;
				}
			}
			return isContinue;
		}
	}
});

/**进入页面弹出键盘*/
var initNativeObjects = function() {
    if (mui.os.android) {
        var main = plus.android.runtimeMainActivity();
        var Context = plus.android.importClass("android.content.Context");
        InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
        imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
    } else {
        nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    }
};
var showSoftInput = function() {
    var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
    if (mui.os.android) {
        //强制当前webview获得焦点
        plus.android.importClass(nativeWebview);
        nativeWebview.requestFocus();
        imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
    } else {
        nativeWebview.plusCallMethod({
            "setKeyboardDisplayRequiresUserAction": false
        });
    }
    setTimeout(function() {
       //此处可写具体逻辑设置获取焦点的input
       document.getElementById("hideInput").focus();
    }, 300);
};