/** 网络请求码 */
var QUERY_REMAIN = 1001;
var myScroll;
var vueObj = new Vue({
	el: '#main',
	data: {
		realNameStatus: 0, // 0未开通 1启用 2销户 3关闭
		eacctStatus: 0, // 0未开通 1启用 2销户 3关闭
		remainValue: '', //余额
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function() {
			//状态栏设置
			setStatusBarMain();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarMain();
				}
			}, false);
			//监听余额变动
			window.addEventListener("onWalletReaminChange", function(event){
				vueObj.remainValue = event.detail.remainValue;
			});
			//监听银行卡添加成功 钱包开通成功 刷新界面
			window.addEventListener("onBankAddSuccess", function(event){
				vueObj.refreshData();
			});
			//监听二类户销户后, 开户成功 钱包开通成功 刷新界面
			window.addEventListener("onWalletOpenSuccess", function(event){
				vueObj.refreshData();
			});
			//查询余额
			vueObj.refreshData();
			vueObj.eacctStatus = getUserInfo().eacctStatus;
			vueObj.realNameStatus = getUserInfo().realNameStatus;
		});
	},
	methods: {
		/**
		 * 重新加载界面数据
		 */
		refreshData: function() {
			vueObj.pulldownRefresh();
		},
		/**
		 * 下拉刷新具体业务实现
		 */
		pulldownRefresh: function() {
			var mediumId = getCache(USER_MEDIUM_ID_KEY);
			webCall2("/compus/wallet/queryBalance", {
				"mediumId":mediumId, //客户二类账号唯一编码
			}, QUERY_REMAIN, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			vueObj.closePullStatus();
			switch(requestCode) {
			case QUERY_REMAIN: //余额查询 
				vueObj.remainValue = data.data && data.data.accountBalance ? data.data.accountBalance : 0.0;
				vueObj.eacctStatus = data.data.status;
				var userInfo = getUserInfo();
				//钱包状态不一致 更新用户钱包状态
				if(userInfo.eacctStatus != vueObj.eacctStatus){
					userInfo.eacctStatus = vueObj.eacctStatus;
					updateLoginInfo(null, userInfo);	
				}
				//更新个人中心余额
				var centerMain = plus.webview.getWebviewById("center/center_main.html");
				if(centerMain && vueObj.eacctStatus == 1){
					mui.fire(centerMain, "onWalletReaminChange", {
						remainValue: vueObj.remainValue
					});
				}
				//处理弹窗，证件：0表示正常，1表示即将过期，2表示已过期
				if(data.data.expiryStatus == 1 || data.data.expiryStatus == 2){
					var authDialog = plus.webview.create("../common/auth_dialog.html", "authDialog", 
						{top: '0px', bottom: '0px', position: 'fiexd', zindex: '9999', background: 'transparent'},
						{type:'over', overType: data.data.expiryStatus == 1 ? '100813' : '200811'});
					plus.webview.currentWebview().append(authDialog);
				}
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode) {
			onError(resultCode, resultMsgDesc);
			closeWaiting();
			vueObj.closePullStatus();
		},
		/**
		 * 关闭上拉/下拉刷新 
		 */
		closePullStatus: function(data) {
			//刷新列表
			Vue.nextTick(function(){
				setTimeout(function(){
					myScroll.refresh();
				}, 200); 
			}); 
		},
		/*
		 * 未开通钱包点击  去绑定银行卡
		 */
		onUnopenClick:function(){
			vueObj.eacctStatus = getUserInfo().eacctStatus;
			if(vueObj.eacctStatus == 2) {//已销户
				openWindow("authSecond", "../center/auth_second.html", false, {
					source:"walletMain",
					statusBarType:STATUS_BAR_MAIN_KEY
				});
			} else if(vueObj.eacctStatus == 3) {//已关闭
				openWindow("bankAddFirst", "bank_add_first.html", false, {
					statusBarType:STATUS_BAR_MAIN_KEY
				});
			} else if(vueObj.eacctStatus == 0){//未实名认证
				openWindow("authFirst", "../center/auth_first.html", false, {
					statusBarType:STATUS_BAR_MAIN_KEY,
					from: "walletMain"
				});
			}
		},
		/**
		 * 点击事件监听
		 */
		onButtonClick: function(e) {
			var type = e.currentTarget.dataset.type;
			vueObj.eacctStatus = getUserInfo().eacctStatus;
			if(vueObj.eacctStatus != 1 && (type == "recharge" || type == "withdraw" || 
				type == "remainDetail" || type == "bank")) {
				vueObj.onUnopenClick();
				return;
			}
			switch (type){
			case "recharge": //充值
				openWindow("walletRecharge", "wallet_recharge.html", false, {statusBarType:STATUS_BAR_MAIN_KEY});
				break;
			case "withdraw": //提现
				openWindow("walletWithdraw", "wallet_withdraw.html", false, {
					remainValue: vueObj.remainValue,
					statusBarType:STATUS_BAR_MAIN_KEY
				});
				break;
			case "remainDetail": //余额明细
				openWindow("walletRemainList", "wallet_remain_list.html", false, {statusBarType:STATUS_BAR_MAIN_KEY});
				break;
			case "bank": //银行卡
				openWindow("bankList", "../wallet/bank_list.html", false, {
					remainValue: vueObj.remainValue,
					statusBarType: STATUS_BAR_MAIN_KEY
				});
				break;
			case "baby": //宝贝基金
				
				break;
			case "plan": //宝贝成长计划
				openWindow("walletIntroduce", "../common/web_page.html", false, {
					webUrl: h5Host + '/auth/h5/walletIntroduceYi12?activityCode=yi12WalletIntroduce',
					statusBarType: STATUS_BAR_MAIN_KEY
				});
				break;
			default:
				break;
			}
		}
	}
});

/**iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			vueObj.pulldownRefresh();
		};
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, null);
		myScroll.refresh();
	});
})(mui);