//请求码
var DO_RECHARGE = 1001, QUERY_DEFAULT_BANK = 1002;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		bankId: null, //选择的银行卡ID
		bankRows:[], //银行卡列表
		payLimitDesc:null,//限额提示
		onceLimit: "",//限额大小
		cardNoId:null,//银行卡号Id
		cardChannelName:null,//显示的银行卡号尾号
		bankLogoUrl: null,//银行图标
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			//监听银行卡选择
			window.addEventListener("onBankSelectBack", function(event){
				var selectIndex = event.detail.selectIndex;
				vueObj.cardChannelName = vueObj.bankRows[selectIndex].mediumChannelName + '（' + vueObj.bankRows[selectIndex].bindMedium.substring(vueObj.bankRows[selectIndex].bindMedium.length - 4, vueObj.bankRows[selectIndex].bindMedium.length) + '）';
				vueObj.cardNoId = vueObj.bankRows[selectIndex].id;
				vueObj.payLimitDesc = vueObj.bankRows[selectIndex].payLimitDesc;
				vueObj.bankLogoUrl = vueObj.bankRows[selectIndex].logoUrl;
				vueObj.onceLimit = vueObj.bankRows[selectIndex].onceLimit;
			});
			//查询默认银行卡
			vueObj.queryUserDefaultBank();
		});
	},
	methods: {
		/*
		 * 查询默认银行卡
		 */
		queryUserDefaultBank: function(){
			webCall2("/compus/wallet/bindingQuery", {
				mediumId: getCache(USER_MEDIUM_ID_KEY),//二类户开户id
			}, QUERY_DEFAULT_BANK, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 下一步
		 */
		doNext: function(e) {
			if(!vueObj.cardNoId){
				toast("请选择银行卡")
				return;
			}
			var rechargeMoney = document.getElementById("rechargeMoney").value;
			if(!rechargeMoney){
				toast("请输入充值金额")
				return;
			}
			if (rechargeMoney <= 0) {
				toast("充值金额不得小于0")
				return; 
			}
			if (vueObj.onceLimit &&  parseFloat(vueObj.onceLimit) > 0 && parseFloat(rechargeMoney) > parseFloat(vueObj.onceLimit)) {
				toast("充值金额不得大于银行限额");
				return; 
			}
			//小数点不足 补足两位
			rechargeMoney = toDecimalTwo(rechargeMoney);
			document.activeElement.blur();
			showWaiting();
			webCall2("/compus/wallet/recharge", {
				mediumId: getCache(USER_MEDIUM_ID_KEY),
				bindMediumId: vueObj.cardNoId,
				amount:rechargeMoney,
			}, DO_RECHARGE, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DEFAULT_BANK: //默认银行卡查询
				vueObj.bankRows = data.rows;
				if(!vueObj.bankRows || vueObj.bankRows.length <= 0) return;
				vueObj.cardNoId = vueObj.bankRows[0].id;
				vueObj.payLimitDesc = vueObj.bankRows[0].payLimitDesc;
				vueObj.bankLogoUrl = vueObj.bankRows[0].logoUrl;
				vueObj.onceLimit = vueObj.bankRows[0].onceLimit;
				vueObj.cardChannelName = vueObj.bankRows[0].mediumChannelName + '（' + vueObj.bankRows[0].bindMedium.substring(vueObj.bankRows[0].bindMedium.length - 4, vueObj.bankRows[0].bindMedium.length) + '）';
				break;
			case DO_RECHARGE: //充值申请
				//status 1申请中 2充值成功 3充值失败 4遗账
				if(data.data.status == 3) {
					toast(data.data.msg ? data.data.msg: "充值失败, 请重试");
					return;
				}
				//跳转到成功页
				openWindow("walletRechargeResult", "wallet_recharge_result.html", false, {
					title: data.data.msg,
					type: vueObj.cardChannelName,
					statusBarType:STATUS_BAR_MAIN_KEY
				});
				closeWebview("walletRecharge");
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			if(data && data.alertType == 1){ 
				openWindow("authError", "../center/auth_error.html", false, {
					errorMessage: resultMsgDesc,//失败原因
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				closeWebview("walletRecharge");
				return;
			} 
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 选择提现银行卡
		 */
		onSelectBank: function(e) {
			document.activeElement.blur();
			openWindow("bankList", "bank_list.html", false, {
				"source":"recharge",
				"bankData":vueObj.bankRows,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			}); 
		},
		/**
		 * 输入金额监听
		 */
		onMoneyInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9.]/g, '');
			e.currentTarget.value = value;
			//控制输入两位小数
			value = value + '';
			var values = value.split('.');
			//控制整数位位数
			/*if(values[0].length > moneyLength) {
				values[0] = values[0].substring(0, moneyLength);
			}*/
			if(values.length > 1) {
				if(values[1].length > 2) {
					value = values[0] + '.' + values[1].substring(0, 2);
				} else {
					value = values[0] + '.' + values[1];
				}
			} else {
				value = values[0];
			} 
			if(values.length > 1 && (values[0].length <= 0 || values[0] == "")) {
				value = "0.";
			}
			e.currentTarget.value = value;
		}
	}
});