/** 网络请求码 */
var QUERY_ADS = 1001, QUERY_REMAIN = 1002;
//初始化vue
var vueObj = new Vue({
	el: '#main',
	data: {
		payType: null,//显示的支付方式
		bannerLength: 0, //
		bannerRows: [], // 广告列表数据
		payTitle: null,
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//参数接收
			vueObj.payType = plus.webview.currentWebview().type;
			document.getElementById("payTitle").innerText = plus.webview.currentWebview().title;
			vueObj.payTitle = plus.webview.currentWebview().title;
			//查询广告
			showWaiting();
			vueObj.queryUserBalance();
			webCall2("/compus/advertising/getAdvertisingList", {addressCode:'k12_4007'}, QUERY_ADS, vueObj.onSuccess, vueObj.onErrorBefore);
		});
	},
	methods: {
		/*
		 * 成功后查询余额
		 */
		queryUserBalance: function() {
			webCall2("/compus/wallet/queryBalance", {
				"mediumId":getCache(USER_MEDIUM_ID_KEY), //二类户开户id
			}, QUERY_REMAIN, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口请求成功
		 */
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_REMAIN:
				var accountBalance =  data.data.accountBalance ? data.data.accountBalance : 0;
				//获取当前余额，变更相应页面
				var walletMain = plus.webview.getWebviewById("walletMain");
				if(walletMain){
					mui.fire(walletMain, "onWalletReaminChange", {
						remainValue: accountBalance
					});
				}
				var centerMain = plus.webview.getWebviewById("center/center_main.html");
				if(centerMain){
					mui.fire(centerMain, "onWalletReaminChange", {
						remainValue: accountBalance
					});
				}
				var bankDetail = plus.webview.getWebviewById("bankDetail");
				if(bankDetail){
					mui.fire(bankDetail, "onWalletReaminChange", {
						remainValue: accountBalance
					});
				}
				break;
			case QUERY_ADS: //广告数据加载
				vueObj.bannerRows = data.rows;
				vueObj.bannerLength = vueObj.bannerRows.length;
				vueObj.$nextTick(function() {
					// banner多余1条时才循环播放
					if(vueObj.bannerLength > 1) {
						mui("#slider").slider({
							interval: 3000
						});
					} else {
						mui("#slider").slider({
							interval: 0
						});
					}
					//懒加载图片刷新
					var imgLazyloadApi = mui('#slider').imageLazyload({
						autoDestroy: false,
						placeholder: '../../img/banner_default.png'
					});
					//懒加载图片刷新
					imgLazyloadApi.refresh(true);
				})
				break;
			default:
				break;
			}
		},
		/**
		 * 接口请求失败
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closeWaiting();
		},
		/**
		 * 广告监听
		 */
		onBannerClick: function(e) {
			//添加统计事件
			statisticEvent("bannerClickTime", {"title" : e.currentTarget.dataset.btitle, "from" : "钱包充值提现成功页", "pos": "充值提现成功页"});
			var linkUrl = e.currentTarget.dataset.linkUrl;
			var imgPath = e.currentTarget.dataset.imgPath;
			var type = e.currentTarget.dataset.type; //广告类型(0：应用型;1:链接型;2:数据型)
			var appType = e.currentTarget.dataset.apptype; //应用类型（0数据型，1链接型）
			var bindStatus = e.currentTarget.dataset.bind; //是否需要验证绑定（0是 1否）
			if(!linkUrl) return;
			if(type == 0 && bindStatus == 0 && getUserInfo().bindCardStatus == 0){ //未绑卡
				openBindCard();
				return;
			}
			if((type == 0 && appType == 0) || type == 2) { //应用数据型 或 数据型
				openWindow(linkUrl, linkUrl, false, {statusBarType: STATUS_BAR_DEFAULT_KEY}, null, false);
			}else if(linkUrl){
				openWindow(linkUrl, '../common/web_page.html', false, {
					"webUrl": linkUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_DEFAULT_KEY
				}, null, false);
			}
		}
	}
});