var myScroll;
var isLoadingMore;
var isNoMore;
var start = 0;
//请求码
var QUERY_LIST = 1001;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		datas: [],
		redbagValue:"0.0",//红包余额
		isHaveRdbbag:false,//是否有红包
		supportAuth: false, //是否支持实名认证
		supportAuthUrl: null, //实名认证跳转链接
		realNameStatus: 2, //实名认证状态 1未实名 2申请中 3认证成功 4认证失败 //最新状态 0 编辑中 1申请中 2受理成功 3成功 4 失败
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarMain();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarMain();
				}
			}, false);
			//监听红包激活状态
			window.addEventListener("onRedbagActiveStatus", function(event){
				//回到头部
				myScroll.scrollTo(0, -39);
				start = 0;
				//刷新
				vueObj.loadData();
			});
			vueObj.supportAuth = plus.webview.currentWebview().supportAuth;
			vueObj.supportAuthUrl = plus.webview.currentWebview().supportAuthUrl;
			vueObj.realNameStatus = getUserInfo().realNameStatus ? getUserInfo().realNameStatus : 0;
			//加载数据
			vueObj.loadData();
		});
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			webCall2("/compus/redbag/queryUserRedbagPage", {
				offset: start,
				limit: 10
			}, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){
			case QUERY_LIST: //查询数据 红包状态，0未使用，1已使用，2已过期 3已发放 8未激活
				if(start == 0 && data.data){
					vueObj.redbagValue = data.data;
					//更新个人中心余额
					mui.fire(plus.webview.getWebviewById("center/center_main.html"), "onWalletRedbagChange", {
						redbagValue: vueObj.redbagValue
					});
				}
				vueObj.datas = (start == 0 ? data.rows : vueObj.datas.concat(data.rows));
				if(vueObj.datas && vueObj.datas.length > 0){
					vueObj.isHaveRdbbag = false;
				} else {
					vueObj.isHaveRdbbag = true;
				}
				start = vueObj.datas.length;
				vueObj.dataChangeJudge();
				closePullStatus(data.rows);
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
			if(start == 0){
				document.getElementById("item0mobileSpan").style.display = "none";
			}
		},
		/*
		 * 数据变化, 界面背景图判断
		 */
		dataChangeJudge: function(){
			if(vueObj.datas.length < 4) {
				document.getElementById("item0mobileSpan").style.display = "none";
			} else {
				document.getElementById("item0mobileSpan").style.display = "";
			}
		},
		/*
		 * 使用规则点击
		 */
		onRedbagRule: function(){
			var linkUrl = h5Host + "/activity/h5/common?activityCode=wallet1003";
			openWindow(linkUrl, '../common/web_page.html', false, {
				"webUrl": linkUrl,
				statusBarType: STATUS_BAR_MAIN_KEY
			}, null, false);		
		},
		/*
		 * 去领取点击
		 */
		onReceiveRedbag: function(){
			if(!vueObj.supportAuthUrl) return;
			if(vueObj.supportAuthUrl.indexOf("http") == 0){
				openWindow(vueObj.supportAuthUrl, '../common/web_page.html', false, {
					"webUrl": vueObj.supportAuthUrl,
					"imgPath": imgPath,
					statusBarType: STATUS_BAR_MAIN_KEY
				}, null, false);
			}else{
				openWindow(vueObj.supportAuthUrl, vueObj.supportAuthUrl, false, {statusBarType: STATUS_BAR_MAIN_KEY}, null, false);
			}
		},
		/*
		 * 红包激活  
		 */
		onRedbagActive: function(){
			openWindow("authFirst", "../center/auth_first.html", false, {
				statusBarType: STATUS_BAR_MAIN_KEY,
					from: "walletRedbag"
			});
		},
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore = false;
			setTimeout(function() {
				start = 0;
				vueObj.loadData();
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
	
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull('.wrapper', pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		if(data.length < 10) {
			document.getElementById("item0mobileSpan").innerHTML = "没有更多数据了";
			isNoMore = true;
		} else {
			document.getElementById("item0mobileSpan").innerHTML = "正在加载...";
			isNoMore = false;
		}
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		setTimeout(function(){
			myScroll.refresh();
		}, 200); 
	});
}

