var myScroll;
var isLoadingMore;
var isNoMore;
var start = 0;
var dtpicker;
//请求码
var QUERY_LIST = 1001;
/*初始化vue*/
var vueObj = new Vue({
	el: '#main',
	data: {
		datas: [],//明细数据
		withdrawAmount: null,//提现总数
		rechargeAmount: null,//充值总数
		queryTime: null, //查询时间，例如:2018-0
		billType:0,//查询明细类型 1充值 2提现 3消费 全部什么也不传0不生效
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			//当前时间 年月
			vueObj.queryTime = formatDate(new Date().getTime()).substring(0,7);
			//加载数据
			vueObj.loadData();
		}); 
	},
	methods: {
		/**
		 * 加载数据
		 */
		loadData: function() {
			var qTime = vueObj.queryTime.replace("-", "");
			var params = {
				"mediumId": getCache(USER_MEDIUM_ID_KEY), //二类账户开户id
				"date": qTime, //选择的时间
				"offset":start,
				"limit":"10",
			}
			//查看明细类型
			if(vueObj.billType && vueObj.billType > 0){
				params.billType = vueObj.billType;
			}
			webCall2("/compus/wallet/billQuery",params, QUERY_LIST, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		onSuccess: function(data, requestCode){
			closeWaiting();
			switch (requestCode){ 
			case QUERY_LIST:
				//更新数据
				vueObj.rechargeAmount = data.data.rechargeAmount;
				vueObj.withdrawAmount = data.data.withdrawAmount;
				vueObj.datas = (start == 0 ? data.data.billDetail : vueObj.datas.concat(data.data.billDetail));
				start = vueObj.datas.length;
				//无数据图
				if(vueObj.datas.length == 0) {
					setNoDataBackground(true);
				} else {
					setNoDataBackground(false);
				}
				if(vueObj.datas.length < 4){
					document.getElementById("item0mobileSpan").style.display = "none";
				}else {
					document.getElementById("item0mobileSpan").style.display = "";
				}
				closePullStatus(data.data.billDetail);
				break;
			default:
				break;
			}
		},
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode){
			onError(resultCode, resultMsgDesc);
			closePullStatus();
			closeWaiting();
			if(start == 0){
				document.getElementById("item0mobileSpan").style.display = "none";
			}
		},
		/**
		 * 选择日期
		 */
		selectDate: function(e) {
			if(dtpicker == null){
				dtpicker = new mui.DtPicker({
				    type: "month",//设置日历初始视图模式 
				    beginDate: new Date(2000, 01, 01),//设置开始日期 
				    endDate: new Date(),//设置结束日期 
				});
			}
			dtpicker.show(function(e) {
			    var sdate = e.text;
			    console.log(e + e.text);
			    if(vueObj.queryTime == sdate) return;
			    start = 0;
			    vueObj.queryTime = sdate;
			    showWaiting();
			    vueObj.loadData();
			});
		}
	}
});

/*iscroll下拉刷新组件初始化需要*/
(function($) {
	$(function() {
		var pullDownAction = function() {
			isNoMore = false;
			setTimeout(function() {
				start = 0;
				vueObj.loadData();
			}, 300);
		};
		var pullLoadMoreAction = function() {
			if (isLoadingMore) {
				return;
			}
			if (isNoMore) {
				myScroll.refresh();
				return;
			};
			setTimeout(function() {
				isLoadingMore = true;
				vueObj.loadData();
			}, 300);
		};
	
		//初始化下拉刷新
		myScroll = iscrollAssist.newVerScrollForPull($('#main'), pullDownAction, pullLoadMoreAction);
		myScroll.refresh();
		isLoadingMore = false;
		isNoMore= false;
	});
})(mui);

/**
 * 关闭上拉/下拉刷新 
 */
function closePullStatus(data) {
	if(data){
		if(data.length < 10) {
			document.getElementById("item0mobileSpan").innerHTML = "没有更多数据了";
			isNoMore = true;
		} else {
			document.getElementById("item0mobileSpan").innerHTML = "正在加载...";
			isNoMore = false;
		}
		isLoadingMore = (start > 0) ? false : true;
	}
	//刷新列表
	Vue.nextTick(function(){
		myScroll.refresh();
	});
}

// 设置背景
function setNoDataBackground(isNoData) {
	if(isNoData) {
		document.getElementById("main").style.backgroundImage = "url(../../img/no_content_bg.png)";
		document.getElementById("main").style.backgroundSize = "100% auto";
		document.getElementById("main").style.backgroundRepeat = "no-repeat";
		document.getElementById("main").style.backgroundPosition = "center";
		//无数据时不显示上拉显示更多
		document.getElementById("item0mobileSpan").style.display = "none";
	} else {
		document.getElementById("main").style.backgroundImage = "none";
		document.getElementById("item0mobileSpan").style.display = "";
	}
}

//title点击监听
document.getElementById("title").addEventListener("tap", function(e){
	var buttons = [{id:'1', title:'全部', desc:'余额明细'}, {id:'2', title:'充值', desc:'充值'}, {id:'3', title:'提现', desc:'提现'}, {id:'4', title:'支出', desc:'支出'}, {id:'5', title:'退款', desc:'退款'}];
	plus.nativeUI.actionSheet({
		title: "请选择",
		cancel: "取消",
		buttons: buttons
	}, function(e){
		//和当前查询类型一样 直接返回
		if((e.index - 1) == vueObj.billType) return;
		if(e.index > 0){
			var id = buttons[e.index - 1].id;
			document.getElementById("titleText").innerText = buttons[e.index - 1].desc;
			start = 0;
			showWaiting();
			vueObj.billType = e.index - 1; 
			vueObj.loadData();
		}
	});
});