//请求码
var DO_WITHDRAW = 1001, QUERY_REMAIN = 1002, QUERY_DEFAULT_BANK = 1003;
//vue初始化
var vueObj = new Vue({
	el: "#main",
	data: {
		bankId: null, //选择的银行卡ID
		remainValue: '', //可提现余额
		bankRows:[], //银行卡列表
		payLimitDesc:null,//限额提示
		cardNoId:null,//银行卡号Id
		cardChannelName:null,//显示的银行卡号尾号
		mediumChannelName:null,//银行名称
		bankLogoUrl: null,//银行图标
	},
	beforeMount: function() {
		mui.init({
			//监听返回事件
			beforeback: function() {
				setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				return true;
			}
		});
		mui.plusReady(function(){
			//状态栏设置
			setStatusBarDefault();
			plus.webview.currentWebview().addEventListener("popGesture", function(e) {
				if(e.type == 'start'){ //侧滑开始
					setUpViewStatusBar(plus.webview.currentWebview().statusBarType);
				}else if(e.type == 'end' && e.result === false){ //侧滑返回取消
					setStatusBarDefault();
				}
			}, false);
			keyboardAdjustResize();
			//滚动初始化
			mui('.mui-scroll-wrapper').scroll();
			vueObj.remainValue = plus.webview.currentWebview().remainValue;
			//监听银行卡选择
			window.addEventListener("onBankSelectBack", function(event){
				var selectIndex = event.detail.selectIndex;
				vueObj.cardNoId = vueObj.bankRows[selectIndex].id;
				vueObj.bankLogoUrl = vueObj.bankRows[selectIndex].logoUrl;
				vueObj.mediumChannelName = vueObj.bankRows[selectIndex].mediumChannelName;
				vueObj.cardChannelName = '尾号' + vueObj.bankRows[selectIndex].bindMedium.substring(vueObj.bankRows[selectIndex].bindMedium.length - 4, vueObj.bankRows[selectIndex].bindMedium.length)  + '储蓄卡';
			});
			//余额查询
			showWaiting();
			webCall2("/compus/wallet/queryBalance", {mediumId:getCache(USER_MEDIUM_ID_KEY)}, QUERY_REMAIN, vueObj.onSuccess, vueObj.onErrorBefore);
			//查询默认银行卡
			vueObj.queryUserDefaultBank();
		});
	},
	methods: {
		/*
		 * 查询银行卡列表
		 */
		queryUserDefaultBank: function(){
			webCall2("/compus/wallet/bindingQuery", {
				mediumId: getCache(USER_MEDIUM_ID_KEY),
			}, QUERY_DEFAULT_BANK, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 提现
		 */
		doNext: function(e) {
			if(!vueObj.remainValue || vueObj.remainValue == 0){
				toast("暂无可用余额");
				return;
			}
			var withdrawMoney = document.getElementById("withdrawMoney").value;
			if(!withdrawMoney){
				toast("请输入提现金额");
				return;
			}
			if (withdrawMoney <= 0) {
				toast("提现金额不得小于0")
				return; 
			}
			if(parseFloat(vueObj.remainValue) < parseFloat(withdrawMoney)){
				toast("超过可提现金额，请修改");
				return;
			}
			//小数点不足 补足两位
			vueObj.doWithdraw(toDecimalTwo(withdrawMoney));
		},
		/**
		 * 全部提现
		 */
		doAllWithdraw: function(e) {
			if(!vueObj.remainValue || vueObj.remainValue == 0){
				toast("暂无可用余额");
				return;
			}
			//先显示出来, 点提现 再进行下一步
			document.getElementById("withdrawMoney").value = vueObj.remainValue;
//			vueObj.doWithdraw(vueObj.remainValue);
		},
		/**
		 * 执行提现操作
		 */
		doWithdraw: function(money) {
			document.activeElement.blur();
			if(!vueObj.cardNoId){
				toast("请选择银行卡")
				return;
			}
			showWaiting();
			webCall2("/compus/wallet/withdraw", {
				mediumId:getCache(USER_MEDIUM_ID_KEY),
				bindMediumId: vueObj.cardNoId,
				amount: money
			}, DO_WITHDRAW, vueObj.onSuccess, vueObj.onErrorBefore);
		},
		/**
		 * 接口访问成功返回
		 * @param {Object} data
		 * @param {Object} requestCode
		 */
		onSuccess: function(data, requestCode) {
			closeWaiting();
			switch(requestCode) {
			case QUERY_DEFAULT_BANK: //查询银行卡列表
				vueObj.bankRows = data.rows;
				if(!vueObj.bankRows || vueObj.bankRows.length <= 0) return;
				vueObj.cardNoId = vueObj.bankRows[0].id;
				vueObj.bankLogoUrl = vueObj.bankRows[0].logoUrl;
				vueObj.mediumChannelName = vueObj.bankRows[0].mediumChannelName;
				vueObj.cardChannelName = '尾号' + vueObj.bankRows[0].bindMedium.substring(vueObj.bankRows[0].bindMedium.length - 4, vueObj.bankRows[0].bindMedium.length)  + '储蓄卡';
				break;
			case QUERY_REMAIN: //余额查询
				vueObj.remainValue = data.data.accountBalance ? data.data.accountBalance : '0';
				break;
			case DO_WITHDRAW: //提现申请
				//status 1申请中 2提现成功 3提现失败 4遗账
				if(data.data.status == 3) {
					toast(data.data.msg ? data.data.msg: "提现失败, 请重试");
					return;
				}
				//跳转到成功页
				openWindow("walletRechargeResult", "wallet_recharge_result.html", false, {
					title: data.data.msg,
					statusBarType:STATUS_BAR_MAIN_KEY
				});
				closeWebview("walletWithdraw");
				break;
			default:
				break;
			}
		},
		/**
		 * 接口访问失败返回
		 * @param {Object} resultCode
		 * @param {Object} resultMsgDesc
		 */
		onErrorBefore: function(resultCode, resultMsgDesc, requestCode, data) {
			closeWaiting();
			if(data && data.alertType == 1){ 
				openWindow("authError", "../center/auth_error.html", false, {
					errorMessage: resultMsgDesc,//失败原因
					statusBarType: plus.webview.currentWebview().statusBarType
				});
				closeWebview("walletWithdraw");
				return;
			} 
			onError(resultCode, resultMsgDesc);
		},
		/**
		 * 选择提现银行卡
		 */
		onSelectBank: function(e) {
			document.activeElement.blur();
			openWindow("bankList", "bank_list.html", false, {
				"source":"withdraw", 
				"bankData":vueObj.bankRows,
				statusBarType: STATUS_BAR_DEFAULT_KEY
			}, null, true);
		},
		/**
		 * 输入金额监听
		 */
		onMoneyInput: function(e) {
			var value = e.currentTarget.value;
			//去除特殊字符
			value = value.replace(/[^0-9.]/g, '');
			e.currentTarget.value = value;
			//控制输入两位小数
			value = value + '';
			var values = value.split('.');
			//控制整数位位数
			/*if(values[0].length > moneyLength) {
				values[0] = values[0].substring(0, moneyLength);
			}*/
			if(values.length > 1) {
				if(values[1].length > 2) {
					value = values[0] + '.' + values[1].substring(0, 2);
				} else {
					value = values[0] + '.' + values[1];
				}
			} else {
				value = values[0];
			}
			if(values.length > 1 && (values[0].length <= 0 || values[0] == "")) {
				value = "0.";
			}
			e.currentTarget.value = value;
		}
	}
});